Package: AllelicImbalance
Type: Package
Title: Investigates Allele Specific Expression
Version: 1.51.0
Date: 2021-11-17
Encoding: UTF-8
Author: Jesper R Gadin, Lasse Folkersen
Maintainer: Jesper R Gadin <j.r.gadin@gmail.com>
Description: Provides a framework for allelic specific expression
    investigation using RNA-seq data.
License: GPL-3
URL: https://github.com/pappewaio/AllelicImbalance
BugReports: https://github.com/pappewaio/AllelicImbalance/issues
Suggests: testthat, org.Hs.eg.db, TxDb.Hsapiens.UCSC.hg19.knownGene,
        SNPlocs.Hsapiens.dbSNP144.GRCh37, BiocStyle, knitr, rmarkdown
Depends: R (>= 4.0.0), grid, GenomicRanges (>= 1.31.8),
        SummarizedExperiment (>= 0.2.0), GenomicAlignments (>= 1.15.6)
Imports: methods, BiocGenerics, AnnotationDbi, BSgenome (>= 1.47.3),
        VariantAnnotation (>= 1.25.11), Biostrings (>= 2.47.6),
        S4Vectors (>= 0.17.25), IRanges (>= 2.13.12), Rsamtools (>=
        1.99.3), GenomicFeatures (>= 1.31.3), Gviz, lattice,
        latticeExtra, gridExtra, seqinr, GenomeInfoDb, nlme
LazyData: TRUE
biocViews: Genetics, Infrastructure, Sequencing
VignetteBuilder: knitr
Collate: 'AllelicImbalance-package.R' 'initialize-methods.R'
        'ASEset-class.R' 'DetectedAI-class.R' 'GlobalAnalysis-class.R'
        'barplot-methods.R' 'locationplot-methods.R'
        'GvizTrack-methods.R' 'LinkVariantAlmlof-class.R'
        'RegionSummary-class.R' 'RiskVariant-class.R'
        'auxillary-functions-annotation.R'
        'auxillary-functions-visuals.R'
        'auxillary-methods-annotation.R'
        'auxillary-methods-summaries.R' 'auxillary-methods.R'
        'chisq.test-methods.R' 'binom.test-methods.R'
        'boxplot-methods.R' 'deprecations.R' 'detect-methods.R'
        'filter-methods.R' 'histplot-methods.R' 'inference-methods.R'
        'linkage-methods.R' 'list-methods.R' 'mapbias-methods.R'
        'plot-methods.R' 'show-methods.R' 'simulation-methods.R'
        'summary-methods.R' 'utils.R'
RoxygenNote: 7.1.1
git_url: https://git.bioconductor.org/packages/AllelicImbalance
git_branch: devel
git_last_commit: 718ddd4
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 21:14:27 UTC; biocbuild

<a href="http://www.bioconductor.org/packages/devel/bioc/html/AllelicImbalance.html#since"><img border="0" src="http://www.bioconductor.org/shields/years-in-bioc/AllelicImbalance.svg" title="How long since the package was first in a develd Bioconductor version (or is it in devel only)."></a> <a href="http://bioconductor.org/packages/stats/bioc/AllelicImbalance.html"><img border="0" src="http://www.bioconductor.org/shields/downloads/AllelicImbalance.svg" title="Percentile (top 5/20/50% or 'available') of downloads over last 6 full months. Comparison is done across all package categories (software, annotation, experiment)."></a> <a href="https://support.bioconductor.org/t/AllelicImbalance/"><img border="0" src="http://www.bioconductor.org/shields/posts/AllelicImbalance.svg" title="Support site activity, last 6 months: tagged questions/avg. answers per question/avg. comments per question/accepted answers, or 0 if no tagged posts."></a> <a href="http://www.bioconductor.org/packages/devel/bioc/html/AllelicImbalance.html#svn_source"><img border="0" src="http://www.bioconductor.org/shields/commits/bioc/AllelicImbalance.svg" title="average Subversion commits (to the devel branch) per month for the last 6 months"></a>

Status: Travis CI [![Build Status](https://travis-ci.org/pappewaio/AllelicImbalance.svg?branch=master)](https://travis-ci.org/pappewaio/AllelicImbalance)

Bioc-release <a href="http://www.bioconductor.org/packages/release/bioc/html/AllelicImbalance.html#archives"><img border="0" src="http://www.bioconductor.org/shields/availability/release/AllelicImbalance.svg" title="Whether the package is available on all platforms; click for details."></a> <a href="http://bioconductor.org/checkResults/release/bioc-LATEST/AllelicImbalance/"><img border="0" src="http://www.bioconductor.org/shields/build/release/bioc/AllelicImbalance.svg" title="build results; click for full report"></a>

Bioc-devel <a href="http://www.bioconductor.org/packages/devel/bioc/html/AllelicImbalance.html#archives"><img border="0" src="http://www.bioconductor.org/shields/availability/devel/AllelicImbalance.svg" title="Whether the package is available on all platforms; click for details."></a> <a href="http://bioconductor.org/checkResults/devel/bioc-LATEST/AllelicImbalance/"><img border="0" src="http://www.bioconductor.org/shields/build/devel/bioc/AllelicImbalance.svg" title="build results; click for full report"></a>

The Bioc-release and Bioc-devel builds are updated every day at 10:30AM Seattle
time.

The latest bioconductor releases and the bioconductor development branch can be
found either on [github][bioc-mirror-branches] or at the home of
[bioconductor][bioc-home], 
* [release][bioc-release]
* [devel][bioc-devel]

# AllelicImbalance

A Bioconductor package for allelic imbalance analysis on RNA sequencing data.
The aim is to support infrastructure for storage of summarized allele counts and
functions to quickly retrieve important figures for AI analyses. The package
also provides SNP or region specific visualization and interaction with other
common bioconductor functionality.

See the "DESCRIPTION" file for additional requirements.

## Documentation

The vignette provides an introduction to the allelic imbalance
concept and show examples of how the AllelicImbalance package can be used to
find AI-events and measure the global or local mapping bias from the alignment
of RNA-seq reads to a reference genome. 

* [vignette-release][vignette-release]
* [vignette-devel][vignette-devel]

## Installation

Installation of the devel version of this package from Github requires the
[devtools][devtoolsLink] package.

```r
install.packages("devtools")
library(devtools)
install_github("pappewaio/AllelicImbalance")
```

Alternatively, you can easily install the release version of **AllelicImbalance** from
Bioconductor.

```r
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install("AllelicImbalance")
```

## Citation

Jesper R. Gådin, Ferdinand M. van’t Hooft, Per Eriksson and Lasse Folkersen.
(2015). AllelicImbalance: an R/ bioconductor package for detecting, managing,
and visualizing allele expression imbalance data from RNA sequencing. BMC
Bioinformatics. [link](http://www.biomedcentral.com/1471-2105/16/194)

## Bug Reports / Issues

The official development site for `AllelicImbalance` is at
https://github.com/pappewaio/AllelicImbalance. For bug-reports / issues /
comments regarding the development branch you may preferably submit there, and
for the release version it might be more appropriate to submit at the
bioconductor support-site which can be found [HERE][bioc-support-site]


[vignette-release]: http://bioconductor.org/packages/release/bioc/vignettes/AllelicImbalance/inst/doc/AllelicImbalance-vignette.pdf "AllelicImbalance Vignette"
[vignette-devel]: http://bioconductor.org/packages/devel/bioc/vignettes/AllelicImbalance/inst/doc/AllelicImbalance-vignette.pdf "AllelicImbalance Vignette"
[bioc-mirror-branches]: https://github.com/Bioconductor-mirror/AllelicImbalance/branches "bioc-mirror-branches"
[bioc-home]: https://www.bioconductor.org/ "Bioconductor home"
[bioc-release]: http://bioconductor.org/packages/release/bioc/html/AllelicImbalance.html "Bioconductor release"
[bioc-devel]: http://bioconductor.org/packages/devel/bioc/html/AllelicImbalance.html "Bioconductor devel"
[bioc-support-site]: https://support.bioconductor.org/t/AllelicImbalance "support site AllelicImbalance"
[devtoolsLink]: https://github.com/hadley/devtools "devtools"

#'@include ASEset-class.R
NULL

#' genotype filter methods 
#' 
#' useful genotype filters
#' 
#' hetFilt returns TRUE if the samples is heterozygote, based on stored genotype information
#' present in the phase data.
#' 
#' @name ASEset-filters
#' @rdname ASEset-filters
#' @aliases hetFilt hetFilt,ASEset-method 
#' @docType methods
#' @param x ASEset object
#' @param source 'genotype' or 'alleleCounts'
#' @param ... internal param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords filter
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' genotype(a) <- inferGenotypes(a)
#' hets <- hetFilt(a) 
#' 
NULL

#' @rdname ASEset-filters
#' @export 
setGeneric("hetFilt", function(x, ...){
    standardGeneric("hetFilt")
})

#' @rdname ASEset-filters
#' @export 
setMethod("hetFilt", signature(x = "ASEset"), 
	function(x, source="genotype", ...)
	{
		if(source=="genotype"){
			.heterozygozityFromPhaseArray(phase(x , return.class="array"))
		}else if(source=="alleleCounts"){
			stop("not implemented")
		}else{
			stop("source must be 'genotype' or 'alleleCounts' ")
		}
	}
)

### -------------------------------------------------------------------------
### helpers for hetFilt
###
.heterozygozityFromPhaseArray <- function(x){
	!(x[,,1] == x[,,2])
}

#' multi-allelic filter methods 
#' 
#' filter on multiallelic snps
#' 
#' based on the allele counts for all four variants A, T, G and C and returns true 
#' if there is counts enough suggesting a third or more alleles. The sensitivity can 
#' be specified using 'threshold.count.sample' and 'threshold.frequency'.
#' 
#' @name multiAllelicFilt
#' @rdname multiAllelicFilt
#' @aliases multiAllelicFilt multiAllelicFilt,ASEset-method 
#' @docType methods
#' @param x \code{ASEset} object
#' @param strand strand to infer from
#' @param filterOver 'eachSample' or 'allSamples' 
#' @param threshold.count.sample least amount of counts to try to infer allele
#' @param threshold.frequency least fraction to classify (see details)
#' @param ... internal param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords filter
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' multiAllelicFilt(a)
#' 
NULL

#' @rdname multiAllelicFilt
#' @export 
setGeneric("multiAllelicFilt", function(x, ...){
    standardGeneric("multiAllelicFilt")
})

#' @rdname multiAllelicFilt
#' @export 
setMethod("multiAllelicFilt", signature(x = "ASEset"), 
		function(x, strand="*", threshold.count.sample=10, threshold.frequency=0.10,
				   filterOver="eachSample"){

		#find SNP types
		fr <- frequency(x, strand=strand, 
			threshold.count.sample=threshold.count.sample,
			return.class="array")

		#apply over alleles
		alleles <- apply(fr,c(1,2), function(x){
			sum(x >= threshold.frequency)
		})

		if(filterOver=="allSamples"){
			apply(alleles,1, function(x){
				any(x > 2 ,na.rm=TRUE)
			})
		}else if(filterOver=="eachSample"){
			alleles > 2
		}
})

#' minFreqFilt methods 
#' 
#' filter on minFreqFilt snps
#' 
#' Description info here
#' 
#' @name minFreqFilt
#' @rdname minFreqFilt
#' @aliases minfreqFilt minFreqFilt,ASEset-method 
#' @docType methods
#' @param x \code{ASEset} object
#' @param strand strand to infer from
#' @param sum 'each' or 'all' 
#' @param threshold.frequency least fraction to classify (see details)
#' @param replace.with only option 'zero' 
#' @param return.class 'ASEset', 'array' or 'matrix'
#' @param ... internal param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords filter
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' minFreqFilt(a)
#' 
NULL

#' @rdname minFreqFilt
#' @export 
setGeneric("minFreqFilt", function(x, ...){
    standardGeneric("minFreqFilt")
})

#' @rdname minFreqFilt
#' @export 
setMethod("minFreqFilt", signature(x = "ASEset"), 
		function(x, strand="*", threshold.frequency=0.10, replace.with="zero", 
				 return.class="ASEset", sum="all" )
				
		{
		thr <- threshold.frequency
		fr <- frequency(x, strand=strand, threshold.count.sample=1,
				return.class="array")

		#create tfmat
		if(sum=="each"){
			#check if ref and alt allele are present
			if(!refExist(x)){stop("ref(x) is empty")}
			if(!altExist(x)){stop("alt(x) is empty")}
			#check if ref and alt are character, otherwise give a warning and 
			#coerce to character
			ref <- .verboseCoerceToCharacter(ref(x)) 
			alt <- .verboseCoerceToCharacter(alt(x)) 
			tfmat <- .toKeepMatrixMinFreqFilterEach(fr,ref,alt,ncol(x),thr,x@variants)

		}else if(sum=="all"){
			tfmat <- .Na2False(.toKeepMatrixMinFreqFilterAll(fr, thr))
		}

		#return object
		if(return.class=="ASEset"){
			#will only filter out the selected strand, and while the unknown strand is
			#based on the plus and minus we have to filter all of them, to have the back
			#free. In the future the assays(x)[["countsUnknown"]] will be dropped so it 
			#always calculated on the fly as the sum of the plus and minus strand
			tfarray <- .expandMatrixToArray(tfmat, length(x@variants))
			if(strand=="*"){
				if(.unknownStrandCountsExists(x)) alleleCounts(x, strand="*", return.class="array")[!tfarray] <- 0
				if(.minusStrandCountsExists(x)) alleleCounts(x, strand="-", return.class="array")[!tfarray] <- 0
				if(.plusStrandCountsExists(x)) alleleCounts(x, strand="+", return.class="array")[!tfarray] <- 0
			}else if(strand=="+" | strand=="-"){
				alleleCounts(x, strand=strand, return.class="array")[!tfarray] <- 0
			}
			return(x)
		}
		if(return.class=="array") return(.expandMatrixToArray(tfmat, length(x@variants)))
		if(return.class=="matrix") return(tfmat)
})
### -------------------------------------------------------------------------
### helpers for minFreqFilt
###

#get the replacement matrix for "all"
.toKeepMatrixMinFreqFilterAll <- function(fr, thr){
		tf <- fr >= thr
		apply(tf, c(1,2), function(x){sum(x)>=2})	
}

#get the replacement matrix for "each"
.toKeepMatrixMinFreqFilterEach <- function(fr,ref,alt,nc,thr,var){
			#check that overall dimensions are fine
			if(!length(nc)==1) stop("dimensions do not agree in .altAlleleFreqThreshold")
			if(any(!dim(fr) == c(length(ref), nc, length(var))) | 
			   !(length(ref) == length(alt)) |
			   !(length(nc) == 1) |
			   !(length(thr) == 1)
			) stop("dimensions do not agree in .altAlleleFreqThreshold")
			

			#take out count values only for ref allele
			ref.ar <- .arrayFromAlleleVector(var, ref, nc )
			alt.ar <- .arrayFromAlleleVector(var, alt, nc )

			#use on counts
			ref.fr <- .subsetArrayToMatrix(fr, ref.ar)
			alt.fr <- .subsetArrayToMatrix(fr, alt.ar)

			#at least eg. 0.1 in each group
			.Na2False(ref.fr > thr) & .Na2False(alt.fr > thr)

			#tfFilt <- .Na2False(ref.fr > thr) & .Na2False(alt.fr > thr)
			#take out these pairs and look at them (manually control that all is fine)
			#this is atm not tested in a unit test, but should be covered by
			#another test
			#matrix(c(ref.fr[tfFilt], alt.fr[tfFilt]), ncol=2)
			#matrix(c(ref.fr[!tfFilt], alt.fr[!tfFilt]), ncol=2)

			#extend the matrix to 3d for the subset/replacement now done outside this unit
			#.expandMatrixToArray(tfFilt, length(var))
}

#' minCountFilt methods 
#' 
#' filter on minCountFilt snps
#' 
#' Description info here
#' 
#' @name minCountFilt
#' @rdname minCountFilt
#' @aliases minCountFilt minCountFilt,ASEset-method 
#' @docType methods
#' @param x \code{ASEset} object
#' @param strand strand to infer from
#' @param sum 'each' or 'all' 
#' @param threshold.counts cutoff for read counts (see details)
#' @param replace.with only option 'zero' 
#' @param return.class 'ASEset', 'array' or 'matrix'
#' @param ... internal param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords filter
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' minCountFilt(a)
#' 
NULL

#' @rdname minCountFilt
#' @export 
setGeneric("minCountFilt", function(x, ...){
    standardGeneric("minCountFilt")
})

#' @rdname minCountFilt
#' @export 
setMethod("minCountFilt", signature(x = "ASEset"), 
		function(x, strand="*", threshold.counts=1,
				   sum="all", replace.with="zero", return.class="ASEset"){

		#set shorter name
		thr <- threshold.counts

		#extract alleleCounts
		ac <- alleleCounts(x, strand=strand, return.class="array")

		#create tfmat
		if(sum=="all") tfmat <- .toKeepMatrixMinCountFilterAll(ac, thr)
		else if(sum=="each"){
			#check if ref and alt allele are present
			if(!refExist(x)){stop("ref(x) is empty")}
			if(!altExist(x)){stop("alt(x) is empty")}
			#check if ref and alt are character, otherwise give a warning and 
			#coerce to character
			ref <- .verboseCoerceToCharacter(ref(x)) 
			alt <- .verboseCoerceToCharacter(alt(x)) 
			tfmat <- .toKeepMatrixMinCountFilterEach(ac,ref,alt,ncol(x),thr,x@variants)
		}

		#return object
		if(return.class=="ASEset"){
			#will only filter out the selected strand, and while the unknown strand is
			#based on the plus and minus we have to filter all of them, to have the back
			#free. In the future the assays(x)[["countsUnknown"]] will be dropped so it 
			#always calculated on the fly as the sum of the plus and minus strand
			tfarray <- .expandMatrixToArray(tfmat, length(x@variants))
			if(strand=="*"){
				if(.unknownStrandCountsExists(x)) alleleCounts(x, strand="*", return.class="array")[!tfarray] <- 0
				if(.minusStrandCountsExists(x)) alleleCounts(x, strand="-", return.class="array")[!tfarray] <- 0
				if(.plusStrandCountsExists(x)) alleleCounts(x, strand="+", return.class="array")[!tfarray] <- 0
			}else if(strand=="+" | strand=="-"){
				alleleCounts(x, strand=strand, return.class="array")[!tfarray] <- 0
			}
			return(x)
		}
		if(return.class=="array") return(.expandMatrixToArray(tfmat, length(x@variants)))
		if(return.class=="matrix") return(tfmat)

})

### -------------------------------------------------------------------------
### helpers for minCountFilt
###

#get the replacement matrix for "all"
.toKeepMatrixMinCountFilterAll <- function(ac, thr){
	apply(ac, c(1,2), function(x,thr){sum(x)> thr},thr=thr)
}

#get the replacement matrix for "each"
.toKeepMatrixMinCountFilterEach <- function(ac,ref,alt,nc,thr,var){
			#check that overall dimensions are fine
			if(!length(nc)==1) stop("dimensions do not agree in .toKeepArrayMinCountFilter")
			if(any(!dim(ac) == c(length(ref), nc, length(var))) | 
			   !(length(ref) == length(alt)) |
			   !(length(nc) == 1) |
			   !(length(thr) == 1)
			) stop("dimensions do not agree in .toKeepArrayMinCountFilter")
			

			#take out count values only for ref allele
			ref.ar <- .arrayFromAlleleVector(var, ref, nc )
			alt.ar <- .arrayFromAlleleVector(var, alt, nc )

			#use on counts
			ref.ac <- .subsetArrayToMatrix(ac, ref.ar)
			alt.ac <- .subsetArrayToMatrix(ac, alt.ar)

			#at least 30 in both groups
			(ref.ac > thr) & (alt.ac > thr)

			#take out these pairs and look at them (manually control that all is fine)
			#this is atm not tested in a unit test, but should be covered by
			#another test
			#matrix(c(ref.ac[tfFilt], alt.ac[tfFilt]), ncol=2)
			#matrix(c(ref.ac[!tfFilt], alt.ac[!tfFilt]), ncol=2)

			#extend the matrix to 3d for the subset/replacement now done outside this unit
			#.expandMatrixToArray(tfFilt, length(var))
}

#'@include chisq.test-methods.R
NULL

#' binomial test
#' 
#' Performs a binomial test on an ASEset object.
#' 
#' the test can only be applied to one strand at the time.
#' 
#' @name binom.test
#' @rdname binom.test
#' @aliases binom.test,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param n strand option
#' @return \code{binom.test} returns a matrix
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{chisq.test}} which is another test
#' that can be applied on an \link{ASEset} object.  }
#' @keywords binomial test
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' 
#' #make a binomial test
#' binom.test(ASEset,'*')
#' 
#' 
NULL

#' @rdname binom.test
#' @export 
setMethod("binom.test", signature(x = "ASEset", n = "ANY"), function(x, n = "*") {
    
	if(!("genotype" %in% assayNames(x))){
		genotype(x) <- inferGenotypes(x)
	}

    strand <- n

	fr <- fraction(x, strand=strand,
			top.fraction.criteria="ref",
			threshold.count.sample= 1)
    
    # checks
    if (!sum(strand %in% c("+", "-", "*")) > 0) {
        stop("strand parameter n has to be either '+', '-' or '*' ")
    }
	idx <- which(!is.na(fr))
	arn <- arank(x,return.type="names",return.class="matrix") 
	ac <- alleleCounts(x, strand=strand, return.class="array")

	mat1 <- matrix(aperm(ac,c(3,2,1))[aperm(array(matrix(x@variants, ncol=length(x@variants),
		 nrow=nrow(x), byrow=TRUE)==arn[,1]
	 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
	],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))

	mat2 <- matrix(aperm(ac,c(3,2,1))[aperm(array(matrix(x@variants, ncol=length(x@variants),
		 nrow=nrow(x), byrow=TRUE)==arn[,2]
	 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
	],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))


	allele1 <- mat1[idx] 
	allele2 <- mat2[idx]

	#test the two most expressed alleles
	biasmat1 <- matrix(aperm(mapBias(x, return.class="array"),c(3,2,1))[aperm(array(matrix(
		x@variants, ncol=length(x@variants),
		 nrow=nrow(x), byrow=TRUE)==arn[,1]
	 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
	],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))


	biasAllele1 <- biasmat1[idx] 
	
	#maybe put a check here later that bias1 and bias2 sum to 1

	ml <- mapply(allele1,allele2,biasAllele1,FUN=function(x,y,z){
		binom.test(c(x,y), p = z)[[3]]
	})

	#cerate matrix in same size as fr	
	pv <- fr	
	pv[idx] <- ml

	t(pv)
    
}) 

##' @rdname binom.test
##'  @export 
#setMethod("binom.test", signature(x = "ASEset", n = "ANY"), function(x, n = "*") {
#    
#    strand <- n
#    
#    # checks
#    if (!sum(strand %in% c("+", "-", "*")) > 0) {
#        stop("strand parameter n has to be either '+', '-' or '*' ")
#    }
#    
#    
#    biasWarning <- vector()
#    pLst <- list()
#    
#    # use this strand to get dimension information
#    if (strand == "both") {
#        tmpStrand <- "+"
#    } else {
#        tmpStrand <- strand
#    }
#    
#    for (i in 1:length(alleleCounts(x, strand = tmpStrand))) {
#        bias <- mapBias(x)[[i, drop = FALSE]]
#        
#        df <- alleleCounts(x, tmpStrand)[[i]]
#        returnVec <- rep(NA, nrow(df))
#        for (j in 1:nrow(df)) {
#            so <- sort(df[j, ], decreasing = TRUE)
#            if (so[2] != 0) {
#                # place bias in same order as so
#                bi <- bias[, names(so)[1:2]]
#                
#                # check that bi[1] and bi[2] adds up to 100% or force 0.5-0.5 and give warning
#                if (bi[1] + bi[2] != 1) {
#                  bi[1] <- bi[2] <- 0.5
#                  warning("Found disrepancy between mapping bias information and mapBiasExpMean and the allele count. Coerced to expectation of 0.5 to 0.5 ratio")
#                }
#                expCounts <- c(sum(so) * bi[1], sum(so) * bi[2])
#                returnVec[j] <- binom.test(as.numeric(c(so[1], so[2])), p = as.numeric(bi[1]/(bi[1] + 
#                  bi[2])))[[3]]
#            } else {
#                returnVec[j] <- NA
#            }  # if it's mono-allelic
#        }  #end for-loop
#        pLst[[names(alleleCounts(x, strand = tmpStrand)[i])]] <- returnVec
#    }
#    if (length(biasWarning) > 0) {
#        warning(paste(length(biasWarning), "SNPs had disrepancy between their two highest read count alleles and the\n\n\t\t\t\t\t\t\t\t\ttwo alleles indicated in mapBiasExpMean. They were coerced to a standard and expected alignment \n\t\t\t\t\t\t\t\t\tbias of 0.5 to 0.5, but could be checked further as this indicates non-standard allele distributions:\n", 
#            paste(biasWarning[1:(min(c(length(biasWarning), 20)))], collapse = ", ")))
#    }
#    return(as.matrix(as.data.frame(pLst)))
#}) 

#'@include ASEset-class.R
NULL

#' regionSummary
#'
#' Gives a summary of AI-consistency for a transcript
#'
#' From a given set of e.g. transcripts exon ranges the function will return
#' a summary for the sum of all exons. Phase information, reference and alternative
#' allele is required.
#'
#' A limitation comes to the strand-specificness. At the moment it is not possible
#' to call over more than one strand type using the strands in region. This will be
#' improved before going to release.
#'
#' to calculate the direction and binomial p-values of AI the mapbias stored in the
#' ASEset is used. see '?mapBias'.
#'
#'
#' @name regionSummary
#' @rdname regionSummary
#' @aliases regionSummary,numeric-method
#' @docType methods
#' @param x ASEset object
#' @param region to summmarize over, the object can be a GRanges, GRangesList
#' @param strand can be "+", "-" or "*"
#' @param return.class "array" or "list".
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords summary
#' @examples
#'
#' data(ASEset)
#' a <- ASEset
#' # Add phase
#' set.seed(1)
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#'
#' phase(a) <- p
#'
#' #add alternative allele information
#' mcols(a)[["alt"]] <- inferAltAllele(a)
#'
#' # in this example each and all snps in the ASEset defines the region
#' region <- granges(a)
#' t <- regionSummary(a, region)
#'
#' # in this example two overlapping subsets of snps in the ASEset defines the region
#' region <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))
#' t <- regionSummary(a, region)
#'
NULL

#' @rdname regionSummary
#' @export
setGeneric("regionSummary", function(x, ... ){
    standardGeneric("regionSummary")
})


#' @rdname regionSummary
#' @export
setMethod("regionSummary", signature("ASEset"),
		function(x, region, strand="*",
				 return.class="RegionSummary", ...
	){

		#checks are needed for
		#1 phase
		#2 alt ALT
		#3 ref REF

		if(is(region, "GRanges") | is(region, "GRangesList")){
			reg <- .unlistGRangesListAndIndex(region)
		}else if(is.list(region)){cat("list version not implemented")}

		#make overlap and subset for ASEset
		x <- .selectRegionAndTransferIndexToASEset(x, reg)
		#make regional granges for she summaries
		gr <- .makeRegionGRangesFromASEsetWithRegionIndex(x)
		#fraction with maternal phase used as numerator
		fr <- t(fraction(x, strand=strand, top.fraction.criteria="phase"))
		#which snp and sample pairs are heterozygotes
		fr.het.filt <- hetFilt(x)
		#filter so all homozygotes become NAs
		fr[!t(fr.het.filt)] <- NA
		#maternal phase map bias
		mb <- t(.maternalPhaseMapBias(mb=mapBias(x, return.class="array"), ma=maternalAllele(x), va=x@variants))
		#calculate delta
		fr.d <- .deltaFromFractionMatrixAndMapBias(fr, mb)
		#pick our important variables
		idx <-  mcols(x)[["regionIndex"]][[1]]
		#Summarize the statistics
		hets <- .regionStatisticsFromMatrixAndIndex(t(fr.het.filt), idx, sum)
		homs <- .regionStatisticsFromMatrixAndIndex(t(!fr.het.filt), idx, sum)
		mean.delta <- .regionStatisticsFromMatrixAndIndex(fr.d, idx, mean)
		sd.delta <- .regionStatisticsFromMatrixAndIndex(fr.d, idx, mean)
		mean.fr <- .regionStatisticsFromMatrixAndIndex(fr, idx, mean)
		sd.fr <- .regionStatisticsFromMatrixAndIndex(fr, idx, mean)
		ai.dir <- .aiRegionDirectionFromMaternalPhaseMapBiasAndIndex(fr, mb, idx)

		#For Meta infor, split ASEset and put into a DataFrame with same nrows as return object
		assays(x, withDimnames=FALSE)[["matfreq"]] <- t(fr)
		xdf <- .makeMetaASEsetDataFrameForRegionSummary(x, idx)

		#make array
		ar <- aperm(array(c(hets, homs, mean.fr, sd.fr, mean.delta, sd.delta, ai.dir),
			  dim=c(ncol(x),length(unique(idx)), 8),), c(2,1,3))

		dimnames(ar) <- list(1:length(unique(idx)), colnames(x),
			  c("hets","homs","mean.fr","sd.fr","mean.delta","sd.delta","ai.up","ai.down"))

		#create RegionSummary object
		sset <- SummarizedExperiment(
					assays = SimpleList(rs1=ar),
					colData = colData(x),
					rowRanges = gr)

		rownames(sset) <- names(gr)

		#add ASEset meta objects
		mcols(sset)[["ASEsetMeta"]] <- xdf

		#valid
		#validObject(.Object)

		#Return object
		new("RegionSummary", sset,
			meta = list(),
			sumnames = dimnames(ar)[[3]]
		)
})


### -------------------------------------------------------------------------
### helpers for regionSummary
###

# fr is the value for when maternal phase is the numerator in the freq. ekv.
# output: dim3 first element is up and second element is down
.aiRegionDirectionFromMaternalPhaseMapBiasAndIndex<- function(fr, mb, idx){

		fr.up.filt <- fr > mb
		fr.down.filt <- fr < mb

		mode(fr.up.filt) <- "integer"
		mode(fr.down.filt) <- "integer"

		array(c(
			 t(rowsum(t(fr.up.filt),idx, na.rm=TRUE)),
			 t(rowsum(t(fr.down.filt),idx, na.rm=TRUE))
		 ), dim=c(nrow(fr), length(unique(idx)), 2))
}

.maternalPhaseMapBias<- function(mb, ma, va){
		#for loop (for now)
		vmat <- matrix(va, byrow=TRUE, ncol=length(va), nrow=ncol(mb))
		mbias.values <- matrix(NA, ncol=ncol(mb), nrow=nrow(mb))
		for (i in 1:nrow(mb)){
			it.mbias <- mb[i,,]
			it.mallele <- ma[i,]
			mat.mallele <- matrix(it.mallele, ncol=length(va), nrow=nrow(vmat))
			tf <- mat.mallele == vmat
			mbias.values[i,] <- it.mbias[tf]
		}
		mbias.values
}

#input: ar has dim(samples, SNPs)
.regionStatisticsFromMatrixAndIndex<- function(mat, idx, fun){
			t(tapply(t(mat), list(idx[row(t(mat))], col(t(mat))), fun, na.rm=TRUE))

}

.deltaFromFractionMatrixAndMapBias<- function(ar, mb){
			abs(ar - mb)
}

# input, ASEset and unlisted region, (region is a GRanges object, with index information)
# output an indexed and sorted(lowest idx to highest) ASEset overlapping the region
.selectRegionAndTransferIndexToASEset <- function(a, reg){

		hits <- findOverlaps(a, reg)
		a <- a[queryHits(hits)]
		mcols(a)[["ASEsetIndex"]] <- queryHits(hits)
		mcols(a)[["regionIndex"]] <- mcols(reg[subjectHits(hits)])[["regionIndex"]]
		mcols(a)[["regionIndexName"]] <- mcols(reg[subjectHits(hits)])[["regionIndexName"]]
		a <- a[sort(mcols(a)[["regionIndex"]][[1]], index.return=TRUE)$ix]
		a
}

#sorted and indexed ASEset
.unlistGRangesListAndIndex <- function(grl){
		idx <- togroup(PartitioningByWidth(elementNROWS(grl)))
		if(!is.null(names(grl))){
			idn <- names(grl)[idx]
		}else{
			idn <- "nameless"
		}
		# Don't unlist if 'grl' is not a GRangesList object (e.g.
		# a GRanges object).
                if (is(grl , "GRangesList")){
			gr <- unlist(grl)
                }else{
			gr <- grl
		}
		mcols(gr)[["regionIndex"]] <- DataFrame(lvl1=idx)
		mcols(gr)[["regionIndexName"]] <- DataFrame(lvl1=idn)
		gr
}

#return granges for each bin (index has to be sorted)
.makeRegionGRangesFromASEsetWithRegionIndex <- function(x){
	idx <- mcols(x)[["regionIndex"]][[1]]
	idn <- mcols(x)[["regionIndexName"]][[1]]
	spl <- split(granges(x), idx)
	il <- IntegerList(lapply(spl,function(x){mcols(x)[["ASEsetIndex"]]}))
	names(il) <- NULL
	gr <- unlist(reduce(spl, min.gapwidth=100000000))
	mcols(gr) <- NULL
	mcols(gr)[["ASEsetIndex"]] <- il
	mcols(gr)[["regionIndex"]] <- DataFrame(lvl1=as.integer(unique(idx)))
	mcols(gr)[["regionIndexName"]] <- DataFrame(lvl1=as.character(unique(idn)))
	gr
}

#make list of the ASEset components relative to region
.makeMetaASEsetDataFrameForRegionSummary <- function(as, idx){
		DataFrame(ASEsetList=split(as, idx))
}

context("test units for method regionSummary")

test_that(paste("checking .aiRegionDirectionFromMaternalPhaseMapBiasAndIndex"), {

	#####################
	# Test 1
	#####################
	#Samples on rows
	#SNPs on cols
	fr <- matrix(c(0.3, 0.3, 0.4, 0.5,
				   0.7, 0.6, 0.5, 0.6,
		  	       NA ,  NA,  NA,  NA), ncol=3, nrow=4, byrow=FALSE)
	#same dim as fr
	mb <- array(0.5,dim=dim(fr))
	idx <- c(1,1,2)

	#prepare expected data 
	e1 <- c(1,1,0,1,0,0,0,0)
	e2 <- c(1,1,1,0,0,0,0,0)
	exp <- array(c(e1, e2),dim=c(4,2,2))

	#run tests
	res <- .aiRegionDirectionFromMaternalPhaseMapBiasAndIndex(fr, mb, idx)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .regionStatisticsFromMatrixAndIndex"), {

	#####################
	# Test 1 - mean
	#####################
	#Samples on rows
	#SNPs on cols
	mat <- matrix(c(0.3, 0.3, 0.4, 0.5,
				   0.7, 0.6, 0.5, 0.6,
		  	       NA ,  NA,  NA,  NA), ncol=3, nrow=4, byrow=FALSE)
	#same dim as fr
	idx <- c(1,1,2)

	#prepare expected data 
	e1 <- c(0.5, 0.45, 0.45, 0.55, NA, NA, NA, NA)
	exp <- matrix(e1, nrow=4, ncol=2)
	dimnames(exp) <- list(1:4,1:2)

	#run tests
	res <- .regionStatisticsFromMatrixAndIndex(mat, idx, mean)
	
	#test equality
    expect_equal(exp, res, tolerance=1e-6)

})

test_that(paste("checking .deltaFromFractionMatrixAndMapBias"), {

	#####################
	# Test 1 - mean
	#####################
	#Samples on rows
	#SNPs on cols
	ar <- matrix(c(0.3, 0.3, 0.4, 0.5,
				   0.7, 0.6, 0.5, 0.6,
		  	       NA ,  NA,  NA,  NA), ncol=3, nrow=4, byrow=FALSE)
	mb <- array(0.5, dim=dim(ar))

	#prepeare expected data
	e1 <- c(0.2, 0.2, 0.1, 0.0, 0.2, 0.1, 0.0, 0.1, NA, NA, NA, NA)
	exp <- matrix(e1, nrow=4, ncol=3)

	#run tests
	res <- .deltaFromFractionMatrixAndMapBias(ar, mb)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .selectRegionAndTransferIndexToASEset"), {

	#####################
	# Prepare data 1 
	#####################
	data(ASEset) 
	a <- ASEset

	#####################
	# Test 1 - one level region
	#####################
	reg <- c(split(granges(a)[c(1,2,2,3,1,1)], c(1,1,2,2,3,3)))
			 
	start(reg)[[3]] <- c(1,2)
	end(reg)[[3]] <- c(1,2)

	#prepeare expected data
	reg <- .unlistGRangesListAndIndex(reg)

	#prepeare expected data
	exp <- a[c(1,2,2,3)]
	idx <- c(1,1,2,2)
	idn <- paste(c(1,1,2,2))
	mcols(exp)[["ASEsetIndex"]] <- c(1,2,2,3)
	mcols(exp)[["regionIndex"]] <- DataFrame(lvl1=idx)
	mcols(exp)[["regionIndexName"]] <- DataFrame(lvl1=idn)

	#run tests
	res <- .selectRegionAndTransferIndexToASEset(a, reg)
	
	#test equality
    expect_that(exp, equals(res))

})


test_that(paste("checking .unlistGRangesListAndIndex"), {

	#####################
	# Prepare data 1 
	#####################
	data(ASEset) 
	a <- ASEset

	#####################
	# Test 1 
	#####################
	
	#add one region that is missing
	reg <- c(split(granges(a)[c(1,2,2,3,1,1)], c(1,1,2,2,3,3)),
			 split(granges(a)[c(1,2,2,3,1,1)], c(1,1,2,2,3,3)))
	start(reg)[[3]] <- c(1,2)
	end(reg)[[3]] <- c(1,2)

	#prepeare expected data
	idx <- c(1,1,2,2,3,3,4,4,5,5,6,6)
	idn <- paste(c(1,1,2,2,3,3,1,1,2,2,3,3))
	exp <- unlist(reg)
	mcols(exp)[["regionIndex"]] <- DataFrame(lvl1=idx)
	mcols(exp)[["regionIndexName"]] <- DataFrame(lvl1=idn)

	#run tests
	res <- .unlistGRangesListAndIndex(reg)
	
	#test equality
    expect_that(exp, equals(res))

	#####################
	# Test 2 - test what happens if names(region) is null
	#####################

	## The function can handle it right now.
	## Implement test as fast as possible!!

})

test_that(paste("checking .makeRegionGRangesFromASEsetWithRegionIndex"), {

	#####################
	# Prepare data 1 
	#####################
	data(ASEset) 
	a <- ASEset

	#####################
	# Test 1 
	#####################
	
	#add one region that is missing
	x <- a[c(1,2,3,2,2,2,3,2,1,3)]
	mcols(x)[["ASEsetIndex"]] <- c(1,2,3,2,2,2,3,2,1,3)
	mcols(x)[["regionIndex"]] <- DataFrame(lvl1=c(1,1,2,2,3,3,4,4,5,5))
	mcols(x)[["regionIndexName"]] <- DataFrame(lvl1=c(1,1,2,2,3,3,4,4,5,5))

	#prepeare expected data
	exp <- granges(a)[c(1,3,2,3,3)]
	end(exp) <-	start(exp)[c(3,3,3,3,1)]
	names(exp) <- 1:5
	mcols(exp) <- NULL
	mcols(exp)[["ASEsetIndex"]] <- IntegerList(list(c(1,2),c(3,2),c(2,2),c(3,2),c(1,3)))
	mcols(exp)[["regionIndex"]] <- DataFrame(lvl1=1:5)
	mcols(exp)[["regionIndexName"]] <- DataFrame(lvl1=as.character(c(1,2,3,4,5)))

	#run tests
	res <- .makeRegionGRangesFromASEsetWithRegionIndex(x)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .makeMetaFractionValueForRegion"), {
			
	#####################
	# Prepare data 1 
	#####################
	data(ASEset) 
	a <- ASEset
	
	#####################
	# Test 1 
	#####################
	x <- a[c(1,1,2,2,3)]
	idx <- c(1,2,1,2,2)
	
	#prepeare expected data
	exp <- DataFrame(ASEsetList=split(x,idx))
	
	#run tests
	res <- .makeMetaASEsetDataFrameForRegionSummary(x, idx)
	
	#test equality
	expect_that(exp, equals(res))
							
})

#'@include locationplot-methods.R
NULL

#' ASEset-gviztrack ASEset objects
#' 
#' plotting ASE effects over a specific genomic region
#' 
#' For information of how to use these tracks in more ways, visit the Gviz
#' package manual.
#' 
#' @name ASEset-gviztrack
#' @rdname ASEset-gviztrack
#' @aliases ASEset-gviztrack CoverageDataTrack ASEDAnnotationTrack
#' CoverageDataTrack,ASEset-method ASEDAnnotationTrack,ASEset-method
#' @docType methods
#' @param x an ASEset object.
#' @param GR genomic range of plotting
#' @param type 'fraction' or 'count'
#' @param strand '+','-'. This argument determines which strand is plotted.
#' @param BamList GAlignmnentsList object of reads from the same genomic region
#' as the ASEset
#' @param start start position of reads to be plotted
#' @param trackName name of track (ASEDAnnotationTrack)
#' @param meanCoverage mean of coverage over samples (CoverageGataTrack)
#' @param trackNameVec names of tracks (CoverageDataTrack)
#' @param end end position of reads to be plotted
#' @param verbose Setting \code{verbose=TRUE} gives details of procedure during
#' function run
#' @param ... arguments passed on to barplot function
#' @author Jesper R. Gadin
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the functions
#' can be called up on.}
#' @keywords ASEDAnnotationTrack CoverageDataTrack
#' @examples
#' 
#' data(ASEset)
#' x <- ASEset[,1:2]
#' r <- reads[1:2]
#' genome(x) <- 'hg19'
#' seqlevels(r) <- seqlevels(x)
#' 
#' GR <- GRanges(seqnames=seqlevels(x),
#'			ranges=IRanges(start=min(start(x)),end=max(end(x))),
#'			strand='+', genome=genome(x))
#' 
#' deTrack <- ASEDAnnotationTrack(x, GR=GR, type='fraction',strand='+')
#' covTracks <- CoverageDataTrack(x,BamList=r,strand='+') 
#' 
#' lst <- c(deTrack,covTracks)
#' 
#' sizes <- c(0.5,rep(0.5/length(covTracks),length(covTracks)))
#' #temporarily do not run this function 
#' #plotTracks(lst, from=min(start(x)), to=max(end(x)), 
#' #sizes=sizes, col.line = NULL, showId = FALSE, main='mainText', 
#' #cex.main=1, title.width=1, type='histogram')
#' 
#'
NULL


#' @rdname ASEset-gviztrack
#' @export
setGeneric("ASEDAnnotationTrack", function(x, GR = rowRanges(x), type = "fraction", 
    strand = "*", trackName = paste("deTrack", type), verbose = TRUE, 
    ...) {
    standardGeneric("ASEDAnnotationTrack")
})

#' @rdname ASEset-gviztrack
#' @export
setMethod("ASEDAnnotationTrack", signature(x = "ASEset"), function(x, GR = rowRanges(x), 
    type = "fraction", strand = "*",  trackName = paste("deTrack", 
        type), verbose = TRUE, ...) {
    
    # check genome
    if (is.null(genome(x)) | is.na(genome(x))) {
        stop(paste("genome have be set for object x", "e.g. genome(x) <- \"hg19\" "))
    }
    
    # check seqnames has length=1
    if (!(length(seqlevels(x)) == 1)) {
        stop("This function can only use objects with one seqlevel")
    }
    
    if (!nrow(x) == 0) {
		if(strand %in% c("+","-","*")){
			GR <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
				end = max(end(x))), strand = strand, genome = genome(x))
		}else if (strand=="both"){
			GR <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
				end = max(end(x))), strand = "*", genome = genome(x))
		}else{
			stop("strand has to be +, -, * or 'both'")
		}
	}else{
		stop("there are no rows in ASEset")
	}

	#make an environment from ...
    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }

	#always TRUE
	e$deAnnoPlot <- TRUE
	e$x <- x
	
	#print(ls(envir=e))
	#print(e$mainvec)	

    if (!exists("mainvec", envir = e, inherits = FALSE)) {
		e$mainvec <- rep("",nrow(e$x))
	}

    if (!exists("cex.mainvec", envir = e, inherits = FALSE)) {
		e$cex.mainvec <- 1
	}

    if (!exists("ylab", envir = e, inherits = FALSE)) {
        e$ylab <- ""
    }
    if (!exists("xlab", envir = e, inherits = FALSE)) {
        e$xlab <- ""
    }
		
    if (!exists("middleLine", envir = e, inherits = FALSE)) {
        e$middleLine <- TRUE
    }

    if (!exists("top.fraction.criteria", envir = e, inherits = FALSE)) {
        e$top.fraction.criteria <- "maxcount"
    }

    ranges <- rowRanges(x)
    
    colnames(x) <- 1:ncol(x)
    
    details <- function(identifier, ...) {
        
		if (length(list(...)) == 0) {
			e2<- new.env(hash = TRUE)
		} else {
			e2<- list2env(list(...))
		}

		type<- e2$type 
        
        if (type == "fraction") {
            print(barplotLatticeFraction(identifier, 
                ...), newpage = FALSE, prefix = "plot")
            
        } else if (type == "count") {
            print(barplotLatticeCounts(identifier, 
                ...), newpage = FALSE, prefix = "plot")
        }
        
    }

    # plot the fraction
    deTrack <- AnnotationTrack(
		range = ranges,
		genome = genome(x),
		id = rownames(x),
		name = trackName,
		stacking = "squish",
		fun = details,
		detailsFunArgs = list(
			ylab = e$ylab,
			xlab = e$xlab,
			deAnnoPlot = e$deAnnoPlot,
			cex.mainvec = e$cex.mainvec,
			mainvec=list(list(e$mainvec)),
			type = type,
			x = x,
			astrand = strand,
			ids = list(list(rownames(x))),
			middleLine = e$middleLine,
			top.fraction.criteria = e$top.fraction.criteria))
    deTrack
})

#' @rdname ASEset-gviztrack
#' @export
setGeneric("CoverageDataTrack", function(x, GR = rowRanges(x), BamList = NULL, strand = NULL, 
    start = NULL, end = NULL, trackNameVec = NULL, meanCoverage=FALSE, verbose = TRUE, ...) {
    standardGeneric("CoverageDataTrack")
#' @export
})
setMethod("CoverageDataTrack", signature(x = "ASEset"), function(x, GR = rowRanges(x), 
	 BamList = NULL, strand = "*", start = NULL, end = NULL, trackNameVec = NULL,
	 meanCoverage=FALSE, verbose = TRUE, ...) {
    
     # GR is not in use atm. Missing is a subset of the return matrix based on the GR
     # values.
    
    if (!is.null(strand)) {
        if (strand == "+") {
            pstrand = TRUE
        } else if (strand == "-") {
            mstrand = TRUE
        } else if (strand == "*") {
            pstrand = TRUE
            mstrand = TRUE
        } else if (strand == "both") {
            pstrand = TRUE
            mstrand = TRUE
        } else {
            stop("strand has to be '+', '-', '*' or 'both' if not NULL\n")
        }
    } else {
         stop("strand has to be '+', '-', '*' or 'both' if not NULL\n")
    }
    
    # check genome
    if (is.null(genome(x)) | is.na(genome(x))) {
        stop(paste("genome have be set for object x", "e.g. genome(x) <- \"hg19\" "))
    }
    
    # check seqnames has length=0
    if (!(length(seqlevels(x)) == 1)) {
        stop("This function can only use objects with one seqlevel")
    }
   
	if(strand=="both"){
		GR.p <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
			end = max(end(x))), strand = '+')
		GR.m <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
			end = max(end(x))), strand = '-')
	}else{
		GR <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
			end = max(end(x))), strand = strand)
	}
    
    trackList <- list()
	
    if (is.null(BamList)) {
        stop("must include GappedAlignmentsList as BamList ")
    } 
	
	# check that only one chromosome is present
	if (!length(seqlevels(BamList)) == 1) {
		stop("can only be one seq level\n")
	}

	if(strand=="both"){
		covMatList <- coverageMatrixListFromGAL(BamList, strand='both')

		mat.p <- covMatList[["mat"]][["plus"]]
		mat.m <- covMatList[["mat"]][["minus"]]
		start <- covMatList[["start"]]
		end <- covMatList[["end"]]

		if(meanCoverage){
			vec.p <- apply(mat.p,2,mean)
			mat.p <- matrix(vec.p,nrow=1)	
			dimnames(mat.p)[1] <- list("meancoverage")
			vec.m <- apply(mat.m,2,mean)
			mat.m <- matrix(vec.m,nrow=1)	
			dimnames(mat.m)[1] <- list("meancoverage")
		}



		if (is.null(trackNameVec)) {
			trackNameVec <- vector()

			if(!meanCoverage){
				for (i in 1:ncol(x)){
					trackNameVec <- c(trackNameVec,
									  paste(colnames(x)[i],"(+)",sep="-"),
									  paste(colnames(x)[i],"(-)",sep="-"))
				}
			 }else{
					trackNameVec <- c(trackNameVec,
									  paste(colnames(x)[i],"(+)",sep="-"),
									  paste(colnames(x)[i],"(-)",sep="-"))
			}
		} else {
			if (!((length(trackNameVec)*2) == nrow(mat.p))) {
				stop(paste("length of trackNameVec must be a two times the numer",
					 "of rows in out matrix"))
			}
		}
			
		# prepare Gviz dtracks
		for (j in 1:nrow(mat.p)) {

			#merge strands
			data <- matrix(0,nrow=2,ncol=ncol(mat.m))
			data[1,] <- mat.p[j,]
			data[2,] <- -mat.m[j,]
			rownames(data) <- c(paste(colnames(x)[i], "(+)", sep="-"),
								paste(colnames(x)[i], "(-)", sep="-"))

			trackList[[length(trackList) + 1]] <- DataTrack(data = data, start = start:end, 
				width = 1, chromosome = seqlevels(x), genome = genome(x),
				name = trackNameVec[j], groups=rownames(data),
				type = "s")
		}

	}else{

		covMatList <- coverageMatrixListFromGAL(BamList, strand)

		mat <- covMatList[["mat"]]
		start <- covMatList[["start"]]
		end <- covMatList[["end"]]
		
		if(meanCoverage){
			vec <- apply(mat,2,mean)
			mat <- matrix(vec,nrow=1)	
			dimnames(mat)[1] <- list("meancoverage")
		}


		if (is.null(trackNameVec)) {
			if(!meanCoverage){
				trackNameVec <- vector()
				trackNameVec[1:ncol(x)] <- colnames(x)
			}else{
				trackNameVec <- "mean coverage"
			}
		} else {
			if (!(length(trackNameVec) == nrow(mat))) {
				stop("length of trackNameVec must be equal to cols in (ASEset)")
			}
		}
		
		# prepare Gviz dtracks
		for (j in 1:nrow(mat)) {
			trackList[[length(trackList) + 1]] <- DataTrack(data = mat[j, ], start = start:end, 
				width = 1, chromosome = seqlevels(x), genome = genome(x), name = trackNameVec[j], 
				type = "s")
		}
	}
    
    trackList
}) 

#######################
# Deprecated functions
#######################

#was deprecated 2015-03-26
implodeList <- function()
{
	    .Deprecated("implodeList.old",msg="no longer serving any purpose in the AllelicImbalance package and is deprecated")
}



#was deprecated 2015-03-25
realCigarPositions <- function()
{
	    .Deprecated("realCigarPositions.old",msg="no longer serving any purpose in the AllelicImbalance package and is deprecated")
}

#was deprecated 2015-03-25
realCigarPositionsList <- function()
{
	    .Deprecated("realCigarPositionsList.old",msg="no longer serving any purpose in the AllelicImbalance package and is deprecated")
}

#was deprecated 2015-03-25
realCigarPosition <- function()
{
	    .Deprecated("realCigarPosition",msg="no longer serving any purpose in the AllelicImbalance package and is deprecated")
}

#was deprecated 2015-03-24
impBamGRL <- function()
{
	    .Deprecated("impBamGRL.old",msg="no longer serving any purpose in the AllelicImbalance package and is deprecated")
}

#in 2014
getAlleleCount <- function() {
    .Deprecated("getAlleleCounts")
}

#' Import Bam-2
#'
#' Imports bla bal bal a specified genomic region from a bam file using a GenomicRanges
#' object as search area.
#'
#' These functions are right  on tahea wrappers to import bam files into R and store them into
#' either GRanges, GAlignments or GappedAlignmentpairs objects.
#'
#' It is recommended to use the impBamGAL() which takes information of gaps
#' into account. It is also possible to use the other variants as well, but
#' then pre-filtering becomes important keps to understand because gapped, intron-spanning reads
#' will cause problems. This is because the GRanges objects can not handle if
#' gaps are present and will then give a wrong result when calculating the
#' allele (SNP) count table.
#'
#' @name import-bam-2
#' @rdname import-bam-2
#' @aliases import-bam-2 impBamGRL
#' @param UserDir The relative or full path of folder containing bam files.
#' @param searchArea A \code{GenomicRanges object} that contains the regions of
#' interest
#' @param verbose Setting \code{verbose=TRUE} gives details of procedure during
#' function run.
#' @return \code{impBamGRL} returns a GRangesList object containing the RNA-seq
#' reads in the region defined by the \code{searchArea} argument.
#' \code{impBamGAL} returns a list with GAlignments objects containing the
#' RNA-seq reads in the region defined by the \code{searchArea} argument.
#' \code{funImpBamGAPL} returns a list with GappedAlignmentPairs object
#' containing the RNA-seq reads in the region defined by the \code{searchArea}
#' argument.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords bam import
#' @examples
#'
#' #Declare searchArea
#' searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))
#'
#' #Relative or full path
#' pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')
#'
#'
#' @export impBamGRL
NULL


#' @rdname import-bam-2
impBamGRL.old <- function(UserDir, searchArea, verbose = TRUE) {
    # Set parameters
    which <- searchArea  #A GRanges, IntegerRangesList, or missing object, from which a IRangesList instance will be constructed.
    what <- scanBamWhat()  #A character vector naming the fields to return. scanBamWhat() returns a vector of available fields. Fields are described on the scanBam help page.
    flag <- scanBamFlag(isUnmappedQuery = FALSE)
    param <- ScanBamParam(flag = flag, which = which, what = what)  #store ScanBamParam in param.

    # Point to correct directory and create a BamFileList object
    bamDir <- normalizePath(UserDir)
    allFiles <- list.files(bamDir, full.names = TRUE)
    bamFiles <- allFiles[grep(".bam$", allFiles)]
    if (length(bamFiles) == 0) {
        stop(paste("No bam files found in", bamDir))
    }
    if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
        if (verbose) {
            cat(paste("The bam files in UserDir are required to also have", ".bam.bai index files.",
                " Trying to run indexBam function on each", "\n"), )
        }
        indexBam(bamFiles)
        if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
            stop("The bam files in UserDir are required to also have", ".bam.bai index files.")
        } else {
            if (verbose) {
                cat(paste("Succesfully indexed all bamFiles in UserDir", UserDir,
                  "\n"))
            }
        }
    }
    # store all the .bam paths in a BamFile.
    bamFilesList <- BamFileList(bamFiles)

    # check that sequences in searchArea are actually found in the bam files
    header <- scanBamHeader(bamFiles)
    checkSeqNameExists <- function(bamHeader, requestedSeqNames) {
        as.character(requestedSeqNames) %in% names(bamHeader[["targets"]])
    }
    if (!all(unlist(lapply(header, checkSeqNameExists, seqnames(searchArea))))) {
        # not all searchArea requested seq-names found in bam files. Create nice error
        # report and stop
        seqNotFoundErrors <- lapply(header, checkSeqNameExists, seqnames(searchArea))
        seqNotFounds <- vector()
        for (sampleName in names(seqNotFoundErrors)) {
            seqNotFounds <- c(seqNotFounds, as.character(seqnames(searchArea)[!seqNotFoundErrors[[sampleName]]]))
        }
        stop(paste("The following seq name(s) not found in the bam files:", paste(sort(unique(seqNotFounds)),
            collapse = ", ")))
    }

    # Loop through, open scanBam, store in GRList and then close each object in the
    # BamFileList object.
    i <- 1
    BamGRL <- GRangesList()
    for (bamName in names(bamFilesList)) {
        # Description
        bf <- bamFilesList[[bamName]]
        open(bf)
        if (verbose) {
            cat(paste("Reading bam file", i, "with filename", basename(bamName)),
                "\n")
        }
        bam <- scanBam(bf, param = param)
        # Description
        for (rangeName in names(bam)) {

            # if NA values your in trouble. That means the read didnt map
            ranges <- IRanges(start = bam[[rangeName]][["pos"]], width = cigarWidthAlongReferenceSpace(bam[[rangeName]][["cigar"]]))
            GRangeBam <- GRanges(seqnames = as.character(bam[[rangeName]][["rname"]]),
                ranges = ranges, strand = bam[[rangeName]][["strand"]], names = bam[[rangeName]][["qname"]],
                flag = bam[[rangeName]][["flag"]], cigar = bam[[rangeName]][["cigar"]],
                mapq = bam[[rangeName]][["mapq"]], mpos = bam[[rangeName]][["mpos"]],
                isize = bam[[rangeName]][["isize"]], seq = bam[[rangeName]][["seq"]],
                qual = bam[[rangeName]][["qual"]])
            # This way of merging the different chromosomes to the same GRangeObject is maybe
            # not the best way. Later try to store them in a separate list, and then unlist
            # before importing to GrangeBam Store GRangeBam in BamGRL (which is the GRange
            # List object)
            if (basename(bamName) %in% names(BamGRL)) {
                BamGRL[[basename(bamName)]] <- c(BamGRL[[basename(bamName)]], GRangeBam)
            } else {
                BamGRL[[basename(bamName)]] <- GRangeBam
            }
        }
        if (verbose) {
            cat(paste("stored", basename(bamName), "in BamGRL"), "\n")
        }
        i <- 1 + i
        gc()
        close(bf)
    }
    return(BamGRL)
}



#'@include ASEset-class.R
NULL

#' realCigarPosition
#'
#' From a GAlignments calculate the real corresponding position for each read
#' based on its cigar.
#'
#' The main intention for these functions are to be the internal functions for
#' \code{scanForHeterozygotes} and \code{getAlleleCount}.
#'
#' @name cigar-utilities
#' @rdname cigar-utilities
#' @aliases cigar-utilities realCigarPosition realCigarPositions
#' realCigarPositionsList
#' @param RleCigar An \code{Rle} containing cigar information
#' @param RleCigarList An \code{RleList} containing cigar information
#' @param BpPos the absolute position on the chromosome of interest
#' @return realCigarPosition returns the new position
#' realCigarPositions returns a vector with the corrected positions to
#' be subsetted from a read.  \code{realCigarPositionsList} returns a list
#' where each element i a vector with the corrected positions to be subsetted
#' from a read.
#' @author Jesper R. Gadin
#' @keywords internal
#' @examples
#'
#'   RleCigarList <-  cigarToRleList('3M4I93M')
#'   BpPos <- 5
#'
#'   newPos <- realCigarPosition.old(RleCigar=RleCigarList[[1]], BpPos)
#'   newPositions <- realCigarPositions.old(RleCigar=RleCigarList[[1]])
#'   newPositionsList <- realCigarPositionsList.old(RleCigarList=RleCigarList)
NULL

#' @rdname cigar-utilities
#' @export
realCigarPosition.old <- function(RleCigar, BpPos) {

    # because of speed issues, checks are best performed outside this function.
    if (!is(RleCigar, "Rle")) {
        stop("RleCigar must an Rle object")
    }

    e <- as.character(RleCigar)

    # changeVector
    v <- rep(0, length = length(e))
    names(v) <- e

    v[e == "M"] <- 1
    v[e == "I"] <- unlist(lapply(runLength(RleCigar)[runValue(RleCigar) == "I"],
        function(x) {
            c(x + 1, rep(1, x - 1))
        }))
    # v[e=='D'] <- 0 #already zero v[e=='N'] <- 0 #already zero

    # sum all until interesting position
    cs <- cumsum(v)

    if (names(cs[BpPos]) == "D") {
        retPos <- 0
    } else if (names(cs[BpPos]) == "N") {
        retPos <- -1
    } else {
        retPos <- cs[BpPos]
        names(retPos) <- NULL
        if (retPos > sum(e == "M" | e == "I")) {
            retPos <- -1  # the position went outside the read
        }
    }
    retPos
}



#' @rdname cigar-utilities
#' @export
realCigarPositions.old <- function(RleCigar) {
    # returns a vector that have order all positions to match with the cigar

    # because of speed issues, checks are best performed outside this function.
    if (!is(RleCigar, "Rle")) {
        stop("RleCigar must be an Rle object")
    }


    e <- as.character(RleCigar)
    # make a new representation vector
    v <- rep(0, length = length(e))
    names(v) <- e

    v[e == "M"] <- 1
    v[e == "I"] <- unlist(lapply(runLength(RleCigar)[runValue(RleCigar) == "I"],
        function(x) {
            c(x + 1, rep(1, x - 1))
        }))
    # v[e=='D'] <- 0 v[e=='N'] <- 0

    # sum all until interesting position
    cs <- cumsum(v)

    cs <- cs[!names(cs) == "D"]
    cs <- cs[!names(cs) == "N"]

	#remove matches overexeeding the length of the read
	cs <- cs[!cs>length(v)]

    cs
}


#' @rdname cigar-utilities
#' @export
realCigarPositionsList.old <- function(RleCigarList) {

    # because of speed issues, checks are best performed outside this function.
    if (!is(RleCigarList, "RleList")) {
        stop("RleCigarList must be an RleList object")
    }

    lapply(RleCigarList, function(RleCigar) {
        e <- as.character(RleCigar)
        # make a new representation vector
        v <- rep(0, length = length(e))
        names(v) <- e

        v[e == "M"] <- 1
        v[e == "I"] <- unlist(lapply(runLength(RleCigar)[runValue(RleCigar) == "I"],
            function(x) {
                c(x + 1, rep(1, x - 1))
            }))
        # v[e=='D'] <- 0 v[e=='N'] <- 0

        # sum all until interesting position
        cs <- cumsum(v)

        cs <- cs[!names(cs) == "D"]
        cs <- cs[!names(cs) == "N"]


		#remove matches overexeeding the length of the read
		cs <- cs[!cs>length(v)]

        cs
    })
}

#####
# Kept for performance comparions
# will be removed in short
#####
#' scanForHeterozygotes-old
#'
#' Identifies the positions of SNPs found in BamGR reads.
#'
#' This function scans all reads stored in a \code{GAlignmentsList} for
#' possible heterozygote positions. The user can balance the sensitivity of the
#' search by modifying the minimumReadsAtPos, maximumMajorAlleleFrequency and
#' minimumBiAllelicFrequency arguments.
#'
#' @rdname scanForHeterozygotes-old
#' @param BamList A \code{GAlignmentsList object}
#' @param minimumReadsAtPos minimum number of reads required to call a SNP at a
#' given position
#' @param maximumMajorAlleleFrequency maximum frequency allowed for the most
#' common allele. Setting this parameter lower will minimise the SNP calls
#' resulting from technical read errors, at the cost of missing loci with
#' potential strong ASE
#' @param minimumBiAllelicFrequency minimum frequency allowed for the first and
#' second most common allele. Setting a Lower value for this parameter will
#' minimise the identification of loci with three or more alleles in one
#' sample. This is useful if sequencing errors are suspected to be common.
#' @param maxReads max number of reads of one list-element allowed
#' @param verbose logical indicating if process information should be displayed
#' @return \code{scanForHeterozygotes.old} returns a GRanges object with the SNPs
#' for the BamList object that was used as input.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{getAlleleCounts}} which is a
#' function that count the number of reads overlapping a site.  }
#' @keywords scan SNP heterozygote
#' @examples
#'
#' data(reads)
#' s <- scanForHeterozygotes.old(reads,verbose=FALSE)
#'
#' @export scanForHeterozygotes.old
scanForHeterozygotes.old <- function(BamList, minimumReadsAtPos = 20, maximumMajorAlleleFrequency = 0.9,
    minimumBiAllelicFrequency = 0.9, maxReads = 15000, verbose = TRUE) {

    # if just one element of, make list (which is a convenient way of handling this
    # input type)
    if (is(BamList, "GAlignments")) {
        BamList <- GAlignmentsList(BamList)
    }
    if (is(BamList, "GRanges")) {
        BamList <- GRangesList(BamList)
    }

    if (!is.numeric(minimumReadsAtPos))
        stop(paste("minimumReadsAtPos must be a numeric vector, not a", class(minimumReadsAtPos)))
    if (length(minimumReadsAtPos) != 1)
        stop(paste("minimumReadsAtPos must be of length 1, not", length(minimumReadsAtPos)))
    if (!is.numeric(maximumMajorAlleleFrequency))
        stop(paste("maximumMajorAlleleFrequency must be a numeric vector, not a", class(maximumMajorAlleleFrequency)))
    if (length(maximumMajorAlleleFrequency) != 1)
        stop(paste("maximumMajorAlleleFrequency must be of length 1, not", length(maximumMajorAlleleFrequency)))
    if (maximumMajorAlleleFrequency < 0 | maximumMajorAlleleFrequency > 1)
        stop("maximumMajorAlleleFrequency must be between 0 and 1")
    if (!is.numeric(minimumBiAllelicFrequency))
        stop(paste("minimumBiAllelicFrequency must be a numeric vector, not a", class(minimumBiAllelicFrequency)))
    if (length(minimumBiAllelicFrequency) != 1)
        stop(paste("minimumBiAllelicFrequency must be of length 1, not", length(minimumBiAllelicFrequency)))
    if (minimumBiAllelicFrequency < 0 | maximumMajorAlleleFrequency > 1)
        stop("minimumBiAllelicFrequency must be between 0 and 1")
    if (!is.logical(verbose))
        stop(paste("verbose must be a logical, not a", class(verbose)))
    if (length(verbose) != 1)
        stop(paste("verbose must be of length 1, not", length(verbose)))

    # checking that BamList format is ok (has to be done quite carefully for the
    # list-class gappedAlignments
    if (is(BamList, "GRangesList"))
        stop("The use of GRangesList is not recommended. Use BamImpGAList or BamImpGAPList")
    if (!is(BamList, "GAlignmentsList"))
        stop("BamList has to be a GAlignmentsList object")

    # checks specific for GAlignments
    if (all(vapply(BamList, is, logical(1), "GAlignments"))) {
        if (!all(unlist(lapply(BamList, function(x) {
            all(c("cigar", "qwidth") %in% colnames(mcols(x)))
        })))) {
            stop("BamList given as GAlignmentsLists of GAlignments objects must contain mcols named qwidth and cigar")
        }
    }

    # check that we dont create a too large and memory-consuming matrix
    if (sum(unlist(lapply(BamList, length)) > maxReads) > 0) {
        stop("you may consume too much memory. If there is plenty of memory, then increase maxReads to allow more reads")
    }

    ans <- GRanges()
    chromosomeLevels <- unique(unlist(lapply(BamList, function(x) {
        levels(droplevels(runValue(seqnames(x))))
    })))

    for (chr in chromosomeLevels) {
        if (verbose)
            cat(paste("Investigating chromosome", chr), "\n")

        BamListchr <- GAlignmentsList(mapply(function(x, y) {
            x[y]
        }, BamList, seqnames(BamList) == chr))


        for (sample in 1:length(BamListchr)) {
            if (verbose)
                cat(paste("Investigating sample", sample), "out of", length(BamListchr),
                  "\n")

            # extract samples
            BamListHere <- BamListchr[[sample]]

            if (!(length(BamListHere) == 0)) {

                # then iterate over all reads
                cigarRle <- cigarToRleList(mcols(BamListHere)[, "cigar"])
                toKeep <- realCigarPositionsList.old(cigarRle)

                seq <- mcols(BamListHere)[, "seq"]
                charList <- strsplit(as.character(seq), "")

                start <- start(BamListHere) - min(start(BamListHere)) + 1

                nw <- max(end(BamListHere)) - min(start(BamListHere)) + 2

                # populate matrix
                new <- matrix(NA, nrow = max(end(BamListHere)) - min(start(BamListHere)) +
                  1, ncol = length(BamListHere))
                for (i in 1:ncol(new)) {
                  new[start[i]:(start[i] + length(toKeep[[i]]) - 1), i] <- charList[[i]][toKeep[[i]]]

                }

                # set rownames
                rownames(new) <- as.character(1:(nw - 1))

                new <- new[apply(!is.na(new), 1, sum) > minimumReadsAtPos, ]

                if (!nrow(new) == 0) {

                  # tabulate countsPerPosition (cpp)
                  cpp <- apply(new, 1, table)

                  TFl <- unlist(lapply(cpp, function(x) {
                    if (length(x) > 1) {

                      MajorAlleleFrequency <- x[order(x, decreasing = TRUE)[1]]/sum(x)
                      if (MajorAlleleFrequency < maximumMajorAlleleFrequency) {
                        MinorAlleleFrequency <- x[order(x, decreasing = TRUE)[2]]/sum(x)
                        if ((MinorAlleleFrequency + MajorAlleleFrequency) > minimumBiAllelicFrequency) {
                          TRUE
                        } else {
                          FALSE
                        }
                      } else {
                        FALSE
                      }
                    } else {
                      FALSE
                    }
                  }))
                  if (!all(!TFl)) {
                    GR <- GRanges(ranges = IRanges(start = (as.numeric(names(cpp[TFl])) +
                      min(start(BamListHere)) - 1), width = 1), seqnames = chr)
                    ans <- c(ans, GR)
                  }
                }
            }
        }
    }
    # merge from all individuals
    ans <- unique(ans)

    # Add a Snp name based on position
    if (!(length(ans) == 0)) {
        names(ans) <- paste("chr", seqnames(ans), "_", start(ans),
            sep = "")

    }
    return(ans)
}


#' implode list of arguments into environment
#'
#' apply on list of variables to be put in the local environment
#'
#' help the propagation of e.g. graphical paramters
#'
#' @rdname implodeList-old
#' @param x list of variables
#' @author Jesper R. Gadin
#' @keywords implode
#' @examples
#'
#' lst <- list(hungry='yes', thirsty='no')
#' implodeList.old(lst)
#' #the check ls()
#'  ls()
#' @export implodeList.old
implodeList.old <- function(x) {
    oname <- deparse(substitute(x))
    eval(parse(text = paste0("for(i in 1:length(", oname, ")){assign(names(", oname,
        ")[i],", oname, "[[i]])}")), parent.frame())
}

#' detectAI
#' 
#' detection of AllelicImbalance 
#' 
#' threshold.frequency is the least fraction needed to classify as bi tri or
#' quad allelic SNPs. If 'all' then all of bi tri and quad allelic SNPs will use the same
#' threshold. Everything under the treshold will be regarded as noise. 'all' will return 
#' a matrix with snps as rows and uni bi tri and quad will be columns. For this function
#' Anything that will return TRUE for tri-allelicwill also return TRUE for uni and bi-allelic
#' for the same SNP an Sample. 
#'
#' return.type 'ref' return only AI when reference allele is more expressed. 'alt' return only
#' AI when alternative allele is more expressed or 'all' for both 'ref' and 'alt' alleles.
#' Reference allele is the one present in the reference genome on the forward strand.
#'
#' threshold.delta.frequency and function.test will use the value in mapBias(x) as expected value. 
#' 
#' function.test will use the two most expressed alleles for testing. Make therefore sure there
#' are no tri-allelic SNPs or somatic mutations among the SNPs in the ASEset. 
#' 
#' inferGenotype(), set TRUE it should be used with as much samples as possible. If you split up the
#' samples and run detectAI() on each sample separately, please make sure you have inferred 
#' the genotypes in before hand, alternatively used the genotypes detected by another variantCaller
#' or chip-genotypes. Use ONLY biallelic genotypes.
#'
#' @name detectAI
#' @rdname detectAI
#' @aliases detectAI
#' detectAI,ASEset-method 
#' @docType methods
#' @param x ASEset
#' @param strand strand to infer from
#' @param threshold.count.sample least amount of counts to try to infer allele
#' @param threshold.frequency least fraction to classify (see details)
#' @param return.class class to return (atm only class 'logical')
#' @param threshold.delta.frequency minimum of frequency difference 
#' from 0.5 (or mapbias adjusted value)
#' @param threshold.pvalue pvalue over this number will be filtered out
#' @param function.test At the moment the only available option is 'binomial.test'
#' @param inferGenotype infer genotypes based on count data in ASEset object
#' @param random.ref set the reference as random if you dont know. Affects interpretation of results.
#' @param verbose makes function more talkative
#' @param gc use garbage collection when possible to save space
#' @param biasMatrix use biasMatrix in ASEset, or use default expected frequency of 0.5 for all sites
#' @param ... internal arguments 
#' @author Jesper R. Gadin
#' @keywords detection
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' dai <- detectAI(a)
#' 
#'
#' @export
setGeneric("detectAI", function(x, ...){
    standardGeneric("detectAI")
})

#' @rdname detectAI
#' @export
setMethod("detectAI", signature(x = "ASEset"), function(x, 
	return.class = "DetectedAI", strand = "*",
	threshold.frequency=0, threshold.count.sample=1,
	threshold.delta.frequency=0, threshold.pvalue=0.05,
	inferGenotype=FALSE,
	random.ref=FALSE,
	function.test="binom.test",
	verbose=TRUE,
	gc=FALSE, biasMatrix=FALSE) {

	if(inferGenotype){
		genotype(x) <- inferGenotypes(x,threshold.frequency = 0.05, return.allele.allowed ="bi")
	}
	#check for presence of genotype data
    if (!("genotype" %in% assayNames(x))) {
		stop(paste("genotype matrix is not present as assay in",
				   " ASEset object, see '?inferGenotypes' ",
				   "or set 'inferGenotypes=TRUE'"))
    }

	if(!random.ref){
		if(!("ref" %in% colnames(mcols(x)))){
			stop("column name 'ref' in mcols(x) is required")
		}
	}else{
		mcols(x)[,"ref"] <- randomRef(x)
	}

	#1) make refFreq array (third dim has length 1 and softest condition)
	if(verbose){cat("calculating reference fractions\n")}
	fr <- fraction(x, strand=strand,
				top.fraction.criteria="ref",
				threshold.count.sample = 1)

	#2) make t.c.s array
	if(verbose){cat("checking count thresholds\n")}
	acounts <- alleleCounts(x, strand=strand, return.class="array")
	#acounts[array(!hetFilt(x), dim=c(nrow(x), ncol(x), 4))] <- 0  # unnecessary het is checked from fraction later
	allele.count.tot <- apply(acounts, c(1,2), sum)
	t.c.s  <- !array(allele.count.tot,dim=c(nrow(x),ncol(x),length(threshold.count.sample))) < 
					aperm(array(threshold.count.sample,
						dim=c(length(threshold.count.sample),nrow(x),ncol(x) )),
					c(2,3,1))
	dimnames(t.c.s) <- list(rownames(fr),colnames(fr),paste(threshold.count.sample))

	if(gc){
		if(verbose){cat("removing and garbage collect temporary variables\n")}
		rm(acounts,allele.count.tot)
		gc()
	}

	#3) make thr.req array (if TRUE it fullfills the condition)
	if(verbose){cat("checking frequency thresholds\n")}
	newDims <- length(threshold.frequency)
	thr.fr.freq <- array(fr,dim=c(nrow(x),ncol(x),newDims))
	thr.freq <- aperm(array(threshold.frequency, dim=c(newDims,nrow(x),ncol(x))),c(2,3,1))

	thr.freq.ret <- !(thr.fr.freq < thr.freq | thr.fr.freq > (1-thr.freq))
	dimnames(thr.freq.ret) <- list(rownames(fr),colnames(fr),paste(threshold.frequency))

	if(gc){
		if(verbose){cat("removing and garbage collect temporary variables\n")}
		rm(newDims, thr.fr.freq, thr.freq)
		gc()
	}

	#4) delta freq array 
	if(verbose){cat("checking delta frequency thresholds\n")}

	if(biasMatrix){
		biasmatRef <- mapBiasRef(x)
	}else{
		biasmatRef <- matrix(0.5, ncol=ncol(x), nrow=nrow(x))
	}

	fr2 <- fr
	fr2[is.na(fr2)] <- biasmatRef[is.na(fr2)] 

	#make fr2 and biasmatRef to array dim 3
	newDims <- length(threshold.delta.frequency)

	t.d.f <- aperm(array(threshold.delta.frequency, dim=c(newDims,ncol(x),nrow(x))),dim=c(3,2,1))

	#to keep1 (fullfills cond min.delta.freq)
	#if(any(fr2<biasmatRef)){
	#	#fr3 <- fr2
	#	#fr3[fr2<biasmatRef] <- biasmatRef[fr2<biasmatRef] - fr2[fr2<biasmatRef]
	#	#fr3[fr2<=biasmatRef] <- 1	
	#	#reset the NA again
	#	#fr3[is.na(fr)] <- NA
	#	#make 3d array return object 
	#	#fr3 <- array(fr3,dim=c(nrow(x),ncol(x),newDims))
	#	#tf.keep1 <- !(fr3 < t.d.f)
	#	tf.not.keep1 <- !array(abs(fr2-biasmatRef),dim=c(nrow(x),ncol(x),newDims)) > t.d.f

	#}else{
	#	#set all FALSE (NAs will not be kept )
	#	tf.keep1 <- matrix(FALSE,ncol=ncol(fr),nrow=nrow(fr))
	#	#tf.keep1[is.na(fr)] <- NA
	#	#make 3d array return object 
	#	tf.not.keep1 <- !array(tf.keep1,dim=c(nrow(x),ncol(x),newDims))
	#}

	##to keep2 (fullfills cond min.delta.freq)
	#if(any(fr2>biasmatRef)){
	#	#fr3 <- fr2
	#	##fr3[fr2>biasmatRef] <- fr[fr2>biasmatRef] - biasmatRef[fr2>biasmatRef] 
	#	#fr3[fr2>biasmatRef] <- fr[fr2>biasmatRef] - biasmatRef[fr2>biasmatRef] 
	#	#fr3[fr2<=biasmatRef] <- 1	
	#	##fr3[is.na(fr)] <- NA
	#	##make 3d array return object 
	#	#fr3 <- array(fr3,dim=c(nrow(x),ncol(x),newDims))
	#	#tf.keep2 <- !(fr3 < t.d.f)
	#	tf.not.keep1 <- !array((fr2-biasmatRef),dim=c(nrow(x),ncol(x),newDims)) > t.d.f
	#}else{
	#	#set all FALSE (NAs will not be kept )
	#	tf.keep2 <- matrix(TRUE,ncol=ncol(fr),nrow=nrow(fr))
	#	#tf.keep2[is.na(fr)] <- NA
	#	#make 3d array return object 
	#	tf.not.keep2 <- !array(tf.keep2,dim=c(nrow(x),ncol(x),newDims))
	#}
	
	tf.keep <- array(abs(fr2-biasmatRef),dim=c(nrow(x),ncol(x),newDims)) >= t.d.f

	#delta.freq <- tf.not.keep1 | tf.not.keep2
	delta.freq <- tf.keep
	dimnames(delta.freq) <- list(rownames(fr),colnames(fr),1:length(threshold.delta.frequency))
	#delta.freq[is.na(fr)] <- NA

	if(gc){
		if(verbose){cat("removing and garbage collect temporary variables\n")}
		rm(fr2, biasmatRef, tf.keep, newDims)
		gc()
	}

	#5)  p-value array
	if(verbose){cat("checking p-value thresholds\n")}
	if(function.test=="binom.test"){
		idx <- which(!is.na(fr))
		arn <- arank(x,return.type="names",return.class="matrix") 
		ac <- alleleCounts(x, strand=strand, return.class="array")

		mat1 <- matrix(aperm(ac,c(3,2,1))[aperm(array(matrix(x@variants, ncol=length(x@variants),
			 nrow=nrow(x), byrow=TRUE)==arn[,1]
		 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
		],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))

		mat2 <- matrix(aperm(ac,c(3,2,1))[aperm(array(matrix(x@variants, ncol=length(x@variants),
			 nrow=nrow(x), byrow=TRUE)==arn[,2]
		 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
		],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))


		allele1 <- mat1[idx] 
		allele2 <- mat2[idx]

		#test the two most expressed alleles
		biasmat1 <- matrix(aperm(mapBias(x, return.class="array"),c(3,2,1))[aperm(array(matrix(
			x@variants, ncol=length(x@variants),
			 nrow=nrow(x), byrow=TRUE)==arn[,1]
		 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
		],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))


		biasAllele1 <- biasmat1[idx] 
		
		#maybe put a check here later that bias1 and bias2 sum to 1

		ml <- mapply(allele1,allele2,biasAllele1,FUN=function(x,y,z){
			binom.test(c(x,y), p = z)[[3]]
		})

		#cerate matrix in same size as fr	
		pv <- fr	
		pv[idx] <- ml
		#replace na with 1
		pv[is.na(fr)] <- 1
		

		#make pv array
		pv <- array(pv,dim=c(nrow(fr), ncol(fr),length(threshold.pvalue)),
					dimnames=list(rownames(fr),colnames(fr),paste(threshold.pvalue)))

		#filter
		newDims <- length(threshold.pvalue)
		pv.thr <- aperm(array(threshold.pvalue, dim=c(newDims,nrow(x),ncol(x))), c(2,3,1))
		pv.thr.ret <- pv <= pv.thr
	
		if(gc){
			if(verbose){cat("removing and garbage collect temporary variables\n")}
			rm(idx,arn,ac,mat2,mat1,allele1,allele2,biasmat1,biasAllele1,ml,pv,newDims,pv.thr)
			gc()
		}

	}else{stop("function.test must be binom.test")}

	if(return.class=="DetectedAI"){

		#make DetectedAI object
		if(verbose){cat("creating DetectedAI object\n")}
		DetectedAIFromArray(
			x, 
			strand=strand,
			reference.frequency=fr,
			threshold.frequency=thr.freq.ret,
			threshold.count.sample=t.c.s,
			threshold.delta.frequency=delta.freq,
			threshold.pvalue=pv.thr.ret,

			#reference.frequency.names=reference.frequency,
			threshold.frequency.names=paste(threshold.frequency),
			threshold.count.sample.names=paste(threshold.count.sample),
			threshold.delta.frequency.names=paste(threshold.delta.frequency),
			threshold.pvalue.names=paste(threshold.pvalue)

		)

	}else if(return.class=="list"){
		stop("return.class list as option is not available atm")
	}else{
		stop(paste("return.class",return.class,"as option is not available"))
	}

})

##the draft of the function giving us a fastq file for all samples to detect mapbias
#
##' simulate reads from ASEset
##' 
##' simulate reads
##' 
##' to compensate for reference genome mapping bias
##' 
##' @param x ASEset
##' @param reads number of reads to create
##' @param refPath reference genome path
##' @param read.length length of reads
##' @param PE paired-end reads, TRUE or FALSE
##' @param insert.size Nr bases separating the two reads, only if PE=TRUE 
##' @param insert.sd standard deviation for the insert.size
##' @author Jesper R. Gadin
##' @keywords infer
##' @examples
##' 
##' data(ASEset)
##' g <- makeMapBiasReads(ASEset)
##' 
##' @export makeMapBiasReads
#
#makeMapBiasReads <- function(x, reads=100, refPath, read.length=100, PE=FALSE, insert.size=-30, insert.sd=1){
#
#	#tmp ref file
#
#
#	#the output will be a GRanges or GrangesList  with reads
#
#	# x is of ASEset class
#	# reads are the numeber of simulated reads for each variant
#	# ref is the reference genome used
#
#	#require
#	require(Rsamtools)
#
#	#no junctions(if junctions we need txdb)
#	searchArea.ref <- rowRanges(x) + read.length-1
#
#	#make FaFile
#	fl <- FaFile("hg19.fa")
#
#	#check if the index file is present otherwise tell the user to use the indexFa(FaFile("pathToReference")) command
#	if(list.files("placeholder", pattern=paste("*",ref,".fai",sep=""))){
#		indexFa(FaFile("pathToReference"))
#	}
#	#IMPORTANT! The  index command only needs to be executed once
#	#indexFa(fl) #creates a new file as index in the same directory but with extension *.fai 
#
#	#open,scan,close file
#	open(fl)
#	ref <- scanFa(fl,param=rowRanges(x))
#	seq <- scanFa(fl,param=searchArea.ref)
#	close(fl)
#	
#
#
#	#do it for one sample at the time
#	if(PE){
#		#for each snp find all neighbouring snps to that one (all within read size)
#		#and which of these are different from the ref genome?
#		for(i in 1:nrow(x)){
#			hits <- findOverlaps(rowRanges(x)[i]+read.length, rowRanges(x))				
#			#here we need the functionality to store the genotype information for each 
#		       	#snp. So while doing that, I might already plan to include all genotypes and their ranges in a slot that. It would be some kind of transposed colData table. In the end the genotypes for RNA-seqenced allele we can store in an assay	
#			(x)
#		}
#	}
#}



##construct the paried data table
##known phases
#phaseA <- c("TGACT")
#phaseB <- c("CTTGA")
#
##known pairs, and known phase
#pairA <- c("TG","GA","AC","CT")
#pairB <- c("CT","TT","TG","GA")
#
##known pairs, but unknown phase
##X and Y can be seen as temporary phases)
##that the pairs have randomly been located to
##but kepping the location information for each pair
#pairX <- c("TG","TT","AC","CT")
#pairY <- c("CT","GA","TG","GA")
#
##split pair
#pairX.split <- unlist(strsplit(pairX,split="",fixed=TRUE))
#pairY.split <- unlist(strsplit(pairY,split="",fixed=TRUE))
#
##first position in pair
#px1 <- pairX.split[seq.int(1L,length(pairX.split),2L)]
#py1 <- pairY.split[seq.int(1L,length(pairY.split),2L)]
##remove first pair
#px1 <- px1[-1]
#py1 <- py1[-1]
#
##second position in pair
#px2 <- pairX.split[seq.int(2L,length(pairX.split),2L)]
#py2 <- pairY.split[seq.int(2L,length(pairY.split),2L)]
##remove first pair
#px2 <- px2[-c(length(px2))]
#py2 <- py2[-c(length(py2))]
#
##split pairs tables in array (third dimension is for each pair)
#snpPairs <- length(px1)
#ar <- array(c(px2,py2,px2,py2,px1,py1,py1,px1),dim=c(snpPairs,4,2))
#ar <- aperm(ar,c(2,3,1))
#
##check which pairs belong to eachother
#w <- which(ar[,1,] ==ar[,2,]
#)
#
##take out odd numbers which reflects the X strand and then the Y strand (even numbers)
#X <- w[w %% 2!=0]
#Y <- w[w %% 2==0]
#
##move all numbers down to baseline 1-4
#X2 <- X-seq(0,length(X)*3,4)
#Y2 <- X-seq(0,length(Y)*3,4)
#
##compensate for the disorder when one pair was not one the X template
#Rl <- Rle(X2)
#v <- X2
#v[v == 3 ] <- unlist(lapply(runLength(Rl)[runValue(Rl) == 3 ], 
#        function(x) {
#            c(3, rep(1, x - 1))
#        }))
#X2 <- v
#
##phase genotype 1 is same as X template 3 is same as Y Template (X always starts with 1 or TRUE)
#X.TF <- c(TRUE,X2==1)
#X.Ph <- pairX
#X.Ph[!X.TF] <- pairY[!X.TF]
#
##validate to the known phase
#identical(X.Ph,pairA)
#

#'@include ASEset-class.R
NULL


#' lva
#' 
#' make an almlof regression for arrays
#' 
#' internal method that takes one array with results from regionSummary
#' and one matrix with group information for each risk SNP (based on phase)
#'
#' @name lva
#' @rdname lva
#' @aliases lva,array-method
#' @docType methods
#' @param x ASEset object with phase and 'ref'/'alt' allele information
#' @param rv RiskVariant object with phase and 'ref'/'alt' allele information
#' @param region RiskVariant object with phase and alternative allele information
#' @param settings RiskVariant object with phase and alternative allele information
#' @param return.class 'LinkVariantAlmlof' (more options in future)
#' @param verbose logical, if set TRUE, then function will be more talkative
#' @param type "lm" or "nlme", "nlme" needs subject information
#' @param covariates add data.frame with covariates (only integers and numeric)
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#' 
#' data(ASEset) 
#' a <- ASEset
#' # Add phase
#' set.seed(1)
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#' 
#' phase(a) <- p
#' 
#' #add alternative allele information
#' mcols(a)[["alt"]] <- inferAltAllele(a)
#' 
#' #init risk variants
#' p.ar <- phaseMatrix2Array(p)
#' rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p.ar)
#'
#' #colnames has to be samea and same order in ASEset and RiskVariant
#' colnames(a) <- colnames(rv)
#'
#' # in this example each and every snp in the ASEset defines a region
#' r1 <- granges(a)
#' 
#' #use GRangesList to merge and use regions defined by each element of the
#' #GRangesList
#' r1b <- GRangesList(r1)
#' r1c <- GRangesList(r1, r1)
#'
#' # in this example two overlapping subsets of snps in the ASEset defines the region
#' r2 <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))
#'
#' # link variant almlof (lva)
#' lva(a, rv, r1)
#' lva(a, rv, r1b)
#' lva(a, rv, r1c)
#' lva(a, rv, r2)
#'
#' # Use covariates (integers or nuemric)
#' cov <- data.frame(age=sample(20:70, ncol(a)), sex=rep(c(1,2), each=ncol(a)/2),  
#' row.names=colnames(a))
#' lva(a, rv, r1, covariates=cov)
#' lva(a, rv, r1b, covariates=cov)
#' lva(a, rv, r1c, covariates=cov)
#' lva(a, rv, r2, covariates=cov)
#'
#' # link variant almlof (lva), using nlme
#' a2 <- a
#' ac <- assays(a2)[["countsPlus"]]
#' jit <- sample(c(seq(-0.10,0,length=5), seq(0,0.10,length=5)), size=length(ac) , replace=TRUE)
#' assays(a2, withDimnames=FALSE)[["countsPlus"]] <- round(ac * (1+jit),0)
#' ab <- cbind(a, a2)
#' colData(ab)[["subject.group"]] <- c(1:ncol(a),1:ncol(a))
#' rv2 <- rv[,c(1:ncol(a),1:ncol(a))]
#' colnames(ab) <- colnames(rv2)
#'
#' lva(ab, rv2, r1, type="nlme")
#' lva(ab, rv2, r1b, type="nlme")
#' lva(ab, rv2, r1c, type="nlme")
#' lva(ab, rv2, r2, type="nlme")
#'
#' 
NULL

#' @rdname lva
#' @export
setGeneric("lva", function(x, ... 
	){
    standardGeneric("lva")
})

#' @rdname lva
#' @export
setMethod("lva", signature(x = "ASEset"),
		function(x, rv, region, settings=list(),
				 return.class="LinkVariantAlmlof", type="lm",
				 verbose=FALSE, covariates=matrix(),  ...
	){

		#safety check
		if(any(!colnames(x) %in% colnames(rv)) | any(!colnames(rv) %in% colnames(x)))
				stop("missmatch of colnames for x and rv")

		if("threshold.distance" %in% names(settings)){
			distance <- settings[["threshold.distance"]]
		}else{
			distance <- 200000
		}
		#if(nrow(covariates)==ncol(x)){stop("nrow(covariates) must match ncol(x)")}

		#region summary
		rs <- regionSummary(x, region)


		#match riskVariant to rs granges
		hits <- findOverlaps(rv, granges(rs) + distance)
		#stop if no overlap
		if(length(hits)==0){stop(paste("no rs and rv are close with distance: ",distance, sep=""))}
		#if overlap, then subset hits
		rs2 <- rs[subjectHits(hits)]
		rv2 <- rv[queryHits(hits),, drop=FALSE]
		#make groups for regression based on (het hom het)
		grp <- .groupBasedOnPhaseAndAlleleCombination(phase(rv2, return.class="array")[,,c(1, 2), drop=FALSE])
		plotGroups <- .lvaGroups(mcols(rv2)[["ref"]], mcols(rv2)[["alt"]])
		#call internal regression function	
		if(type=="lm"){
			mat <- lva.internal(x = assays(rs2)[["rs1"]], grp = grp, element = 3, 
								type=type, covariates=covariates)
		}else if(type=="nlme"){
			#covariates have not been implemented completely
			mat <- lva.internal(x = assays(rs2)[["rs1"]], grp = grp, element = 3, type=type, 
								subject=colData(rs2)[["subject.group"]], covariates=covariates)
		}

		#make txSNP specific lva test
		rs2 <- .addLva2ASEset(rs2, grp, type=type, covariates=covariates)

		#create return object
		if(return.class=="LinkVariantAlmlof"){
			sset <- SummarizedExperiment(
						assays = SimpleList(rs1=assays(rs2)[["rs1"]], lvagroup=grp), 
						colData = colData(rs2),
						rowRanges = granges(rs2))

			rownames(sset) <- rownames(rs2)
			mcols(sset)[["RiskVariantMeta"]] <- DataFrame(GR=granges(rv2), rsid=rownames(rv2))
			mcols(sset)[["RiskVariantMetaFull"]] <- rv2
			mcols(sset)[["LMCommonParam"]] <- DataFrame(mat, row.names=NULL)
			mcols(sset)[["LvaPlotGroups"]] <- DataFrame(plotGroups, row.names=NULL)

			#create an object with results
			new("LinkVariantAlmlof", sset,
				meta = list()
			)
		}
})


### -------------------------------------------------------------------------
### helpers for lva
###

#send in an array rows=SNPs, cols=sampels, 3dim=phase with maternal as el. 1 and paternal as el. 2)
#returns a matrix with three groups, het A/B =1, hom (A/A, B/B) =2 and het B/A =3
.groupBasedOnPhaseAndAlleleCombination <- function(ar){
		grp <- matrix(2, nrow=dim(ar)[1], ncol=dim(ar)[2])
		grp[(ar[,,1] == 1) & (ar[,,2] == 0)] <- 1                             	
		grp[(ar[,,1] == 0) & (ar[,,2] == 1)] <- 3
		grp
}


.lvaGroups <- function(ref, alt){
		fir <- paste(alt,"|", ref, sep="")
		sec <- paste(ref,"|", ref, " AND ",alt,"|", alt, sep="")
		thi <- paste(ref,"|", alt, sep="")

		matrix(c(fir, sec, thi), ncol=3)
}

.addLva2ASEset <- function(rs2, grp, type, covariates=matrix()){
		lst <- mcols(rs2)[["ASEsetMeta"]][[1]]
		for(i in 1:length(lst)){
		  fr <- assays(lst[[i]])[["matfreq"]]
		  grp2 <- grp[i,]
		  if(type=="lm"){ 
				  lmcomparam <- .lvaRegressionReturnCommonParamMatrixTxSNPspecific(fr,grp2, covariates)
		  }else if(type=="nlme"){
				  subj <- colData(rs2)[["subject.group"]]
				  lmcomparam <- .lvaRegressionReturnCommonParamMatrixTxSNPspecific.nlme(fr,grp2, subj)
		  }
		  mcols(mcols(rs2)[["ASEsetMeta"]][[1]][[i]])[["lmcomparam"]] <- DataFrame(lmcomparam)
		}
		rs2
}


#' lva.internal
#' 
#' make an almlof regression for arrays (internal function)
#' 
#' internal method that takes one array with results from regionSummary
#' and one matrix with group information for each risk SNP (based on phase).
#' Input and output objects can change format slightly in future.
#'
#' @name lva.internal
#' @rdname lva.internal
#' @aliases lva.internal,array-method
#' @docType methods
#' @param x regionSummary array phased for maternal allele
#' @param grp group 1-3 (1 for 0:0, 2 for 1:0 or 0:1, and 3 for 1:1)
#' @param element which column in x contains the values to use with lm.
#' @param type which column in x contains the values to use with lm.
#' @param subject which samples belongs to the same individual
#' @param covariates add data.frame with covariates (only integers and numeric)
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#' 
#' data(ASEset) 
#' a <- ASEset
#' # Add phase
#' set.seed(1)
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#' 
#' phase(a) <- p
#' 
#' #add alternative allele information
#' mcols(a)[["alt"]] <- inferAltAllele(a)
#' 
#' # in this example two overlapping subsets of snps in the ASEset defines the region
#' region <- split(granges(a)[c(1,2,2,3)], c(1,1,2,2))
#' rs <- regionSummary(a, region, return.class="array", return.meta=FALSE)
#'
#' # use  (change to generated riskSNP phase later)
#' phs <- array(c(phase(a,return.class="array")[1,,c(1, 2)], 
#'				 phase(a,return.class="array")[2,,c(1, 2)]), dim=c(20,2,2))
#' grp <- matrix(2, nrow=dim(phs)[1], ncol=dim(phs)[2])		 
#' grp[(phs[,,1] == 0) & (phs[,,2] == 0)] <- 1
#' grp[(phs[,,1] == 1) & (phs[,,2] == 1)] <- 3

#' #only use mean.fr at the moment, which is col 3
#' lva.internal(x=assays(rs)[["rs1"]],grp=grp, element=3)
#' 
NULL

#' @rdname lva.internal
#' @export
setGeneric("lva.internal", function(x, ... 
	){
    standardGeneric("lva.internal")
})

#' @rdname lva.internal
#' @export
setMethod("lva.internal", signature(x = "array"),
		function(x, grp, element=3, type="lm", subject=NULL, covariates=matrix(), ...
	){
		
		#unlist(.lvaRegressionPvalue(x, grp, element))
		#normal regression
		if(type=="lm"){
			.lvaRegressionReturnCommonParamMatrix(ar=x, grp, element, covariates=covariates)
		#mixed models lme4 regression
		} else if(type=="nlme"){
			if(!is.null(subject)){
			.lvaRegressionReturnCommonParamMatrix.nlme(ar=x, grp, subject, element)
			#.lvaRegressionReturnCommonParamMatrix.nlme(ar, grp, subject, element)
			}else{
				stop("subject cannot be null when using nlme method")
			}
		}else{
				stop("type version not specified")
		}

})

### -------------------------------------------------------------------------
### helpers for lva.internal
###

# input ar array 1d=SNP, 2d=samples, 3d=variable
# input grp matrix with group 1 2 3. 2d=samples, 1d=SNP
# lapply over each snp and make regression over variable element based on grp
# output is a list with one result for each SNP
.lvaRegressionPvalue <- function(ar, grp, element){
	lapply(1:dim(ar)[1], function(i, y, x){
				summary(lm(y[i, ,element]~x[, i]))$coefficients[2, 4]
		}, y=ar, x=grp)
}



.lvaRegressionReturnCommonParamMatrix <- function(ar, grp, element, covariates){

	mat <- matrix(NA, ncol=dim(ar)[3], nrow=nrow(ar))
	nocalc <- apply(ar[,,3, drop=FALSE], 1, function(x){sum(!(is.na(x)))==0})

	#use covariates if they exist
	cov2 <- covariates
	if(!length(covariates)==1){
	  if(!ncol(grp)==nrow(covariates)) stop("grp and cov has to be same length")
	  #cov2 <-covariates[!nocalc,drop=FALSE,] #nocalc is for SNPs not samples
	}

	#only make regression if there is at least one row possible to compute
	if(any(!nocalc)){
		mat[!nocalc,] <- t(sapply(which(!nocalc), function(i, y, x, c){
						mat2 <- matrix(NA, ncol=2, nrow=4)
						covform <- paste(colnames(c), collapse="+")
						if(!length(c)==1) form <- formula(paste("y2~x2",covform, sep="+"))
						if(length(c)==1) form <- formula("y2~x2")
						df <- cbind(c, data.frame(y2=y[i, ,element], x2=x[i, ]))
						s <-summary(lm(form, data=df))$coefficients
						mat2[,1:2] <- s[rownames(s) %in% c("(Intercept)","x2"),]
						c(mat2)
					}, y=ar[!nocalc,,,drop=FALSE], x=grp[!nocalc,,drop=FALSE], c=cov2))
	}
	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
	mat
}

#mixed model variant lme4 (gives no straight forward p-value)
#.lvaRegressionReturnCommonParamMatrix.lme4 <- function(ar, grp, subject, element){
#
#	mat <- matrix(NA, ncol=dim(ar)[3], nrow=nrow(ar))
#	nocalc <- apply(ar[,,3, drop=FALSE], 1, function(x){sum(!(is.na(x)))==0})
#
#	#only make regression if there is at least one row possible to compute
#	if(any(!nocalc)){
#		mat[!nocalc,] <- t(sapply(which(!nocalc), function(i, y, x, s){
#						mat2 <- matrix(NA, ncol=2, nrow=4)
#						nas <- !(is.na(y[i, ,element]) | is.na(x[, i]) | is.na(s))
#						l <- lmer(y[i,nas ,element]~x[nas, i]+(1|s[nas]))
#
#						s <-l$coefficients
#						mat2[,1:nrow(s)] <- s
#						c(mat2)
#					}, y=ar[!nocalc,,,drop=FALSE], x=grp[,!nocalc,drop=FALSE], s=subject))
#	}
#	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
#	mat
#}
#
#inspired by ben bolkers answer here
#http://stats.stackexchange.com/questions/22988/how-to-obtain-the-p-value-check-significance-of-an-effect-in-a-lme4-mixed-mode
.lvaRegressionReturnCommonParamMatrix.nlme <- function(ar, grp, subject, element){

	mat <- matrix(NA, ncol=dim(ar)[3], nrow=nrow(ar))
	nocalc <- apply(ar[,,3, drop=FALSE], 1, function(x){sum(!(is.na(x)))==0})

	#only make regression if there is at least one row possible to compute
	if(any(!nocalc)){
		mat[!nocalc,] <- t(sapply(which(!nocalc), function(i, y, x, s){
						#for(i in 1:5){
							mat2 <- matrix(NA, ncol=2, nrow=4)
							nas <- (is.na(y[i, ,3]) | is.na(x[, i]) | is.na(s))
							few <- length(unique(x[!nas,i])) == 1
							few2 <- length(x[!nas,i]) == 2
							
							#zero counts (which logically should not exist, but does in one instance)
							zc <- all(y[i,!nas ,3]==0)

							#less than four we do not calculate
							few3 <- length(s[!nas]) <=5

							if(!few & !few2 & !few3 & !zc){
								df <- data.frame(res=y[i,!nas ,3], exp=x[!nas, i], ran=s[!nas])
								m1 <- lme(res~exp, random=~1|ran, data=df)
								mat2[7:8] <- anova(m1)$'p-value'
								c(mat2)
							}else{
								c(mat2)
							}
						#}
					}, y=ar[!nocalc,,,drop=FALSE], x=t(grp)[,!nocalc,drop=FALSE], s=subject))
	}
	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
	mat
}


.lvaRegressionReturnCommonParamMatrixTxSNPspecific <- function(fr, grp, covariates=matrix()){
	fr2 <- t(fr)
	grp2 <- grp
	mat <- matrix(NA, ncol=8, nrow=ncol(fr2))
	nocalc <- apply(fr2[,, drop=FALSE], 2, function(x){sum(!(is.na(x)))==0})

	#use covariates if they exist
	cov2 <- covariates
	if(!length(covariates)==1){
	  if(!length(grp2)==nrow(covariates)) stop("grp and cov has to be same length")
	  #cov2 <-covariates[!nocalc,drop=FALSE,] #nocalc is for SNPs not samples
	}

		#y <- fr2[!nocalc,,drop=FALSE]
		#x <- grp[,!nocalc,drop=FALSE]
	    x <- grp2
		for(i in 1:ncol(fr2)){
			y <- fr2[,i]
			mat2 <- matrix(NA, ncol=2, nrow=4)
			if(!(nocalc[i])){
				covform <- paste(colnames(cov2), collapse="+")
				if(!length(cov2)==1) form <- formula(paste("y2~x2",covform, sep="+"))
				if(length(cov2)==1) form <- formula("y2~x2")
				df <- cbind(cov2, data.frame(y2=y, x2=x))
				s <-summary(lm(form, data=df))$coefficients
				mat2[,1:2] <- s[rownames(s) %in% c("(Intercept)","x2"),]
			  mat[i,] <- c(mat2)
			}
		}
	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")

	mat
}

.lvaRegressionReturnCommonParamMatrixTxSNPspecific.nlme <- function(fr, grp, subj){
	fr2 <- t(fr)
	grp2 <- grp
	s <- subj
	mat <- matrix(NA, ncol=8, nrow=ncol(fr2))
	nocalc <- apply(fr2[,, drop=FALSE], 2, function(x){sum(!(is.na(x)))==0})
	#y <- fr2[!nocalc,,drop=FALSE]
	#x <- grp[,!nocalc,drop=FALSE]
	x <- grp2
	if(!(any(nocalc))){
      for(i in 1:ncol(fr2)){
		y <- fr2[,i,drop=TRUE]
		mat2 <- matrix(NA, ncol=2, nrow=4)
		nas <- (is.na(y) | is.na(x) | is.na(s))
		few <- length(unique(x[!nas])) == 1
		if(!few){
		 df <- data.frame(res=y[!nas], exp=x[!nas], ran=s[!nas])
		 m1 <- lme(res~exp, random=~1|ran, data=df)
		 mat2[7:8] <- anova(m1)$'p-value'
		 mat[i,] <- c(mat2)
		}else{
		 mat[i,] <- c(mat2)
	    }
	  }
	}
	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")

	mat
}

context("test units for method lva and lva.internal")

test_that(paste("checking .lvaRegressionPvalue"), {

	#####################
	# Test 1
	#####################
	#
	#
	hets <- c(3, 4, 2)
	homs <- c(1, 2, 2)
	mean.fr <- c(0.2, 0.3, 0.5)
	sd.fr <- c(NA, NA, 0.3)
	mean.delta <- c(NA, NA, 0.2)
	sd.delta <- c(NA, NA, 0.2)
	ai.up <- c(1, 2, 2)
	ai.down <- c(0, 1, 2)
						  
	ar <- array(c(hets,homs,mean.fr, sd.fr, mean.delta, sd.delta, ai.up, ai.down), dim=c(3,8,2))
	ar <- aperm(ar,c(3,1,2))
	grp <- t(matrix(c(1,1,3,2,2,3),nrow=2))

	#prepare expected data (values are from an execution of the linear model)
	exp <- list(0.7877044, 0.1210377)

	#run tests
	res <- .lvaRegressionPvalue(ar, grp, 3)
	
	#test equality
    expect_equal(exp, res, tolerance=1e-6)

})

test_that(paste("checking .lvaRegressionReturnCommonParamMatrix"), {

	#####################
	# Test 1
	#####################
	#
	#
	hets <- c(3, 4, 2)
	homs <- c(1, 2, 2)
	mean.fr <- c(0.2, 0.3, 0.5)
	sd.fr <- c(NA, NA, 0.3)
	mean.delta <- c(NA, NA, 0.2)
	sd.delta <- c(NA, NA, 0.2)
	ai.up <- c(1, 2, 2)
	ai.down <- c(0, 1, 2)
						  
	ar <- array(c(hets,homs,mean.fr, sd.fr, mean.delta, sd.delta, ai.up, ai.down), dim=c(3,8,2))
	ar <- aperm(ar,c(3,1,2))
	
	grp <- matrix(c(1,1,3,2,2,3),nrow=2)

	#prepare expected data (values are from an execution of the linear model)
	exp <- matrix(
			c(0.23333333, 0.05, 0.31180478, 0.14433757, 0.7483315, 0.3464102, 0.5910148, 0.7877044,
			  0.03333333, 0.15, 0.06236096, 0.02886751, 0.5345225, 5.1961524, 0.6874944, 0.1210377),
			  ncol=8, nrow=2,byrow=TRUE)
	colnames(exp) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")

	#run tests
	res <- .lvaRegressionReturnCommonParamMatrix(ar, grp, 3, cov=matrix())
	
	#test equality
    expect_equal(exp, res, tolerance=1e-6)

	#####################
	# Test 2 -what if there are only NAs. or only one value is non.NA
	#####################
	#
	#

	#introduce NAs in a complete row
	ar1 <- ar
	ar1[2,,] <- NA

	#introduce NAs in a complete row, but having one non-na value
	ar2 <- ar1
	ar2[2,1,] <- 1
	
	#prepare expected data (values are from an execution of the linear model)
	exp1 <- matrix(
			c(0.23333333, 0.05, 0.31180478, 0.14433757, 0.7483315, 0.3464102, 0.5910148, 0.7877044,
			  NA, NA, NA, NA, NA, NA, NA, NA),
			  ncol=8, nrow=2,byrow=TRUE)
	exp2 <- matrix(
			c(0.23333333, 0.05, 0.31180478, 0.14433757, 0.7483315, 0.3464102, 0.5910148, 0.7877044,
			  1.00000000, NaN, NaN, NaN, 1.00000000, NaN, NaN, NaN),
			  ncol=8, nrow=2,byrow=TRUE)
	colnames(exp1) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
	colnames(exp2) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")

	#run tests
	res1 <- .lvaRegressionReturnCommonParamMatrix(ar1, grp, 3, cov=matrix())
	res2 <- .lvaRegressionReturnCommonParamMatrix(ar2, grp, 3, cov=matrix())
	
	#test equality
    expect_equal(exp1, res1, tolerance=1e-6)
    expect_equal(exp2, res2, tolerance=1e-6)

	#####################
	# Test 3 - works when ar is full of NA
	#####################
	#
	#

	#introduce NAs in a whole matrix
	ar1 <- ar
	ar1[] <- NA
	#prepare expected data (values are from an execution of the linear model)
	exp1 <- matrix(
			c(NA, NA, NA, NA, NA, NA, NA, NA,
			  NA, NA, NA, NA, NA, NA, NA, NA),
			  ncol=8, nrow=2,byrow=TRUE)
	colnames(exp1) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")

	#run tests
	res1 <- .lvaRegressionReturnCommonParamMatrix(ar1, grp, 3, cov=matrix())
	
	#test equality
    expect_equal(exp1, res1, tolerance=1e-6)
})

test_that(paste("checking .groupBasedOnPhaseAndAlleleCombination"), {

	#####################
	# Test 1
	#####################
	# rows: SNPs
	# cols: samples
			
	mat <- c(0, 1, 1, 1,
			 1, 0, 1, 1,
			 0, 1, 1, 1)

	pat <- c(0, 1, 0, 1,
			 0, 1, 1, 0,
			 1, 1, 0, 0)

	ar <- aperm(array(c(mat, pat), c(4, 3, 2)),c(2,1,3))

	#prepare expected data (homozygotes should have 2)
	e1  <- c(2, 2, 1, 2,
			 1, 3, 2, 1,
			 3, 2, 1, 1)
	exp <- matrix(e1,ncol=4, byrow=TRUE)

	#run tests
	res <- .groupBasedOnPhaseAndAlleleCombination(ar)
	
	#test equality
    expect_that(exp, equals(res))

	#####################
	# Test 2 - test that same rows give same values in the result
	#####################
	# rows: SNPs
	# cols: samples
			
	mat <- c(0, 1, 1, 1,
			 1, 0, 1, 1,
			 0, 1, 1, 1,
			 0, 1, 1, 1,
			 0, 1, 1, 1)

	pat <- c(0, 1, 0, 1,
			 0, 1, 1, 0,
			 1, 1, 0, 0,
			 1, 1, 0, 0,
			 1, 1, 0, 0)

	ar <- aperm(array(c(mat, pat), c(4, 5, 2)),c(2,1,3))

	#prepare expected data (homozygotes should have 2)
	e1  <- c(2, 2, 1, 2,
			 1, 3, 2, 1,
			 3, 2, 1, 1,
			 3, 2, 1, 1,
			 3, 2, 1, 1)
	exp <- matrix(e1,ncol=4, byrow=TRUE)

	#run tests
	res <- .groupBasedOnPhaseAndAlleleCombination(ar)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .groupBasedOnPhaseAndAlleleCombination"), {


	#####################
	# Test 2 - test that same rows give same values in the result
	#####################
	# rows: SNPs
	# cols: samples
			
	mat <- c(0, 1, 1, 1,
			 1, 0, 1, 1,
			 0, 1, 1, 1,
			 0, 1, 1, 1,
			 0, 1, 1, 1)

	pat <- c(0, 1, 0, 1,
			 0, 1, 1, 0,
			 1, 1, 0, 0,
			 1, 1, 0, 0,
			 1, 1, 0, 0)

	ar <- aperm(array(c(mat, pat), c(4, 5, 2)),c(2,1,3))

	#prepare expected data (homozygotes should have 2)
	e1  <- c(2, 2, 1, 2,
			 1, 3, 2, 1,
			 3, 2, 1, 1,
			 3, 2, 1, 1,
			 3, 2, 1, 1)
	exp <- matrix(e1,ncol=4, byrow=TRUE)

	#run tests
	res <- .groupBasedOnPhaseAndAlleleCombination(ar)
	
	#test equality
    expect_that(exp, equals(res))

})

#'@include initialize-methods.R
NULL

#' LinkVariantAlmlof class
#' 
#' Object that holds results from AI detection.
#'
#' The LinkVariantAlmlof-class contains 
#'
#' @name LinkVariantAlmlof-class
#' @rdname LinkVariantAlmlof-class
#' @aliases LinkVariantAlmlof-class LinkVariantAlmlof LinkVariantAlmlof-method
#' @docType class
#' @param x LinkVariantAlmlof object
#' @param ... pass arguments to internal functions
#'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class LinkVariantAlmlof
#' @examples
#'
#' #some code
#'
#' @exportClass LinkVariantAlmlof
NULL

#' @rdname LinkVariantAlmlof-class
#' @exportClass LinkVariantAlmlof
setClass("LinkVariantAlmlof", contains = "RangedSummarizedExperiment",
	representation(
		meta = "list"
	)
)

#' @rdname LinkVariantAlmlof-class
#' @export 
setGeneric("pvalue", function(x, ...){
    standardGeneric("pvalue")
})

#' @rdname LinkVariantAlmlof-class
#' @export 
setMethod("pvalue", signature(x = "LinkVariantAlmlof"), function(x) {
		mcols(x)[["LMCommonParam"]][,8]
})

#' Reference allele
#' 
#' Extract the allele based on SNP location from the reference fasta file
#' 
#' The alleles will be placed in the rowRanges() meta column 'ref'
#' 
#' 
#' @name refAllele 
#' @rdname refAllele
#' @aliases refAllele,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param fasta path to fasta file, index should be located in the same folder
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords reference mapbias
#' @examples
#' 
#' #load example data
#' data(ASEset.sim)
#'
#' fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
#' a <- refAllele(ASEset.sim,fasta=fasta) 
#'
#' @exportMethod refAllele
NULL

#' @rdname refAllele
setGeneric("refAllele", function(x, fasta ){
    standardGeneric("refAllele")
})

setMethod("refAllele", signature(x = "ASEset"), function(x, fasta){

	#does the fasta file exist?
	if(!file.exists(fasta)){
		stop("fasta file doesnt exist")
	}

	#make FaFile
	fl <- FaFile(fasta)

	#check if the index file is present otherwise tell the user to use the
	#indexFa(FaFile("pathToReference")) command
	if(!file.exists(paste(fasta,".fai",sep=""))){
		cat("could not find index file\n")
		cat("creates a new index file")
		indexFa(FaFile(fasta))
		cat("finished creating new index file")
	}
	#IMPORTANT! The  index command only needs to be executed once
	#indexFa(fl) #creates a new file as index in the same directory but
	#with extension *.fai 

	#open,scan,close file
	open(fl)
	#check if seqleveles are present
	fa.info <- scanFaIndex(fl)
	if(!all(seqlevels(x) %in% seqlevels(fa.info))){
		stop("seqlevels in object x are not in fasta index file")
	}
	
	ref <- scanFa(fl, param=rowRanges(x))
	close(fl)
	
	#mcols(x)[["ref"]] <- as.vector(ref)
	#x
	as.vector(ref)
})

#' Generate default mapbias from genotype
#' 
#' Create mapbias array from genotype matrix requires genotype information
#' 
#' Default mapbias will be 0.5 for bi-allelic snps and 1 for
#' homozygots. For genotypes with NA, 0.5 will be placed on all four alleles.
#' Therefore tri-allelic can not be used atm. Genotype information has to be 
#' placed in the genotype(x) assay.
#' 
#' @name defaultMapBias
#' @rdname defaultMapBias
#' @aliases defaultMapBias,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param return.class "array" or "ASEset"
#' @param ... internal arguments
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords mapbias
#' @examples
#' 
#' #load example data
#' data(ASEset.sim)
#'
#' fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
#' refAllele(ASEset.sim,fasta=fasta)
#' a <- refAllele(ASEset.sim,fasta=fasta) 
#'
NULL

#' @rdname defaultMapBias
#' @export
setGeneric("defaultMapBias", function(x,... ){
    standardGeneric("defaultMapBias")
})

#' @rdname defaultMapBias
#' @export
setMethod("defaultMapBias", signature(x = "ASEset"), function(x, return.class="array"){

		if (!("genotype" %in% assayNames(x))) {
			stop(paste("genotype matrix is not present as assay in",
					   " ASEset object, see '?inferGenotypes' "))
		}

		g <- genotype(x)
		allele1 <- sub("/.*","",as.character(g))
		allele2 <- sub(".*/","",as.character(g))

		#set NA allele as "A"
		allele1.nona <-  allele1
		allele1.nona[is.na(allele1.nona)] <- "A"
		allele2.nona <-  allele2
		allele2.nona[is.na(allele2.nona)] <- "A"

		ar <- array(0, dim=c(nrow(x),ncol(x),4),
			dimnames=list(rownames(x),colnames(x),x@variants ))

		ar[,,"A"][allele1.nona=="A"] <- ar[,,"A"][allele1.nona=="A"] + 0.5
		ar[,,"C"][allele1.nona=="C"] <- ar[,,"C"][allele1.nona=="C"] + 0.5
		ar[,,"T"][allele1.nona=="T"] <- ar[,,"T"][allele1.nona=="T"] + 0.5
		ar[,,"G"][allele1.nona=="G"] <- ar[,,"G"][allele1.nona=="G"] + 0.5

		ar[,,"A"][allele2.nona=="A"] <- ar[,,"A"][allele2.nona=="A"] + 0.5
		ar[,,"C"][allele2.nona=="C"] <- ar[,,"C"][allele2.nona=="C"] + 0.5
		ar[,,"T"][allele2.nona=="T"] <- ar[,,"T"][allele2.nona=="T"] + 0.5
		ar[,,"G"][allele2.nona=="G"] <- ar[,,"G"][allele2.nona=="G"] + 0.5

		if(return.class=="array"){
			ar
		}else if(return.class=="ASEset"){
			assays(x, withDimnames=FALSE)[["mapBias"]] <- ar
			x
		}
})

#' Random ref allele from genotype
#' 
#' Create a vector of random reference alleles
#' 
#' Randomly shuffles which of the two alleles for each genotype that is 
#' indicated as reference allele, based on either allele count information
#' or previous ref and alt alleles.
#' 
#' When the source is 'alleleCounts', the two most expressed alleles are taken
#' as reference and alternative allele. 
#' 
#' @name randomRef
#' @rdname randomRef
#' @aliases randomRef,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param ... internal arguments
#' @param source 'alleleCounts'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords mapbias
#' @examples
#' 
#' #load example data
#' data(ASEset.sim)
#' a <- ASEset.sim
#'
#' ref(a) <- randomRef(a, source = 'alleleCounts') 
#'
NULL

#' @rdname randomRef
#' @export
setGeneric("randomRef", function(x,... ){
    standardGeneric("randomRef")
})

#' @rdname randomRef
#' @export
setMethod("randomRef", signature(x = "ASEset"), 
	function(x, source="alleleCounts", ...)
{
	#check for old arguments
	if("inferGenotypes" %in% list(...)){
		stop("inferGenotypes is not an available argument anymore")
	}

	if(source=="alleleCounts"){
		apply(arank(x, return.class="matrix")[,1:2],1,sample,1)
#	}else if(source=="refAndAlt"){
#		
#		if(!("ref" %in% names(mcols(x)))){
#			stop(paste("ref allele is not present in mcols in",
#					   " ASEset object, see '?ASEset' "))
#		}
#		if(!("alt" %in% names(mcols(x)))){
#			stop(paste("alt allele is not present in mcols in",
#					   " ASEset object, see '?inferAltAllele' "))
#		}
#
#		matrix(c(ref(x),alt(x)), nrow(x),ncol=2)
#
	}else{
		stop("selected source is not available")
	}
})

#' mapBias for reference allele 
#' 
#' Create a matrix of bias for the reference allele
#' 
#' select the expected frequency for the reference allele
#' 
#' @name mapBiasRef
#' @rdname mapBiasRef
#' @aliases mapBiasRef,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param ... internal arguments
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords mapbias
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' a <- ASEset
#'
#' mat <- mapBiasRef(a) 
#'
NULL

#' @rdname mapBiasRef
#' @export
setGeneric("mapBiasRef", function(x,... ){
    standardGeneric("mapBiasRef")
})

#' @rdname mapBiasRef
#' @export
setMethod("mapBiasRef", signature(x = "ASEset"), function(x){

	#check presence of mapBias array
    if (!("mapBias" %in% assayNames(x))) {
		stop("column name 'ref' in mcols(x) is required")
		stop(paste("genotype matrix is not present as assay in",
				   " ASEset object, see '?inferGenotypes' ",
				  )) 
	}

	#check presence of reference allele
	if(!("ref" %in% colnames(mcols(x)))){
		stop("column name 'ref' in mcols(x) is required")
	}

	matrix(aperm(mapBias(x, return.class="array"),c(3,2,1))[aperm(array(matrix(
		x@variants, ncol=length(x@variants),
		 nrow=nrow(x), byrow=TRUE) == mcols(x)[,"ref"]
	 ,dim=c(nrow(x), length(x@variants), ncol=ncol(x))),c(2,3,1))
	],ncol=ncol(x),nrow=nrow(x), byrow=TRUE, dimnames=list(rownames(x),colnames(x)))

})

#'@include ASEset-class.R
NULL

#' phaseMatrix2Array
#'
#' used to convert the phase from the visually friendly matrix to array.
#'
#' A more effectice way of store the phase data in the ASEset object
#'
#' @name phaseMatrix2Array
#' @rdname phaseMatrix2Array
#' @aliases phaseMatrix2Array,matrix-method
#' @docType methods
#' @param x matrix see examples
#' @param dimnames list with dimnames
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#'
#' #load data
#' data(ASEset)
#' a <- ASEset
#'
#' #example phase matrix
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#'
#' ar <- phaseMatrix2Array(p)
#'
NULL

#' @rdname phaseMatrix2Array
#' @export
setGeneric("phaseMatrix2Array", function(x, ...)
    standardGeneric("phaseMatrix2Array")
)

#' @rdname phaseMatrix2Array
#' @export
setMethod("phaseMatrix2Array", signature(x = "matrix"),
		function(x, dimnames=NULL, ...
	){

		psplit <- strsplit(x, split="")
		upsplit <- unlist(psplit)
		mat <- as.integer(upsplit[seq(1, length(upsplit), by=3)])
		pat <- as.integer(upsplit[seq(3, length(upsplit), by=3)])
		phased <- as.integer(upsplit[seq.int(from=2, to=length(upsplit), by=3)]=="|")

		array(c(mat, pat, phased), dim=c(nrow(x), ncol(x), 3),
			  dimnames = dimnames)

})

#' phaseArray2phaseMatrix
#'
#' used to convert the phase from the visually friendly matrix to array.
#'
#' A more effectice way of store the phase data in the ASEset object
#'
#' @name phaseArray2phaseMatrix
#' @rdname phaseArray2phaseMatrix
#' @aliases phaseArray2phaseMatrix,array-method
#' @docType methods
#' @param x array see examples
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#'
#' #load data
#' data(ASEset)
#' a <- ASEset
#'
#' #example phase matrix
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#'
#' ar <- phaseMatrix2Array(p)
#'
#' #Convert back
#' mat <- phaseArray2phaseMatrix(ar)
#'
NULL

#' @rdname phaseArray2phaseMatrix
#' @export
setGeneric("phaseArray2phaseMatrix", function(x, ...)
	{
		standardGeneric("phaseArray2phaseMatrix")
	}
)

#' @rdname phaseArray2phaseMatrix
#' @export
setMethod("phaseArray2phaseMatrix", signature(x = "array"),
	function(x, ...)
	{
		.mergePhaseArray2phaseMatrix(x)
	}
)

### -------------------------------------------------------------------------
### helpers for phaseArray2phaseMatrix
###

# if any of the maternal paternal alles are NA, NA is retrieved
# if phase is NA it will be set to /
.mergePhaseArray2phaseMatrix <- function(x, ...)
{
	pha <- matrix("/", ncol=ncol(x), nrow=nrow(x))
	pha[x[,,3]==1] <- "|"

	nas <- is.na(x[,,1]) | is.na(x[,,2])
	merg <- paste(x[,,1], pha, x[,,2], sep="")
	merg[nas] <- NA

	matrix(merg, nrow=nrow(x), ncol(x))
}


#' Plot Dataframe
#'
#' Summarizes information to ease creating plots
#'
#' Main purpose is to reduce the amount of overall code and ease maintenance.
#'
#' top.fraction.criteria can take three options, maxcount, ref and phase. The top
#' allele will be every second row in the data frame, with start from row 2.
#' The maxcount argument will put the allele with most reads on top of the
#' bivariate fraction. Similarly the ref argument will put always the reference
#' allele on top. The phase arguments puts the maternal phase always on top.
#' The top.fraction.criteria for the ref or phase arguments requires that both ref
#' and alt is set in mcols(ASEset).
#'
#'
#' @name fractionPlotDf
#' @rdname fractionPlotDf
#' @aliases fractionPlotDf,ASEset-method
#' @docType methods
#' @param x ASEset
#' @param snp rownames identifier for ASEset or row number
#' @param strand '+', '-' or '*'
#' @param top.fraction.criteria 'maxcount', 'ref' or 'phase'
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase plotDf
#' @examples
#'
#' #test on example ASEset
#' data(ASEset)
#' a <- ASEset
#' df <- fractionPlotDf(a, 1, strand="+")
#'
#' @exportMethod fractionPlotDf
NULL

#' @rdname fractionPlotDf
#' @export
setGeneric("fractionPlotDf", function(x, snp,  strand="*", top.fraction.criteria="maxcount", ...
	)
    standardGeneric("fractionPlotDf")
)

#' @rdname fractionPlotDf
#' @export
setMethod("fractionPlotDf", signature(x = "ASEset"),
		function(x, snp,  strand="*", top.fraction.criteria="maxcount", ...
	){

	##top.fraction.criteria
	# maxcount
	# ref
	# phase

	if(is.integer(snp)){
		snprow <- snp
	}else if(is.character(snp)){
		snprow <- which(rownames(x) %in% snp  )
	}else{
		# If the class of snp is not approprite there will be an informative error message from
		# the base subset method.
		snprow <- snp
	}

	afraction <- t(fraction(x[snprow], strand = strand, top.fraction.criteria=top.fraction.criteria))

	values <- as.vector(t(matrix(as.numeric(afraction), ncol=2, nrow=ncol(x))))
	#values[seq(1,ncol(x)*2,by=2)+1] <- 1 - values[seq(1,ncol(x)*2,by=2)+1]

	#The first value will be the bottom allele (second allele the top allele)
	values[seq(1,ncol(x)*2,by=2)] <- 1 - values[seq(1,ncol(x)*2,by=2)]
	samples <- as.vector(t(matrix(rownames(afraction), ncol=2, nrow=ncol(x))))

	if(top.fraction.criteria=="phase"){

		if(!sum(c("ref", "alt") %in% names(mcols(x))) == 2 ){
			stop("ref and alt has to be set in mcols to use phase option")
		}

		mat <- phase(x[snprow],return.class="array")[,,1]
		mat2 <- matrix(c(rep(mcols(x[snprow])[,"ref"],ncol(x)),rep(mcols(x[snprow])[,"alt"], ncol(x))), ncol=2, nrow=ncol(x))
		mat2[mat==0,1] <- mcols(x[snprow])[,"alt"]
		mat2[mat==0,2] <- mcols(x[snprow])[,"ref"]

		alleles <- as.vector(t(mat2))
		phase <- rep(c("paternal","maternal"), ncol(x))

	}else if(top.fraction.criteria=="ref"){

		if(!sum(c("ref", "alt") %in% names(mcols(x))) == 2 ){
			stop("ref and alt has to be set in mcols to use phase option")
		}

		alleles <- as.vector(t(matrix(c(rep(mcols(x[snprow])[,"alt"],ncol(x)),rep(mcols(x[snprow])[,"ref"], ncol(x))), ncol=2, nrow=ncol(x))))

	}else if(top.fraction.criteria=="maxcount"){

		#arank(x[snprow],return.class="matrix")[c(1,2)]
		alleles <- as.vector(t(matrix(arank(x[snprow], strand=strand, return.class="matrix")[c(2,1)], ncol=2, nrow=ncol(x), byrow=TRUE)))
		#alleles <- as.vector(t(matrix(arank(x[snprow], strand=strand, return.class="matrix")[c(1,2)], ncol=2, nrow=ncol(x), byrow=TRUE)))

	}

    TFna <- is.na(values)
    values[TFna] <- 0  # 0.5 + 0.5 -> 1
    na <- rep("no", length(values))
    na[TFna] <- "yes"

    df <- data.frame(values = values, sample = samples, alleles = alleles, na=na)
    df$sample <- factor(df$sample, levels = unique(df$sample),ordered = TRUE)
    df$alleles <- factor(df$alleles, levels = unique(df$alleles),ordered = TRUE)

	#if phase option add phase information to df
	if(top.fraction.criteria=="phase"){
		df$phase <- phase
		df$phase <- factor(df$phase, levels = unique(df$phase),ordered = TRUE)
	}
	df

})

#' defaultPhase
#'
#' used to populate the phase slot in an ASEset object
#'
#' will set everything to 0
#'
#' @name defaultPhase
#' @rdname defaultPhase
#' @aliases defaultPhase,numeric-method
#' @docType methods
#' @param i number of rows
#' @param j number of columns
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#'
#'
#' i <- 5
#' j <- 10
#' defaultPhase(i,j)
#'
NULL

#' @rdname defaultPhase
#' @export
setGeneric("defaultPhase", function(i, ... ){
    standardGeneric("defaultPhase")
})


#' @rdname defaultPhase
#' @export
setMethod("defaultPhase", signature("numeric"),
		function(i, j, ...
	){
	#x is rows
	#y is columns

    p1 <- matrix(rep(0, i*j), nrow=i, ncol=j)
    p2 <- matrix(rep(0, i*j), nrow=i, ncol=j)
    matrix(paste(p1,rep("/", i*j), p2, sep=""),i, j)

})



#' scanForHeterozygotes
#'
#' Identifies the positions of SNPs found in BamGR reads.
#'
#' This function scans all reads stored in a \code{GAlignmentsList} for
#' possible heterozygote positions. The user can balance the sensitivity of the
#' search by modifying the minimumReadsAtPos, maximumMajorAlleleFrequency and
#' minimumBiAllelicFrequency arguments.
#'
#' @name ASEset-scanForHeterozygotes
#' @rdname ASEset-scanForHeterozygotes
#' @aliases ASEset-scanForHeterozygotes scanForHeterozygotes scanForHeterozygotes,ASEset-method
#' @docType methods
#' @param BamList A \code{GAlignmentsList object}
#' @param minimumReadsAtPos minimum number of reads required to call a SNP at a
#' given position
#' @param maximumMajorAlleleFrequency maximum frequency allowed for the most
#' common allele. Setting this parameter lower will minimise the SNP calls
#' resulting from technical read errors, at the cost of missing loci with
#' potential strong ASE
#' @param minimumMinorAlleleFrequency minimum frequency allowed for the second most
#' common allele. Setting this parameter higher will minimise the SNP calls
#' resulting from technical read errors, at the cost of missing loci with
#' potential strong ASE
#' @param minimumBiAllelicFrequency minimum frequency allowed for the first and
#' second most common allele. Setting a Lower value for this parameter will
#' minimise the identification of loci with three or more alleles in one
#' sample. This is useful if sequencing errors are suspected to be common.
#' @param verbose logical indicating if process information should be displayed
#' @param ... argument to pass on
#' @return \code{scanForHeterozygotes} returns a GRanges object with the SNPs
#' for the BamList object that was used as input.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{getAlleleCounts}} which is a
#' function that count the number of reads overlapping a site.  }
#' @keywords scan SNP heterozygote
#' @examples
#'
#' data(reads)
#' s <- scanForHeterozygotes(reads,verbose=FALSE)
#'
NULL

#' @rdname ASEset-scanForHeterozygotes
#' @export
setGeneric("scanForHeterozygotes", function(BamList, ...){
    standardGeneric("scanForHeterozygotes")
})

#' @rdname ASEset-scanForHeterozygotes
#' @export
setMethod("scanForHeterozygotes", signature(BamList = "GAlignmentsList"),
		  function(BamList, minimumReadsAtPos = 20,
			maximumMajorAlleleFrequency = 0.90, minimumMinorAlleleFrequency = 0.1,
			minimumBiAllelicFrequency = 0.9, verbose = TRUE, ...) {

    # if just one element of, make list (which is a convenient way of handling this
    # input type)
    if (is(BamList, "GAlignments")) {
        BamList <- GAlignmentsList(BamList)
    }
    if (is(BamList, "GRanges")) {
        BamList <- GRangesList(BamList)
    }

    if (!is.numeric(minimumReadsAtPos))
        stop(paste("minimumReadsAtPos must be a numeric vector, not a", class(minimumReadsAtPos)[1]))
    if (length(minimumReadsAtPos) != 1)
        stop(paste("minimumReadsAtPos must be of length 1, not", length(minimumReadsAtPos)))
    if (!is.numeric(maximumMajorAlleleFrequency))
        stop(paste("maximumMajorAlleleFrequency must be a numeric vector, not a", class(maximumMajorAlleleFrequency)[1]))
    if (length(maximumMajorAlleleFrequency) != 1)
        stop(paste("maximumMajorAlleleFrequency must be of length 1, not", length(maximumMajorAlleleFrequency)))
    if (maximumMajorAlleleFrequency < 0 | maximumMajorAlleleFrequency > 1)
        stop("maximumMajorAlleleFrequency must be between 0 and 1")
    if (!is.numeric(minimumBiAllelicFrequency))
        stop(paste("minimumBiAllelicFrequency must be a numeric vector, not a", class(minimumBiAllelicFrequency)[1]))
    if (length(minimumBiAllelicFrequency) != 1)
        stop(paste("minimumBiAllelicFrequency must be of length 1, not", length(minimumBiAllelicFrequency)))
    if (minimumBiAllelicFrequency < 0 | maximumMajorAlleleFrequency > 1)
        stop("minimumBiAllelicFrequency must be between 0 and 1")
    if (!is.logical(verbose))
        stop(paste("verbose must be of a logical, not a", class(verbose)[1]))
    if (length(verbose) != 1)
        stop(paste("verbose must be of length 1, not", length(verbose)))

    # checking that BamList format is ok (has to be done quite carefully for the
    # list-class gappedAlignments
    if (is(BamList, "GRangesList"))
        stop("The use of GRangesList is not recommended. Use BamImpGAList or BamImpGAPList")
    if (!is(BamList, "GAlignmentsList"))
        stop("BamList has to be a GAlignmentsList object")

    # checks specific for GAlignments
    if (all(vapply(BamList, is, logical(1), "GAlignments"))) {
        if (!all(unlist(lapply(BamList, function(x) {
            all(c("cigar", "qwidth") %in% colnames(mcols(x)))
        })))) {
            stop("BamList given as GAlignmentsLists of GAlignments objects must contain mcols named qwidth and cigar")
        }
    }


    chromosomeLevels <- unique(unlist(lapply(BamList, function(x) {
        levels(droplevels(runValue(seqnames(x))))
    })))

	#create pos to extract
	x <- BamList
	x <- GAlignmentsList(lapply(x,function(y){
			strand(y)<- "*"
			y
	}))
	x <- reduce(granges(unlist(x)))
	pos <- unlist(mapply(width(x), start(x), FUN = function(y, z){z:(z+y-1)}))
	chrnames <- unlist(mapply(as.character(seqnames(x)),width(x), FUN=rep))
	#strand.vec <- unlist(mapply(as.character(strand(x)),width(x), FUN=rep))
	my_IGPOI <- GRanges(seqnames=chrnames, ranges=IRanges(start=pos, width=1),
						strand="*")

	#empty array that handles only four nucleotides + one del columns
	dimnames = list(paste("pos",1:length(my_IGPOI), sep=""), names(BamList), c("A", "C", "G", "T"))
	ar <- array(NA, c(length(my_IGPOI), length(BamList), 4),
				 dimnames = dimnames)

	for (i in 1:length(BamList)) {
		if (verbose)
			cat(paste("Investigating sample", i), "out of", length(BamList),
			  "\n")

		# extract samples
		gal <- BamList[[i]]

		if (!(length(gal) == 0)) {
			seqlevels(gal) <- seqlevels(my_IGPOI)
			qseq <- mcols(gal)$seq

			nuclpiles <- pileLettersAt(qseq, seqnames(gal), start(gal), cigar(gal),
																 my_IGPOI)
			# fill array
			nstr <- strsplit(as.character(nuclpiles), "")
			for (k in 1:length(my_IGPOI)) {
				ar[k, i, ] <- c(sum(nstr[[k]] %in% "A"), sum(nstr[[k]] %in% "C"), sum(nstr[[k]] %in%
					"G"), sum(nstr[[k]] %in% "T"))
			}
		}
	}

	#mat <- apply(ar, c(1,3),sum, na.rm=TRUE)
	allele.count.tot <- apply(ar, c(1,2), sum)
	tf <- allele.count.tot  < minimumReadsAtPos
	allele.count.tot[tf] <- NA


	#make frequency array
	ar2 <- ar * array(as.vector(1/allele.count.tot),dim=dim(ar))
	ar2[is.na(ar2)] <- 0

	#rank alleles
	rank <- t(apply(apply(ar,c(1,3),sum, na.rm=TRUE),
					1, function(x){rank(x,ties.method="first")}))

	ar.rank1 <- array(rank==4, dim=c(nrow(ar2), dim(ar2)[3], ncol=ncol(ar2)))
	ar.rank2 <- array(rank==3, dim=c(nrow(ar2), dim(ar2)[3], ncol=ncol(ar2)))

	#rearrange to be able to subset
	ar.rank1 <- aperm(ar.rank1, c(1,3,2))
	ar.rank2 <- aperm(ar.rank2, c(1,3,2))

	#rearrange to be able to transform back
	ar3 <- aperm(ar2, c(3,2,1))
	ar.rank1b <- aperm(ar.rank1, c(3,2,1))
	ar.rank2b <- aperm(ar.rank2, c(3,2,1))

	#subset ref allele frequencies
	maj.al.fr <- aperm(array(ar3[ar.rank1b],dim=dim(ar2)[2:1],
					   dimnames=dimnames(ar2)[2:1]),c(2,1))

	min.al.fr <- aperm(array(ar3[ar.rank2b],dim=dim(ar2)[2:1],
					   dimnames=dimnames(ar2)[2:1]),c(2,1))

	#check conditions
	tf1 <- apply(!min.al.fr <= minimumMinorAlleleFrequency,1,any)
	tf2 <- apply(!maj.al.fr >= maximumMajorAlleleFrequency,1,any)
	tf3 <- apply(((min.al.fr + maj.al.fr) >= minimumBiAllelicFrequency),1,any)

	toBeReturned <- my_IGPOI[tf1&tf2&tf3]

    #add an SNP name based on position
    if (!(length(toBeReturned) == 0)) {
        names(toBeReturned) <- paste("chr", seqnames(toBeReturned), "_", start(toBeReturned),
            sep = "")

    }

    return(toBeReturned)
})

#' Import Bam
#'
#' Imports a specified genomic region from a bam file using a GRanges
#' object as search area.
#'
#' If the sequence data is strand-specific you may want to set XStag=TRUE. The
#' strand specific information has then to be stored in the meta columns with
#' column name 'XS'. If the aligner did not set the XS-tag and the data is strand-
#' specific it is still be possible to infer the strand from the bit flags after importing
#' the reads to R. Depending on the strand-specific protocol different combinations of the
#' flags will have to be used. For illumina fr-secondstrand, 83 and 163 are minus strand
#' reads and 99 and 147 are plus strand reads.
#'
#' @name import-bam
#' @rdname import-bam
#' @aliases import-bam impBamGAL impBamGAL,character-method
#' @docType methods
#' @param UserDir The relative or full path of folder containing bam files.
#' @param searchArea A \code{GenomicRanges object} that contains the regions of
#' interest
#' @param files use character vector to specify one or more files to import. The
#' default imports all bam files from the directory.
#' @param XStag Setting \code{XStag=TRUE} stores the strand specific
#' information in the mcols slot 'XS'
#' @param verbose makes the function more talkative.
#' @param ... arguments to pass on
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords bam import
#' @examples
#'
#' #Declare searchArea
#' searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))
#'
#' #Relative or full path
#' pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')
#'
#' #all files in directory
#' reads <- impBamGAL(pathToFiles,searchArea,verbose=FALSE)
#' #specified files in directory
#' reads <- impBamGAL(pathToFiles,searchArea,
#'				files=c("ERR009160.bam", "ERR009167.bam"),verbose=FALSE)
#'
NULL

#' @rdname import-bam
#' @export
setGeneric("impBamGAL", function(UserDir, ...){
    standardGeneric("impBamGAL")
})

#' @rdname import-bam
#' @export
setMethod("impBamGAL", signature(UserDir = "character"),
	function(UserDir, searchArea, files = NULL, XStag = FALSE, verbose = TRUE, ...) {

	UserDir <- sub("/$", "", UserDir)

    # Set parameters
    which <- searchArea  #A GRanges, IntegerRangesList, or missing object, from which a IRangesList instance will be constructed.
    what <- scanBamWhat()  #A character vector naming the fields to return. scanBamWhat() returns a vector of available fields. Fields are described on the scanBam help page.
    flag <- scanBamFlag(isUnmappedQuery = FALSE)

    if (XStag) {
        param <- ScanBamParam(flag = flag, which = which, what = what, tag = "XS")  #store ScanBamParam in param.
    } else {
        param <- ScanBamParam(flag = flag, which = which, what = what)  #store ScanBamParam in param.\t\t
    }
    # Point to correct directory and create a BamFileList object
    bamDir <- normalizePath(UserDir)  #Point to the directory containing your Bam files and its respective bam.bai files.

	if(is.null(files)){
		allFiles <- list.files(bamDir, full.names = TRUE)  #list files in a folder.
		bamFiles <- allFiles[grep(".bam$", allFiles)]  #list only the files ending in .bam .
	}else{
		bamFiles <- .mergeDirAndFilename(bamDir, files)
	}

    if (length(bamFiles) == 0)
        stop(paste("No bam files found in", bamDir))
    if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
        if (verbose)
            cat(paste("The bam files in UserDir are required to also have .bam.bai index files in the same directory. Trying to run indexBam function on each"),
                "\n")
        indexBam(bamFiles)
        if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
            stop("The bam files in UserDir are required to also have .bam.bai index files.")
        } else {
            if (verbose)
                cat(paste("Succesfully indexed all bamFiles in UserDir", UserDir),
                  "\n")
        }
    }
    bamFilesList <- BamFileList(bamFiles)  #store all the .bam paths in a BamFile.

    # check that sequences in searchArea are actually found in the bam files
    header <- scanBamHeader(bamFiles)
    checkSeqNameExists <- function(bamHeader, requestedSeqNames) {
        as.character(requestedSeqNames) %in% names(bamHeader[["targets"]])
    }
    if (!all(unlist(lapply(header, checkSeqNameExists, seqnames(searchArea))))) {
        # not all searchArea requested seq-names found in bam files. Create nice error
        # report and stop
        seqNotFoundErrors <- lapply(header, checkSeqNameExists, seqnames(searchArea))
        seqNotFounds <- vector()
        for (sampleName in names(seqNotFoundErrors)) {
            seqNotFounds <- c(seqNotFounds, as.character(seqnames(searchArea)[!seqNotFoundErrors[[sampleName]]]))
        }
        stop(paste("The following seq name(s) not found in the bam files:", paste(sort(unique(seqNotFounds)),
            collapse = ", ")))
    }

    # Loop through, open scanBam, store in GRList and then close each object in the
    # BamFileList object.
    BamGAL <- list()
    i <- 1
    for (bamName in names(bamFilesList)) {
        # Description
        bf <- bamFilesList[[bamName]]
        open(bf)
        if (verbose)
            cat(paste("Reading bam file", i, "with filename", basename(bamName)),
                "\n")  #Print information to the user
        GappedAlign <- readGAlignments(bf, param = param)

        BamGAL[[basename(bamName)]] <- GappedAlign

        if (verbose)
            cat(paste("stored", basename(bamName), "in BamGAL"), "\n")
        gc()
        close(bf)
        i <- i + 1
    }
    BamGAL <- GAlignmentsList(BamGAL)

    return(BamGAL)
})



#' Import Bcf Selection
#'
#' Imports a selection of a bcf file or files specified by a GenomicRanges
#' object as search area.
#'
#' A wrapper to import bcf files into R in the form of GenomicRanges objects.
#'
#' @name import-bcf
#' @rdname import-bcf
#' @aliases import-bcf impBcfGRL impBcfGR impBcfGRL,character-method impBcfGR,character-method
#' @docType methods
#' @param UserDir The relative or full path of folder containing bam files.
#' @param searchArea A \code{GenomicRanges} object that contains the regions of
#' interest
#' @param verbose Setting \code{verbose=TRUE} gives details of the procedure
#' during function run.
#' @param ... parameters to pass on
#' @return \code{BcfImpGRList} returns a GRangesList object.  \code{BcfImpGR}
#' returns one GRanges object of all unique entries from one or more bcf files.
#' @note Make sure there is a complementary index file \code{*.bcf.csi} for
#' each bcf file in \code{UserDir}. If there is not, then the functions
#' \code{impBcfGRL} and \code{impBcfGR} will try to create them.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The impBamGRL for importing bam files
#' \item The \code{\link{getAlleleCounts}} for how to get allele(SNP) counts
#' \item The \code{\link{scanForHeterozygotes}} for how to find possible
#' heterozygote positions }
#' @keywords bcf import
#' @examples
#'
#' #Declare searchArea
#' searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))
#'
#' #Relative or full path
#' pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')
#'
#' #import
#' reads <- impBcfGRL(pathToFiles, searchArea, verbose=FALSE)
#'
NULL

#' @rdname import-bcf
#' @export
setGeneric("impBcfGRL", function(UserDir, ...
	){
    standardGeneric("impBcfGRL")
})

#' @rdname import-bcf
#' @export
setMethod("impBcfGRL", signature(UserDir = "character"),
	function(UserDir, searchArea = NULL, verbose = TRUE, ...) {


	UserDir <- sub("/$", "", UserDir)

    # Set parameters
    if (is.null(searchArea)) {
        param <- ScanBcfParam()
    } else {
        param <- ScanBcfParam(which = searchArea)
    }
    # Point to correct directory and create a BcfFileList object
    bcfDir <- normalizePath(UserDir)  #Point to the directory containing your Bam files and its respective bam.bai files.
    allFiles <- list.files(bcfDir, full.names = TRUE)  #list files in a folder.
    bcfFiles <- allFiles[grep(".bcf$", allFiles)]  #list only the files ending in .bam .
    if (length(bcfFiles) == 0)
        stop(paste("No bcf files were found in", UserDir))

    # bcfFilesList <- BcfFileList(bcfFiles) #store all the .bam paths in a BamFile.
    if (!all(file.exists(paste(bcfFiles, ".csi", sep = "")))) {
        if (verbose)
            cat("Did not find csi files for all bcf files. Trying the indexBcf function obtain these",
                "\n")
        for (bcfFile in bcfFiles) {
            indexBcf(bcfFile)
        }
        if (!all(file.exists(paste(bcfFiles, ".csi", sep = "")))) {
            stop("The bcf files in UserDir are required to also have .bcf.csi index files. Run the indexBcf function in package Rsamtools on each bam file.")
        }
    }

    # Loop through, open scanBam, store in GRList and then close each object in the
    # BamFileList object.
    BcfGRL <- GRangesList()
    for (i in 1:length(bcfFiles)) {

        bcf <- suppressWarnings(scanBcf(file = bcfFiles[i], param = param))

        # need to protect against empty bcf files
        if (length(bcf[["POS"]]) == 0) {
            GRangeBcf <- GRanges(seqnames = vector(), ranges = IRanges(start = vector(),
                width = vector()), ref = vector(), alt = vector(), qual = vector())
            bcfName <- bcfFiles[i]
            BcfGRL[[basename(bcfName)]] <- GRangeBcf

        } else {
            # if they are not empty we just proceed as usual
            ranges <- IRanges(start = bcf[["POS"]], width = 1L)
            GRangeBcf <- GRanges(seqnames = as.character(bcf[["CHROM"]]), ranges = ranges,
                ref = bcf[["REF"]], alt = bcf[["ALT"]], qual = bcf[["QUAL"]])
            # Store GRangeBam in BamGRL (which is the GRange List object)
            bcfName <- bcfFiles[i]
            BcfGRL[[basename(bcfName)]] <- GRangeBcf
            if (verbose)
                cat(paste("stored", basename(bcfName), "in BcfGRL"), "\n")
            gc()
        }
    }
    return(BcfGRL)
})

#' @rdname import-bcf
#' @export
setGeneric("impBcfGR", function(UserDir, ...
	){
    standardGeneric("impBcfGR")
})

#' @rdname import-bcf
#' @export
setMethod("impBcfGR", signature(UserDir = "character"),
	function(UserDir, searchArea = NULL, verbose = TRUE, ...) {
		BcfGRList <- impBcfGRL(UserDir, searchArea, verbose)
		BcfGR <- do.call(c, unname(as.list(BcfGRList)))
		BcfGR <- unique(BcfGR)
		names(BcfGR) <- paste("chr", seqnames(BcfGR), "_", start(BcfGR), sep = "")
		return(BcfGR)
})

#' snp count data
#'
#' Given the positions of known SNPs, this function returns allele counts from
#' a BamGRL object
#'
#' This function is used to retrieve the allele counts from specified positions
#' in a set of RNA-seq reads. The \code{BamList} argument will typically have
#' been created using the \code{impBamGAL} function on bam-files. The
#' \code{GRvariants} is either a GRanges with user-specified locations or else
#' it is generated through scanning the same bam-files as in \code{BamList} for
#' heterozygote locations (e.g. using \code{scanForHeterozygotes}). The
#' GRvariants will currently only accept locations having width=1,
#' corresponding to bi-allelic SNPs. In the \code{strand} argument, specifying
#' '*' is the same as retrieving the sum count of '+' and '-' reads
#' (and unknown strand reads in case these are found in the bam file). '*' is
#' the default behaviour and can be used when the RNA-seq experiments strand
#' information is not available.
#'
#' @name getAlleleCounts
#' @rdname getAlleleCounts
#' @aliases getAlleleCounts getAlleleCounts,GAlignmentsList-method
#' @docType methods
#' @param BamList A \code{GAlignmentsList object} or \code{GRangesList object}
#' containing data imported from a bam file
#' @param GRvariants A \code{GRanges object} that contains positions of SNPs to
#' retrieve
#' @param strand A length 1 \code{character} with value  '+',
#' '-', or '*'.  This argument determines if \code{getAlleleCounts} will
#' retrieve counts from all reads, or only from reads marked as '+', '-' or '*'
#' (unknown), respectively.
#' @param return.class 'list' or 'array'
#' @param verbose Setting \code{verbose=TRUE} makes function more talkative
#' @param ... parameters to pass on
#' @return \code{getAlleleCounts} returns a list of several data.frame objects,
#' each storing the count data for one SNP.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{scanForHeterozygotes}} which is a
#' function to find possible heterozygote sites in a
#' GenomicAlignments object }
#' @keywords SNP count
#' @examples
#'
#' #load example data
#' data(reads)
#' data(GRvariants)
#'
#'
#' #get counts at the three positions specified in GRvariants
#' alleleCount <- getAlleleCounts(BamList=reads,GRvariants,
#' strand='*')
#'
#' #if the reads had contained stranded data, these two calls would
#' #have given the correct input objects for getAlleleCounts
#' alleleCountPlus <- getAlleleCounts(BamList=reads,GRvariants,
#' strand='+')
#' alleleCountMinus <- getAlleleCounts(BamList=reads,GRvariants,
#' strand='-')
#'
#'
NULL

#' @rdname getAlleleCounts
#' @export
setGeneric("getAlleleCounts", function(BamList, ...
	){
    standardGeneric("getAlleleCounts")
})

#' @rdname getAlleleCounts
#' @export
setMethod("getAlleleCounts", signature(BamList = "GAlignmentsList"),
function(BamList, GRvariants, strand = "*",
						return.class = "list", verbose = TRUE, ...) {


    if (!(is(BamList, "GAlignments") || is(BamList, "GAlignmentsList"))) {
        stop("BamList has to be a GAlignments or GAlignmnetsList object\n")
    }
    # if just one element of, make list (which is a convenient way of
	# handling this input type)
    #
    if (is(BamList, "GAlignments")) {
        BamList <- GAlignmentsList(BamList)
    }

    # check for strand name
    if (!is.character(strand)) {
        stop("strand has to be a character vector")
    }
    if (!length(strand) == 1) {
        stop("strand has to be of length 1")
    }
    if (!sum(strand %in% c("+", "-", "*")) > 0) {
        stop("strand parameter has to be either '+', '-' or '*' ")
    }

    # if the user sent in the GRangesList for GRvariants,
	# take out only the unique entries.
    #
    if (is(GRvariants, "GRangesList")) {
        GRvariants <- unique(unlist(GRvariants, use.names = FALSE))
    }

	#if BamList is not list, make it a list
	if(is(BamList, "GAlignments")){
		BamList <- GAlignmentsList(BamList)
	}

	#Drop seqlevels in BamList that are not in GRvariants
	#seqlevels(BamList,pruning.mode="coarse") <- seqlevels(GRvariants)
	seqinfo(GRvariants) <- merge(seqinfo(GRvariants), seqinfo(BamList))
	seqlevels(GRvariants) <- seqlevelsInUse(GRvariants)


    # check that seqlevels are the same
   # if (!identical(seqlevels(BamList), seqlevels(GRvariants))) {
   #     stop("!identical(seqlevels(BamList), seqlevels(GRvariants))\n")
   # }

    # checking that GRvariants is ok
    if (!is(GRvariants, "GRanges"))
        stop(paste("GRvariants must be a GRanges object, not a",
				   class(GRvariants)[1]))
    if (length(GRvariants) == 0)
        stop("GRvariants was given as an empty GRanges object.",
			 " There can be no Snps retrieved by getAlleleCount then")
    if (any(width(GRvariants) != 1))
        stop("GRvariants can contain only entries of width=1,",
			 " corresponding to SNPs.")

    # checking that verbose is ok
    if (!is.logical(verbose))
        stop(paste("verbose must be a logical, not a", class(verbose)[1]))
    if (length(verbose) != 1)
        stop(paste("verbose must be of length 1, not", length(verbose)))

    # make row-names
    if (sum(grepl("chr", seqnames(GRvariants))) > 0) {
        snpNames <- paste(seqnames(GRvariants),
						  "_", start(GRvariants), sep = "")
    } else {
        snpNames <- paste("chr", seqnames(GRvariants),
						  "_", start(GRvariants), sep = "")
    }

	# needs name, need a more general solution here
	if(length(names(BamList)) == 0){
		warning("no set names for list, new names will be sample1,2,3,etc")
		names(BamList) <- paste("sample",1:length(BamList),sep="")
	}

	#empty array that handles only four nucleotides + one del columns
    dimnames = list(snpNames, names(BamList), c("A", "C", "G", "T"))
    ar1 <- array(NA, c(length(GRvariants), length(BamList), 4),
				 dimnames = dimnames)

    # use strand choice to only get reads from that strand
    if (!strand == "*") {
        BamList <- GAlignmentsList(mapply(function(x, y) {
            x[y]
        }, BamList, strand(BamList) == strand))
    }

    for (j in 1:length(names(BamList))) {
        sample <- names(BamList)[j]
        if (verbose)
            cat("sample ", sample, "\n")

        gal <- BamList[[j]]
		my_IGPOI <- GRvariants
		seqlevels(gal) <- seqlevels(my_IGPOI)
		qseq <- mcols(gal)$seq

#        nuclpiles <- pileLettersAt(mcols(gal)[, "seq"], seqnames(gal), start(gal),
#            cigar(gal), GRvariants)
#
		nuclpiles <- pileLettersAt(qseq, seqnames(gal), start(gal), cigar(gal),
							                                 my_IGPOI)

        # fill array
        nstr <- strsplit(as.character(nuclpiles), "")
        for (k in 1:length(GRvariants)) {
            ar1[k, j, ] <- c(sum(nstr[[k]] %in% "A"), sum(nstr[[k]] %in% "C"), sum(nstr[[k]] %in%
                "G"), sum(nstr[[k]] %in% "T"))
        }

    }

    # check return.type argument
    if (return.class == "list") {
        alleleCountList <- list()
        for (i in 1:nrow(ar1)) {
            mat <- ar1[i, , ]
			if(is.integer(mat)){
				mat <- t(as.matrix(mat))
			}
            if (is.numeric(mat)) {
                mat <- t(mat)
                colnames(mat) <- dimnames[[3]]
            } else {
                colnames(mat) <- dimnames[[3]]
            }
            rownames(mat) <- dimnames[[2]]
            alleleCountList[[i]] <- mat
        }
        names(alleleCountList) <- dimnames[[1]]
        alleleCountList
    } else if (return.class == "array") {
        ar1
    } else {
        cat("return.type unknown\n Nothing will be returned from function!")
    }
})

#' Map Bias
#'
#' an allele frequency array
#'
#' This function will assume there is no bias that comes from the mapping of
#' reads, and therefore create a matrix with expected frequency of 0.5 for each
#' allele.
#'
#' @name getDefaultMapBiasExpMean
#' @rdname getDefaultMapBiasExpMean
#' @aliases getDefaultMapBiasExpMean getDefaultMapBiasExpMean3D
#' getDefaultMapBiasExpMean,ANY-method getDefaultMapBiasExpMean3D,ANY-method
#' @aliases getDefaultMapBiasExpMean getDefaultMapBiasExpMean3D
#' @docType methods
#' @param alleleCountList A \code{GRangesList object} containing read
#' information
#' @param ... parameters to pass on
#' @return \code{getDefaultMapBiasExpMean} returns a matrix with a default
#' expected mean of 0.5 for every element.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords mapping bias
#' @examples
#'
#' #load example data
#' data(ASEset)
#' #access SnpAfList
#' alleleCountList <- alleleCounts(ASEset)
#' #get default map bias exp mean
#' matExpMean <- getDefaultMapBiasExpMean(alleleCountList)
#'
#'
NULL

#' @rdname getDefaultMapBiasExpMean
#' @export
setGeneric("getDefaultMapBiasExpMean", function(alleleCountList, ...
	){
    standardGeneric("getDefaultMapBiasExpMean")
})

#' @rdname getDefaultMapBiasExpMean
#' @export
setGeneric("getDefaultMapBiasExpMean3D", function(alleleCountList, ...
	){
    standardGeneric("getDefaultMapBiasExpMean3D")
})

#' @rdname getDefaultMapBiasExpMean
#' @export
setMethod("getDefaultMapBiasExpMean", signature(alleleCountList = "list"),
 function(alleleCountList) {

    l <- lapply(alleleCountList, function(x) {
        ap <- apply(x, 2, sum)
        char <- names(sort(ap, decreasing = TRUE))[1:2]

        v <- rep(0, length(colnames(x)))
        v[colnames(x) %in% char] <- 0.5
        v
    })

    MapBiasExpMean <- matrix(unlist(l), byrow = TRUE, nrow = length(alleleCountList),
        ncol = 4, dimnames = list(c(names(alleleCountList)), colnames(alleleCountList[[1]])))  # alleleCountList[[1]] assumes that in each list the colnames are the same.
    MapBiasExpMean
})


#' @rdname getDefaultMapBiasExpMean
#' @export
setMethod("getDefaultMapBiasExpMean3D", signature(alleleCountList = "ANY"),
function(alleleCountList) {

	if(is.list(alleleCountList)){
		MapBiasExpMean <- getDefaultMapBiasExpMean(alleleCountList)
		# make 3D array
		MapBiasExpMean3D <- array(NA, c(length(alleleCountList),
										length(unlist(unique(lapply(alleleCountList,
			rownames)))), 4))  #empty array
		for (i in 1:length(unlist(unique(lapply(alleleCountList, rownames))))) {
			MapBiasExpMean3D[, i, ] <- MapBiasExpMean
		}
	}else if(is.array(alleleCountList)){
		# make 3D array
		MapBiasExpMean3D <- alleleCountList
		mapbiasmat <- t(apply(apply(alleleCountList,c(1,3),sum),
					1, function(x){rank(x,ties.method="first")}))
		mapbiasmat[mapbiasmat==1] <- 0.5
		mapbiasmat[mapbiasmat==2] <- 0.5
		mapbiasmat[mapbiasmat==3] <- 0
		mapbiasmat[mapbiasmat==4] <- 0

		MapBiasExpMean3D <- aperm(array(mapbiasmat, dim=dim(alleleCountList)[c(1,3,2)]),c(1,3,2))

	}
    MapBiasExpMean3D
})

#' Get Gene Area
#'
#' Given a character vector with genesymbols and an OrgDb object, this function
#' returns a GRanges giving the coordinates of the genes.
#'
#' This function is a convenience function that can be used to determine which
#' genomic coordinates to specify to e.g. \code{impBamGAL} when retrieving
#' reads.
#'
#' The function cannot handle genes that do not exist in the annotation. To
#' remove these please set the na.rm=TRUE.
#'
#' @name getAreaFromGeneNames
#' @rdname getAreaFromGeneNames
#' @aliases getAreaFromGeneNames
#' getAreaFromGeneNames,character-method
#' @docType methods
#' @param genesymbols A character vector that contains genesymbols of genes
#' from which we wish to retrieve the coordinates
#' @param OrgDb An \code{OrgDb} object containing gene annotation
#' @param leftFlank A \code{integer} specifying number of additional
#' nucleotides before the genes
#' @param rightFlank A \code{integer} specifying number of additional
#' nucleotides after the genes
#' @param na.rm A \code{boolean} removing genes that returned NA from the
#' annotation
#' @param verbose Setting \code{verbose=TRUE} makes function more talkative
#' @param ... arguments to pass on
#' @return \code{getAreaFromGeneNames} returns a GRanges object with genomic
#' coordinates around the specified genes
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords genes locations
#' @examples
#'
#' #load example data
#' data(ASEset)
#'
#' #get counts at the three positions specified in GRvariants
#' library(org.Hs.eg.db )
#' searchArea<-getAreaFromGeneNames(c('PAX8','TLR7'), org.Hs.eg.db)
#'
NULL

#' @rdname getAreaFromGeneNames
#' @export
setGeneric("getAreaFromGeneNames", function(genesymbols, ...
	){
    standardGeneric("getAreaFromGeneNames")
})

#' @rdname getAreaFromGeneNames
#' @export
setMethod("getAreaFromGeneNames", signature(genesymbols = "character"),
function(genesymbols, OrgDb, leftFlank = 0, rightFlank = 0,
    na.rm = FALSE, verbose = TRUE) {

    # start up sets
    if (!is.character(genesymbols))
        stop(paste("genesymbols must be a character vector, not a", class(genesymbols)[1]))

    if (!is(OrgDb, "OrgDb"))
        stop(paste("OrgDb must be an OrgDb object, not a", class(OrgDb)[1]))

    if (!is.numeric(leftFlank))
        stop(paste("leftFlank must be a numeric vector, not a", class(leftFlank)[1]))
    if (length(leftFlank) != 1)
        stop(paste("leftFlank must be of length 1, not", length(leftFlank)))
    if (leftFlank < 0)
        stop(paste("leftFlank must be equal to or larger than 0"))

    if (!is.numeric(rightFlank))
        stop(paste("rightFlank must be of a numeric vector, not a", class(rightFlank)[1]))
    if (length(rightFlank) != 1)
        stop(paste("rightFlank must be of length 1, not", length(rightFlank)))
    if (rightFlank < 0)
        stop(paste("rightFlank must be equal to or larger than 0"))

    if (!is.logical(verbose))
        stop(paste("verbose must be a logical, not a", class(verbose)[1]))
    if (length(verbose) != 1)
        stop(paste("verbose must be of length 1, not", length(verbose)))

    # retrieving data
    colsFilter <- c("CHR", "CHRLOC", "CHRLOCEND", "SYMBOL")
    s <- suppressWarnings(select(OrgDb, keys = genesymbols, columns = colsFilter, keytype = "SYMBOL"))

    missing <- genesymbols[!genesymbols %in% s[, "SYMBOL"]]
    if (verbose & length(missing) > 0) {
        cat(paste("Did not find information on these", length(missing), "genes:",
            paste(missing, collapse = ", ")), "\n")
    } else {
        if (verbose)
            cat("Found all requested genes in annotation", "\n")
    }

    # remove NAs
    if (na.rm == TRUE) {
        s <- s[!(is.na(s[, "CHR"]) | is.na(s[, "CHRLOC"]) | is.na(s[, "CHRLOCEND"])),
            ]
    } else {
        warningGenes <- s[is.na(s[, "CHR"]) | is.na(s[, "CHRLOC"]) | is.na(s[, "CHRLOCEND"]),
            ]
        if (!nrow(warningGenes) == 0) {
            warning(paste(warningGenes[, "SYMBOL"], "had NAs", "\n"), "you better remove these genes from your 'genesymbols'")
        }
    }

    strand <- rep("+", nrow(s))
    TFstrand <- s[, "CHRLOC"] < 0
    strand[TFstrand] <- "-"

    searchArea <- GRanges(seqnames = paste("chr", s[, "CHR"], sep = ""), ranges = IRanges(abs(s[,
        "CHRLOC"]) - leftFlank, abs(s[, "CHRLOCEND"]) + rightFlank), strand = strand,
        symbol = s[["SYMBOL"]])

    searchArea <- reduce(searchArea, with.revmap = TRUE)
    l <- lapply(searchArea$revmap, function(x) {
        paste(unique(s[x, "SYMBOL"]), collapse = ",")
    })
    mcols(searchArea)[, "symbol"] <- unlist(l)
    # remove the mapping column
    mcols(searchArea)[["revmap"]] <- NULL

    return(searchArea)
})

#' Get rsIDs from locations of SNP
#'
#' Given a GRanges object of SNPs and a SNPlocs annotation, this function
#' attempts to replace the names of the GRanges object entries with rs-IDs.
#'
#' This function is used to try to identify the rs-IDs of SNPs in a GRanges
#' object.
#'
#' @name getSnpIdFromLocation
#' @rdname getSnpIdFromLocation
#' @aliases getSnpIdFromLocation
#' getSnpIdFromLocation,GRanges-method
#' @docType methods
#' @param GR A \code{GRanges} that contains positions of SNPs to look up
#' @param SNPloc A \code{SNPlocs object} containing information on SNP
#' locations (e.g. SNPlocs.Hsapiens.dbSNP.xxxxxxxx)
#' @param return.vector Setting \code{return.vector=TRUE} returns vector with
#' rsIds
#' @param verbose Setting \code{verbose=TRUE} makes function more talkative
#' @param ... arguments to pass on
#' @return \code{getSnpIdFromLocation} returns the same GRanges object it was
#' given with, but with updated with rs.id information.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords SNP rs-id
#' @examples
#'
#' is_32bit_windows <- .Platform$OS.type == "windows" &&
#'                   .Platform$r_arch == "i386"
#' if (!is_32bit_windows && require(SNPlocs.Hsapiens.dbSNP144.GRCh37)) {
#' 	#load example data
#' 	data(ASEset)
#'
#'   #get counts at the three positions specified in GRvariants
#'   updatedGRanges <- getSnpIdFromLocation(rowRanges(ASEset),
#'     SNPlocs.Hsapiens.dbSNP144.GRCh37)
#    rowRanges(ASEset) <- updatedGRanges
#' }
#'
#'
NULL

#' @rdname getSnpIdFromLocation
#' @export
setGeneric("getSnpIdFromLocation", function(GR, ...
	){
    standardGeneric("getSnpIdFromLocation")
})

#' @rdname getSnpIdFromLocation
#' @export
setMethod("getSnpIdFromLocation", signature(GR = "GRanges"),
function(GR, SNPloc, return.vector = FALSE, verbose = TRUE) {

	#genome <- genome(GR)

    if (!is(GR, "GRanges"))
        stop(paste("GR must be a GRanges object, not a", class(GR)[1]))
    if (!is(SNPloc, "SNPlocs"))
        stop(paste("SNPlocs must be a SNPlocs object, not a", class(SNPloc)[1]))
    if (!exists("getSNPlocs"))
        stop("There must exist a function called getSNPlocs, available from the SNPlocs.Hsapiens.dbSNP.xxxxxxx package. Try to load such package.")

	if (any(!(seqlevels(GR) %in% seqlevels(SNPloc)) )){
		stop("one or more seqlevels in GR are not present in SNPloc")
	}
    # remove chr from seqnames if present
   # if (any(grepl("^chr", seqnames(GR))) != length(GR)) {
   #     if (length(grep("^chr", seqnames(GR))) != 0)
   #         stop("seqnames must all begin with 'chr'. In the GR it seemed that some, but not all, seqnames began with chr. Please correct manually")
   #     seqlevels(GR) <- paste("chr", seqlevels(GR), sep = "")
   #     # seqnames(GR)<-seqnames
   # }

    # changing chr to ch to adapt to SNPloc (not anymore)
    #if (length(grep("^chr", seqnames(GR))) == length(GR)) {
    #    # seqnames<-seqnames(GR)
    #    seqlevels(GR) <- sub("^chr", "ch", seqlevels(GR))
    #    # seqlevels(GR)<-as.character(unique(seqnames)) seqlevels(GR) <- levels(seqnames)
    #    # seqnames(GR)<-seqnames
    #}


    #SNPlocThisChr <- getSNPlocs(seqlevels(GR), as.GRanges = TRUE, caching = FALSE)
    #
    #seqlevels(SNPlocThisChr, pruning.mode="coarse") <- seqlevels(GR)
    ## seqlengths(GR) <- seqlengths(SNPlocThisChr)
	#genome(SNPlocThisChr) <- genome(GR)
    #
    #overlaps <- findOverlaps(GR, SNPlocThisChr)
    #
    #if (verbose)
    #    cat(paste("Replacing position-based SNP name with rs-ID for", length(overlaps),
    #        "SNP(s)"), "\n")
    #
    ## replace name in GR for(i in 1:length(overlaps)){
    ## snp<-paste('rs',mcols(SNPlocThisChr[subjectHits(overlaps[i])])[,'RefSNP_id'],sep='')
    ## names(GR)[queryHits(overlaps[i])] <-snp }
    #
    #snp <- paste("rs", mcols(SNPlocThisChr[subjectHits(overlaps)])[, "RefSNP_id"],
    #    sep = "")

	if(any(is.na(genome(GR)))| any(is.null(genome(GR)))){
		genome(GR) <- "NoSetGenome"
	}

	if(!(unique(genome(GR))==unique(genome(SNPloc)))){
		message("setting the GR genome to the same as SNPloc,
				which is a requirement to make overlap calculations")
		genome(GR) <- genome(SNPloc)
	}
	overlap1 <- snpsByOverlaps(SNPloc, GR, type="equal")
	overlap1 <- keepSeqlevels(overlap1, seqlevels(GR))
#	seqinfo(overlap1) <- seqinfo(GR)
#	strand(overlap1) <- "*"
#	mcols(overlap1) <- NULL
#	names(GR) <- NULL

	overlap2 <- findOverlaps(overlap1, GR, type="equal")
    names(GR)[subjectHits(overlap2)] <- mcols(overlap1)[["RefSNP_id"]][queryHits(overlap2)]

    # change back to chr from ch (not needed anymore)
    #seqlevels(GR) <- sub("^ch", "chr", seqlevels(GR))


    if (return.vector) {
        names(GR)
    } else {
        return(GR)
    }

})

#' coverage matrix of GAlignmentsList
#'
#' Get coverage per nucleotide for reads covering a region
#'
#' a convenience function to get the coverage from a list of reads stored in
#' GAlignmnetsList, and returns by default a list with one matrix, and
#' information about the genomic start and stop positions.
#'
#' @name coverageMatrixListFromGAL
#' @rdname coverageMatrixListFromGAL
#' @aliases coverageMatrixListFromGAL
#' coverageMatrixListFromGAL,GAlignmentsList-method
#' @docType methods
#' @param BamList GAlignmentsList containing reads over the region to calculate
#' coverage
#' @param strand strand has to be '+' or '-'
#' @param ignore.empty.bam.row argument not in use atm
#' @param ... arguments to pass on
#' @author Jesper R. Gadin
#' @keywords coverage
#' @examples
#'
#' r <- reads
#' seqlevels(r) <- '17'
#' covMatList <- coverageMatrixListFromGAL(BamList=r, strand='+')
#'
NULL

#' @rdname coverageMatrixListFromGAL
#' @export
setGeneric("coverageMatrixListFromGAL", function(BamList, ...
	){
    standardGeneric("coverageMatrixListFromGAL")
})

#' @rdname coverageMatrixListFromGAL
#' @export
setMethod("coverageMatrixListFromGAL", signature(BamList = "GAlignmentsList"),
function(BamList, strand = "*", ignore.empty.bam.row = TRUE) {

    # If having common start and end points for all gviz track objects the matrix
    # will start on the specific start regardless if there are reads in the bamList
    # or not.

    # TODO, to conveniently access data without loading into memory, the bam file
    # should be read again by using the argument BamPath.

    GAL <- BamList

    # Could be good with a check that the matrix is not longer than CNTNAP2 -
    # 2300000bp long which is the longest gene But will wait with that.
    pstrand = FALSE
    mstrand = FALSE

    if (!is.null(strand)) {
        if (strand == "+") {
            pstrand = TRUE
        } else if (strand == "-") {
            mstrand = TRUE
        } else if (strand == "*") {
            mstrand = TRUE
            pstrand = TRUE
        } else if (strand == "both") {
            mstrand = TRUE
            pstrand = TRUE
        } else {
            stop("strand has to be '+' or '-' if not NULL\n")
        }
    }

    if (!length(seqlevels(GAL)) == 1) {
        stop("can only be one seq level\n")
    }

    # get start and end before filtering on strand, will make things easier
    # downstream.
    suppressWarnings(bamStart <- min(min(start(GAL))))
    suppressWarnings(bamEnd <- max(max(end(GAL))))
    bamWidth <- bamEnd - bamStart + 1

    # if(is.null(start) | is.null(end)){
    start <- bamStart
    end <- bamEnd
    width <- bamWidth
    # }

    if (pstrand) {
        GALp <- GAL[strand(GAL) == "+"]
    }
    if (mstrand) {
        GALm <- GAL[strand(GAL) == "-"]
    }

    if (pstrand) {
        matP <- matrix(0, ncol = (width), nrow = length(GAL))
    }
    if (mstrand) {
        matM <- matrix(0, ncol = (width), nrow = length(GAL))
    }
    if (pstrand) {
        rownames(matP) <- names(GAL)
    }
    if (mstrand) {
        rownames(matM) <- names(GAL)
    }
    ##################################################

    covVecFromGA <- function(GA) {
        mcols(GA) <- NULL
        one <- unlist(grglist(GA))
        covRle <- coverage(one)[[1]]
        cov <- as.integer(window(covRle, start, end))
        cov
    }

    if (pstrand) {
        for (i in 1:length(GALp)) {
            matP[i, ] <- covVecFromGA(GALp[[i]])
        }
    }
    if (mstrand) {
        for (i in 1:length(GALm)) {
            matM[i, ] <- covVecFromGA(GALm[[i]])
        }
    }

    # make mat from matP or matM
    if (strand=="+") {
        mat <- matP
    }
    if (strand=="-") {
        mat <- matM
    }
    if (strand=="*") {
        mat <- matM+matP
    }

    if (strand=="both") {
        mat <- list(plus=matP,minus=matM)
    }

    # store in a list
    if (!is.null(strand)) {
        retList <- list(mat, start, end)
    } else {
        stop("strand must be present")
    }
    # set name on list
    if (!is.null(strand)) {
        names(retList) <- c("mat", "start", "end")
    } else {
        stop("strand must be present")
    }

    retList
})

#' alleleCounts from bam file
#'
#' count alleles before creating ASEse.
#'
#' counts the alleles in a bam file based on GRanges positions.
#'
#' Important excerpt from the details section of the internal applyPileups
#'  function: Regardless of 'param' values, the algorithm follows samtools by
#'  excluding reads flagged as unmapped, secondary, duplicate, or
#'  failing quality control.
#'
#' @name countAllelesFromBam
#' @rdname countAllelesFromBam
#' @aliases countAllelesFromBam
#' countAllelesFromBam,GRanges-method
#' @docType methods
#' @param gr GRanges that contains SNPs of interest
#' @param pathToDir path to directory of bam files
#' @param flag specify one flag to use as filter, default is no filtering.
#' allowed flags are 99, 147, 83 and 163
#' @param scanBamFlag set a custom flag to use as filter
#' @param return.class type of class for the returned object
#' @param verbose makes funciton more talkative
#' @param ... arguments to pass on
#' @author Jesper R. Gadin
#' @keywords allelecount counting
#' @examples
#'
#' data(GRvariants)
#' gr <- GRvariants
#'
#' ##not run at the moment
#' #pathToDir <- system.file('inst/extdata/ERP000101_subset', package='AllelicImbalance')
#' #ar <- countAllelesFromBam(gr, pathToDir)
#'
NULL

#' @rdname countAllelesFromBam
#' @export
setGeneric("countAllelesFromBam", function(gr, ...
	){
    standardGeneric("countAllelesFromBam")
})

#' @rdname countAllelesFromBam
#' @export
setMethod("countAllelesFromBam", signature(gr = "GRanges"),
function(gr, pathToDir, flag=NULL, scanBamFlag=NULL, return.class="array", verbose=TRUE, ...) {

	bamDir <- normalizePath(pathToDir)
	allFiles <- list.files(bamDir, full.names = TRUE)
	bamFiles <- allFiles[grep(".bam$", allFiles)]
	if (length(bamFiles) == 0) {
		stop(paste("No bam files found in", bamDir))
	}
	if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
		if (verbose) {
			cat(paste("The bam files in UserDir are required to also have", ".bam.bai index files.",
				" Trying to run indexBam function on each", "\n"), )
		}
		indexBam(bamFiles)
		if (!all(file.exists(paste(bamFiles, ".bai", sep = "")))) {
			stop("The bam files in UserDir are required to also have", ".bam.bai index files.")
		} else {
			if (verbose) {
				cat(paste("Succesfully indexed all bamFiles in UserDir", pathToDir,
				  "\n"))
			}
		}
	}

	#scanBamFlag
	if(is.null(scanBamFlag) & is.null(flag)){
		flag <- scanBamFlag()
	}
	if(!is.null(scanBamFlag) ){
		if(length(scanBamFlag)==2){
			flag <- scanBamFlag
		}else{
			stop("scanBamFlag has to be the return values from scanBamFlag()")
		}
	}
	#flags can be 99 147 83 or 163
	if(length(flag)==1 & is.null(scanBamFlag)){
		if(! (flag%in%c(99,147,83,163))){
			stop(paste("flag values can only be 99 147 83 or 163",
					   "the input flag value was", flag,sep=" "))
		}

		if(flag==99){

			flag=scanBamFlag( isPaired = TRUE,
					isProperPair = TRUE,
					isFirstMateRead = TRUE,
					isMateMinusStrand = TRUE
					)
		}else if(flag==83){

			flag=scanBamFlag(
					isPaired = TRUE,
					isProperPair = TRUE,
					isFirstMateRead = TRUE,
					isMinusStrand = TRUE
					)
		}else if(flag==147){

			flag=scanBamFlag(
					isPaired = TRUE,
					isProperPair = TRUE,
					isFirstMateRead = FALSE,
					isMinusStrand = TRUE
					)
		}else if(flag==163){

			flag=scanBamFlag(
					isPaired = TRUE,
					isProperPair = TRUE,
					isFirstMateRead = FALSE,
					isMateMinusStrand = TRUE
					)
		}
	}


	if(verbose){
		cat("sam flag used:",flag,"\n")
	}
	fls <- PileupFiles(bamFiles)

	countF <-
		function(x){
		x[["seq"]][-5,,1]

	}

	which <- gr
	p1 <- ApplyPileupsParam(flag=flag,
							which=which,
							minBaseQuality = 0L,
							what="seq",
							yieldBy = "position",
							yieldAll=TRUE,
							maxDepth=.Machine$integer.max,
							...
							)

	res <- applyPileups(fls, countF, param=p1)

	ar <- array(unlist(res), dim=c(4, length(fls), length(which)),
				dimnames=list(c("A","C","G","T"),
							  names(fls),
							  names(which)))
	ar <- aperm(ar,dim=c(3,2,1))

	ar
})

#' ASEset from bam file
#'
#' count alleles and create an ASEset direct from bam file instead of reading into R first.
#'
#' counts the alleles in a bam file based on GRanges positions.
#'
#'
#' @name ASEsetFromBam
#' @rdname ASEsetFromBam
#' @aliases ASEsetFromBam
#' ASEsetFromBam,GRanges-method
#' @docType methods
#' @param gr GenomicRanges of SNPs to create ASEset for
#' @param PE if paired end or not (default: TRUE)
#' @param pathToDir Directory of bam files with index in same directory
#' @param strandUnknown default: FALSE
#' @param ... passed on to ASEsetFromBam function
#' @param flagsMinusStrand flags that mark reads coming from minus strand
#' @param flagsPlusStrand flags that mark reads coming from plus strand
#' @author Jesper R. Gadin
#' @keywords ASEset
#' @examples
#'
#' data(GRvariants)
#' gr <- GRvariants
#'
#' ##no execution at the moment
#' #pathToDir <- system.file('inst/extdata/ERP000101_subset', package='AllelicImbalance')
#' #a <- ASEsetFromBam(gr, pathToDir)
#'
NULL

#' @rdname ASEsetFromBam
#' @export
setGeneric("ASEsetFromBam", function(gr, ...
	){
    standardGeneric("ASEsetFromBam")
})

#' @rdname ASEsetFromBam
#' @export
setMethod("ASEsetFromBam", signature(gr = "GRanges"),
 function(gr, pathToDir,PE=TRUE, flagsMinusStrand=c(83,163), flagsPlusStrand=c(99,147), strandUnknown=FALSE, ...) {

	if(!PE){
		stop("no support for SE atm")
	}

	if(PE==TRUE){
		#minus strand
		arm1 <- countAllelesFromBam(gr, pathToDir, flag=83)
		arm2 <- countAllelesFromBam(gr, pathToDir, flag=163)
		arm <- arm1 + arm2

		#plus strand
		arp1 <- countAllelesFromBam(gr, pathToDir, flag=99)
		arp2 <- countAllelesFromBam(gr, pathToDir, flag=147)
		arp <- arp1 + arp2
	}

	#ASEsetFromArray
	if(!strandUnknown){
		a <- ASEsetFromArrays(gr, countsPlus = arp,
			countsMinus = arm)

	}else{
		a <- ASEsetFromArrays(gr, countsUnknown = arp+arm)
	}
	a
})

#' makes masked fasta reference
#'
#' Replaces all selected positions in a fasta file with the character N
#'
#' @name makeMaskedFasta
#' @rdname makeMaskedFasta
#' @aliases makeMaskedFasta
#' makeMaskedFasta,character-method
#' @docType methods
#' @param fastaIn character string of the path for the fasta file to be used
#' @param fastaOut character string of the path for the masked fasta file (no extension)
#' @param posToReplace GRanges object with the genomic ranges to replace
#' @param splitOnSeqlevels write on file for each seqlevel to save memory
#' @param verbose makes function more talkative
#' @param ... arguments to pass on
#' @author Jesper R. Gadin
#' @keywords masked fasta reference
#' @examples
#'
#' data(ASEset.sim)
#' gr <- rowRanges(ASEset.sim)
#' fastaIn <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
#' makeMaskedFasta(fastaIn=fastaIn, fastaOut="fastaOut",posToReplace=gr)
#'
#'
NULL

#' @rdname makeMaskedFasta
#' @export
setGeneric("makeMaskedFasta", function(fastaIn, ...
	){
    standardGeneric("makeMaskedFasta")
})

#' @rdname makeMaskedFasta
#' @export
setMethod("makeMaskedFasta", signature(fastaIn = "character"),
function(fastaIn, fastaOut, posToReplace, splitOnSeqlevels=TRUE, verbose=TRUE){

	#does the inFasta file exist?
	if(!file.exists(fastaIn)){
		stop("fasta infile doesnt exist")
	}

	#make FaFile
	fl <- FaFile(fastaIn)

	#check if the index file is present otherwise tell the user to use the
	#indexFa(FaFile("pathToReference")) command
	if(!file.exists(paste(fastaIn,".fai",sep=""))){
		cat("could not find index file\n")
		cat("creates a new index file")
		indexFa(FaFile(fastaIn))
		cat("finished creating new index file")
	}
	#indexFa(fl) #creates a new file as index in the same directory but
	#with extension *.fai

	#open,scan,close file
	open(fl)
	#check if seqleveles are present
	fa.info <- scanFaIndex(fl)
	if(!(all(seqlevels(posToReplace) %in% seqlevels(fa.info)))){
		close(fl)
		stop("seqlevels in object x are not in fasta index file")
	}

	###############LOOOP
	chrs <- seqlevels(posToReplace)
	for (chr in chrs){
	#	chr <- "chr1"

		searchArea <- fa.info[seqnames(fa.info)==chr]
		seq <- scanFa(fl,param=searchArea)

		#replace the SNPs with N
		toReplace <- unique(IRanges:::unlist_as_integer(ranges(posToReplace)))
		seq <- seq[[1]]
		seq[toReplace] <- "N"

		if(verbose){cat("replaced", length(toReplace),"instances with N\n")}

		#write new file
		#library("seqinr")
		outfile <- paste(fastaOut,chr,".fa",sep="")

		write.fasta(as.character(seq),names=chr, file.out=outfile, nbchar=80)
		if(verbose){cat("wrote chr",chr,"to file\n")}

		gc()
	}
	close(fl)
	if(verbose){cat("all chromosomes written to file\n")}
})


#' global analysis wrapper
#'
#' A wrapper to make a global analysis based on paths for BAM, VCF and GFF files
#'
#' @name gba
#' @rdname gba
#' @aliases gba
#' gba,character-method
#' @docType methods
#' @param pathBam path to bam file
#' @param pathVcf path to vcf file
#' @param pathGFF path to gff file
#' @param verbose makes function more talkative
#' @param ... arguments to pass on
#' @author Jesper R. Gadin
#' @keywords global wrapper
#' @examples
#'
#' #empty as function doesn't exist
#'
NULL

#' @rdname gba
#' @export
setGeneric("gba", function(pathBam, ...
	){
    standardGeneric("gba")
})

#' @rdname gba
#' @export
setMethod("gba", signature(pathBam = "character"),
function(pathBam,pathVcf,pathGFF=NULL, verbose){

	#summarize counts

	#detectAI

})


#' snp quality data
#'
#' Given the positions of known SNPs, this function returns allele quality from
#' a BamGRL object
#'
#' This function is used to retrieve the allele quality strings from specified positions
#' in a set of RNA-seq reads. The \code{BamList} argument will typically have
#' been created using the \code{impBamGAL} function on bam-files. The
#' \code{GRvariants} is either a GRanges with user-specified locations or else
#' it is generated through scanning the same bam-files as in \code{BamList} for
#' heterozygote locations (e.g. using \code{scanForHeterozygotes}). The
#' GRvariants will currently only accept locations having width=1,
#' corresponding to bi-allelic SNPs. The strand type information will be kept in the
#' returned object. If the strand is marked as unknown "*", it will be forced to the "+"
#' strand.
#'
#' quaity information is extracted from the BamList object, and requires the presence of
#' mcols(BamList)[["qual"]] to contain quality sequences.
#'
#' @name getAlleleQuality
#' @rdname getAlleleQuality
#' @aliases getAlleleQuality getAlleleQuality,GAlignmentsList-method
#' @docType methods
#' @param BamList A \code{GAlignmentsList object} or \code{GRangesList object}
#' containing data imported from a bam file
#' @param GRvariants A \code{GRanges object} that contains positions of SNPs to
#' retrieve.
#' @param fastq.format default 'illumina.1.8'
#' @param return.class 'list' or 'array'
#' @param verbose Setting \code{verbose=TRUE} makes function more talkative
#' @param ... parameters to pass on
#' @return \code{getAlleleQuality} returns a list of several data.frame objects,
#' each storing the count data for one SNP.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords allele quality
#' @examples
#'
#' #load example data
#' data(reads)
#' data(GRvariants)
#'
#' #get counts at the three positions specified in GRvariants
#' alleleQualityArray <- getAlleleQuality(BamList=reads,GRvariants)
#'
#' #place in ASEset object
#' alleleCountsArray <- getAlleleCounts(BamList=reads,GRvariants,
#'                      strand='*', return.class="array")
#'
#' 	a <- ASEsetFromArrays(GRvariants, countsUnknown = alleleCountsArray)
#' 	aquals(a) <- alleleQualityArray
NULL

#' @rdname getAlleleQuality
#' @export
setGeneric("getAlleleQuality", function(BamList, ...
	){
    standardGeneric("getAlleleQuality")
})

#' @rdname getAlleleQuality
#' @export
setMethod("getAlleleQuality", signature(BamList = "GAlignmentsList"),
function(BamList, GRvariants, fastq.format = "illumina.1.8",
						return.class = "array", verbose = TRUE, ...) {

	if(!return.class %in% c("array")){
		stop("return.class has to be array")
	}

    if (!(is(BamList, "GAlignments") || is(BamList, "GAlignmentsList"))) {
        stop("BamList has to be a GAlignments or GAlignmnetsList object\n")
    }
    # if just one element of, make list (which is a convenient way of
	# handling this input type)
    #
    if (is(BamList, "GAlignments")) {
        BamList <- GAlignmentsList(BamList)
    }

    # if the user sent in the GRangesList for GRvariants,
	# take out only the unique entries.
    #
    if (is(GRvariants, "GRangesList")) {
        GRvariants <- unique(unlist(GRvariants, use.names = FALSE))
    }

	#if BamList is not list, make it a list
	if(is(BamList, "GAlignments")){
		BamList <- GAlignmentsList(BamList)
	}

	#Drop seqlevels in BamList that are not in GRvariants
	#seqlevels(BamList,pruning.mode="coarse") <- seqlevels(GRvariants)
	seqinfo(GRvariants) <- merge(seqinfo(GRvariants), seqinfo(BamList))
	seqlevels(GRvariants) <- seqlevelsInUse(GRvariants)


    # check that seqlevels are the same
   # if (!identical(seqlevels(BamList), seqlevels(GRvariants))) {
   #     stop("!identical(seqlevels(BamList), seqlevels(GRvariants))\n")
   # }

    # checking that GRvariants is ok
    if (!is(GRvariants, "GRanges"))
        stop(paste("GRvariants must be a GRanges object, not a",
				   class(GRvariants)[1]))
    if (length(GRvariants) == 0)
        stop("GRvariants was given as an empty GRanges object.",
			 " There can be no Snps retrieved by getAlleleCount then")
    if (any(width(GRvariants) != 1))
        stop("GRvariants can contain only entries of width=1,",
			 " corresponding to SNPs.")

    # checking that verbose is ok
    if (!is.logical(verbose))
        stop(paste("verbose must be a logical, not a", class(verbose)[1]))
    if (length(verbose) != 1)
        stop(paste("verbose must be of length 1, not", length(verbose)))

    # make row-names
    if (sum(grepl("chr", seqnames(GRvariants))) > 0) {
        snpNames <- paste(seqnames(GRvariants),
						  "_", start(GRvariants), sep = "")
    } else {
        snpNames <- paste("chr", seqnames(GRvariants),
						  "_", start(GRvariants), sep = "")
    }

	# needs name, need a more general solution here
	if(length(names(BamList)) == 0){
		warning("no set names for list, new names will be sample1,2,3,etc")
		names(BamList) <- paste("sample",1:length(BamList),sep="")
	}

	#choose format
	if(fastq.format=="illumina.1.8"){
		dim3 <- c("!","\"","#","$","%","&","'","(",")","*","+",",","-",".","\\","/","0","1","2","3","4","5","6","7","8","9",":",";","<","=",">","?","@","A","B","C","D","E","F","G","H","I","J")
	}


	#empty array that handles only four nucleotides + one del columns
    dimnames = list(snpNames, names(BamList), dim3, c("+","-"))
    ar1 <- array(NA, c(length(GRvariants), length(BamList), length(dim3), 2),
				 dimnames = dimnames)

    # force all "*" on "+" strand
	un1 <- strand(BamList)=="*"
	un2 <- any(un1)
	if(any(un2)){
		strand(BamList)[un2][un1[un2]] <- "+"
	}

    for (j in 1:length(names(BamList))) {
        sample <- names(BamList)[j]
        if (verbose)
            cat("sample ", sample, "\n")

		my_IGPOI <- GRvariants

		# + strand
        gal <- BamList[[j]][strand(BamList[[j]]) == "+"]
		seqlevels(gal) <- seqlevels(my_IGPOI)

		nuclpiles <- pileLettersAt(mcols(gal)$qual, seqnames(gal), start(gal), cigar(gal),
							                                 my_IGPOI)
        # fill array
        nstr <- factor(unlist(strsplit(as.character(nuclpiles), "")),
					   levels=dim3, labels=dim3)
		levels(nstr) <- dim3

        for (k in 1:length(nuclpiles)) {
			tbl <- table(factor(unlist(strsplit(as.character(nuclpiles[k]), "")),
					   levels=dim3, labels=dim3))
			ar1[k, j, names(tbl), "+"] <- as.integer(tbl)
        }

		# - strand
        gal <- BamList[[j]][strand(BamList[[j]]) == "-"]
		seqlevels(gal) <- seqlevels(my_IGPOI)

		nuclpiles <- pileLettersAt(mcols(gal)$qual, seqnames(gal), start(gal), cigar(gal),
							                                 my_IGPOI)

        # fill array
        nstr <- factor(unlist(strsplit(as.character(nuclpiles), "")),
					   levels=dim3, labels=dim3)
		levels(nstr) <- dim3

        for (k in 1:length(nuclpiles)) {
			tbl <- table(factor(unlist(strsplit(as.character(nuclpiles[k]), "")),
					   levels=dim3, labels=dim3))
			ar1[k, j, names(tbl), "-"] <- as.integer(tbl)
        }
    }

	if (return.class == "array") {
        ar1
    } else {
        cat("return.class unknown\n Nothing will be returned from function!")
    }
})


#' genotype2phase
#'
#' used to convert the genomatrix from the visually friendly matrix to phase array.
#'
#' To not introduce redundant information in the ASEset object, the genotype matrix is
#' translated to a phase matrix, containing the same information.
#' Does not allow tri-allelic or multi-allelic SNPs, and if present the multi-allelic
#' SNPs will lose the least occuring genotype.
#'
#' This function can handle indels, but if the reference allele is not provided, the
#' rank matrix which is temporary created might use lots of memory, depending on the
#' amount of indels among the genotypes. As conclusion, it is preferable to send in
#' reference genome when converting to phase.
#'
#' levels information is only important if the reference allele has to be guessed,
#' and so if reference information is provided, the levels argument can be ignored.
#'
#' @name genotype2phase
#' @rdname genotype2phase
#' @aliases genotype2phase,matrix-method
#' @docType methods
#' @param x matrix see examples
#' @param ref reference alleles
#' @param return.class 'array' or 'list'
#' @param levels vector of expected alleles
#' @param ... pass on additional param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#'
#' #load example data
#' data(genomatrix)
#' data(ASEset)
#' p <- genotype2phase(genomatrix, ref(ASEset))
#'
NULL

#' @rdname genotype2phase
#' @export
setGeneric("genotype2phase", function(x, ...
	){
    standardGeneric("genotype2phase")
})

#' @rdname genotype2phase
#' @export
setMethod("genotype2phase", signature(x = "matrix"),
		function(x, ref=NULL, return.class="array", levels=c("A","C","G","T") , ...
	){

	#check x
	if(!is.matrix(x)){
		stop("x is not of a matrix")
	}

	#checks return.class
	if(return.class=="list" & !is.null(ref)){
		stop("reference is already known, no need to use return.class='list'")
	}

	#check ref
	if(!is.null(ref)){
		if(!length(ref)==nrow(x)){
		 stop("reference length is not equal to genotype matrix nrow")
		}
	}

	sgm <- .splitGenotypeMatrix(x)
	if(is.null(ref)){
		#if length of levels is to long the rank matrix risks being very huge
		sgc <- .splitGenotypeCount(sgm, levels)
		sgr <- .splitGenotypeRank(sgc)
		ref <- .splitGenotypePickRefAllele(sgr)
		alt <- .splitGenotypePickAltAllele(sgr, ref)
	}

	p <-  array(c((!sgm == ref)*1, rep(0, length(sgm[,,1]))),dim= c(nrow(x), ncol(x), 3), dimnames=list(rownames(x), colnames(x), NULL))

	if(return.class=="list"){
		list(phase=p,ref=ref,alt=alt)
	}else if(return.class=="array"){
		p
	}
})

### -------------------------------------------------------------------------
### helpers for genotype2phase
###

#split a genotype matrix into an array of two dimensions(one for each allele)
.splitGenotypeMatrix <-
	function(genomatrix, ...)	{
	str <- unlist(strsplit(genomatrix,"/"))
	inx <- which(is.na(str))
	val <- c(str, rep(NA,length(inx)))
	id  <- sort(c( seq_along(str), inx+0.5), index.return=TRUE)$ix

	aperm(array(val[id], dim=c(2, nrow(genomatrix), ncol(genomatrix))),c(2,3,1))
}

#from a genotype array of two dimensions, count occurences of each allele for
#each snp
.splitGenotypeCount <-
	function(x, levels=c("A", "C", "G", "T"), ...)
{
	mat <- matrix(aperm(x, c(3,2,1)), ncol(x)*2, nrow(x))
	t(apply(mat, 2, function(x){table(factor(x, levels=levels))}))
}

#from matrix rank the alleles for each SNP
.splitGenotypeRank <-
	function(x, levels=colnames(x), ...)
{
	mat <- t(apply(x, 1, function(x){sort(x, decreasing=TRUE, index.return=TRUE)$ix}))
	matrix(levels[mat], nrow(x), ncol(x), dimnames=list(NULL,paste("r",1:length(levels),sep="")))
}

#pick a random ref allele from two most occured
.splitGenotypePickRefAllele <- function(x, ...){
	apply(x[,1:2], 1, sample,1)
}

#pick a random alt allele from two most occured (which is not ref allele)
.splitGenotypePickAltAllele <- function(x, ref, ...){
	x[,1:2][!x[,1:2] == ref]
}


#' phase2genotype
#'
#' Convert the phase from the internally stored phase, ref and alt information
#'
#' To not introduce redundant information in the ASEset object, the genotype matrix is
#' accessed from the phase matrix, which together with ref and alt allele information
#' contains the same information(not taken into account three-allelic or more SNPs).
#'
#' The genotype matrix retrieved from an ASEset object can differ from the genotype matrix
#' stored in the object if reference and alternative alleles were not used or has changed
#' since the phase genotype matrix was stored. Basically, it is preferable to provide
#' reference and alternative information when storing the genotype matrix.
#'
#' If possible, it is better to not use a genotype matrix, but instead relying completely
#' on storing a phase matrix(or array) together with reference and alternative allele
#' information.
#'
#' @name phase2genotype
#' @rdname phase2genotype
#' @aliases phase2genotype,array-method
#' @docType methods
#' @param x array see examples
#' @param ref reference allele vector
#' @param alt alternative allele vector
#' @param return.class 'matrix' or 'array'
#' @param ... pass on additional param
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#'
#' #load example data
#' data(ASEset)
#' data(genomatrix)
#' p <- genotype2phase(genomatrix, ref(ASEset), return.class="array")
#' ref <- ref(ASEset)
#' alt <- inferAltAllele(ASEset)
#'
#' gt <- phase2genotype(p, ref, alt, return.class="matrix")
#'
NULL

#' @rdname phase2genotype
#' @export
setGeneric("phase2genotype", function(x, ...
	){
    standardGeneric("phase2genotype")
})

#' @rdname phase2genotype
#' @export
setMethod("phase2genotype", signature(x = "array"),
		function(x, ref, alt, return.class="matrix", ...
	){

	gta <- .phaseArray2genotypeArray(x, ref, alt)

	if(return.class=="matrix"){
		.genotypeArray2genotypeMatrix(gta)
	}else if(return.class=="array"){
		gta
	}else{ stop("return.class type doesnt exist")}

})

### -------------------------------------------------------------------------
### helpers for phase2genotype
###
#NAs will be kept
.phaseArray2genotypeArray <- function(x, ref, alt){
	mat <- matrix(alt, nrow(x), ncol(x))
	pat <- matrix(alt, nrow(x), ncol(x))
	pha <- matrix("/", ncol=ncol(x), nrow=nrow(x))

	namat <- is.na(x[,,1])
	napat <- is.na(x[,,2])

	mat[x[,,1]==0 & !namat] <- matrix(ref, nrow(x), ncol(x))[x[,,1]==0 & !namat]
	pat[x[,,2]==0 & !napat] <- matrix(ref, nrow(x), ncol(x))[x[,,2]==0 & !napat]

	mat[namat] <- NA
	pat[napat] <- NA

	pha[x[,,3]==1] <- "|"

	array(c(mat, pat, pha), dim=c(dim(x)),
		  dimnames=list(NULL, NULL, c("mat","pat", "phased")))
}

#NAs will be kept and merged
.genotypeArray2genotypeMatrix <- function(x, ...)
{
	napha <- is.na(x[,,3])
	x[,,3][napha] <- "/"

	gv <- paste(x[,,1], x[,,3], x[,,2], sep="")
	namat <- is.na(x[,,1])
	napat <- is.na(x[,,2])

	gv[namat | napat] <- NA
	matrix(gv, nrow(x), ncol(x))
}

##
## DNAStringSet2character
##
## forces e.g. simplelist of variants to an atomic character vector
##
## @name DNAStringSet2character
## @rdname DNAStringSet2character
## @aliases DNAStringSet2character
## DNAStringSet2character,DNAStringSet-method
## @docType methods
## @param x DNAStringSet
## @param verbose makes function more talkative
## @param ... arguments to pass on
## @author Jesper R. Gadin
## @keywords global wrapper
## @examples
##
## #empty as function doesn't exist
##
#NULL
#
## @rdname gba
## @export
#setGeneric("DNAStringSet2character", function(x, ...
#	){
#    standardGeneric("DNAStringSet2character")
#})
#
## @rdname gba
## @export
#setMethod("DNAStringSet2character", signature(x = "character"),
#function(x, verbose){
#
#	if(any(width(x)>1)){
#		stop("One or more variants are not bi-allelic SNPs")
#	}
#	as.character(x)
#
#)
#
#
#isSnp <- function(x) {
#	refSnp <- nchar(ref(x)) == 1L
#	a <- alt(x)
#	altSnp <- elementNROWS(a) == 1L
#	ai <- unlist(a[altSnp]) # all length 1, so unlisting is 1:1 map
#	altSnp[altSnp] <- nchar(ai) == 1L & (ai %in% c("A", "C", "G", "T"))
#	refSnp & altSnp
#}
#
#

context("internal functions for genotype2phase")

test_that(paste("checking .splitGenotypeMatrix"), {

	#####################
	# Test 1
	#####################
	#A matrix with both alleles present in all samples (simplest case)
	#Dim: 3 SNPs 4 Samples
	a1 <- c("A", "A", "T", "T",
			"G", "G", "C", "C",
			"C", "G", "C", "G")
	a2 <- c("T", "A", "A", "T",
			"C", "C", "C", "G",
			"G", "G", "C", "C")
	mat <- matrix(paste(a1,"/",a2,sep=""), nrow=3, ncol=4, byrow=TRUE)
	exp <- aperm(array(c(a1, a2), c(4,3,2)),c(2,1,3))
			
	#run tests
	res <- .splitGenotypeMatrix(mat)
	
	#test equality
    expect_that(exp, equals(res))

	#####################
	# Test 2
	#####################
	#A matrix with two genotypes missing
	#Dim: 3 SNPs 4 Samples
	a1 <- c("A", "A", "T", "T",
			"G", "G", "C", "C",
			"C", "G", "C", "G")
	a2 <- c("T", "A", "A", "T",
			"C", "C", "C", "G",
			"G", "G", "C", "C")
	mat <- matrix(paste(a1,"/",a2,sep=""), nrow=3, ncol=4, byrow=TRUE)
	mat[c(1,6)] <- NA
	exp <- aperm(array(c(a1, a2), c(4,3,2)),c(2,1,3))
	exp[c(1,6,1+12,6+12)] <- NA
			
	#run tests
	res <- .splitGenotypeMatrix(mat)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .splitGenotypeCount"), {

	#####################
	# Test 1
	#####################
	#A matrix with both alleles present in all samples (simplest case)
	#Dim: 3 SNPs 4 Samples
	a1 <- c("A", "A", "T", "T",
			"G", "G", "C", "C",
			"C", "G", "C", "G")
	a2 <- c("T", "A", "A", "T",
			"C", "C", "C", "G",
			"G", "G", "C", "C")
	ar <- aperm(array(c(a1, a2), c(4,3,2)),c(2,1,3))
	exp <- matrix(c(4, 0, 0, 4, 
					0, 5, 3, 0,
					0, 4, 4, 0), nrow=3, byrow=TRUE)
	colnames(exp) <- c("A","C","G","T")
			
	#run tests
	res <- .splitGenotypeCount(ar)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .splitGenotypeRank"), {

	#####################
	# Test1
	#####################
	#A matrix with both alleles present in all samples (simplest case)
	#Dim: 3 SNPs 4 Samples
	mat <- matrix(c(4, 0, 0, 4, 
					0, 5, 3, 0,
					0, 4, 4, 0), nrow=3, byrow=TRUE)
	colnames(mat) <- c("A","C","G","T")
	exp <- matrix(c("A", "T", "C", "G",
					"C", "G", "A", "T",
					"C", "G", "A", "T"), nrow=3, byrow=TRUE)
	colnames(exp) <- c("r1","r2","r3","r4")
			
	#run tests
	res <- .splitGenotypeRank(mat)
	
	#test equality
    expect_that(exp, equals(res))

})

#'@include auxillary-methods.R
NULL

#' chi-square test
#' 
#' Performs a chisq.test on an ASEset object.
#' 
#' The test is performed on one strand in an ASEset object.
#' 
#' @name chisq.test
#' @rdname chisq.test
#' @aliases chisq.test,ASEset-method
#' @docType methods
#' @param x \code{ASEset} object
#' @param y strand option
#' @return \code{chisq.test} returns a matrix with the chisq.test P-value for
#' each SNP and sample
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{binom.test}} which is another test
#' that can be applied on an \link{ASEset} object.  }
#' @keywords chi-square test
#' @examples
#' 
#' #load example data
#' data(ASEset)
#' 
#' #make a chi-square test on default non-stranded strand 
#' chisq.test(ASEset)
#' 
NULL


#' @rdname chisq.test
#' @export
setMethod("chisq.test", signature(x = "ASEset", y = "ANY"), function(x, y = "*") {
    strand = y
    
    if (!sum(strand %in% c("+", "-", "*")) > 0) {
        stop(paste("strand parameter y has to be either '+', '-' or '*'"))
    }
    
    biasWarning <- vector()
    pLst <- list()
    
    if (strand == "both") {
        tmpStrand <- "+"
    } else {
        tmpStrand <- strand
    }
    
    for (i in 1:length(alleleCounts(x, strand = tmpStrand))) {
        
        bias <- mapBias(x)[[i, drop = FALSE]]
        
        df <- alleleCounts(x, strand = tmpStrand)[[i]]
        
        returnVec <- rep(NA, nrow(df))
        for (j in 1:nrow(df)) {
            so <- sort(df[j, ], decreasing = TRUE)
            if (so[2] != 0) {
                # place bias in same order as so
                bi <- bias[j, names(so)[1:2]]
                
                # check that bi[1] and bi[2] adds up to 100% or force 0.5-0.5 and give warning
                if (bi[1] + bi[2] != 1) {
                  bi[1] <- bi[2] <- 0.5
                  warning("Found disrepancy between mapping bias information and mapBiasExpMean and the allele count. Coerced to expectation of 0.5 to 0.5 ratio")
                }
                expCounts <- c(sum(so) * bi[1], sum(so) * bi[2])
                if (!(expCounts[1] < 5 | expCounts[2] < 5)) {
                  # the condition is that none of the Expected Counts should be below 5
                  returnVec[j] <- chisq.test(c(so[1], so[2]), p = c(bi[1], bi[2]), 
                    correct = FALSE)[[3]]
                } else {
                  returnVec[j] <- NA
                }  #if it's below 5 expected counts in either 
            } else {
                returnVec[j] <- NA
            }  # if it's mono-allelic
        }  #end for-loop
        pLst[[rownames(x)[i]]] <- returnVec
    }
    if (length(biasWarning) > 0) {
        warning(paste(length(biasWarning), "SNPs had disrepancy between their two highest read count alleles and the\n\n\t\t\t\t\t\t\t\t\ttwo alleles indicated in mapBiasExpMean. They were coerced to a standard and expected alignment \n\t\t\t\t\t\t\t\t\tbias of 0.5 to 0.5, but could be checked further as this indicates non-standard allele distributions:\n", 
            paste(biasWarning[1:(min(c(length(biasWarning), 20)))], collapse = ", ")))
    }
    return(as.matrix(as.data.frame(pLst)))
}) 

##'@include ASEset-class.R
#NULL
#
##' genotype filter methods 
##' 
##' useful genotype filters
##' 
##' These filters are called upon ASEset objects 
##' 
##' @name ReferenceBias-show
##' @rdname ReferenceBias-show
##' @aliases ReferenceBias-show ReferenceBias-show,ReferenceBias-method show,ReferenceBias-method
##' @docType methods
##' @param object ReferenceBias object
##' @author Jesper R. Gadin, Lasse Folkersen
##' @keywords show
##' @examples
##' 
##' #load example data
##' cat("there is no example data yet for this method")
##' 
##' @importFrom methods show
##' @exportMethod show
#
#setMethod("show","ReferenceBias",
#	function(object)
#		{
#
#		#Header
#		cat("Class:","ReferenceBias\n")
#		cat("Contains: RefFraction array\n")
#		}
#)
#
#

#'@include ASEset-class.R
NULL

#' AnnotationDb wrappers
#' 
#' These functions acts as wrappers to retrieve information from annotation
#' database objects (\code{annotationDb objects}) or (\code{transcriptDb
#' objects})
#' 
#' These functions retrieve regional annotation from OrgDb or TxDb objects,
#' when given GRanges objects.
#' 
#' @name annotation-wrappers
#' @rdname annotation-wrappers
#' @aliases getGenesFromAnnotation getGenesVector getExonsFromAnnotation
#' getTranscriptsFromAnnotation getCDSFromAnnotation getExonsVector
#' getTranscriptsVector getCDSVector getAnnotationDataFrame
#' @param OrgDb An \code{OrgDb} object
#' @param GR A \code{GenomicRanges} object with sample area
#' @param leftFlank An \code{integer} specifying number of additional
#' nucleotides around the SNPs for the leftFlank
#' @param rightFlank An \code{integer} specifying number of additional
#' nucleotides around the SNPs for the rightFlank
#' @param getUCSC A \code{logical} indicating if UCSC transcript IDs should
#' also be retrieved
#' @param TxDb A \code{transcriptDb} object
#' @param strand Two options,'+' or '-'
#' @param annotationType select one or more from 'gene', 'exon', 'transcript',
#' 'cds'.
#' @param verbose A \code{logical} making the functions more talkative
#' @return %OrgDb The \code{getGenesFromAnnotation} function will return a
#' \code{GRanges object} with ranges over the genes in the region.
#' 
#' The \code{getGenesVector} function will return a character vector where each
#' element are gene symbols separated by comma
#' 
#' %transcriptDb The \code{getExonsFromAnnotation} function will return a
#' \code{GRanges object} with ranges over the exons in the region.
#' 
#' The \code{getTranscriptsFromAnnotation} function will return a \code{GRanges
#' object} with ranges over the transcripts in the region.
#' 
#' The \code{getCDSFromAnnotation} function will return a \code{GRanges object}
#' with ranges over the CDSFs in the region.
#' 
#' The \code{getExonsVector} function will return a character vector where each
#' element are exons separated by comma
#' 
#' The \code{getTranscriptsVector} function will return a character vector
#' where each element are transcripts separated by comma
#' 
#' The \code{getCDSVector} function will return a character vector where each
#' element are CDSs separated by comma
#' 
#' The \code{getAnnotationDataFrame} function will return a data.frame with
#' annotations. This function is used internally by i.e. the barplot-function
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords genes exons transcripts CDS annotation
#' @examples
#' 
#' 
#'   data(ASEset)
#'   require(org.Hs.eg.db)
#'   require(TxDb.Hsapiens.UCSC.hg19.knownGene)
#'   OrgDb <- org.Hs.eg.db
#'   TxDb <- TxDb.Hsapiens.UCSC.hg19.knownGene
#' 
#'   #use for example BcfFiles as the source for SNPs of interest
#'   GR <- rowRanges(ASEset)
#'   #get annotation
#'   g <- getGenesFromAnnotation(OrgDb,GR)
#'   e <- getExonsFromAnnotation(TxDb,GR)
#'   t <- getTranscriptsFromAnnotation(TxDb,GR)
#'   c <- getCDSFromAnnotation(TxDb,GR)
#'   
#' @export getGenesFromAnnotation
#' @export getExonsFromAnnotation
#' @export getTranscriptsFromAnnotation
#' @export getCDSFromAnnotation
#' @export getGenesVector
#' @export getExonsVector
#' @export getTranscriptsVector
#' @export getCDSVector
#' @export getAnnotationDataFrame
NULL

#' @rdname annotation-wrappers
getGenesFromAnnotation <- function(OrgDb, GR, leftFlank = 0, rightFlank = 0, getUCSC = FALSE, 
    verbose = FALSE) {
    # checks
    if (class(OrgDb)[1] != "OrgDb") 
        stop(paste("OrgDb must of class OrgDb, not", class(OrgDb)[1]))
    
    if (class(GR)[1] != "GRanges") 
        stop(paste("GR must of class GRanges, not", class(GR)[1]))
    
    if (!class(leftFlank)[1] %in% c("numeric")) 
        stop(paste("leftFlank must be of class numeric, not:", class(leftFlank)[1]))
    if (length(leftFlank) != 1) 
        stop(paste("leftFlank must be of length 1, not:", length(leftFlank)))
    if (leftFlank < 0) 
        stop(paste("leftFlank must be equal to or larger than 0"))
    
    if (!class(rightFlank)[1] %in% c("numeric")) 
        stop(paste("rightFlank must be of class numeric, not:", class(rightFlank)[1]))
    if (length(rightFlank) != 1) 
        stop(paste("rightFlank must be of length 1, not:", length(rightFlank)))
    if (rightFlank < 0) 
        stop(paste("rightFlank must be equal to or larger than 0"))
    
    if (!class(getUCSC)[1] %in% c("logical")) 
        stop(paste("getUCSC must be of class logical, not:", class(getUCSC)[1]))
    if (length(getUCSC) != 1) 
        stop(paste("getUCSC must be of length 1, not:", length(getUCSC)))
    
    if (!"UCSCKG" %in% columns(OrgDb)) {
        if (verbose) 
            message("Unable to retrieve UCSCKG column from OrgDb. Omitting")
        getUCSC <- FALSE
    }
    
    if (!class(verbose)[1] %in% c("logical")) 
        stop(paste("verbose must be of class logical, not:", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose must be of length 1, not:", length(verbose)))
    
    # remove chr in seqnames
    seqLevels <- sub("^chr", "", seqlevels(GR))
    seqlevels(GR) <- seqLevels
    
    # pre-filtering to local region +/- 1MB (for speed purposes)
    startFilter <- max(c(1, start(range(GR)) - 10^6))
    endFilter <- end(range(GR)) + 10^6
    colsFilter <- c("CHR", "CHRLOC", "CHRLOCEND", "SYMBOL")
    sFilter <- suppressWarnings(select(OrgDb, keys = seqLevels, columns = colsFilter, 
        keytype = "CHR"))
    symbolsToGet <- sFilter[abs(sFilter[, "CHRLOC"]) > startFilter & abs(sFilter[, 
        "CHRLOCEND"]) < endFilter & !is.na(sFilter[, "CHRLOCEND"]) & !is.na(sFilter[, 
        "CHRLOC"]), "SYMBOL"]
    
    
    # then create an annGR for genes in range
    if (getUCSC) {
        cols <- c("SYMBOL", "CHR", "CHRLOC", "CHRLOCEND", "ENSEMBL", "UCSCKG")
    } else {
        cols <- c("SYMBOL", "CHR", "CHRLOC", "CHRLOCEND", "ENSEMBL")
    }
    s <- suppressWarnings(select(OrgDb, keys = symbolsToGet, columns = cols, keytype = "SYMBOL"))
    
    
    # remove Symbols with NAs
    TFminusStrand <- s[["CHRLOC"]] < 0
    TFplusStrand <- s[["CHRLOC"]] > 0
    sNoNas <- s[c(which(TFminusStrand), which(TFplusStrand)), ]
    
    # make Strand vector
    TFminusStrand2 <- sNoNas[["CHRLOC"]] < 0
    strand <- rep("+", length = (dim(sNoNas)[1]))
    
    strand[TFminusStrand2] <- "-"
    
    # make start and end vector
    sNonNegative <- sNoNas
    sNonNegative[TFminusStrand2, c("CHRLOC", "CHRLOCEND")] <- -sNonNegative[TFminusStrand2, 
        c("CHRLOC", "CHRLOCEND")]
    start <- sNonNegative[["CHRLOC"]]
    end <- sNonNegative[["CHRLOCEND"]]
    
    # make seqnames
    seqnames <- sNonNegative[["CHR"]]
    
    # make the annGR containing all genes
    if (getUCSC) {
        annGR <- GRanges(seqnames = Rle(seqnames), ranges = IRanges(start, end), 
            strand = Rle(strand), Symbol = sNonNegative[["SYMBOL"]], Ensembl = sNonNegative[["ENSEMBL"]], 
            UCSCKG = sNonNegative[["UCSCKG"]])
    } else {
        annGR <- GRanges(seqnames = Rle(seqnames), ranges = IRanges(start, end), 
            strand = Rle(strand), Symbol = sNonNegative[["SYMBOL"]], Ensembl = sNonNegative[["ENSEMBL"]])
        
    }
    
    # check that all levels in GR exist in annGR, if not exclude these levels
    if (sum(!levels(seqnames(GR)) %in% levels(seqnames(annGR))) > 0) {
        TFkeepLevels <- levels(seqnames(GR)) %in% levels(seqnames(annGR))
        seqlevels(GR) <- seqlevels(GR)[TFkeepLevels]
        
    }
    
    # check that all levels in annGR exist in GR, if not exclude these levels
    if (sum(!levels(seqnames(annGR)) %in% levels(seqnames(GR))) > 0) {
        TFkeepLevels <- levels(seqnames(annGR)) %in% levels(seqnames(GR))
        seqlevels(annGR, pruning.mode="coarse") <- seqlevels(annGR)[TFkeepLevels]
    }
    
    # the seqlevels comes in different orders. This will give the correct order.
    seqlevels(GR) <- seqlevels(annGR)
    
    # find overlaps between annGR and Snps incl. flank region
    GenesInRegion <- subsetByOverlaps(annGR, GR)  #put in flankSize here when you have time ;)
    seqlengths(GenesInRegion) <- seqlengths(GR)
    GenesInRegion
}

#' @rdname annotation-wrappers
getGenesVector <- function(OrgDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    if (verbose) {
        cat("start gene extraction\n")
    }
    GenesInRegion <- getGenesFromAnnotation(OrgDb, GR, leftFlank = leftFlank, rightFlank = rightFlank, 
        verbose = FALSE)
    
    seqlevels(GR) <- seqlevels(GenesInRegion)
    
    # remove duplicate symbol names if same symbol merge regions
    symbolList <- unique(mcols(GenesInRegion)[["Symbol"]])
    newGenesInRegion <- GRanges()
    
    # check if GenesInRegion is zero
    if (!length(GenesInRegion) == 0) {
        for (i in 1:length(symbolList)) {
            symbol <- symbolList[i]
            TF <- mcols(GenesInRegion)[["Symbol"]] == symbol
            
            G <- GRanges(seqnames = unique(seqnames(GenesInRegion[TF])), ranges = IRanges(min(start(GenesInRegion[TF])), 
                max(end(GenesInRegion[TF]))), strand = unique(strand(GenesInRegion[TF])))
            mcols(G) <- unique(mcols(GenesInRegion[TF])[, "Symbol", drop = FALSE])
            
            newGenesInRegion <- c(newGenesInRegion, G)
        }
    }
    
    # half-vectorized solution
    h <- findOverlaps(newGenesInRegion, GR)
    symbolVec <- vector()
    for (i in 1:length(GR)) {
        symbolVec[i] <- paste(mcols(newGenesInRegion[queryHits(h)[subjectHits(h) == 
            i]])[["Symbol"]], collapse = ",")
    }
    # set NAs where appropriate
    symbolVec[symbolVec == ""] <- NA
    # return list with symbols
    symbolVec
    
    # return list with symbols
    symbolVec
}

#' @rdname annotation-wrappers
getExonsFromAnnotation <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    
    # checks
    if (class(TxDb)[1] != "TxDb") 
        stop(paste("GR must of class TxDb, not", class(TxDb)[1]))
    
    if (class(GR)[1] != "GRanges") 
        stop(paste("GR must of class GRanges, not", class(GR)[1]))
    
    if (!class(leftFlank)[1] %in% c("numeric")) 
        stop(paste("leftFlank must be of class numeric, not:", class(leftFlank)[1]))
    if (length(leftFlank) != 1) 
        stop(paste("leftFlank must be of length 1, not:", length(leftFlank)))
    if (leftFlank < 0) 
        stop(paste("leftFlank must be equal to or larger than 0"))
    
    if (!class(rightFlank)[1] %in% c("numeric")) 
        stop(paste("rightFlank must be of class numeric, not:", class(rightFlank)[1]))
    if (length(rightFlank) != 1) 
        stop(paste("rightFlank must be of length 1, not:", length(rightFlank)))
    if (rightFlank < 0) 
        stop(paste("rightFlank must be equal to or larger than 0"))
    
    if (!class(verbose)[1] %in% c("logical")) 
        stop(paste("verbose must be of class logical, not:", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose must be of length 1, not:", length(verbose)))
    
    # remove chr in seqnames for GR
    seqLevels <- sub("^chr", "", seqlevels(GR))
    seqlevels(GR) <- seqLevels
    
    seqlevels(TxDb, pruning.mode="coarse") <- paste("chr", names(seqlengths(GR)), sep = "")
    
    # Get all exons from the active chromosomes By creating a GRanges from TxDb
    annGR <- exons(TxDb, columns = c("exon_id", "tx_name"))
    
    # remove chr in seqnames for annGR
    seqLevels <- sub("^chr", "", seqlevels(annGR))
    seqlevels(annGR) <- seqLevels
    
    # check that all levels in GR exist in annGR, if not exclude these levels
    if (sum(!levels(seqnames(GR)) %in% levels(seqnames(annGR))) > 0) {
        TFkeepLevels <- levels(seqnames(GR)) %in% levels(seqnames(annGR))
        seqlevels(GR) <- seqlevels(GR)[TFkeepLevels]
        
    }
    
    # check that all levels in annGR exist in GR, if not exclude these levels
    if (sum(!levels(seqnames(annGR)) %in% levels(seqnames(GR))) > 0) {
        TFkeepLevels <- levels(seqnames(annGR)) %in% levels(seqnames(GR))
        seqlevels(annGR, pruning.mode="coarse") <- seqlevels(annGR)[TFkeepLevels]
    }
    
    # the seqlevels comes in different orders. This will give the correct order.
    seqlevels(GR) <- seqlevels(annGR)
    
    # add flanking regions
    lf <- flank(GR, leftFlank, start = TRUE)
    rf <- flank(GR, rightFlank, start = FALSE)
    GR <- c(lf, GR, rf)
    start <- max(c(1, min(start(GR))))
    end <- max(end(GR))
    
    # speed-increasing coarse subset to +/- 1MB before extracting (because smaller
    # annGR is faster and we have to access several times)
    annGR <- annGR[start(ranges(annGR)) > max(c(1, start - 10^6)) & end(ranges(annGR)) < 
        (end + 10^6)]
    
    # extract names of all transcripts with exons in plotting window
    tx_names <- unique(unlist(as.list(mcols(annGR[start(ranges(annGR)) > start & 
        end(ranges(annGR)) < end])[["tx_name"]])))
    
    # retrieve all transcript annotation, including potential off-plot tails and
    # heads
    ExonsInRegion <- annGR[sapply(mcols(annGR)[["tx_name"]], function(x) {
        any(tx_names %in% x)
    })]
    
    seqlengths(ExonsInRegion) <- seqlengths(GR)
    ExonsInRegion
    
}

#' @rdname annotation-wrappers
getExonsVector <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    if (verbose) {
        cat("start exon extraction\n")
    }
    
    ExonsInRegion <- getExonsFromAnnotation(TxDb, GR, leftFlank, rightFlank, verbose = verbose)
    
    seqlevels(GR) <- seqlevels(ExonsInRegion)
    
    # half-vectorized solution
    h <- findOverlaps(ExonsInRegion, GR)
    ExonVec <- vector()
    for (i in 1:length(GR)) {
        ExonVec[i] <- paste(mcols(ExonsInRegion[queryHits(h)[subjectHits(h) == i]])[["exon_id"]], 
            collapse = ",")
    }
    # set NAs where appropriate
    ExonVec[ExonVec == ""] <- NA
    # return list with symbols
    ExonVec
    
}

#' @rdname annotation-wrappers
getTranscriptsFromAnnotation <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, 
    verbose = FALSE) {
    
    # checks
    if (class(TxDb)[1] != "TxDb") 
        stop(paste("GR must of class TxDb, not", class(TxDb)[1]))
    
    if (class(GR)[1] != "GRanges") 
        stop(paste("GR must of class GRanges, not", class(GR)[1]))
    
    if (!class(leftFlank)[1] %in% c("numeric")) 
        stop(paste("leftFlank must be of class numeric, not:", class(leftFlank)[1]))
    if (length(leftFlank) != 1) 
        stop(paste("leftFlank must be of length 1, not:", length(leftFlank)))
    if (leftFlank < 0) 
        stop(paste("leftFlank must be equal to or larger than 0"))
    
    if (!class(rightFlank)[1] %in% c("numeric")) 
        stop(paste("rightFlank must be of class numeric, not:", class(rightFlank)[1]))
    if (length(rightFlank) != 1) 
        stop(paste("rightFlank must be of length 1, not:", length(rightFlank)))
    if (rightFlank < 0) 
        stop(paste("rightFlank must be equal to or larger than 0"))
    
    if (!class(verbose)[1] %in% c("logical")) 
        stop(paste("verbose must be of class logical, not:", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose must be of length 1, not:", length(verbose)))
    
    
    
    # remove chr in seqnames for GR
    seqLevels <- sub("^chr", "", seqlevels(GR))
    seqlevels(GR) <- seqLevels
    
    seqlevels(TxDb, pruning.mode="coarse") <- paste("chr", names(seqlengths(GR)), sep = "")
    
    
    # Get all exons from the active chromosomes By creating a GRanges from TxDb
    annGR <- transcripts(TxDb)
    
    
    # remove chr in seqnames for annGR
    seqLevels <- sub("^chr", "", seqlevels(annGR))
    seqlevels(annGR) <- seqLevels
    
    # check that all levels in GR exist in annGR, if not exclude these levels
    if (sum(!levels(seqnames(GR)) %in% levels(seqnames(annGR))) > 0) {
        TFkeepLevels <- levels(seqnames(GR)) %in% levels(seqnames(annGR))
        seqlevels(GR) <- seqlevels(GR)[TFkeepLevels]
        
    }
    
    # check that all levels in annGR exist in GR, if not exclude these levels
    if (sum(!levels(seqnames(annGR)) %in% levels(seqnames(GR))) > 0) {
        TFkeepLevels <- levels(seqnames(annGR)) %in% levels(seqnames(GR))
        seqlevels(annGR, pruning.mode="coarse") <- seqlevels(annGR)[TFkeepLevels]
    }
    
    # the seqlevels comes in different orders. This will give the correct order.
    seqlevels(GR) <- seqlevels(annGR)
    
    # add flanking regions
    lf <- flank(GR, leftFlank, start = TRUE)
    rf <- flank(GR, rightFlank, start = FALSE)
    GR <- c(lf, GR, rf)
    # find overlaps between annGR and Snps incl. flank region
    TxInRegion <- subsetByOverlaps(annGR, GR)  #put in flankSize here when you have time ;)
    seqlengths(TxInRegion) <- seqlengths(GR)
    TxInRegion
}

#' @rdname annotation-wrappers
getTranscriptsVector <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    if (verbose) {
        cat("start transcript extraction\n")
    }
    
    TxInRegion <- getTranscriptsFromAnnotation(TxDb, GR, leftFlank, rightFlank)
    
    seqlevels(GR) <- seqlevels(TxInRegion)
    
    # half-vectorized solution
    h <- findOverlaps(TxInRegion, GR)
    TxVec <- vector()
    for (i in 1:length(GR)) {
        TxVec[i] <- paste(mcols(TxInRegion[queryHits(h)[subjectHits(h) == i]])[["tx_id"]], 
            collapse = ",")
    }
    # set NAs where appropriate
    TxVec[TxVec == ""] <- NA
    # return list with symbols
    TxVec
    
}

#' @rdname annotation-wrappers
getCDSFromAnnotation <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    # CDS are the coding regions that do not only code for proteins, but other also
    # other types like RNA.
    
    # checks
    if (class(TxDb)[1] != "TxDb") 
        stop(paste("GR must of class TxDb, not", class(TxDb)[1]))
    
    if (class(GR)[1] != "GRanges") 
        stop(paste("GR must of class GRanges, not", class(GR)[1]))
    
    if (!class(leftFlank)[1] %in% c("numeric")) 
        stop(paste("leftFlank must be of class numeric, not:", class(leftFlank)[1]))
    if (length(leftFlank) != 1) 
        stop(paste("leftFlank must be of length 1, not:", length(leftFlank)))
    if (leftFlank < 0) 
        stop(paste("leftFlank must be equal to or larger than 0"))
    
    if (!class(rightFlank)[1] %in% c("numeric")) 
        stop(paste("rightFlank must be of class numeric, not:", class(rightFlank)[1]))
    if (length(rightFlank) != 1) 
        stop(paste("rightFlank must be of length 1, not:", length(rightFlank)))
    if (rightFlank < 0) 
        stop(paste("rightFlank must be equal to or larger than 0"))
    
    if (!class(verbose)[1] %in% c("logical")) 
        stop(paste("verbose must be of class logical, not:", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose must be of length 1, not:", length(verbose)))
    
    # remove chr in seqnames for GR
    seqLevels <- sub("^chr", "", seqlevels(GR))
    seqlevels(GR) <- seqLevels
    
    seqlevels(TxDb, pruning.mode="coarse") <- paste("chr", names(seqlengths(GR)), sep = "")
    
    
    # Get all exons from the active chromosomes By creating a GRanges from TxDb
    annGR <- cds(TxDb)
    
    
    # remove chr in seqnames for annGR
    seqLevels <- sub("^chr", "", seqlevels(annGR))
    seqlevels(annGR) <- seqLevels
    
    # check that all levels in GR exist in annGR, if not exclude these levels
    if (sum(!levels(seqnames(GR)) %in% levels(seqnames(annGR))) > 0) {
        TFkeepLevels <- levels(seqnames(GR)) %in% levels(seqnames(annGR))
        seqlevels(GR) <- seqlevels(GR)[TFkeepLevels]
        
    }
    
    # check that all levels in annGR exist in GR, if not exclude these levels
    if (sum(!levels(seqnames(annGR)) %in% levels(seqnames(GR))) > 0) {
        TFkeepLevels <- levels(seqnames(annGR)) %in% levels(seqnames(GR))
        seqlevels(annGR, pruning.mode="coarse") <- seqlevels(annGR)[TFkeepLevels]
    }
    
    # the seqlevels comes in different orders. This will give the correct order.
    seqlevels(GR) <- seqlevels(annGR)
    
    # add flanking regions
    lf <- flank(GR, leftFlank, start = TRUE)
    rf <- flank(GR, rightFlank, start = FALSE)
    GR <- c(lf, GR, rf)
    # find overlaps between annGR and Snps incl. flank region
    CDSInRegion <- subsetByOverlaps(annGR, GR)  #put in flankSize here when you have time ;)
    seqlengths(CDSInRegion) <- seqlengths(GR)
    CDSInRegion
    
}



#' @rdname annotation-wrappers
getCDSVector <- function(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE) {
    if (verbose) {
        cat("start CDS extraction\n")
    }
    
    CDSInRegion <- getCDSFromAnnotation(TxDb, GR, leftFlank, rightFlank)
    
    seqlevels(GR) <- seqlevels(CDSInRegion)
    
    # half-vectorized solution
    h <- findOverlaps(CDSInRegion, GR)
    CDSVec <- vector()
    for (i in 1:length(GR)) {
        CDSVec[i] <- paste(mcols(CDSInRegion[queryHits(h)[subjectHits(h) == i]])[["cds_id"]], 
            collapse = ",")
    }
    # set NAs where appropriate
    CDSVec[CDSVec == ""] <- NA
    # return list with symbols
    CDSVec
}

#' @rdname annotation-wrappers
getAnnotationDataFrame <- function(GR, strand = "+", annotationType = NULL, OrgDb = NULL, 
    TxDb = NULL, verbose = FALSE) {
    # main checks
    if (sum(!(annotationType %in% c("gene", "exon", "cds", "transcript"))) > 0) {
        stop("annotationType must be one or more of these arguments 'gene','exon','cds','transcript'")
    }
    
    if (is.null(OrgDb) & is.null(TxDb)) {
        stop("at least one of parameters OrgDb or TxDb must be used")
    }
    
    # nr of columns for return df
    ncol <- 0
    if (!is.null(OrgDb)) {
        ncol <- ncol + 1
    }
    if (!is.null(TxDb)) {
        ncol <- ncol + (length(annotationType) - 1)
    }
    
    # return dataframe
    df <- data.frame(row.names = 1:length(GR))
    
    # set strand
    strand(GR) <- strand
    
    # extract annotation
    if (!is.null(OrgDb)) {
        if ("gene" %in% annotationType) {
            gene <- getGenesVector(OrgDb = OrgDb, GR = GR, verbose = verbose)
            df[["symbol"]] <- gene
        }
        if (is.null(annotationType)) {
            gene <- getGenesVector(OrgDb = OrgDb, GR = GR, verbose = verbose)
            df[["symbol"]] <- gene
        }
    }
    if (!is.null(TxDb)) {
        if ("exon" %in% annotationType) {
            df[["exon_id"]] <- getExonsVector(TxDb = TxDb, GR = GR, verbose = verbose)
        }
        if ("transcript" %in% annotationType) {
            df[["tx_id"]] <- getTranscriptsVector(TxDb = TxDb, GR = GR, verbose = verbose)
        }
        if ("cds" %in% annotationType) {
            df[["cds_id"]] <- getCDSVector(TxDb = TxDb, GR = GR, verbose = verbose)
        }
        
        if (is.null(annotationType)) {
            df[["exon_id"]] <- getExonsVector(TxDb = TxDb, GR = GR, verbose = verbose)
            df[["tx_id"]] <- getTranscriptsVector(TxDb = TxDb, GR = GR, verbose = verbose)
            df[["cds_id"]] <- getCDSVector(TxDb = TxDb, GR = GR, verbose = verbose)
        }
    }
    df
}

#' decorateWithGenes
#' 
#' Internal function that can draw gene regions on pre-specified surfaces.
#' Necessary for the genomic-location plots.
#' 
#' The main intention of this function is to be used when plotting several bar
#' plots in the same window. This function add gene regions under the bars.
#' 
#' @param x \code{ASEset} object
#' @param genesInRegion \code{GRanges} object with gene regions. Can be
#' obtained using \code{getGenesFromAnnotation}
#' @param xlim xlim values for the pre-specified surface
#' @param ylim ylim values for the pre-specified surface
#' @param chromosome character
#' @return \code{decorateWithGenes} returns nothing, but draws genes
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{locationplot}} which is uses this
#' function internally.  \item The \code{\link{decorateWithExons}} which is
#' another similar function that \code{\link{locationplot}} uses internally.  }
#' @keywords internal
#' @examples
#' 
#'   data(ASEset)
#' 
#' @export decorateWithGenes
decorateWithGenes <- function(x, genesInRegion, xlim, ylim, chromosome) {
    
    # check the input variables
    if (class(xlim)[1] != "integer") 
        xlim <- as.numeric(xlim)
    if (class(xlim)[1] != "numeric") 
        stop(paste("xlim must be of class numeric, not", class(xlim)[1]))
    if (length(xlim) != 2) 
        stop(paste("xlim must be of length 2, not", length(xlim)))
    if (class(ylim)[1] != "integer") 
        ylim <- as.numeric(ylim)
    if (class(ylim)[1] != "numeric") 
        stop(paste("ylim must be of class numeric, not", class(ylim)[1]))
    if (length(ylim) != 2) 
        stop(paste("ylim must be of length 2, not", length(ylim)))
    if (class(chromosome)[1] != "character") 
        stop(paste("chromosome must be of class character, not", class(chromosome)[1]))
    if (length(chromosome) != 1) 
        stop(paste("chromosome must be of length 1, not", length(chromosome)))
    if (!chromosome %in% unique(seqnames(genesInRegion))) {
        if (sub("^chr", "", chromosome) %in% unique(seqnames(genesInRegion))) {
            chromosome <- sub("^chr", "", chromosome)
        } else {
            stop(paste("chromosome", chromosome, "was not found amongst the seqnames of the genesInRegion object:", 
                paste(sort(unique(seqnames(genesInRegion))), collapse = ", ")))
        }
    }
    
    
    # only work with genes on current chromosome
    genesInRegion <- genesInRegion[seqnames(genesInRegion) == chromosome]
    
    # calculate how many 'rows' have to be made available
    maxCoverage <- max(coverage(genesInRegion)[[chromosome]])
    
    # loop over all unique genes, drawing them as specified
    uniqueGenes <- unique(mcols(genesInRegion)[["Symbol"]])
    
    for (i in 1:length(uniqueGenes)) {
        # getting the name of the gene and the height on the Y-axis
        genesymbol <- uniqueGenes[i]
        yPos <- ylim[1] + (i - 1)%%maxCoverage * ((ylim[2] - ylim[1])/maxCoverage)
        
        # this block checks for double instances and just arbitrarily take the first
        # (typically miRNAs with two locations)
        if (sum(mcols(genesInRegion)[["Symbol"]] %in% genesymbol) > 1) {
            geneData <- genesInRegion[which(mcols(genesInRegion)[["Symbol"]] %in% 
                genesymbol)[1], ]
        } else {
            geneData <- genesInRegion[which(mcols(genesInRegion)[["Symbol"]] %in% 
                genesymbol), ]
        }
        
        # draw and label
        start <- max(c(xlim[1] - (xlim[2] - xlim[1])/10, start(geneData)))
        end <- min(c(xlim[2] + (xlim[2] - xlim[1])/10, end(geneData)))
        lines(x = c(start, end), y = c(yPos, yPos), lwd = 2)
        text(x = start + (end - start)/2, y = yPos + (ylim[2] - ylim[1])/6, label = genesymbol, 
            cex = 0.8)
    }
}



#' decorateWithExons
#' 
#' Internal function that can draw gene regions on pre-specified surfaces.
#' Necessary for the genomic-location plots.
#' 
#' The main intention of this function is to be used when plotting several bar
#' plots in the same window. This function add gene regions under the bars.
#' 
#' @param x \code{ASEset} object
#' @param exonsInRegion \code{GRanges} object with generegions. Can be obtained
#' using \code{getExonsFromAnnotation}. Must contain a column 'tx_name'
#' @param xlim xlim values for the pre-specified surface
#' @param ylim ylim values for the pre-specified surface
#' @param chromosome character
#' @return \code{decorateWithExons} returns nothing, but draws genes
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{locationplot}} which is uses this
#' function internally.  \item The \code{\link{decorateWithGenes}} which is
#' another similar function that \code{\link{locationplot}} uses internally.  }
#' @keywords internal
#' @examples
#' 
#'   data(ASEset)
#' 
#' @export decorateWithExons
decorateWithExons <- function(x, exonsInRegion, xlim, ylim, chromosome) {
    
    # check the input variables
    if (class(exonsInRegion)[1] != "GRanges") 
        stop(paste("exonsInRegion must be of class GRanges, not", class(exonsInRegion)[1]))
    if (!"tx_name" %in% colnames(mcols(exonsInRegion))) 
        stop("exonsInRegion must contain an mcol variable named 'tx_name'")
    if (class(xlim)[1] != "integer") 
        xlim <- as.numeric(xlim)
    if (class(xlim)[1] != "numeric") 
        stop(paste("xlim must be of class numeric, not", class(xlim)[1]))
    if (length(xlim) != 2) 
        stop(paste("xlim must be of length 2, not", length(xlim)))
    if (class(ylim)[1] != "integer") 
        ylim <- as.numeric(ylim)
    if (class(ylim)[1] != "numeric") 
        stop(paste("ylim must be of class numeric, not", class(ylim)[1]))
    if (length(ylim) != 2) 
        stop(paste("ylim must be of length 2, not", length(ylim)))
    if (class(chromosome)[1] != "character") 
        stop(paste("chromosome must be of class character, not", class(chromosome)[1]))
    if (length(chromosome) != 1) 
        stop(paste("chromosome must be of length 1, not", length(chromosome)))
    if (!chromosome %in% unique(seqnames(exonsInRegion))) {
        if (sub("^chr", "", chromosome) %in% unique(seqnames(exonsInRegion))) {
            chromosome <- sub("^chr", "", chromosome)
        } else {
            stop(paste("chromosome", chromosome, "was not found amongst the seqnames of the exonInRegion object:", 
                paste(sort(unique(seqnames(exonsInRegion))), collapse = ", ")))
        }
    }
    # only work with exons on current chromosome
    exonsInRegion <- exonsInRegion[seqnames(exonsInRegion) == chromosome]
    
    
    # calculate how many 'rows' have to be made available (corresponding to the
    # number of unique transcripts in exonsInRegion
    uniqueGenes <- unique(unlist(as.list(mcols(exonsInRegion)[["tx_name"]])))
    maxCoverage <- length(uniqueGenes)
    
    
    for (i in 1:length(uniqueGenes)) {
        # getting the name of the gene and the height on the Y-axis
        tx_name <- uniqueGenes[i]
        yPos <- ylim[1] + (i - 1)%%maxCoverage * ((ylim[2] - ylim[1])/maxCoverage)
        
        # extracting and drawing all exons for each transcript
        exonsInTranscript <- which(sapply(as.list(mcols(exonsInRegion)[["tx_name"]]), 
            function(x) {
                tx_name %in% x
            }))
        for (exonInTranscript in exonsInTranscript) {
            x1 <- start(exonsInRegion[exonInTranscript])
            x2 <- end(exonsInRegion[exonInTranscript])
            lines(x = c(x1, x2), y = c(yPos, yPos), lwd = 2)
        }
        
        
        # draw a thin connecting line for each transcript
        end <- max(end(exonsInRegion[exonsInTranscript]))
        start <- min(start(exonsInRegion[exonsInTranscript]))
        lines(x = c(start, end), y = c(yPos, yPos), lwd = 0.5)
        
        # label with the tx_name
        start <- max(c(start, xlim[1]))
        end <- min(c(end, xlim[2]))
        text(x = start + (end - start)/2, y = yPos + (ylim[2] - ylim[1])/6, label = tx_name, 
            cex = 0.8)
        
    }
} 

#'@include AllelicImbalance-package.R
NULL

### =========================================================================
### General helper functions not exported
### =========================================================================

#supposed to merge paths and file irrespective OS and presence of trailing slash
.mergeDirAndFilename <- function(dir, files){
	#check for presence of / in filename in that case remove
	files <- sub("/","",files)
	paste(normalizePath(dir),"/",files, sep="")
}

.matrixFromLmListCommonParam <- function(lst){
	mat <- t(sapply(lst, function(x){
		s <- summary(x)$coefficients	   
		c(s[1,1],s[2,1],s[1,2],s[2,2],s[1,3],s[2,3],s[1,4],s[2,4])
	}))
	colnames(mat) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
	mat
}

#transform an index vector into a IRanges object
.IRangesFromIntegerList <- function(idx){
	IRanges(c(1,idx@partitioning@end[-length(idx@partitioning@end)]+1), idx@partitioning@end)
}

#first dimension of array will make up the length of the list
.array2MatrixList <- function(ar){
	lapply(setNames(1:dim(ar)[1], dimnames(ar)[[1]]), function(i, ar){
		ar[i,,]
	}, ar=ar)
}

#important helper to pick put the frequence of the reference allele
.arrayFromAlleleVector <- function(var, sel, nc){
	selmat <- array(sel, dim=c(length(sel), length(var)))
	varmat <- array(var, dim=c(length(var), length(sel)))
	tf <- t(selmat) == varmat

	#expand to array
	aperm(array(tf,dim=c(nrow(tf),ncol(tf),nc)),c(2,3,1) )
		

}

#this is eg. the follow up on arrayFromAlleleVector to extract frequency from that spcific variant
#It accepts all dimensions, as long as dim(fr)==dim(ar)
.subsetArrayToMatrix <- function(fr, ar){
	array(aperm(fr,c(3,1,2))[aperm(ar,c(3,1,2))],dim=c(nrow(fr),ncol(fr)))
}

#this is eg. the follow up on arrayFromAlleleVector to extract frequency from that spcific variant
#It accepts dim 1 or 2, and is the one
.expandMatrixToArray <- function(mat, len){
	array(mat, dim=c(nrow(mat),ncol(mat), len))
}

#when we need to make sure the input is character
#returns target as character and issues a warning if the input wasnt
.verboseCoerceToCharacter <- function(x){
	if(!class(x)[1]=="character"){
		warning("arg was not of type character, and will therefore be coerced to character")
		as.character(x)
	}else x
}

#convert NA to FALSE
.Na2False <- function(x){
	if(class(x[1])[1]=="numeric" | class(x[1])[1]=="integer") 
		stop("not possible to replace a numeric or integer with FALSE and get the expected result")
	x[is.na(x)] <- FALSE
	x
}

context("test utils functions")

test_that(paste("test trailing slash remover"), {


	dir1 <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')
	dir2 <- paste(dir1,"/",sep="")	

	files1 <- c("ERR009113.bam","ERR009147.bam", "ERR009159.bam" )
	files2 <- paste(files1,"/",sep="")	
	files3 <- paste("/", files1,sep="")	


	##prepare result string (at the moment only system specific)
	#res <- c(
	#		 paste("/mnt/kelewan/pappewaio/Documents/PHD/repos/AllelicImbalance",
	#			 "/bioCgit/AllelicImbalance/inst/extdata/ERP000101_subset/",
	#			 "ERR009113.bam",
	#			 sep=""),
	#		 paste("/mnt/kelewan/pappewaio/Documents/PHD/repos/AllelicImbalance",
	#			 "/bioCgit/AllelicImbalance/inst/extdata/ERP000101_subset/",
	#			 "ERR009147.bam",
	#			 sep=""),
	#		 paste("/mnt/kelewan/pappewaio/Documents/PHD/repos/AllelicImbalance",
	#			 "/bioCgit/AllelicImbalance/inst/extdata/ERP000101_subset/",
	#			 "ERR009159.bam",
	#			 sep="")
	#	)

	##check single file
    #expect_that(res[1], equals(.mergeDirAndFilename(dir1, files1[1])))
    #expect_that(res[1], equals(.mergeDirAndFilename(dir1, files2[1])))
    #expect_that(res[1], equals(.mergeDirAndFilename(dir1, files3[1])))

    #expect_that(res[1], equals(.mergeDirAndFilename(dir2, files1[1])))
    #expect_that(res[1], equals(.mergeDirAndFilename(dir2, files2[1])))
    #expect_that(res[1], equals(.mergeDirAndFilename(dir2, files3[1])))

	##check multiple files
    #expect_that(res, equals(.mergeDirAndFilename(dir1, files1)))
    #expect_that(res, equals(.mergeDirAndFilename(dir1, files2)))
    #expect_that(res, equals(.mergeDirAndFilename(dir1, files3)))

    #expect_that(res, equals(.mergeDirAndFilename(dir2, files1)))
    #expect_that(res, equals(.mergeDirAndFilename(dir2, files2)))
    #expect_that(res, equals(.mergeDirAndFilename(dir2, files3)))

})

test_that(paste("test lm simplifier"), {

	#######################
	# Test 1
	#######################
	y <- c(1,2,4,3,2,4,3,2)
	x <- c(1,1,1,1,2,2,2,2)
	en	<- lm(x~y)
	lst <- list(en,en,en,en)

	exp <- matrix(c(1.333333, 0.06349206, 0.5727498, 0.2040984,
				  2.327951, 0.3110855, 0.05880542, 0.7662601),
				  ncol=8, nrow=4, byrow=TRUE)
	colnames(exp) <- c("est1","est2","stderr1","stderr2","tvalue1","tvalue2","pvalue1","pvalue2")
	
	res <- .matrixFromLmListCommonParam(lst)

    expect_equal(res, exp, tolerance=1e-5)

})

test_that(paste("checking .IRangesFromIntegerList"), {

	#####################
	# Test 1 
	#####################
	
	#add one region that is missing
	idx <- IntegerList(list(c(1,2),c(3,3,4,1),c(4,4,3)))

	#prepeare expected data
	exp <- IRanges(c(1,3,7), c(2,6,9))

	#run tests
	res <- .IRangesFromIntegerList(idx)
	
	#test equality
    expect_that(exp, equals(res))

})

test_that(paste("checking .arrayFromAlleleVector"), {

	#####################
	# Test 1 
	#####################
	
	#add one region that is missing
	var <- c("A", "T", "G", "C")
	sel <- c("A", "A","C")
	nc <- 2

	#prepeare expected data
	exp <- array(c(c(T,T,F,T,T,F,F,F,F,F,F,F),
				   c(F,F,F,F,F,F,F,F,T,F,F,T))
				   , dim=c(3,2,4))

	#run tests
	res <- .arrayFromAlleleVector(var, sel, nc)
	
	#test equality
    expect_equal(exp, res)


	#####################
	# Test 2 - something the unit test 1, did not catch
	#####################
	
	#add one region that is missing
	var <- c("A", "C", "G", "T")
	sel <- c("T", "C","G")
	nc <- 20

	#prepeare expected data
	ma <- array(c(F,F,F,T,F,T,F,F,F,F,T,F), dim=c(4,3))
	exp <- aperm(array(ma,dim=c(nrow(ma),ncol(ma),nc)),c(2,3,1) )
 
	#run tests
	res <- .arrayFromAlleleVector(var, sel, nc)
	
	#test equality
    expect_equal(exp, res)


})

test_that(paste("checking .subsetArrayToMatrix"), {

	#####################
	# Test 1 - when array to be subsetted is the frequency array
	#####################
	
	#add one region that is missing
	ar2 <- aperm(array(c(T,T,F,F,F,F,F,F,F,F,F,T), dim=c(3,4,2)), c(1,3,2))
	ar <- array(c(0.3,0.2,0.3,0.2,0.8,0.2,0.3,0.7,0.4,0.2,0.1,0.3), dim=c(3,2,4))

	#prepeare expected data
	exp <- array(c(0.3,0.2,0.4,0.2,0.8,0.3), dim=c(3,2))

	#run tests
	res <- .subsetArrayToMatrix(ar, ar2)
	
	#test equality
    expect_equal(exp, res)

	#####################
	# Test 2 - when array to be subsetted is the count array
	#####################
	
	#add one region that is missing
	ar2 <- aperm(array(c(T,T,F,F,F,F,F,F,F,F,F,T), dim=c(3,4,2)), c(1,3,2))
	ar <- array(c(10,20,30,40,50,60,11,22,33,44,55,66), dim=c(3,2,4))

	#prepeare expected data
	exp <- array(c(10,20,33,40,50,66), dim=c(3,2))

	#run tests
	res <- .subsetArrayToMatrix(ar, ar2)
	
	#test equality
    expect_equal(exp, res)

})

test_that(paste("checking .expandMatrixToArray"), {

	#####################
	# Test 1 - 
	#####################
	
	#prepeare expected data
	mat <- array(c(0.3,0.2,0.4,0.2,0.8,0.3), dim=c(3,2))
	len <- 4

	#add one region that is missing
	exp <- array(mat, dim=c(3,2,4))

	#run tests
	res <- .expandMatrixToArray(mat, len)
	
	#test equality
    expect_equal(exp, res)

})

test_that(paste("checking .verboseCoerceToCharacter"), {

	#####################
	# Test 1 - 
	#####################
	
	#prepeare expected data
	vec <- c("A","T","G")

	#add one region that is missing
	exp <- c("A","T","G")

	#run tests
	res <- .verboseCoerceToCharacter(vec)
	
	#test equality
    expect_equal(exp, res)

	#####################
	# Test 1 - test a class that is not character
	#####################

	vec <- c(1,2,3)
	#add one region that is missing
	exp <- c("1","2","3")

	#test 
    expect_warning(res <- .verboseCoerceToCharacter(vec))
    expect_equal(exp, res)

})

test_that(paste("checking .Na2False"), {

	#####################
	# Test 1 - vector
	#####################
	
	#prepeare expected data
	vec <- c("A",NA,"G")
	#add one region that is missing
	exp <- c("A",FALSE,"G")
	#run tests
	res <- .Na2False(vec)
	#test equality
    expect_equal(exp, res)

	#####################
	# Test 2 - test a matrix with numbers
	# numbers will not give the expected output
	#####################

	vec <- matrix(c(1,2,3,NA,5,6), ncol=2)
    expect_error(.Na2False(vec))

	#####################
	# Test 2 - test a matrix with numbers
	# numbers will not give the expected output
	#####################
	vec <- matrix(c(T,F,T,NA,F,T), ncol=2)
	exp <- matrix(c(T,F,T,F,F,T), ncol=2)
	res <- .Na2False(vec)
	expect_equal(exp, res)

})

#' barplot ASEset objects
#' 
#' Generates barplots for ASEset objects. Two levels of plotting detail are
#' provided: a detailed barplot of read counts by allele useful for fewer
#' samples and SNPs, and a less detailed barplot of the fraction of imbalance,
#' useful for more samples and SNPs.
#' 
#' \code{filter.pValue.fraction} is intended to remove p-value annotation with
#' very large difference in frequency, which could just be a sequencing
#' mistake. This is to avoid p-values like 1e-235 or similar.
#' 
#' \code{sampleColour}User specified colours, either given as named colours
#' ('red', 'blue', etc) or as hexadecimal code. Can be either length 1 for all
#' samples, or else of a length corresponding to the number of samples for
#' individual colouring.
#' 
#' @name ASEset-barplot
#' @rdname ASEset-barplot
#' @aliases ASEset-barplot barplot barplot,ASEset-method
#' @docType methods
#' @param height An \code{ASEset} object
#' @param type 'count' or 'fraction'
#' @param sampleColour.top User specified colours for top fraction
#' @param sampleColour.bot User specified colours for bottom fraction
#' @param legend Display legend
#' @param pValue Display p-value
#' @param strand four options, '+', '-', 'both' or '*'
#' @param testValue if set, a matrix or vector with user p-values
#' @param testValue2 if set, a matrix or vector with user p-values
#' @param OrgDb an OrgDb object which provides annotation
#' @param TxDb a TxDb object which provides annotation
#' @param annotationType select one or more from
#' 'gene','exon','transcript','cds'.
#' @param main text to use as main label
#' @param ylim set plot y-axis limit
#' @param yaxis wheter the y-axis is to be displayed or not
#' @param xaxis wheter the x-axis is to be displayed or not
#' @param ylab showing labels for the tic marks
#' @param ylab.text ylab text
#' @param xlab showing labels for the tic marks
#' @param xlab.text xlab text
#' @param legend.colnames gives colnames to the legend matrix
#' @param las.ylab orientation of ylab text
#' @param las.xlab orientation of xlab text
#' @param cex.main set main label size (max 2)
#' @param cex.pValue set pValue label size
#' @param cex.ylab set ylab label size
#' @param cex.xlab set xlab label size
#' @param cex.legend set legend label size
#' @param cex.annotation size of annotation text
#' @param ypos.annotation relative ypos for annotation text
#' @param annotation.interspace space between annotation text
#' @param legend.interspace set legend space between fills and text
#' @param add \code{boolean} indicates if a new device should be started
#' @param lowerLeftCorner integer that is only useful when \code{add}=TRUE
#' @param size Used internally by locationplot. Rescales each small barplot
#' window
#' @param addHorizontalLine adds a horizontal line that marks the default
#' fraction of 0.5 - 0.5
#' @param add.frame \code{boolean} to give the new plot a frame or not
#' @param filter.pValue.fraction \code{numeric} between 0 and 1 that filter
#' away pValues where the main allele has this frequency.
#' @param legend.fill.size size of the fill/boxes in the legend (default:NULL)
#' @param verbose Makes function more talkative
#' @param top.fraction.criteria 'maxcount', 'ref' or 'phase'
#' @param ... for simpler generics when extending function
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the barplot
#' function can be called up on.  }
#' @keywords barplot
#' @examples
#' 
#' data(ASEset)
#' barplot(ASEset[1])
#'
#' @importFrom graphics plot
#' @importFrom graphics barplot
#' @exportMethod barplot
NULL

#' @rdname ASEset-barplot
setGeneric("barplot")

#' @rdname ASEset-barplot
setMethod("barplot", signature(height = "ASEset"), function(height, type = "count", 
    sampleColour.top = NULL, sampleColour.bot = NULL, legend = TRUE, pValue = TRUE, strand = "*", testValue = NULL, 
    testValue2 = NULL, OrgDb = NULL, TxDb = NULL, annotationType = c("gene", "exon", 
        "transcript"), main = NULL, ylim = NULL, yaxis = TRUE, xaxis = FALSE, ylab = TRUE,
											 ylab.text=NULL, xlab.text="samples",
    xlab = TRUE, legend.colnames = "", las.ylab = 1, las.xlab = 2, cex.main = 1, 
    cex.pValue = 0.7, cex.ylab = 0.7, cex.xlab = 0.7, cex.legend = 0.6, add = FALSE, 
    lowerLeftCorner = c(0, 0), size = c(1, 1), addHorizontalLine = 0.5, add.frame = TRUE, 
    filter.pValue.fraction = 0.99,  legend.fill.size=1, legend.interspace=1, verbose = FALSE, 
	top.fraction.criteria="maxcount", cex.annotation=0.7, ypos.annotation=0, annotation.interspace=1,
	...) {
    
    # catch useful graphical parameters that can be used to later add onto plot. This
    # list will be retireved by using 'glst <- barplot(x)'
    graphParamList <- list()
    
    x <- height
    
    # check type
    okPlotTypes <- c("fraction", "count")
    if (!type %in% okPlotTypes) 
        stop(paste("type can't be '", type, "' - it should be one of these: ", paste(okPlotTypes, 
            collapse = ", "), sep = ""))
    
    # check verbose
    if (class(verbose)[1] != "logical") 
        stop(paste("verbose should be of class logical, not", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose should be of length 1, not", length(verbose)))
    
    
    # check strand
    okStrandTypes <- c("both", "+", "-", "*")
    if (!strand %in% okStrandTypes) 
        stop(paste("strand can't be '", strand, "' - it should be one of these: ", 
            paste(okStrandTypes, collapse = ", "), sep = ""))
    
    # check if strand type is present in object
	# there is a check at the alleleCountsList aswell.
	# And since the new ASEset version the strands will always be present
	#
    #if (strand == "+") {
    #    el <- "countsPlus"
    #    if (!(el %in% assayNames(x))) {
    #        stop("strand is not present as assay in ASEset object")
    #    }
    #} else if (strand == "-") {
    #    el <- "countsMinus"
    #    if (!(el %in% assayNames(x))) {
    #        stop("strand is not present as assay in ASEset object")
    #    }
    #} else if (strand == "*") {
    #    el <- "countsUnknown"
    #    if (!(el %in% assayNames(x))) {
    #        stop("strand is not present as assay in ASEset object")
    #    }
    #} else if (strand == "both") {
    #    el <- "countsPlus"
    #    if (!(el %in% assayNames(x))) {
    #        stop("strand is not present as assay in ASEset object")
    #    }
    #    el <- "countsMinus"
    #    if (!(el %in% assayNames(x))) {
    #        stop("strand is not present as assay in ASEset object")
    #    }
    #} else {
    #    stop("unknown strand option")
    #}
    
    # check legend
    if (!is.logical(legend)) {
        stop("legend has to be logical, TRUE or FALSE")
    }
    if (!length(legend) == 1) {
        stop("legend has to be of length 1")
    }
    
    # check pValue
    if (!is.logical(pValue)) {
        stop("pValue has to be logical, TRUE or FALSE")
    }
    if (!length(pValue) == 1) {
        stop("pValue has to be of length 1")
    }
    
    
    # check ylim
    if (!is.null(ylim)) {
    }
    
    # check testValue
    if (!is.null(testValue)) {
        if (!class(testValue)[1] == "numeric" & !class(testValue)[1] == "matrix") {
            stop("wrong class for testValue")
        }
        if (!class(testValue)[1] == "matrix") {
            if (!sum(dim(testValue) == rev(dim(x))) == 2) {
                stop("wrong dimensions of testValue")
            }
        }
        if (!class(testValue)[1] == "numeric") {
            if (!length(testValue) == ncol(x)) {
                stop("wrong dimensions of testValue")
            }
        }
    }
    # check testValue2
    if (!is.null(testValue2)) {
        if (!class(testValue2)[1] == "numeric" & !class(testValue2)[1] == "matrix") {
            stop("wrong class for testValue")
        }
        if (!class(testValue2)[1] == "matrix") {
            if (!sum(dim(testValue2) == rev(dim(x))) == 2) {
                stop("wrong dimensions of testValue")
            }
        }
        if (!class(testValue2)[1] == "numeric") {
            if (!length(testValue2) == ncol(x)) {
                stop("wrong dimensions of testValue")
            }
        }
    }
    
    # check testValue combinations
    if (!strand == "both" & !is.null(testValue2)) {
        stop("testValue2 is supposed to only be \n\t\t\tspecified when using strand='both', and then be the values for the minus strand.")
    }
    
    # check ylim
    if (!is.null(ylim)) {
        if (type == "fraction") {
            warning("an ylim argument given to barplot with type fraction is ignored")
            ylim <- NULL
        } else {
            if (class(ylim)[1] != "numeric") 
                stop(paste("if given, ylim must be of class numeric, not", class(ylim)[1]))
            if (length(ylim) != 2) 
                stop(paste("if given, ylim must be of length 2, not", length(ylim)))
            if (ylim[2] < ylim[1]) 
                stop(paste("if ylim is given, ylim[2] must be larger than ylim[1]"))
        }
    }
    
    # set easy accessor to samples
    samples <- colnames(x)
    # set easy accessor to snps
    snps <- rownames(x)
    
    
    # check sampleColour
    if (is.null(sampleColour.top)) {
        sampleColour.top <- rep("darkolivegreen4", length(samples))
	}
    if (is.null(sampleColour.bot)) {
        sampleColour.bot <- rep("brown2", length(samples))
	}
#    if (is.null(sampleColour)) {
#        sampleColour <- rep("dodgerblue", length(samples))
#    } else {
#        if (class(sampleColour) != "character") 
#            stop(paste("if given, sampleColour should be of class character, not", 
#                class(sampleColour)))
#        if (length(sampleColour) == 1) {
#            sampleColour <- rep(sampleColour, length(samples))
#        } else {
#            if (length(sampleColour) != length(samples)) 
#                stop(paste("if given, sampleColour should be of length 1 or length", 
#                  length(samples), "(corresponding to the number of samples)"))
#        }
#        hexadecimals <- sampleColour[grep("^#[0-9A-F]{6}", sampleColour)]
#        missing <- sampleColour[!(sampleColour %in% colors() | sampleColour %in% 
#            hexadecimals)]
#        if (length(missing) > 0) {
#            stop(paste("The following", length(unique(missing)), "colour(s) from sampleColour were not recognised:", 
#                paste(sort(unique(missing)), collapse = ", ")))
#        }
#    }
    
    # check OrgDb
    if (!is.null(OrgDb)) {
        if (!class(OrgDb)[1] == "OrgDb") {
            stop("class of OrgDb has to be an OrgDb class")
        }
    }
    if (!is.null(TxDb)) {
        if (!class(TxDb)[1] == "TxDb") {
            stop("class of TxDb has to be a TxDb class")
        }
    }
    
    # check annotationType
    okAnnotationTypes <- c("gene", "exon", "cds", "transcript")
    if (!sum(annotationType %in% okAnnotationTypes) == length(annotationType)) {
        stop(paste("type can't be '", annotationType, "' - it should be one of these: ", 
            paste(okAnnotationTypes, collapse = ", "), sep = ""))
    }
    
    # check main
    if (!is.null(main)) {
        if (!class(main)[1] == "character") {
            stop("main has to be of class character")
        }
    }
    
    # check yaxis
    if (!is.logical(yaxis)) {
        stop("yaxis has to be logical, TRUE or FALSE")
    }
    if (!length(yaxis) == 1) {
        stop("yaxis has to be of length 1")
    }
    
    # check xaxis
    if (!is.logical(xaxis)) {
        stop("xaxis has to be logical, TRUE or FALSE")
    }
    if (!length(xaxis) == 1) {
        stop("xaxis has to be of length 1")
    }
    
    # check ylab
    if (!is.logical(ylab)) {
        stop("ylab has to be logical, TRUE or FALSE")
    }
    if (!length(ylab) == 1) {
        stop("ylab has to be of length 1")
    }
    
    # check xlab
    if (!is.logical(xlab)) {
        stop("xlab has to be logical, TRUE or FALSE")
    }
    if (!length(xlab) == 1) {
        stop("xlab has to be of length 1")
    }
    
    # check legend.colnames
    if (!class(legend.colnames)[1] == "character") {
        stop("legend.colnames has to be of class character")
    }
    
    # check las.ylab
    if (!class(las.ylab)[1] == "numeric" & !class(las.ylab)[1] == "integer") {
        stop("las.ylab has to be of class numeric or integer")
    }
    if (!las.ylab == 1 & !las.ylab == 2) {
        stop("las.ylab has to be a number, either 1 or 2")
    }
    
    # check las.xlab
    if (!class(las.xlab)[1] == "numeric" & !class(las.xlab)[1] == "integer") {
        stop("las.xlab has to be of class numeric or integer")
    }
    if (!las.xlab == 1 & !las.xlab == 2) {
        stop("las.xlab has to be a number, either 1 or 2")
    }
    
    # check cex all of them
    if (!class(cex.main)[1] == "numeric") {
        if (cex.main <= 0 | !length(cex.main) == 1) 
            stop("cex.main has to be of class numeric, and have length 1, and a value above 0 ")
    }
    if (!class(cex.pValue)[1] == "numeric") {
        if (cex.pValue > 1 | cex.pValue <= 0 | !length(cex.pValue) == 1) 
            stop("cex.pValue has to be of class numeric, and have length 1, and a value above 0")
    }
    if (!class(cex.ylab)[1] == "numeric") {
        if (cex.ylab <= 0 | !length(cex.ylab) == 1) 
            stop("cex.ylab has to be of class numeric, and have length 1, and a value above 0 ")
    }
    if (!class(cex.xlab)[1] == "numeric") {
        if (cex.xlab <= 0 | !length(cex.xlab) == 1) 
            stop("cex.xlab has to be of class numeric, and have length 1, and a value above 0 ")
    }
    if (!class(cex.legend)[1] == "numeric") {
        if (cex.legend <= 0 | !length(cex.legend) == 1) 
            stop("cex.legend has to be of class numeric, and have length 1, and a value above 0 ")
    }
    
    # check add
    if (!is.logical(add)) {
        stop("add has to be logical, TRUE or FALSE")
    }
    if (!length(add) == 1) {
        stop("add has to be of length 1")
    }
    
    # check lowerLeftCorner
    if (!class(lowerLeftCorner)[1] == "numeric" & !class(lowerLeftCorner)[1] == "integer") {
        stop("lowerLeftCorner has to be of class numeric or integer")
    }
    if (!length(lowerLeftCorner) == 2) {
        stop("lowerLeftCorner has be of length 2")
    }
    
    # check size
    if (!class(size)[1] == "numeric" & !class(size)[1] == "integer") {
        stop("size has to be of class numeric or integer")
    }
    if (!length(size) == 2) {
        stop("size has be of length 2")
    }
    
    # check addHorizontalLine
    if (!is.null(addHorizontalLine)) {
        if (!class(addHorizontalLine)[1] == "numeric") {
            stop("addHorizontalLine has to be either NULL or of class numeric")
        }
        if (!length(addHorizontalLine) == 1) {
            stop("addHorizontalLine has be of length 1")
        }
        if (addHorizontalLine > 1 | addHorizontalLine <= 0) {
            stop("addHorizontalLine has be numeric between 0 and 1")
        }
    }
    
    # check add.frame
    if (!is.logical(add.frame)) {
        stop("add.frame has to be logical, TRUE or FALSE")
    }
    if (!length(add.frame) == 1) {
        stop("add.frame has to be of length 1")
    }
    
    # check filter.pValue.fraction=0.99
    if (!class(filter.pValue.fraction)[1] == "numeric") {
        stop("filter.pValue.fraction has to be of class numeric")
    }
    if (!length(filter.pValue.fraction) == 1) {
        stop("filter.pValue.fraction has to be of length 1")
    }
    if (filter.pValue.fraction < 0 | filter.pValue.fraction > 1) {
        stop("filter.pValue.fraction has to be a value between 0 and 1")
    }
    
    # make annotation dataframes
    if ((!is.null(OrgDb) | !is.null(TxDb)) & (strand == "+" |  
        strand == "*" | strand == "both")) {
        annDfPlus <- getAnnotationDataFrame(rowRanges(x), strand = "+", annotationType = annotationType, 
            OrgDb = OrgDb, TxDb = TxDb, verbose = verbose)
    } else {
        annDfPlus <- NULL
    }
    if ((!is.null(OrgDb) | !is.null(TxDb)) & (strand == "-" |  
        strand == "*" | strand == "both")) {
        annDfMinus <- getAnnotationDataFrame(rowRanges(x), strand = "-", annotationType = annotationType, 
            OrgDb = OrgDb, TxDb = TxDb, verbose = verbose)
    } else {
        annDfMinus <- NULL
    }
    
    # creating a background from foreground colour - basically just turning down the
    # saturation a little compared to the foreground color except for very
    # low-saturated fg's which are made more saturated, and very dark fg's which are
    # made lighter
    #hsvColoursBg <- hsvColoursFg <- rgb2hsv(col2rgb(sampleColour))
    #veryLowSaturation <- hsvColoursFg["s", ] < 0.3
    #veryDark <- hsvColoursFg["v", ] < 0.2
    #remaining <- !veryLowSaturation & !veryDark
    #hsvColoursBg["s", veryLowSaturation] <- hsvColoursFg["s", veryLowSaturation] + 
    #    0.3
    #hsvColoursBg["v", veryDark] <- hsvColoursFg["v", veryDark] + 0.2
    #hsvColoursBg["s", remaining] <- hsvColoursFg["s", remaining] - 0.4
    #fgCol <- hsv(hsvColoursFg["h", ], hsvColoursFg["s", ], hsvColoursFg["v", ])
    #bgCol <- hsv(hsvColoursBg["h", ], hsvColoursBg["s", ], hsvColoursBg["v", ])

    #fgCol <- hsv(rgb2hsv(col2rgb(sampleColour.bot))["h",])
    #bgCol <- hsv(rgb2hsv(col2rgb(sampleColour.top))["h",])
    fgCol <- sampleColour.bot
    bgCol <- sampleColour.top

    if (type == "count") {
        # the intention of this is to be able to create barplots which show both the
        # amount of counts and the distribution between alleles this is the least
        # digested format and consequently produces the most cluttered plots. It is
        # therefore intended for subsets, few snps, few samples etc in these smaller
        # subsets it is useful to get information on higher expression values at certain
        # points of genes etc.
        
        if (strand == "+" | strand == "-" | strand == "*" ) {
            for (i in 1:length(snps)) {
                # getting revelant data
                snp <- snps[i]
                tmp <- t(alleleCounts(x, strand)[[snp]][samples, , drop = FALSE])
                
                if ((ncol(tmp) * nrow(tmp)) == sum(tmp == 0)) {
                  zeroRows <- TRUE
                } else {
                  zeroRows <- FALSE
                }
                
                # alleles are
                n <- names(sort(apply(tmp, 1, sum), decreasing = TRUE)[1:2])
                # theor total count
                tc <- sort(apply(tmp, 1, sum), decreasing = TRUE)[1:2]
                
                # extracting only major and minor allele in correctly transposed format and
                # ordering colours accordingly
                height <- tmp[match(n, rownames(tmp)), , drop = FALSE]
                # change all zero rows to X names
                rownames(height)[apply(height, 1, sum) == 0] <- "X"
                
                # warn if the two remaining alleles have too many counts
                majorAndMinorFraction <- sum(height)/sum(tmp)
                if (verbose & majorAndMinorFraction < 0.9) {
                  message(paste("Snp", snp, "was possible tri-allelic, but only two most frequent alleles were plotted. Counts:\n", 
                    paste(paste(names(apply(tmp, 1, sum)), apply(tmp, 1, sum), sep = "="), 
                      collapse = ", ")))
                }
                
                
                ## make bars section
                extraspaceOnTop <- 1.15
                if (is.null(ylim)) {
                  if (!zeroRows) {
                    ylimHere <- c(0, max(abs(range(height, na.rm = TRUE))) * extraspaceOnTop)
                  } else {
                    ylimHere <- c(0, 10)
                  }
                } else {
                  ylimHere <- ylim
                }
                
                # init frame
                if (!add) {
                  size <- c(1, 1)
                  lowerLeftCorner <- c(0, 0)
                  plot.default(NULL, xlim = c(0, 1), ylim = c(0, 1), ylab = "", xlab = "", 
                    xaxt = "n", yaxt = "n", frame.plot = FALSE)
                }
                
                
                # set so the ylimHere is at least 10.
                if (ylimHere[2] < 10) {
                  ylimHere[2] <- 10
                }
                
                # make tics and labels prettier
                ylabels <- pretty(ylimHere[1]:ylimHere[2])
                if (strand == "both") {
                  ylimHere[1] <- -max(abs(ylabels))
                  ylimHere[2] <- max(abs(ylabels))
                } else {
                  ylimHere[1] <- min(ylabels)
                  ylimHere[2] <- max(ylabels)
                }
                
                # all x positions
                xPointsAll <- seq(lowerLeftCorner[1], lowerLeftCorner[1] + size[1], 
                  length.out = length(height) * 1.5 + 2)[2:(length(height) * 1.5 + 
                  1)]
                widthsOfRectangles <- rep(size[1]/(length(height) * 1.5 + 1), length(height)/2)
                # normalize toPlot-values to a range of c(0,size[2])
                heightsOfRectangles <- ((height - ylimHere[1])/(ylimHere[2] - ylimHere[1]) * 
                  size[2])
                
                
                # take every third element (start at 2)
                xPoints1 <- xPointsAll[seq(1, length(height) * 1.5, by = 3)]
                yPoints <- lowerLeftCorner[2] + heightsOfRectangles[1, ]/2
                
                # alleleColors1 <- rep(fgCol[1],9)
                alleleColors1 <- fgCol
                symbols(x = xPoints1, y = yPoints, bg = alleleColors1, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectangles[1, ])), add = TRUE, inches = FALSE)
                
                # take every third element (start at 3)
                xPoints2 <- xPointsAll[seq(2, length(height) * 1.5, by = 3)]
                yPoints <- lowerLeftCorner[2] + heightsOfRectangles[2, ]/2
                
                alleleColors2 <- rep(bgCol[1], 9)
                alleleColors2 <- bgCol
                widthsOfRectangles <- rep(size[1]/(length(height) * 1.5 + 1), length(height)/2)
                symbols(x = xPoints2, y = yPoints, bg = alleleColors2, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectangles[2, ])), add = TRUE, inches = FALSE)
                
                ## make axis and labels section
                
                # y-axis
                yat <- (ylabels + abs(min(ylabels)))/(sum(abs(min(ylabels)) + max(ylabels)))
                graphParamList[["yat"]] <- yat
                if (yaxis) {
                  # vertical line
                  lines(c(lowerLeftCorner[1], lowerLeftCorner[1]), c(lowerLeftCorner[2], 
                    lowerLeftCorner[2] + 1))
                  # horizontal lines
                  invisible(mapply(FUN = function(x, y) {
                    lines(c(x, x - size[1] * 0.01), c(y, y))
                  }, rep(lowerLeftCorner[1], length(yat)), (lowerLeftCorner[2] + 
                    yat)))
                }
                if (ylab) {
                  if (las.ylab == 2) {
                    text(lowerLeftCorner[1] - size[1] * 0.02, yat, labels = abs(ylabels), 
                      xpd = TRUE, srt = 90, adj = c(1, 0.5), cex = cex.ylab)
                  }
                  if (las.ylab == 1) {
                    text(lowerLeftCorner[1] - size[1] * 0.02, yat, labels = abs(ylabels), 
                      xpd = TRUE, srt = 0, adj = c(1, 0.5), cex = cex.ylab)
                  }
                }
                # x-axis labels
                xat <- xPoints1 + (xPoints2 - xPoints1)/2
                graphParamList[["xat"]] <- xat
                
                if (xaxis) {
                  # vertical line
                  lines(c(lowerLeftCorner[1], lowerLeftCorner[1] + 1), c(lowerLeftCorner[2], 
                    lowerLeftCorner[2]))
                  # horizontal lines
                  invisible(mapply(FUN = function(x, y) {
                    lines(c(x, x), c(y, y - size[1] * 0.01))
                  }, (lowerLeftCorner[2] + xat), rep(lowerLeftCorner[1], length(xat))))
                }
                
                if (xlab) {
                  if (las.xlab == 2) {
                    text(xat, lowerLeftCorner[2] - size[2] * 0.02, labels = samples, 
                      xpd = TRUE, srt = 90, adj = c(1, 0.5), cex = cex.xlab)
                  }
                  if (las.xlab == 1) {
                    text(xat, lowerLeftCorner[2] - size[2] * 0.02, labels = samples, 
                      xpd = TRUE, srt = 0, adj = c(1, 0.5), cex = cex.xlab)
                  }
                }
                
                if (is.null(main)) {
                  text(x = lowerLeftCorner[1] + size[1] * 0.5, y = lowerLeftCorner[2] + 
                    size[2] * 1.05, labels = paste(snp), cex = cex.main, 
                    adj = 0.5, xpd = TRUE)
                } else {
                  text(x = lowerLeftCorner[1] + size[1] * 0.5, y = lowerLeftCorner[2] + 
                    size[2] * 1.05, labels = main[i], cex = cex.main, adj = 0.5)
                }
                
                if (pValue) {
                  
                  # check pValue slot
                  if (!is.null(testValue)) {
                    if (class(testValue)[1] == "matrix") {
                      text(xat, apply(heightsOfRectangles, 2, max), signif(testValue[, 
                        i], 1), cex = cex.pValue, adj = c(0.5, 0.01))
                    } else {
                      text(xat, apply(heightsOfRectangles, 2, max), signif(testValue, 
                        1), cex = cex.pValue, adj = c(0.5, 0.01))
                    }
                    
                    
                  } else {
                    # use chisq by default
                    TFf <- t(fraction(x[i], strand = strand) < filter.pValue.fraction)
                    ct <- signif(chisq.test(x[i], strand), 1)
                    ct[!TFf] <- NA
                    text(xat, apply(heightsOfRectangles, 2, max), ct, cex = cex.pValue, 
                      adj = c(0.5, 0.01))
                  }
                  
                }
                
                if (!is.null(OrgDb) | !is.null(TxDb)) {
					annotationBarplot(strand,i, lowerLeftCorner, annDfPlus, annDfMinus,
									  cex=cex.annotation, ypos=ypos.annotation,
									  interspace=annotation.interspace)
                }
                
                if (legend) {
                  
                  # any strand
                  o <- apply(height, 1, sum)
                  
                  # remove zeros count alleles
                  TFz <- rownames(height) == "X"
                  
                  o <- o[!TFz]
                  textOver <- rownames(height)[!TFz]
                  
                  # set another xLegendPos and yLegendPos for  '*'.
                  if ((strand == "*" ) & (!is.null(OrgDb) | 
                    !is.null(TxDb))) {
                    xLegendPos <- 0.5
                    yLegendPos <- 1.00
                  } else {
                    xLegendPos <- 0.94
                    yLegendPos <- 1.00
                  }
                  
				  legendBarplot(lowerLeftCorner, size, rownames=textOver, colnames=legend.colnames,
						   boxsize=legend.fill.size, boxspace=legend.interspace, fgCol, bgCol,
						   ylegendPos=1, xlegendPos=0.96, cex=cex.legend)

                  
                }


			#set y and x labs
			if(is.null(ylab.text)){
				ylab.text <- "reads"
			}
			title(ylab=ylab.text, xlab=xlab.text)

            }
            
        } else if (strand == "both") {
            for (i in 1:length(snps)) {
                
                if (verbose) {
                  cat("plotting snp", i, "\n")
                }
                
                snp <- snps[i]
                
                # getting revelant data forward strand
                tmpPlus <- t(alleleCounts(x, "+")[[snp]][samples, ])
                if ((ncol(tmpPlus) * nrow(tmpPlus)) == sum(tmpPlus == 0)) {
                  zeroRowsPlus <- TRUE
                } else {
                  zeroRowsPlus <- FALSE
                }
                
                tmpMinus <- t(alleleCounts(x, "-")[[snp]][samples, ])
                if ((ncol(tmpMinus) * nrow(tmpMinus)) == sum(tmpMinus == 0)) {
                  zeroRowsMinus <- TRUE
                } else {
                  zeroRowsMinus <- FALSE
                }
                
                # check most common alleles on + and - (should be same)
                allVar <- data.frame(A = c(NA, NA), T = c(NA, NA), G = c(NA, NA), 
                  C = c(NA, NA), del = c(NA, NA))
                o <- apply(tmpPlus, 1, sum)
                u <- apply(tmpMinus, 1, sum)
                
                # to get their total count
                allVar[1, match(names(o), colnames(allVar))] <- o
                allVar[2, match(names(u), colnames(allVar))] <- u
                
                # save to tri-allelic warner
                nAll <- names(sort(apply(allVar, 2, sum), decreasing = TRUE))
                tcAll <- sort(apply(allVar, 2, sum), decreasing = TRUE)
                
                # set colnames to X for non present alleles
                xNames <- colnames(allVar)[apply(allVar, 2, sum) == 0]
                colnames(allVar)[colnames(allVar) %in% xNames] <- "X"
                xNames <- rownames(tmpPlus)[apply(tmpPlus, 1, sum) == 0]
                rownames(tmpPlus)[rownames(tmpPlus) %in% xNames] <- "X"
                xNames <- rownames(tmpMinus)[apply(tmpMinus, 1, sum) == 0]
                rownames(tmpMinus)[rownames(tmpMinus) %in% xNames] <- "X"
                
                # alleles are
                n <- names(sort(apply(allVar, 2, sum), decreasing = TRUE))[1:2]
                # theor total count
                tc <- sort(apply(allVar, 2, sum), decreasing = TRUE)[1:2]
                
                # extracting only major and minor allele in correctly transposed format and
                # ordering colours accordingly
                over <- tmpPlus[match(n, rownames(tmpPlus)), ]
                under <- tmpMinus[match(n, rownames(tmpMinus)), ]
                # change all NAs to X names and zero values
                over[is.na(rownames(over)), ] <- 0
                rownames(over)[is.na(rownames(over))] <- "X"
                
                under[is.na(rownames(under)), ] <- 0
                rownames(under)[is.na(rownames(under))] <- "X"
                
                # Plus Warn if the two remaining alleles have too many counts
                if (!zeroRowsPlus) {
                  majorAndMinorFraction <- sum(allVar[1, ][c(n[1], n[2])])/sum(allVar[1, 
                    ])
                  if (verbose & majorAndMinorFraction < 0.9) {
                    message(paste("Snp", snp, "was possible tri-allelic, but only two most frequent alleles were plotted. Counts:\n", 
                      paste(paste(nAll, tcAll, sep = "="), collapse = ", ")))
                  }
                }
                # Minus calculating major and minor allele, warn if the two remaining alleles
                # have too many counts
                if (!zeroRowsMinus) {
                  majorAndMinorFraction <- sum(allVar[2, ][c(n[1], n[2])])/sum(allVar[2, 
                    ])
                  if (verbose & majorAndMinorFraction < 0.9) {
                    message(paste("Snp", snp, "was possible tri-allelic, but only two most frequent alleles were plotted. Counts:\n", 
                      paste(paste(nAll, tcAll, sep = "="), collapse = ", ")))
                  }
                }
                # set under as minus
                under <- -under
                
                # plotting function
                if (!add) {
                  # init frame
                  plot.default(NULL, xlim = c(0, 1), ylim = c(0, 1), ylab = "", xlab = "", 
                    xaxt = "n", yaxt = "n", , frame.plot = FALSE)
                }
                
                heightPlus <- over
                heightMinus <- under
                
                if (is.null(ylim)) {
                  if (zeroRowsPlus) {
                    ymax <- 5
                  } else {
                    ymax <- max(abs(range(heightPlus, na.rm = TRUE)))
                  }
                  if (zeroRowsMinus) {
                    ymin <- -5
                  } else {
                    ymin <- min(heightMinus)
                  }
                  ylimHere <- c(ymin, ymax)
                } else {
                  ylimHere <- ylim
                }
                
                # increase ylimHere before making pretty
                extraspaceOnTopAndBottom <- 0.15
                extraRealDistance <- (dist(ylimHere) * extraspaceOnTopAndBottom)
                ylimHere[1] <- ylimHere[1] - extraRealDistance
                ylimHere[2] <- ylimHere[2] + extraRealDistance
                
                # set lowest max and min values
                if (ylimHere[2] < 10) {
                  ylimHere[2] <- 10
                }
                if (abs(ylimHere[1]) < 10) {
                  ylimHere[1] <- -10
                }
                
                # make more even limits (make more pretty)
                ylabels <- pretty(ylimHere[1]:ylimHere[2])
                ylimHere[1] <- min(ylabels)
                ylimHere[2] <- max(ylabels)
                
                # breakpoint Plus Minus bars
                middleLine <- (1/(ylimHere[2] - ylimHere[1])) * abs(ylimHere[1])
                
                # make a xPointsAll framework
                xPointsAll <- seq(lowerLeftCorner[1], lowerLeftCorner[1] + size[1], 
                  length.out = length(heightPlus) * 1.5 + 2)[2:(length(heightPlus) * 
                  1.5 + 1)]
                
                widthsOfRectangles <- rep(size[1]/(length(heightPlus) * 1.5 + 1), 
                  length(heightPlus)/2)
                # normalize toPlot-values to a range of c(0,size[2])
                heightsOfRectanglesPlus <- round(((heightPlus - ylimHere[1])/(ylimHere[2] - 
                  ylimHere[1]) * size[2]) - middleLine, 5)
                heightsOfRectanglesMinus <- round(((-heightMinus - ylimHere[1])/(ylimHere[2] - 
                  ylimHere[1]) * size[2]) - middleLine, 5)
                
                # take every third element (start at 2)
                xPoints1 <- xPointsAll[seq(2, length(heightPlus) * 1.5, by = 3)]
                yPointsPlus <- lowerLeftCorner[2] + middleLine + heightsOfRectanglesPlus[1, 
                  ]/2
                
                barMinusEdge <- matrix(rep(NA, length(heightsOfRectanglesMinus)), 
                  nrow = 2)  #is used later to plot p-value
                
                # yPointMinus is a little tricky and needs a more complicated equation
                yPointsMinus1 <- lowerLeftCorner[2] + heightsOfRectanglesMinus[1, 
                  ]/2
                yPointsMinus2 <- 1 - yPointsMinus1
                yPointsMinus3 <- yPointsMinus2 - (1 - middleLine)
                
                barMinusEdge[1, ] <- (1 - (lowerLeftCorner[2] + heightsOfRectanglesMinus[1, 
                  ])) - (1 - middleLine)
                
                yPointsMinus <- yPointsMinus3
                
                alleleColors1 <- fgCol
                
                symbols(x = xPoints1, y = yPointsPlus, bg = alleleColors1, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectanglesPlus[1, ])), add = TRUE, 
                  inches = FALSE)
                symbols(x = xPoints1, y = yPointsMinus, bg = alleleColors1, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectanglesMinus[1, ])), add = TRUE, 
                  inches = FALSE)
                
                # take every third element (start at 3)
                xPoints2 <- xPointsAll[seq(3, length(heightPlus) * 1.5, by = 3)]
                yPointsPlus <- lowerLeftCorner[2] + middleLine + heightsOfRectanglesPlus[2, 
                  ]/2
                
                # yPointMinus is a little tricky and needs a more complicated equation
                yPointsMinus1 <- lowerLeftCorner[2] + heightsOfRectanglesMinus[2, 
                  ]/2
                yPointsMinus2 <- 1 - yPointsMinus1
                yPointsMinus3 <- yPointsMinus2 - (1 - middleLine)
                
                barMinusEdge[2, ] <- (1 - (lowerLeftCorner[2] + heightsOfRectanglesMinus[2, 
                  ])) - (1 - middleLine)
                
                yPointsMinus <- yPointsMinus3
                
                # alleleColors2 <- rep('#7F5959',9)
                alleleColors2 <- bgCol
                
                symbols(x = xPoints2, y = yPointsPlus, bg = alleleColors2, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectanglesPlus[2, ])), add = TRUE, 
                  inches = FALSE)
                symbols(x = xPoints2, y = yPointsMinus, bg = alleleColors2, rectangles = matrix(ncol = 2, 
                  c(widthsOfRectangles, heightsOfRectanglesMinus[2, ])), add = TRUE, 
                  inches = FALSE)
                
                # y-axis
                yat <- (ylabels + abs(min(ylabels)))/(sum(abs(min(ylabels)) + max(ylabels)))
                graphParamList[["yat"]] <- yat
                if (yaxis) {
                  # vertical line
                  lines(c(lowerLeftCorner[1], lowerLeftCorner[1]), c(lowerLeftCorner[2], 
                    lowerLeftCorner[2] + 1))
                  # horizontal lines
                  invisible(mapply(FUN = function(x, y) {
                    lines(c(x, x - size[1] * 0.01), c(y, y))
                  }, rep(lowerLeftCorner[1], length(yat)), (lowerLeftCorner[2] + 
                    yat)))
                }
                if (ylab) {
                  if (las.ylab == 2) {
                    text(lowerLeftCorner[1] - size[1] * 0.02, yat, labels = abs(ylabels), 
                      xpd = TRUE, srt = 90, adj = c(1, 0.5), cex = cex.ylab)
                  }
                  if (las.ylab == 1) {
                    text(lowerLeftCorner[1] - size[1] * 0.02, yat, labels = abs(ylabels), 
                      xpd = TRUE, srt = 0, adj = c(1, 0.5), cex = cex.ylab)
                  }
                }
                
                # x-axis labels
                xat <- xPoints1 + (xPoints2 - xPoints1)/2
                graphParamList[["xat"]] <- xat
                if (xaxis) {
                  # vertical line
                  lines(c(lowerLeftCorner[1], lowerLeftCorner[1] + 1), c(lowerLeftCorner[2], 
                    lowerLeftCorner[2]))
                  # horizontal lines
                  invisible(mapply(FUN = function(x, y) {
                    lines(c(x, x), c(y, y - size[1] * 0.01))
                  }, (lowerLeftCorner[2] + xat), rep(lowerLeftCorner[1], length(xat))))
                }
                if (xlab) {
                  if (las.xlab == 2) {
                    text(xat, lowerLeftCorner[2] - size[2] * 0.02, labels = samples, 
                      xpd = TRUE, srt = 90, adj = c(1, 0.5), cex = cex.xlab)
                  }
                  if (las.xlab == 1) {
                    text(xat, lowerLeftCorner[2] - size[2] * 0.02, labels = samples, 
                      xpd = TRUE, srt = 0, adj = c(1, 0.5), cex = cex.xlab)
                  }
                }
                if (is.null(main)) {
                  text(x = lowerLeftCorner[1] + size[1] * 0.5, y = lowerLeftCorner[2] + 
                    size[2] * 1.05, labels = paste(snp), cex = cex.main, 
                    adj = 0.5, xpd = TRUE)
                } else {
                  text(x = lowerLeftCorner[1] + size[1] * 0.5, y = lowerLeftCorner[2] + 
                    size[2] * 1.05, labels = main[i], cex = cex.main, adj = 0.5)
                }
                
                
                
                if (pValue) {
                  
                  # check pValue slot
                  if (!is.null(testValue)) {
                    if (class(testValue)[1] == "matrix") {
                      text(xat, apply(middleLine + heightsOfRectanglesPlus, 2, max), 
                        signif(testValue[, i], 1), cex = cex.pValue, adj = c(0.4, 
                          -0.3))
                    } else {
                      text(xat, apply(middleLine + heightsOfRectanglesPlus, 2, max), 
                        signif(testValue, 1), cex = cex.pValue, adj = c(0.4, -0.3))
                    }
                  } else {
                    # use chisq by default
                    TFf <- t(fraction(x[i], strand = "+") < filter.pValue.fraction)
                    ct <- signif(chisq.test(x[i], "+"), 1)
                    ct[!TFf] <- NA
                    text(xat, apply(middleLine + heightsOfRectanglesPlus, 2, max), 
                      ct, cex = cex.pValue, adj = c(0.4, -0.3))
                    
                  }
                  if (!is.null(testValue2)) {
                    if (class(testValue)[1] == "matrix") {
                      text(xat, apply(barMinusEdge, 2, min), signif(testValue2[, 
                        i], 1), cex = cex.pValue, adj = c(0.4, 1, 1))
                    } else {
                      text(xat, apply(barMinusEdge, 2, min), signif(testValue2, 1), 
                        cex = cex.pValue, adj = c(0.4, 1, 1))
                    }
                  } else {
                    # use chisq by default
                    TFf <- t(fraction(x[i], strand = "-") < filter.pValue.fraction)
                    ct <- signif(chisq.test(x[i], "-"), 1)
                    ct[!TFf] <- NA
                    text(xat, apply(barMinusEdge, 2, min), ct, cex = cex.pValue, 
                      adj = c(0.4, 1, 1))
                    
                  }
                  
                }
                
                if (!is.null(OrgDb) | !is.null(TxDb)) {
                  
					annotationBarplot(strand,i, lowerLeftCorner, annDfPlus, annDfMinus,
									  cex=cex.annotation, ypos=ypos.annotation,
									  interspace=annotation.interspace)
                }
                
                if (legend) {
                  # plus strand
                  TFz <- rownames(over) == "X"

                  if (!sum(!TFz) == 0) {
                    textOver <- paste(rownames(over)[!TFz], apply(over, 1, sum)[!TFz])
					#remove the total count for that nucleotide
					textOver <- unlist(lapply(strsplit(textOver," "),function(x){x[1]}))

					  legendBarplot(lowerLeftCorner, size, rownames=textOver, colnames=legend.colnames,
						   boxsize=legend.fill.size, boxspace=legend.interspace, fgCol, bgCol,
						   ylegendPos=1, xlegendPos=0.96, cex=cex.legend)
                    }
                  }
            }

			#set y and x labs
			if(is.null(ylab.text)){
				ylab.text <- "reads"
			}
			title(ylab=ylab.text, xlab=xlab.text)
        }
    } else if (type == "fraction") {
        # a plot type that shows the allelic imbalance, irrespective of absolute read
        # counts at each Snp.  this produce plots that are more easily overviewed than
        # those from 'plot_reads_by_allele', but of course omits some detail information
        # from these plots. Intended to use for a medium number of snps and samples
        
        if (strand == "both") {
            stop("strand must be '+', '-' or '*' for type='fraction' ")
        }
        
        for (i in 1:length(snps)) {
            # getting revelant data
            snp <- snps[i]
            fgColHere <- fgCol
            #tmp <- alleleCounts(x, strand)[[snp]][samples, , drop = FALSE]
            
			df <- fractionPlotDf(x, snp, strand=strand, top.fraction.criteria=top.fraction.criteria)
            # check for zeroRows
            if (sum(df$na=="no")==0) {
                zeroRows <- TRUE
            } else {
                zeroRows <- FALSE
            }
            
            # setting no-count samples to colour grey90 and fraction 0
            #fgColHere[df$na[seq(1,nrow(df),by=2)+1]=="yes"] <- "grey90"
            bgCol[df$na[seq(1,nrow(df),by=2)+1]=="yes"] <- "grey90"
            #fraction[is.nan(fraction)] <- 0
            
            # if add=FALSE then make a new device
            if (!add) {
                plot.default(NULL, xlim = c(0, 1), ylim = c(0, 1), ylab = "", xlab = "", 
                  xaxt = "n", yaxt = "n")
            }
            
            # ylim is always (0,1) and usergiven ylims are reset to this with a warning (in
            # start checkups).
            ylim <- c(0, 1)
            
            # find the centers of rectangles
            xPoints <- seq(lowerLeftCorner[1], lowerLeftCorner[1] + size[1], length.out = nrow(df)/2 + 
                2)[2:(nrow(df)/2 + 1)]
            widthsOfRectangles <- rep(size[1]/(nrow(df)/2 + 1), nrow(df)/2)
            
            # normalize fraction-values to a range of c(0,size[2])
            heightsOfRectangles <- ((df$values[seq(1,nrow(df),by=2)] - ylim[1])/(ylim[2] - ylim[1])) * size[2]
            # find the Y-coordinate center points for rectangles
            yPoints <- lowerLeftCorner[2] + heightsOfRectangles/2
            
            # if bgCol is given, start by painting background
            if (!is.null(bgCol)) {
                yPointsBg <- rep(lowerLeftCorner[2] + size[2]/2, length(xPoints))
                rectanglesBg <- matrix(ncol = 2, c(widthsOfRectangles, rep(size[2], 
                  length(widthsOfRectangles))))
                symbols(x = xPoints, y = yPointsBg, bg = bgCol, rectangles = rectanglesBg, 
                  add = TRUE, inches = FALSE)
            }
            
            symbols(x = xPoints, y = yPoints, bg = fgColHere, rectangles = matrix(ncol = 2, 
                c(widthsOfRectangles, heightsOfRectangles)), add = TRUE, inches = FALSE)
            
            # add a frame to the plot
            if (add.frame) {
                symbols(x = lowerLeftCorner[1] + size[1]/2, y = lowerLeftCorner[2] + 
                  size[2]/2, rectangles = matrix(ncol = 2, c(size[1], size[2])), 
                  add = TRUE, inches = FALSE)
            }
            
            # add a tick markers (easier for fraction-plots because they are restricted to
            # 0-100%
            marks <- c(0.25, 0.5, 0.75)
            names(marks) <- c("25%", "50%", "75%")
            for (markName in names(marks)) {
                mark <- marks[markName]
                yBase <- lowerLeftCorner[2] + ((mark - ylim[1])/(ylim[2] - ylim[1])) * 
                  size[2]
                xBase <- xPoints[1] - widthsOfRectangles[1]/2
                lines(x = c(xBase - size[1] * 0.01, xBase + size[1] * 0.01), y = c(yBase, 
                  yBase))
                text(x = xBase - size[1] * 0.015, y = yBase, label = markName, adj = 1, 
                  cex = 0.7)
            }
            
            # writing the name of each Snp on top of the plot(within frame)
            text(x = 0.5, y = 1.02, label = snp, xpd = TRUE, cex = cex.main)
            
            # add horizontal line at 0.5
            if (!is.null(addHorizontalLine)) {
                lines(x = c(lowerLeftCorner[1], lowerLeftCorner[1] + size[1]), y = c(lowerLeftCorner[2] + 
                  size[2] * addHorizontalLine, lowerLeftCorner[2] + size[2] * addHorizontalLine))
                
                mapBiasHere <- mapBias(x)[[snp]]
                #if (!all(mapBiasHere %in% c(0.5, 0)) & !zeroRows) {
                #  # Only activate if anything is different from 0.5 or 0
                #  
                #  for (j in 1:length(fraction)) { #fraction doesnt exist (check df$values instead)
                #    biasfraction <- mapBiasHere[j, majorAllele]/(mapBiasHere[j, majorAllele] + 
                #      mapBiasHere[j, minorAllele])
                #    yPoint <- lowerLeftCorner[2] + ((biasfraction - ylim[1])/(ylim[2] - 
                #      ylim[1])) * size[2]
                #    lines(x = c(xPoints[j] - widthsOfRectangles[j]/2, xPoints[j] + 
                #      widthsOfRectangles[j]/2), y = c(yPoint, yPoint), lty = 2)
                #  }
                #}
            }
			#set y and x labs
			if(is.null(ylab.text)){
				ylab.text <- "fraction"
			}
			title(ylab=ylab.text, xlab=xlab.text)
        }

    }
    # return graphical paramlist (does not work for fraction type yet)
    invisible(graphParamList)
})

#' gbarplot ASEset objects
#' 
#' Generates gbarplots for ASEset objects. Two levels of plotting detail are
#' provided: a detailed gbarplot of read counts by allele useful for fewer
#' samples and SNPs, and a less detailed gbarplot of the fraction of imbalance,
#' useful for more samples and SNPs.
#' 
#' This function serves the same purpose as the normal barplot, but with
#' trellis graphics using lattice, to be able to integrate well with Gviz track
#' functionality.
#' 
#' @name ASEset-gbarplot
#' @aliases ASEset-gbarplot gbarplot gbarplot,ASEset-method
#' @docType methods
#' @param x An \code{ASEset} object
#' @param type 'count' or 'fraction'
#' @param strand four options, '+', '-', 'both' or '*'
#' @param verbose Makes function more talkative
#' @param ... for simpler generics when extending function
#' @author Jesper R. Gadin
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the gbarplot
#' function can be called up on.  \item The \code{\link{barplot}} non trellis
#' barplot.  }
#' @keywords gbarplot
#' @examples
#' 
#' data(ASEset)
#' gbarplot(ASEset[1])
#' 
#' @exportMethod gbarplot

setGeneric("gbarplot", function(x, type = "count", strand = "*", 
    verbose = FALSE, ...) {
    standardGeneric("gbarplot")
})

setMethod("gbarplot", signature(x = "ASEset"), function(x, type = "count", strand = "*", 
    usePhase=FALSE, verbose = FALSE, ...) {

    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }

	#print(ls(envir=e))

    if (!exists("mainvec", envir = e, inherits = FALSE)) {
		e$mainvec <- rep("",nrow(x))
	}
    if (!exists("cex.mainvec", envir = e, inherits = FALSE)) {
		e$cex.mainvec <- 1
	}
    if (!exists("ylab", envir = e, inherits = FALSE)) {
        e$ylab <- "reads"
    }
    if (!exists("xlab", envir = e, inherits = FALSE)) {
        e$xlab <- "samples"
    }
    if (!exists("middleLine", envir = e, inherits = FALSE)) {
        e$middleLine <- TRUE
    }
    if (!exists("deAnnoPlot", envir = e, inherits = FALSE)) {
        e$deAnnoPlot <- FALSE
    }
    if (!exists("top.fraction.criteria", envir = e, inherits = FALSE)) {
        e$top.fraction.criteria <- "maxcount"
    }

	for (i in 1:nrow(x)) {
		name <- rownames(x)[i]
		if (type == "fraction") {
			b <- barplotLatticeFraction(
				identifier = name, 
				x=x, 
				astrand=strand, 
				ids=rownames(x),
				ylab=e$ylab,
				xlab=e$xlab,
				mainvec=e$mainvec,
				middleLine=e$middleLine,
				deAnnoPlot=e$deAnnoPlot,
				cex.mainvec=e$cex.mainvec,
				top.fraction.criteria=e$top.fraction.criteria)
		} else if (type == "count") {
			b <- barplotLatticeCounts(
				identifier = name, 
				x=x, 
				astrand=strand, 
				ids=rownames(x),
				ylab=e$ylab,
				xlab=e$xlab,
				mainvec=e$mainvec)
		} else {
			stop("type has to be fraction or count")
		}
	
		b
	}
}) 

barplotLatticeFraction <- function(identifier, ...) {

    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }

	e$ids <- unlist(e$ids)
	e$strand <- e$astrand

	df <- fractionPlotDf(e$x, identifier, strand=e$strand, top.fraction.criteria=e$top.fraction.criteria)
    
    # Grah params
    my_cols <- c("green", "red")
    
    # set default values
    parset <- list(superpose.polygon=list(col=my_cols))

    scales = list(rot = c(90, 0))
    
	if (e$deAnnoPlot) {
		parset <- list(
				   layout.widths = list(
						left.padding = 0,
						axis.left = 0,
						ylab.axis.padding = 0, 
						right.padding = 0, 
						axis.right = 0
						),
				   layout.heights = list(
						top.padding = 0.1,
						between = 0.1,
						xlab.top= 0.1,
						axis.top = 0,
						main=1.1,
						main.key.padding=1,
						axis.xlab.padding = 1, 
						bottom.padding = 1, 
						axis.bottom = 0.3
						),
				   superpose.polygon=list(col=my_cols)
				   )
	
		scales = list(y = list(at = NULL, labels = NULL),
					  x = list(labels = rep("",ncol(e$x)))
					  )
					  #, rot = c(90, 0))
	}

    
	if(!e$middleLine) {
		b <- barchart(values ~ sample, group = groups, data = df, origin = 0, 
		    stack = TRUE, scales = scales, 
			main = list(label=e$main, cex=e$cex.mainvec), 
			ylab = e$ylab, xlab = e$xlab, 
		    par.settings = parset)
	}else {

# if middle line at 0.5	
		b <- barchart(values ~ sample, group = groups, data = df, origin = 0, 
			stack = TRUE, scales = scales, 
			main = list(label=e$main, cex=e$cex.mainvec), 
			ylab = e$ylab, xlab = e$xlab, 
			par.settings = parset, panel=function(x, y, ...) {
				 panel.barchart(x, y, ...)
				 panel.abline(h=0.5, lty=1)
			}  )
	}

    b
}

#'@include initialize-methods.R
NULL

#' RiskVariant class
#' 
#' Object that holds results from AI detection.
#'
#' The RiskVariant-class contains 
#'
#' @name RiskVariant-class
#' @rdname RiskVariant-class
#' @aliases RiskVariant-class RiskVariant RiskVariant-method
#' @docType class
#' @param x RiskVariant object or list of RiskVariants
#' @param return.class type of class returned eg. "list or ""array".
#' @param value argument used for replacement
#'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class RiskVariant
#' @examples
#'
#' #some code
#'
#' @exportClass RiskVariant
NULL

#' @rdname RiskVariant-class
#' @exportClass RiskVariant
setClass("RiskVariant", contains = "RangedSummarizedExperiment",
	representation(
		meta = "list"
	)
)

#' @rdname RiskVariant-class
#' @export 
setMethod("ref", signature(x = "RiskVariant"), function(x) {

		mcols(x)[["ref"]]
	
})

#' @rdname RiskVariant-class
#' @export 
setMethod("ref<-", signature(x = "RiskVariant"), function(x, value) {

	#we want to accept more classes than just character (e.g. characterList or DNAStringSetList)
	#if(class(value)=="character") {
		#mcols(x)[["ref"]] <- value
	#}else{
		#stop("wrong class")
	#}
	
	mcols(x)[["ref"]] <- value
	x
})


#' @rdname RiskVariant-class
#' @export 
setMethod("alt", signature(x = "RiskVariant"), function(x) {

		mcols(x)[["alt"]]
	
})

#' @rdname RiskVariant-class
#' @export 
#could be renamed to countsAllAlleles
setMethod("alt<-", signature(x = "RiskVariant"), function(x, value) {

	#we want to accept more classes than just character (e.g. characterList or DNAStringSetList)
	#if(class(value)=="character") {

	#	mcols(x)[["alt"]] <- value
	#}else{

	#	stop("wrong class")
	#}
	mcols(x)[["alt"]] <- value
	
	x
})

#' @rdname RiskVariant-class
#' @export 
setMethod("phase", signature(x = "RiskVariant"), function(x, 
	return.class = "matrix" ) {

	if(return.class=="matrix"){
		mat <- phaseArray2phaseMatrix(assays(x)[["phase"]])
		colnames(mat) <- colnames(x)
		rownames(mat) <- rownames(x)
		mat
	}else if(return.class=="array"){
		assays(x)[["phase"]] 
	}
})

#' @rdname RiskVariant-class
#' @export 
setMethod("phase<-", signature(x = "RiskVariant"), function(x,value) {

	if(class(value)[1]=="matrix") {

		if(!identical(dim(x),dim(value))){
			stop("dimension of value does not correspond to the values of object RiskVariant")	
		}
		
		assays(x, withDimnames=FALSE)[["phase"]] <- phaseMatrix2Array(value, dimnames=NULL)

	}else if(class(value)[1]=="array"){
		assays(x, withDimnames=FALSE)[["phase"]] <- value
	}
	
	x
})

#####################
# addColnames might not be needed when phase is required

##' @rdname ASEset-class
##' @export 
#setGeneric("addColnames<-", function(x, value){
#    standardGeneric("addColnames<-")
#})
#
##' @rdname RiskVariant-class
##' @export 
#setMethod("addColnames<-", signature(x = "RiskVariant"), function(x,value) {
#
#		  if(is.null(colnames(x))){
#				sset <- SummarizedExperiment(
#					assays = assays(x), 
#					rowRanges = granges(x),
#					colData=DataFrame(row.names=value))
#				rownames(sset) <- names(x)
#				cnrv <- new("RiskVariant", sset,
#					meta = list()
#				)
#
#		  }else{
#			  (stop("object has already colnames, use cbind."))
#		  }
#})
#

#'@include initialize-methods.R
NULL

#' GlobalAnalysis class
#' 
#' Object that holds results from a global AI analysis including reference bias
#' estimations and AI detection.
#'
#' The GlobalAnalysis-class contains summaries and "pre-configured and pre-calculated lattice plots" needed to create an AI-report
#'
#' @name GlobalAnalysis-class
#' @rdname GlobalAnalysis-class
#' @aliases GlobalAnalysis-class GlobalAnalysis GlobalAnalysis-method
#' @docType class
#' @param x ASEset object or list of ASEsets
#' @param TxDb A \code{transcriptDb} object
#' @param ... pass arguments to internal functions
#' @return An object of class GlobalAnalysis containing all data to make report.
#'
#'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class ASEset
#' @examples
#'
#' data(ASEset)
#' #a <- ASEset
#' #gba <- gba(a)
#' 
#' #report(gba)
#' #write.tables(gba)
#' #graphs(gba)
#' #as.list(gba)
#'
#' @exportClass GlobalAnalysis
NULL

#' @rdname GlobalAnalysis-class
#' @exportClass GlobalAnalysis
setClass("GlobalAnalysis",  
	representation(data = "list"))

## ----style, echo = FALSE, results = 'asis'------------------------------------
BiocStyle::markdown()

## ----functions, include=FALSE-------------------------------------------------
# A function for captioning and referencing images
fig <- local({
    i <- 0
    ref <- list()
    list(
        cap=function(refName, text) {
            i <<- i + 1
            ref[[refName]] <<- i
            #paste("Figure ", i, ": ", text, sep="")
            paste(text, sep="")
        },
        ref=function(refName) {
            ref[[refName]]
        })
})

## ----echo = TRUE, eval = TRUE, message = FALSE--------------------------------
library(AllelicImbalance)

## ----echo = TRUE, eval = TRUE-------------------------------------------------
searchArea <- GRanges(seqnames = c("17"), ranges = IRanges(79478301, 79478361))
pathToFiles <- system.file("extdata/ERP000101_subset", 
								package = "AllelicImbalance")
reads <- impBamGAL(pathToFiles, searchArea, verbose = FALSE)
heterozygotePositions <- scanForHeterozygotes(reads, verbose = FALSE)
countList <- getAlleleCounts(reads, heterozygotePositions, verbose = FALSE)
a.simple <- ASEsetFromCountList(heterozygotePositions, countList)
a.simple

## ----echo = TRUE, eval = TRUE, warning = FALSE--------------------------------
library(VariantAnnotation)
pathToVcf <- paste(pathToFiles,"/ERP000101.vcf",sep="")
VCF <- readVcf(pathToVcf,"hg19") 
gr <- granges(VCF) 

#only use bi-allelic positions
gr.filt <- gr[width(mcols(gr)[,"REF"]) == 1 | 
				unlist(lapply(mcols(gr)[,"ALT"],width))==1]

countList <- getAlleleCounts(reads, gr.filt, verbose=FALSE) 
a.vcf <- ASEsetFromCountList(rowRanges = gr, countList)

## ----echo = TRUE, eval = TRUE-------------------------------------------------
BcfGR <- impBcfGR(pathToFiles,searchArea,verbose=FALSE)
countListBcf <- getAlleleCounts(reads, BcfGR,verbose=FALSE)
a.bcf <- ASEsetFromCountList(BcfGR, countListBcf)

## ----echo = TRUE, eval = TRUE-------------------------------------------------
plus <- getAlleleCounts(reads, heterozygotePositions, strand="+",verbose=F) 
minus <- getAlleleCounts(reads, heterozygotePositions, strand="-",verbose=F)

a.stranded <-
ASEsetFromCountList(
heterozygotePositions,
countListPlus=plus,
countListMinus=minus
)
a.stranded

## ----echo = TRUE, eval = TRUE, message = FALSE, results = 'hide'--------------
#Getting searchArea from genesymbol
library(org.Hs.eg.db )
searchArea<-getAreaFromGeneNames("ACTG1",org.Hs.eg.db)

#Getting rs-IDs
library(SNPlocs.Hsapiens.dbSNP144.GRCh37)
gr <- rowRanges(a.simple)
updatedGRanges<-getSnpIdFromLocation(gr, SNPlocs.Hsapiens.dbSNP144.GRCh37)
rowRanges(a.simple)<-updatedGRanges

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#simulate phenotype data
pdata <- DataFrame(
	Treatment=sample(c("ChIP", "Input"),length(reads),replace=TRUE),
	Gender=sample(c("male", "female"),length(reads),replace=TRUE), 
	row.names=paste("individual",1:length(reads),sep=""))

#make new ASEset with pdata
a.new <- ASEsetFromCountList(
		heterozygotePositions,
		countList,
		colData=pdata)

#add to existing object
colData(a.simple) <- pdata

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#infer and add genotype require declaration of the reference allele 
ref(a.simple) <- randomRef(a.simple)
genotype(a.simple) <- inferGenotypes(a.simple)

#access to genotype information requires not only the information about the
#reference allele but also the alternative allele
alt(a.simple) <- inferAltAllele(a.simple)
genotype(a.simple)[,1:4]

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#construct an example phase matrix 
set.seed(1)
rows <-nrow(a.simple)
cols <- ncol(a.simple)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=rows*cols), nrow=rows, ncol=cols)
p2 <- matrix(sample(c(1,0),replace=TRUE, size=rows*cols), nrow=rows, ncol=cols)
phase.mat <- matrix(paste(p1,sample(c("|","|","/"), size=rows*cols, 
						replace=TRUE), p2, sep=""),	nrow=rows, ncol=cols)

phase(a.simple) <- phase.mat 

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#load VariantAnnotation and use the phase information from a Vcf file
pathToVcf <- system.file("extdata/ERP000101_subset/ERP000101.vcf", 
							package = "AllelicImbalance")
p <- readGT(pathToVcf)
#The example Vcf file contains only 19 out of our 20 samples
#So we have to subset and order
a.subset <- a.simple[,colnames(a.simple) %in% colnames(p)]
p.subset <- p[, colnames(p) %in% colnames(a.subset)]
p.ordered <- p.subset[ , match(colnames(a.subset), colnames(p.subset))]

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#from simulated data
ref(a.simple) <- c("G","T","C")

#infer and set alternative allele
alt <- inferAltAllele(a.simple)
alt(a.simple) <- alt

#from reference genome
data(ASEset.sim)
fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
ref <- refAllele(ASEset.sim,fasta=fasta) 
ref(ASEset.sim) <- ref

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#make an example countList including a global sample of SNPs
set.seed(1)
countListUnknown <- list()
samples <- paste(rep("sample",10),1:10,sep="")
snps <- 1000
for(snp in 1:snps){
	count<-matrix(0, nrow=length(samples), ncol=4, 
					dimnames=list(samples, c('A','T','G','C')))
	alleles <- sample(1:4, 2)
	for(sample in 1:length(samples)){
		count[sample, alleles] <- as.integer(rnorm(2,mean=50,sd=10))
	}
	countListUnknown[[snp]] <- count
}

#make example rowRanges for the corresponding information
gr <- GRanges(
	seqnames = Rle(sample(paste("chr",1:22,sep=""),snps, replace=TRUE)),
	ranges = IRanges(1:snps, width = 1, names= paste("snp",1:snps,sep="")),
	strand="*"
)

#make ASEset
a <- ASEsetFromCountList(gr, countListUnknown=countListUnknown)

#set a random allele as reference
ref(a) <- randomRef(a)
genotype(a) <- inferGenotypes(a)

#get the fraction of the reference allele
refFrac <- fraction(a, top.fraction.criteria="ref")

#check mean
mean(refFrac)


## ----echo=TRUE, eval=TRUE-----------------------------------------------------
#set ref allele
ref(a.stranded) <- c("G","T","C")

#binomial test
binom.test(a.stranded[,5:8], "+")
#chi-square test
chisq.test(a.stranded[,5:8], "-")

## ----echo=TRUE, eval=TRUE, message=FALSE--------------------------------------
# in this example every snp is on separate exons
region <- granges(a.simple)
rs <- regionSummary(a.simple, region)
rs
basic(rs)

## ----echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotPlusStrandDefault", "The red bars show how many reads with the G-allele that overlaps the snp at position chr17:79478331, and the green bars show how many reads with the T allele that overlaps.")----
barplot(a.stranded[2], strand="+", xlab.text="", legend.interspace=2)

## ----echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotPlusStrandPsub", "Here the default chi-square p-values have been replaced by p-values from binomial tests.")----
#use another source of p-values
btp <- binom.test(a.stranded[1],"+")
barplot(a.stranded[2], strand="+", testValue=t(btp), xlab.text="",
			 legend.interspace=2)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
init <- c(15,20)
for(i in c(1,2,4,6)){
	bp <- signif(binom.test(init*i, p=0.5)$p.value,3)
	cp <- signif(chisq.test(init*i, p=c(0.5,0.5))$p.value, 3)
	cat(paste("A: ", init[1]*i , " B: ", init[2]*i, " binom p: ", bp, "chisq p: ", cp,"\n"))
}

## ----echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotFraction", "A barplot with type='fraction'. Each bar represents one sample and by default the most expressed allele over all samples is on the top, here in green. The black line denotes 1:1 expression of the alleles.")----
barplot(a.simple[2], type="fraction", cex.main = 0.7)

## ----echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotSampleColour", "A barplot with allele fractions, additionally colored by gender.")----
#top and bottom colour
sampleColour.top <-rep("palevioletred",ncol(a.simple))
sampleColour.top[colData(a.simple)[,"Gender"]%in%"male"] <- "darkgreen"
sampleColour.bot <- rep("blue",ncol(a.simple))
sampleColour.bot[colData(a.simple)[,"Gender"]%in%"male"] <- "seashell2"
barplot(a.simple[2], type="fraction", sampleColour.top=sampleColour.top,
	 sampleColour.bot=sampleColour.bot, cex.main = 0.7)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotAnnotation", "A barplot with Gene information extracted from the org.Hs.eg.db package")----
library(org.Hs.eg.db)
barplot(a.simple[1],OrgDb=org.Hs.eg.db,
			cex.main = 0.7,
			xlab.text="",
			ypos.annotation = 0.08,
			annotation.interspace=1.3,
			legend.interspace=1.5
			)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotRef", "A barplot with the reference allele as top fraction, top.fraction.criteria='ref' ")----
#load data
data(ASEset)

#using reference and alternative allele information
alt(ASEset) <- inferAltAllele(ASEset)
barplot(ASEset[1], type="fraction", strand="+", xlab.text="", 
			top.fraction.criteria="ref", cex.main=0.7)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotPhase", "A barplot with the maternal phase as top fraction, top.fraction.criteria='phase' ")----
#using phase information
phase(ASEset) <- phase.mat 
barplot(ASEset[1], type="fraction", strand="+", xlab.text="", 
			top.fraction.criteria="phase", cex.main=0.7)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("locationplotDefault", "A locationplot with countbars displaying a region of SNPs")----
# locationplot using count type
a.stranded.sorted <- sort(a.stranded, decreasing=FALSE)
locationplot(a.stranded.sorted, type="count", cex.main=0.7, cex.legend=0.4)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("locationplotAnnotation", "A locationplot with Gene and Transcript information extracted from the org.Hs.eg.db and TxDb.Hsapiens.UCSC.hg19.knownGene packages")----
# locationplot annotation
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
locationplot(a.stranded.sorted, OrgDb=org.Hs.eg.db, 
				TxDb=TxDb.Hsapiens.UCSC.hg19.knownGene)

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("gbarplotcount", "A gbarplot with type='count'")----
#gbarplots with type "count" 
gbarplot(ASEset, type="count")

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("gbarplotfraction", "A gbarplot with type='fraction'")----
# gbarplots with type "fraction" 
gbarplot(ASEset, type="fraction")

## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("glocationplot", "A glocationplot, showing the ASE of SNPs within a defined region")----
#remember to set the genome
genome(ASEset) <- "hg19"

glocationplot(ASEset, strand='+')


## ----echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("glocationplot", "A custom built Gviz plot using the ASEDAnnotationTrack, showing the ASE of SNPs within a defined region together with read coverage information")----

#load Gviz package
library(Gviz)

#subset ASEset and reads
x <- ASEset[,1:2]
r <- reads[1:2]
seqlevels(r, pruning.mode="coarse") <- seqlevels(x)

GR <- GRanges(seqnames=seqlevels(x),
 		ranges=IRanges(start=min(start(x)), end=max(end(x))),
 		strand='+', genome=genome(x))

deTrack <- ASEDAnnotationTrack(x, GR=GR, type='fraction', strand='+')
covTracks <- CoverageDataTrack(x, BamList=r, strand='+') 
lst <- c(deTrack,covTracks)
sizes <- c(0.5,rep(0.5/length(covTracks),length(covTracks)))

plotTracks(lst, from=min(start(x)), to=max(end(x)), sizes=sizes, 
				col.line = NULL, showId = FALSE, main = 'main', cex.main = 1, 
				title.width = 1, type = 'histogram')

## ----echo = TRUE, eval = TRUE, message = FALSE--------------------------------
data(ASEset.old)
#this command doesnt work anymore, for some reason(Will ask the mail-list)
#ASEset.new <- updateObject(ASEset.old)

## ----echo=TRUE, eval=TRUE-----------------------------------------------------
sessionInfo()

#' histogram plots
#' 
#' uses base graphics hist plot
#' 
#' The histogram will show the density over frequencies for each sample
#' 
#' @name histplot
#' @rdname histplot
#' @aliases hist hist,ReferenceBias-method 
#' @docType methods
#' @param x \code{ReferenceBias} object or \code{ASEset} object
#' @param strand '+','-' or '*'
#' @param type 'mean' (only one option atm)
#' @param log an integer to log each value (integer 10 for log10)
#' @param ... arguments to forward to interal boxplots function
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords plot hist
#' @examples
#' 
#' ##load example data
#' 
#' #data(ASEset)
#' #a <- ASEset
#' #hist(a)
#' 
NULL

#' @rdname histplot
setMethod("hist", signature(x = "ASEset"), function(x, strand="*", type="mean", log=1, ...){

		if(log==1){
			counts <- countsPerSnp(x, strand=strand, return.type=type, return.class="vector")
		}else{
			counts <- log(countsPerSnp(x, strand=strand, return.type=type, return.class="vector"),log)
		}

		hi <- hist(counts,breaks = 40, freq=TRUE, ...)
		invisible(hi)
})

#' A package meant to provide all basic functions for high-throughput allele
#' specific expression analysis
#' 
#' Package \code{AllelicImbalance} has functions for importing, filtering and
#' plotting high-throughput data to make an allele specific expression
#' analysis. A major aim of this package is to provide functions to collect as
#' much information as possible from regions of choice, and to be able to
#' explore the allelic expression of that region in detail.
#' 
#' \tabular{ll}{ Package: \tab AllelicImbalance\cr Type: \tab Package\cr
#' Version: \tab 1.2.0\cr Date: \tab 2014-08-24\cr License: \tab GPL-3\cr }
#' 
#' @name AllelicImbalance-package
#' @aliases AllelicImbalance-package AllelicImbalance
#' @docType package
#' @section Overview - standard procedure: Start out creating a \code{GRange}
#' object defining the region of interest. This can also be done using
#' \code{getAreaFromGeneNames} providing gene names as arguments. Then use
#' \code{BamImpGAList} to import reads from that reagion and find potential
#' SNPs using \code{scanForHeterozygotes}. Then retrieve the allele counts of
#' heterozygote sites by the function \code{getAlleleCount}. With this data
#' create an \code{ASEset}. At this point all pre-requisites for a 'basic'
#' allele specific expression analysis is available. Two ways to go on could be
#' to apply \code{\link{chisq.test}} or \code{\link{barplot}} on this ASEset
#' object.
#' @author Author: Jesper Robert Gadin Author: Lasse Folkersen
#' 
#' Maintainer: Jesper Robert Gadin <j.r.gadin@@gmail.com>
#' @seealso \itemize{ \item code?ASEset }
#' @references Reference to published application note (work in progress)
#' @keywords package
#'
#' @import methods
#' @import BiocGenerics
#' @import S4Vectors
#' @import grid
#' @import IRanges
#' @import GenomeInfoDb
#' @import GenomicRanges
#' @import SummarizedExperiment
#' 
#' @importFrom Biostrings subseq
#' @importFrom Biostrings DNAStringSet
#' 
#' @importFrom Rsamtools scanBamWhat
#' @importFrom Rsamtools ScanBamParam
#' @importFrom Rsamtools scanBamFlag
#' @importFrom Rsamtools scanBamHeader
#' @importFrom Rsamtools indexBam
#' @importFrom Rsamtools BamFileList
#' @importFrom Rsamtools scanBam
#' @importFrom Rsamtools ScanBcfParam
#' @importFrom Rsamtools scanBcf
#' @importFrom Rsamtools BcfFile
#' @importFrom Rsamtools BcfFileList
#' @importFrom Rsamtools indexBcf
#' @importFrom Rsamtools indexFa
#' @importFrom Rsamtools FaFile
#' @importFrom Rsamtools scanFa
#' @importFrom Rsamtools scanFaIndex
#' @importFrom Rsamtools applyPileups
#' @importFrom Rsamtools ApplyPileupsParam
#' @importFrom Rsamtools PileupFiles
#' 
#' @importClassesFrom GenomicAlignments GAlignments
#' @importClassesFrom GenomicAlignments GAlignmentPairs
#' @importClassesFrom GenomicAlignments GAlignmentsList
#' 
#' @importFrom GenomicAlignments pileLettersAt
#' @importFrom GenomicAlignments cigar
#' @importFrom GenomicAlignments cigarToRleList
#' @importFrom GenomicAlignments GAlignments
#' @importFrom GenomicAlignments GAlignmentPairs
#' @importFrom GenomicAlignments GAlignmentsList
#' @importFrom GenomicAlignments readGAlignments
#' @importFrom GenomicAlignments readGAlignmentPairs
#' @importFrom GenomicAlignments cigarWidthAlongReferenceSpace
#' 
#' @importFrom VariantAnnotation alt
#' @importFrom VariantAnnotation ref
#' @importFrom VariantAnnotation 'alt<-'
#' @importFrom VariantAnnotation 'ref<-'
#'
#' @importFrom lattice barchart
#' @importFrom lattice levelplot
#' @importFrom lattice xyplot
#' @importFrom lattice trellis.par.set
#' @importFrom lattice panel.abline
#' @importFrom lattice panel.text
#' @importFrom lattice panel.barchart
#' @importFrom lattice panel.smoothScatter
#' @importFrom lattice panel.linejoin
#'
#' @importFrom seqinr write.fasta
#'
#' @importClassesFrom Gviz DataTrack
#' @importClassesFrom Gviz AnnotationTrack
#' @importClassesFrom Gviz DetailsAnnotationTrack
#' @importClassesFrom Gviz GeneRegionTrack
#' @importClassesFrom Gviz GenomeAxisTrack
#'
#' @importFrom Gviz DataTrack
#' @importFrom Gviz AnnotationTrack
#' @importFrom Gviz DetailsAnnotationTrack
#' @importFrom Gviz GeneRegionTrack
#' @importFrom Gviz GenomeAxisTrack
#' @importFrom Gviz plotTracks
#'
#' @importFrom gridExtra grid.arrange
#'
#' @importFrom latticeExtra doubleYScale
#'
#' @importClassesFrom GenomicFeatures TxDb
#' @importClassesFrom AnnotationDbi AnnotationDb
#' @importClassesFrom AnnotationDbi OrgDb
#' @importClassesFrom AnnotationDbi ChipDb
#' @importClassesFrom AnnotationDbi GODb
#' @importClassesFrom AnnotationDbi ReactomeDb
#'
#' @importMethodsFrom AnnotationDbi columns
#'
#' @importMethodsFrom BSgenome snpsByOverlaps
#' 
#' @importFrom AnnotationDbi select
#' @importFrom AnnotationDbi keys
#' 
#' @importFrom GenomicFeatures exons
#' @importFrom GenomicFeatures transcripts
#' @importFrom GenomicFeatures cds
#' @importFrom GenomicFeatures isActiveSeq
#' @importFrom GenomicFeatures 'isActiveSeq<-'
#'
#' @importFrom grDevices heat.colors
#'
#' @importFrom graphics abline 
#' @importFrom graphics lines
#' @importFrom graphics mtext
#' @importFrom graphics plot.default
#' @importFrom graphics symbols
#' @importFrom graphics text
#' @importFrom graphics title
#' @importFrom graphics points
#'
#' @importFrom stats anova
#' @importFrom stats dist
#' @importFrom stats lm
#' @importFrom stats setNames
#' @importFrom stats formula
#'
#' @importFrom nlme lme
#'
NULL

#' GRvariants object
#' 
#' this data is a \code{GRanges} object that contains the ranges for three
#' example SNPs.
#' 
#' 
#' @name GRvariants
#' @docType data
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{reads}} which is another example
#' object }
#' @keywords data object example
#' @examples
#' 
#' #load example data
#' data(GRvariants)
#' 
#' 
NULL


#' reads object
#' 
#' This data set corresponds to the BAM-file data import illustrated in the
#' vignette. The data set consists of a chromosome 17 region from 20 RNA-seq
#' experiments of HapMap samples.
#' 
#' 
#' @name reads
#' @docType data
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{GRvariants}} which is another
#' example object }
#' @references Montgomery SB et al. Transcriptome genetics using second
#' generation sequencing in a Caucasian population. Nature. 2010 Apr
#' 1;464(7289):773-7.
#' @keywords data object example
#' @examples
#' 
#' ##load eample data (Not Run)  
#' #data(reads)
#' 
NULL 


#' ASEset.sim object
#' 
#' ASEset with simulated data with SNPs within the first 200bp of chromosome 17,
#' which is required to have example data for the refAllele function.
#' 
#' @name ASEset.sim
#' @docType data
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords data object example
#' @examples
#' 
#' ##load eample data (Not Run)  
#' #data(ASEset.sim)
#' 
NULL 

#' genomatrix object
#' 
#' genomatrix is an example of a matrix with genotypes
#' 
#' @name genomatrix
#' @docType data
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords data genotype
#' @examples
#' 
#' ##load eample data (Not Run)  
#' #data(genomatrix)
#' 
NULL 


#' ASEset.old object
#' 
#' old version of an ASEset which needs to be updated
#' 
#' @name ASEset.old
#' @docType data
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords data object example
#' @examples
#' 
#' ##load eample data (Not Run)  
#' #data(ASEset.old)
#' 
NULL 

#' add legend to AllelicImbalance barplot
#' 
#' adds a very customizable legend function for AllelicImbalance barplots.
#' 
#' the function is preferably called from within the AllelicImbalance barplot method.
#' 
#' 
#' @param lowerLeftCorner position of the plot to add legend to (default c(0,0))
#' @param size scale the plot, default is 1
#' @param rownames rownames in legend
#' @param colnames colnames in legend
#' @param boxsize size of each box fill
#' @param boxspace space inbetween the box fill
#' @param fgCol color for allele1
#' @param bgCol color for allele2
#' @param ylegendPos placement of the legend within the plot for y
#' @param xlegendPos placement of the legend within the plot for x
#' @param cex size of legend text
#' @author Jesper R. Gadin
#' @keywords legend barplot
#' @examples
#'
#' #code placeholders
#' #< create a barplot with legend >
#' #< add legend >
#'  
#' @export legendBarplot

legendBarplot <- function(lowerLeftCorner, size, rownames, colnames, boxsize=1, boxspace=1,fgCol,bgCol,
						  ylegendPos=1, xlegendPos=0.96, cex=1){
	cex.legend <- cex

	#first fill/box
	x = lowerLeftCorner[1] + size[1] * seq(xlegendPos, (xlegendPos - 
		(0.02 * boxspace * (length(unique(fgCol)) - 1))),
			length = length(unique(fgCol)))
	y = (lowerLeftCorner[2] + size[2] * (ylegendPos + 0.02 * boxspace)) * rep(1,
			length(unique(fgCol)))
	squares	= rep(c(size[1] * 0.012 * boxsize), length(unique(fgCol)))

		symbols(x=x, y = y , bg = unique(fgCol), squares = squares, add = TRUE, 
			inches = FALSE,xpd=TRUE)

	if(length(rownames)==2){
		#second fill/box
		x = lowerLeftCorner[1] + size[1] * seq(xlegendPos, (xlegendPos - 
			(0.02 * boxspace * (length(unique(bgCol)) - 1))),
				length = length(unique(bgCol)))
		y=(lowerLeftCorner[2] + size[2] * 1) * rep(ylegendPos, length(unique(bgCol)))
		squares=rep(c(size[1] * 0.012 * boxsize), length(unique(bgCol)))

		symbols(x=x, y = y , bg = unique(bgCol), squares = squares, add = TRUE, 
			inches = FALSE,xpd=TRUE)
	}
	# row-lab
	if(length(rownames)==2){

		x = c(lowerLeftCorner[1] + (size[1] * (c(xlegendPos, xlegendPos)+0.02 * boxspace)))
		y = lowerLeftCorner[2] + (size[2] * c(ylegendPos+(0.02 * boxspace), 1))
		text(x=x, 
		  y = y, rownames, 
		  srt = 0, cex = cex.legend, adj = c(0, 0.5), xpd = TRUE)

	}else if(length(rownames)==1){

		x = c(lowerLeftCorner[1] + (size[1] * (c(xlegendPos)+0.02 * boxspace)))
		y = lowerLeftCorner[2] + (size[2] * c(ylegendPos+(0.02 * boxspace)))
		text(x=x, 
		  y = y, rownames, 
		  srt = 0, cex = cex.legend, adj = c(0, 0.5), xpd = TRUE)

	}
	# col-lab
	  x = lowerLeftCorner[1] + size[1] * seq(xlegendPos, (xlegendPos - ((0.02 * boxspace) * 
	  (length(unique(fgCol)) - 1))), length = length(unique(fgCol)))
	  y = lowerLeftCorner[2] + size[2] * (ylegendPos+0.03*boxspace)
	text(x=x, 
		y = y, colnames, 
		srt = 90, cex = cex.legend, adj = c(0, 0.5), xpd = TRUE)
}

#' add annotation to AllelicImbalance barplot
#' 
#' adds a customizable annotation functionality for AllelicImbalance barplots.
#' 
#' the function is preferably called from within the AllelicImbalance barplot method.
#' 
#' 
#' @param strand strand, "+", "-", "*" or "both"
#' @param snp integer for the described snp
#' @param lowerLeftCorner position of the plot to add legend to (default c(0,0))
#' @param annDfPlus annotation dataframe plus strand
#' @param annDfMinus annotation dataframe minus strand
#' @param cex size of annotation text
#' @param ypos relative y-axis position for the annotation text 
#' @param interspace space between each annotation block
#' @author Jesper R. Gadin
#' @keywords annotation barplot
#' @examples
#'
#' #code placeholders
#' #< create a barplot without annotation >
#' #< add annotation >
#'  
#' @export annotationBarplot

annotationBarplot <- function(strand,snp, lowerLeftCorner, annDfPlus, annDfMinus,
							  cex=0.7, ypos=0, interspace=1){
	i <- snp

	#ypos, is relative to the default

	  # check which columns to extract
	  dfType <- c("symbol", "exon_id", "tx_id", "cds_id")
	  TFann <- (dfType %in% colnames(annDfPlus)) | (dfType %in% colnames(annDfMinus))


	if (strand == "+" | strand == "-" | strand == "*" ) {

	  # placed on left side
	  if (strand == "+" | strand == "*" ) {
		  df <- annDfPlus[, TFann, drop = FALSE]
		
		yPosTmp <- lowerLeftCorner[2] + (1.03) + ypos
		text <- paste("Plus-strand")
		text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
		  adj = 0, xpd = TRUE, cex=cex)
		yPosTmp <- yPosTmp - (0.03*interspace)
		
		for (j in 1:length(colnames(df))) {
		  text <- paste(colnames(df)[j], df[i, j], sep = ": ")
		  text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
			adj = 0, xpd = TRUE, cex=cex)
		  yPosTmp <- yPosTmp - (0.02*interspace)
		}
	  }
	  # placed on left side
	  if (strand == "-" & (!strand == "*" )) {
	  df <- annDfMinus[, TFann, drop = FALSE]
		
		yPosTmp <- lowerLeftCorner[2] + (1.03) + ypos
		text <- paste("Minus-strand")
		text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
		  adj = 0, xpd = TRUE, cex=cex)
		yPosTmp <- yPosTmp - (0.03*interspace)
		for (j in 1:length(colnames(df))) {
		  text <- paste(colnames(df)[j], df[i, j], sep = ": ")
		  text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
			 adj = 0, xpd = TRUE, cex=cex)
		  yPosTmp <- yPosTmp - (0.02*interspace)
		}
	  }
	  # placed on right side
	  if (strand == "*" ) {
	  df <- annDfMinus[, TFann, drop = FALSE]
		
		yPosTmp <- lowerLeftCorner[2] + (1.03) + ypos
		text <- paste("Minus-strand")
		text(x = lowerLeftCorner[1] + 1, y = yPosTmp, labels = text, 
		  adj = 0.95, xpd = TRUE, cex=cex)
		yPosTmp <- yPosTmp - (0.03*interspace)
		
		for (j in 1:length(colnames(df))) {
		  text <- paste(df[i, j], colnames(df)[j], sep = " :")
		  text(x = lowerLeftCorner[1] + 1, y = yPosTmp, labels = text, 
			 adj = 0.95, xpd = TRUE, cex=cex)
		  yPosTmp <- yPosTmp - (0.02*interspace)
		}
	  }
	

	########
	# Dual barplot 
	########
	}else if (strand == "both") {

	  
	  # plus strand (over)
	  df <- annDfPlus[, TFann, drop = FALSE]
	  yPosTmp <- lowerLeftCorner[2] + (1.01) + ypos
	  for (j in 1:length(colnames(df))) {
		text <- paste(colnames(df)[j], df[i, j], sep = ": ")
		text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
		   adj = 0, cex=cex)
		yPosTmp <- yPosTmp - (0.02*interspace)
	  }
	  
	  # minus strand (under)
	  df <- annDfMinus[, TFann, drop = FALSE]
	  
	  yPosTmp <- lowerLeftCorner[2] - (0.01) + ypos
	  for (j in 1:length(colnames(df))) {
		text <- paste(colnames(df)[j], df[i, j], sep = ": ")
		text(x = lowerLeftCorner[1] + 0.01, y = yPosTmp, labels = text, 
		  adj = 0, cex=cex)
		yPosTmp <- yPosTmp + (0.02*interspace)
	  }
	}
}

#' lattice barplot inner functions for ASEset objects
#' 
#' Generates lattice barplots for ASEset objects. Two levels of plotting detail
#' are provided: a detailed barplot of read counts by allele useful for fewer
#' samples and SNPs, and a less detailed barplot of the fraction of imbalance,
#' useful for more samples and SNPs.
#' 
#' \code{filter.pValue.fraction} is intended to remove p-value annotation with
#' very large difference in frequency, which could just be a sequencing
#' mistake. This is to avoid p-values like 1e-235 or similar.
#' 
#' \code{sampleColour}User specified colours, either given as named colours
#' ('red', 'blue', etc) or as hexadecimal code. Can be either length 1 for all
#' samples, or else of a length corresponding to the number of samples for
#' individual colouring.
#' 
#' @name barplot-lattice-support
#' @rdname barplot-lattice-support
#' @aliases barplot-lattice-support barplotLatticeCounts barplotLatticeFraction
#' @param identifier, the single snp name to plot
#' @param ... used to pass on variables
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the barplot
#' function can be called up on.  }
#' @keywords barplot
#' @examples
#' 
#' a <- ASEset
#' name <- rownames(a)[1]
#' 
#' barplotLatticeFraction(identifier=name, x=a, astrand="+") 
#' barplotLatticeCounts(identifier=name,  x=a, astrand="+") 
#' 
#' @export barplotLatticeFraction
#' @export barplotLatticeCounts
#' 
NULL

#' @rdname barplot-lattice-support
barplotLatticeFraction <- function(identifier, ...) {

    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }

	e$ids <- unlist(e$ids)
	e$strand <- e$astrand

    if (!exists("mainvec", envir = e, inherits = FALSE)) {
		e$mainvec <- rep("",nrow(e$x))
	}
	if(class(e$mainvec)=="list"){
		e$mainvec <- unlist(e$mainvec)
	}
    if (!exists("cex.mainvec", envir = e, inherits = FALSE)) {
		e$cex.mainvec <- 1
	}
    if (!exists("main", envir = e, inherits = FALSE)) {
		e$main <- e$mainvec[e$ids %in% identifier]
	}

    if (!exists("deAnnoPlot", envir = e, inherits = FALSE)) {
        e$deAnnoPlot <- FALSE
    }
    
    if (!exists("ylab", envir = e, inherits = FALSE)) {
        e$ylab <- ""
    }
    if (!exists("xlab", envir = e, inherits = FALSE)) {
        e$xlab <- ""
    }
    if (!exists("middleLine", envir = e, inherits = FALSE)) {
        e$middleLine <- TRUE 
    }
    if (!exists("top.fraction.criteria", envir = e, inherits = FALSE)) {
        e$top.fraction.criteria <- "maxcount"
    }

	df <- fractionPlotDf(e$x, identifier, strand=e$strand, top.fraction.criteria=e$top.fraction.criteria)
    
    # Grah params
    my_cols <- c("green", "red")
    
    # set default values
    parset <- list(superpose.polygon=list(col=my_cols))

    scales = list(rot = c(90, 0))
    
	if (e$deAnnoPlot) {
		parset <- list(
				   layout.widths = list(
						left.padding = 0,
						axis.left = 0,
						ylab.axis.padding = 0, 
						right.padding = 0, 
						axis.right = 0
						),
				   layout.heights = list(
						top.padding = 0.1,
						between = 0.1,
						xlab.top= 0.1,
						axis.top = 0,
						main=1.1,
						main.key.padding=1,
						axis.xlab.padding = 1, 
						bottom.padding = 1, 
						axis.bottom = 0.3
						),
				   superpose.polygon=list(col=my_cols)
				   )
	
		scales = list(y = list(at = NULL, labels = NULL),
					  x = list(labels = rep("",ncol(e$x)))
					  )
					  #, rot = c(90, 0))
	}
	if(e$top.fraction.criteria=="phase"){
		groups <- df$phase
		df$groups <- groups
	}else{
		groups <- df$alleles
		df$groups <- groups
	}
    
	if(!e$middleLine) {
		b <- barchart(values ~ sample, group = groups, data = df, origin = 0, 
		    stack = TRUE, scales = scales, 
			main = list(label=e$main, cex=e$cex.mainvec), 
			ylab = e$ylab, xlab = e$xlab, 
		    par.settings = parset)
	}else if (e$middleLine) {
		b <- barchart(values ~ sample, group = groups, data = df, origin = 0, 
			stack = TRUE, scales = scales, 
			main = list(label=e$main, cex=e$cex.mainvec), 
			ylab = e$ylab, xlab = e$xlab, 
			par.settings = parset, panel=function(x, y, ...) {
				 panel.barchart(x, y, ...)
				 panel.abline(h=0.5, lty=1)
			}  )
	}else {
		stop("middleLine has to be TRUE or FALSE")
	} 
    b
    
}

#' @rdname barplot-lattice-support
barplotLatticeCounts <- function(identifier, ...) {

	#null out a variable later used in a lattice plot
	#read here why: http://stackoverflow.com/questions/9439256/how-can-i-handle-r-cmd-check-no-visible-binding-for-global-variable-notes-when
	alleles <- NULL
   
    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }
	
	#use requested strand instead of Gviz ranges strand
	e$strand <- e$astrand
	e$ids <- unlist(e$ids)
    #e$auto.key <- list(points = FALSE, rectangles = TRUE, space = "top", size = 2, 
	#			cex = 0.8)


    if (!exists("mainvec", envir = e, inherits = FALSE)) {
		e$mainvec <- rep("",nrow(e$x))
	}
	if(class(e$mainvec)=="list"){
		e$mainvec <- unlist(e$mainvec)
	}
    if (!exists("main", envir = e, inherits = FALSE)) {
		e$main <- e$mainvec[e$ids %in% identifier]
		#print(identifier)
		#print(e$ids)
		#print(e$main)
		#print(e$mainvec[which(e$ids %in% identifier)])
		#print(e$mainvec)
		#print(which(e$ids %in% identifier))
	}

    if (!exists("deAnnoPlot", envir = e, inherits = FALSE)) {
        e$deAnnoPlot <- FALSE
    }
    
    if (!exists("ylab", envir = e, inherits = FALSE)) {
        e$ylab <- ""
    }
    if (!exists("xlab", envir = e, inherits = FALSE)) {
        e$xlab <- ""
    }

	### Grah params set default values
	parset <- list()
	scales = list(rot = c(90, 0))
		
	makePlotDf <- function(strand){
		acounts<-  alleleCounts(e$x, strand = strand)
		arank<-  arank(e$x, strand = "*")
		#afraction<-  fraction(e$x, strand = strand)
		#amainVec<-  e$amainVec

		# prepare data to be plotted
		#a.m <- amainVec[identifier]
		a.r <- arank[[identifier]][1:2]
		a.c <- acounts[[identifier]][, a.r, drop = FALSE]
		
		values <- as.vector(t(a.c))
		sample <- vector()
		for (i in 1:nrow(a.c)) {
			sample <- c(sample, rownames(a.c)[i], rownames(a.c)[i])
		}

		if(strand=="-" && e$strand=="both"){
			values <- -values
		}
		alleles <- rep(colnames(a.c), nrow(a.c))
		df <- data.frame(values = values, sample = sample, alleles = alleles)

		
		# to get right order in barchart
		df$sample <- factor(df$sample, levels = unique(df$sample))
	
		df
	}

	if(e$strand %in% c("+","-","*")){

		df <- makePlotDf(strand=e$strand)

		if (e$deAnnoPlot) {
			e$auto.key <- FALSE
			parset <- list(
					   layout.widths = list(
							left.padding = 0,
							axis.left = 0,
							ylab.axis.padding = 0, 
							right.padding = 0, 
							axis.right = 0
							),
					   layout.heights = list(
							top.padding = 0.1,
							between = 0.1,
							xlab.top= 0.1,
							axis.top = 0,
							main=1.1,
							main.key.padding=1,
							axis.xlab.padding = 1, 
							bottom.padding = 1, 
							axis.bottom = 0.3
							)
					   )
			scales = list(y = list(at = NULL, labels = NULL), rot = c(90, 0), auto.key = e$auto.key)
		}

		b <- barchart(values ~ sample, horiz = FALSE, origin = 0, group = alleles, data = df, 
			stack = FALSE, scales = scales, ylab = e$ylab, xlab = e$xlab, 
			box.ratio = 2, abbreviate = TRUE, par.settings = parset, main = e$main )

	}else if(e$strand=="both"){
		
		df <- rbind(makePlotDf(strand="+"),makePlotDf(strand="-"))	

		if (e$deAnnoPlot) {
			e$auto.key <- FALSE
			parset <- list(
					   layout.widths = list(
							left.padding = 0,
							axis.left = 0,
							ylab.axis.padding = 0, 
							right.padding = 0, 
							axis.right = 0
							),
					   layout.heights = list(
							top.padding = 0.1,
							between = 0.1,
							xlab.top= 0.1,
							axis.top = 0,
							main=1.1,
							main.key.padding=1,
							axis.xlab.padding = 1, 
							bottom.padding = 1, 
							axis.bottom = 0.3
							)
					   )
			scales = list(y = list(at = NULL, labels = NULL), rot = c(90, 0), auto.key = e$auto.key)
		}
		
		b <- barchart(values ~ sample, horiz = FALSE, origin = 0, group = alleles, data = df, 
			stack = FALSE, scales = scales, ylab = e$ylab, xlab = e$xlab, 
			box.ratio = 2, abbreviate = TRUE, par.settings = parset, main = e$main)
	}else {
		stop("strand must be + - * or both")
	}
    b
}

#' DetectedAI plot
#' 
#' plot functions for the DetectedAI-class
#' 
#' plot helper functions. The documentation will
#' be improved before next release.
#' 
#' @name DetectedAI-plot
#' @rdname DetectedAI-plot
#' @aliases frequency_vs_threshold_variable_plot frequency_vs_threshold_variable_plot,DetectedAI-class
#' @param x detectedAI object
#' @param var string, see details for available options
#' @param smoothscatter boolean, smoothscatter over the means
#' @param hetOverlay logical, if TRUE show nr of het SNPs used to calculate the reference allele frequency mean
#' @param summaryOverSamples 'mean' or 'sum'
#' @param ncol nr of columns for multiplots
#' @param ... pass on variables internally
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords list
#' @examples
#' 
#' #some example code here
#' #generate example
#' data(ASEset)
#' a <- ASEset
#'dai <- detectAI(a, 
#' 			threshold.count.sample=1:50,
#' 			threshold.frequency=seq(0,0.5,by=0.01),
#' 			threshold.delta.frequency=seq(0,0.5,by=0.01),
#' 			threshold.pvalue=rev(seq(0.001,0.05, by=0.005))
#' )
#' 
#' frequency_vs_threshold_variable_plot(dai)
#' detectedAI_vs_threshold_variable_plot(dai)
#' detectedAI_vs_threshold_variable_multigraph_plot(dai)
#' frequency_vs_threshold_variable_multigraph_plot(dai)
#'
NULL

#' @rdname DetectedAI-plot
#' @export
setGeneric("frequency_vs_threshold_variable_plot", function(x, ... 
	){
    standardGeneric("frequency_vs_threshold_variable_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("frequency_vs_threshold_variable_plot", signature(x = "DetectedAI"),
	function(x,var="threshold.count.sample", hetOverlay=TRUE, smoothscatter=FALSE){

	mat <- frequency_vs_threshold_variable_summary(x, var)
	#mean.het <- apply(mat,2,function(x){sum(!is.na(x))})
	mean.het <- apply(usedSNPs_vs_threshold_variable_summary(x, var), 2, mean)

	#mean for every variable
	vec <- apply(mat,2,mean,na.rm=TRUE)
	labels <- slot(x, paste(var,".names", sep=""))
	labels <- as.numeric(labels)
	if(var=="threshold.pvalue"){
		labels <- -log10(labels)
	}

	data <- data.frame(refFreq=vec, variable=labels)
	data2 <- data.frame(meanHetSNPs=mean.het, variable=labels)

	if(smoothscatter){
		#include points for all samples
		data2 <- data.frame(refFreq=as.vector(t(mat)))
		data2$variable <- rep(labels,nrow(mat))			

		colnames(data2) <- c("refFreq","variable")

		xyplot(refFreq ~ variable, data=data2, grid=T, panel=function(x,y, ...){
			panel.smoothScatter(x, y, ...)
			panel.linejoin(x, y, fun=function(y, ...){
								   mean(y,  na.rm=TRUE)
						   },
						   horizontal=FALSE, lwd=2, col="red", ...)
		})
		
	}else{

		a <- xyplot(refFreq ~ variable,data,grid=TRUE, lwd=2, pch=16,type=c("p","l"),
				xlab=var,ylab="Reference Frequency Mean", col="blue"
		)

		if(hetOverlay==TRUE){

			#library(latticeExtra)
			b <- xyplot(meanHetSNPs ~ variable, data2,grid=TRUE, lwd=2, pch=16,type=c("p","l"),
				xlab="",ylab="Nr. of Het SNPs Left", add=TRUE, col="green")

			doubleYScale(a, b, style1 = 0, style2 = 3, add.ylab2 = TRUE)
			    
		}
		
	}
})

#' @rdname DetectedAI-plot
#' @export
setGeneric("detectedAI_vs_threshold_variable_plot", function(x, ... 
	){
    standardGeneric("detectedAI_vs_threshold_variable_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("detectedAI_vs_threshold_variable_plot", signature(x = "DetectedAI"),
	function(x, var="threshold.count.sample", summaryOverSamples="sum", hetOverlay=TRUE, smoothscatter=FALSE){

	mat <- detectedAI_vs_threshold_variable_summary(x, var)
	mean.het <- apply(usedSNPs_vs_threshold_variable_summary(x, var), 2, mean)

	summaryOverSamplesFun <- function(mat,opt=summaryOverSamples){
		if(opt=="sum"){
			return(apply(mat,2,sum,na.rm=TRUE))
		}else if(opt=="mean"){
			return(apply(mat,2,mean,na.rm=TRUE))
		}
	}
	vec <- summaryOverSamplesFun(mat, summaryOverSamples)

	labels <- slot(x, paste(var,".names", sep=""))
	labels <- as.numeric(labels)

	if(var=="threshold.pvalue"){
		labels <- -log10(labels)
	}

	data <- data.frame(detectedAI=vec, variable=labels)
	data2 <- data.frame(meanHetSNPs=mean.het, variable=labels)

	if(smoothscatter){
		#include points for all samples
		data2 <- data.frame(detectedAI=as.vector(t(mat)))
		data2$variable <- rep(labels, nrow(mat))			

		colnames(data2) <- c("detectedAI","variable")

		xyplot(detectedAI ~ variable, data=data2, grid=T, panel=function(x,y, ...){
			panel.smoothScatter(x, y, ...)
			panel.linejoin(x, y, fun=function(y, ...){
								   mean(y,  na.rm=TRUE)
						   },
						   horizontal=FALSE, lwd=2, col="red", ...)
		})

	}else{

		a <- xyplot(detectedAI ~ variable, data,grid=TRUE, lwd=2, pch=16,type=c("p","l"),
				xlab=var,ylab="Detected AI"
		)

		if(hetOverlay){

			#library(latticeExtra)
			b <- xyplot(meanHetSNPs ~ variable, data2,grid=TRUE, lwd=2, pch=16,type=c("h"),
				xlab=var,ylab="", add=TRUE, col="green")

			doubleYScale(a, b, style1 = 0, style2 = 3, add.ylab2 = TRUE)
			    
		}
	}
})

#' @rdname DetectedAI-plot
#' @export
setGeneric("reference_frequency_density_vs_threshold_variable_plot", function(x, ... 
	){
    standardGeneric("reference_frequency_density_vs_threshold_variable_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("reference_frequency_density_vs_threshold_variable_plot", signature(x = "DetectedAI"),
	function(x, var="threshold.count.sample"){

	fr <- frequency_vs_threshold_variable_summary(x, var, return.class="array")

	labels <- slot(x, paste(var,".names", sep=""))
	labels <- as.numeric(labels)
	if(var=="threshold.pvalue"){
		labels <- -log10(labels)
	}

	labels <- aperm(array(labels, dim=dim(fr)[c(3,2,1)]), c(3,2,1))

	#calculate density
	nbins <- dim(fr)[3] 
	x.bin <- seq(min(labels), max(labels), length=nbins)
	y.bin <- seq(0, 1, length=nbins)

	mat.i <- matrix(NA, ncol=2, nrow=length(fr))
	mat.i[,1] <- findInterval(labels, x.bin)
	mat.i[,2] <- findInterval(fr, y.bin)
	mat.i <- mat.i[!is.na(mat.i[,2]),]

	df.long <- as.data.frame(table(mat.i[,2],mat.i[,1]))
	colnames(df.long) <- c("refFreq","threshold", "z")
	
	#data to long format
	#df.long <- data.frame(refFreq=as.vector(fr))
	#df.long[["threshold"]] <- as.vector()


	levelplot(z ~ refFreq*threshold, data = df.long,
			    xlab = var, ylab = "frequency",
				  main = "density of ref allele frequency",
				    col.regions = rev(heat.colors(100))
				)
})



#' @rdname DetectedAI-plot
#' @export
setGeneric("detectedAI_vs_threshold_variable_multigraph_plot", function(x, ... 
	){
    standardGeneric("detectedAI_vs_threshold_variable_multigraph_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("detectedAI_vs_threshold_variable_multigraph_plot", signature(x = "DetectedAI"),
	function(x, ncol=2, ...){
	
	#require(gridExtra)

	graphs <- c("threshold.frequency", "threshold.count.sample",
	"threshold.delta.frequency", "threshold.pvalue" ) 

	pl <- lapply(graphs, function(y,x ){
			detectedAI_vs_threshold_variable_plot(x, var=y, ...)
		}, x
	)
	do.call(grid.arrange, c(pl, ncol=2))

})

#' @rdname DetectedAI-plot
#' @export
setGeneric("frequency_vs_threshold_variable_multigraph_plot", function(x, ... 
	){
    standardGeneric("frequency_vs_threshold_variable_multigraph_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("frequency_vs_threshold_variable_multigraph_plot", signature(x = "DetectedAI"),
	function(x, ncol=2, ...){

	#require(gridExtra)
	
	graphs <- c("threshold.frequency", "threshold.count.sample",
	"threshold.delta.frequency", "threshold.pvalue" ) 

	pl <- lapply(graphs, function(y,x){
			frequency_vs_threshold_variable_plot(x, var=y)
		}, x
	)
	do.call(grid.arrange, c(pl, ncol=2))

})

#' @rdname DetectedAI-plot
#' @export
setGeneric("reference_frequency_density_vs_threshold_variable_multigraph_plot", function(x, ... 
	){
    standardGeneric("reference_frequency_density_vs_threshold_variable_multigraph_plot")
})

#' @rdname DetectedAI-plot
#' @export
setMethod("reference_frequency_density_vs_threshold_variable_multigraph_plot", signature(x = "DetectedAI"),
	function(x, ncol=2, ...){

	#require(gridExtra)
	
	graphs <- c("threshold.frequency", "threshold.count.sample",
	"threshold.delta.frequency", "threshold.pvalue" ) 

	pl <- lapply(graphs, function(y,x){
			reference_frequency_density_vs_threshold_variable_plot(x, var=y)
		}, x
	)
	do.call(grid.arrange, c(pl, ncol=2))

})


#' plot LinkVariantAlmlof objects
#' 
#' plot an object of type LinkVariantAlmlof
#' 
#' @name LinkVariantAlmlof-plot
#' @rdname LinkVariantAlmlof-plot
#' @aliases LinkVariantAlmlof-plot plot plot,LinkVariantAlmlof-method
#' @docType methods
#' @param x LinkVariantAlmlof object
#' @param y not used
#' @param ... pass on arguments to internal methods
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords plot
#' @examples
#' 
#' data(ASEset) 
#' a <- ASEset
#' # Add phase
#' set.seed(1)
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#' 
#' phase(a) <- p
#' 
#' #add alternative allele information
#' mcols(a)[["alt"]] <- inferAltAllele(a)
#' 
#' #init risk variants
#' p.ar <- phaseMatrix2Array(p)
#' rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p.ar)
#'
#' #colnames has to be samea and same order in ASEset and RiskVariant
#' colnames(a) <- colnames(rv)
#'
#' # in this example each and every snp in the ASEset defines a region
#' r1 <- granges(a)
#'
#' # in this example two overlapping subsets of snps in the ASEset defines the region
#' r2 <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))
#'
#' # link variant almlof (lva)
#' lv1 <- lva(a, rv, r1)
#' lv2 <- lva(a, rv, r2)
#' plot(lv2[1])
#'
#' @importFrom graphics plot
#' @exportMethod plot
NULL

#' @rdname LinkVariantAlmlof-plot
setGeneric("plot")

#' @rdname LinkVariantAlmlof-plot
setMethod("plot", signature(x = "LinkVariantAlmlof"), function(x, 
	...) 
{

	for(i in 1:length(x)){
		#y
		mv <- assays(x)[["rs1"]][i,,3]
		#x
		grp <- assays(x)[["lvagroup"]][i,]
		#lmcp
		lmcp <- mcols(x)[["LMCommonParam"]][i,,drop=FALSE]
		#slope
		slope <- lmcp[["est2"]]
		#intercept
		intcpt <- lmcp[["est1"]]

		plot(grp, mv, pch=16, xaxt='n')
		abline(intcpt, slope, lwd=2)
		
		ra <- paste(as.data.frame(range(granges(x[1]))))
		text1 <- paste("Region:", names(x[i]), " P-value:",signif(pvalue(x[i]),3), sep="")
		text2 <- paste("Chr:", ra[1], " Start:", ra[2], " End:", ra[3] , sep="")

		SNPs <- length(mcols(x[1])[["ASEsetIndex"]][[1]])
		text3 <- paste("Nr of SNPs:", SNPs, " Hom:", sum(assays(x)[["rs1"]][i,,1]), " Het:", sum(assays(x)[["rs1"]][i,,2]) , sep="")

		mtext(text1, padj=-3.5)
		mtext(text2, padj=-2.0)
		mtext(text3, padj=-0.5)
		
	}
    
})

### -------------------------------------------------------------------------
### helpers for plot method to the LinkVariantAlmlof generic
###

#' DetectedAI summary
#' 
#' Summary helper functions for the DetectedAI-class
#' 
#' Summary helper functions. The documentation will
#' be improved before next release.
#' 
#' @name DetectedAI-summary
#' @rdname DetectedAI-summary
#' @aliases frequency_vs_threshold_variable_summary frequency_vs_threshold_variable_summary,DetectedAI-method detectedAI_vs_threshold_variable_summary detectedAI_vs_threshold_variable_summary,DetectedAI-method
#' @param x detectedAI object 
#' @param var string, see details for available options
#' @param ... pass on variables internally
#' @param return.class 'matrix' or 'array'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords list
#' @examples
#' 
#' #some example code here
#' #generate example
#' data(ASEset)
#' a <- ASEset
#' dai <- detectAI(a, 
#' 			threshold.count.sample=1:50,
#' 			threshold.frequency=seq(0,0.5,by=0.01),
#' 			threshold.delta.frequency=seq(0,0.5,by=0.01),
#' 			threshold.pvalue=rev(seq(0.001,0.05, by=0.005))
#' )
#' 
#' frequency_vs_threshold_variable_summary(dai)
#' 
#' 
NULL

#' @rdname DetectedAI-summary
#' @export
setGeneric("frequency_vs_threshold_variable_summary", function(x, ... 
	){
    standardGeneric("frequency_vs_threshold_variable_summary")
})

#' @rdname DetectedAI-summary
#' @export
setMethod("frequency_vs_threshold_variable_summary", signature(x = "DetectedAI"),
		function(x,var="threshold.count.sample", return.class="matrix", ...){

		#check if assay is present
		fr <- assays(x)[["reference.frequency"]]
		ar.var <- assays(x)[[var]]
		ar.fr <- array(fr,dim=c(nrow(fr),ncol(fr),dim(ar.var)[3]),
					  dimnames=list(rownames(x),colnames(x),NULL) )

		is.na(ar.var) <- FALSE 
		ar.fr[!ar.var] <- NA

		#colSums(ar.fr,na.rm=TRUE)

		if(return.class=="matrix"){
			apply(ar.fr,c(2, 3),mean,na.rm=TRUE)
		}else if(return.class=="array"){
			ar.fr	
		}

})

#' @rdname DetectedAI-summary
#' @export
setGeneric("detectedAI_vs_threshold_variable_summary", function(x, ... 
	){
    standardGeneric("detectedAI_vs_threshold_variable_summary")
})

#' @rdname DetectedAI-summary
#' @export
setMethod("detectedAI_vs_threshold_variable_summary", signature(x = "DetectedAI"),
		function(x, var="threshold.count.sample"){

	#check if assay is present
	apply(assays(x)[[var]],c(2, 3),sum,na.rm=TRUE)

})

#' @rdname DetectedAI-summary
#' @export
setGeneric("usedSNPs_vs_threshold_variable_summary", function(x, ... 
	){
    standardGeneric("usedSNPs_vs_threshold_variable_summary")
})

#' @rdname DetectedAI-summary
#' @export
setMethod("usedSNPs_vs_threshold_variable_summary", signature(x = "DetectedAI"),
		function(x, var="threshold.count.sample"){

	# filter variable for heterozygotes used in calculation
	# based on non NA:s in the reference.frequency assay and threshold variable

	tf <- array(!is.na(assays(x)[["reference.frequency"]]) & !(assays(x)[["reference.frequency"]]==1) & !(assays(x)[["reference.frequency"]]==0), dim=dim(assays(x)[[var]])) & assays(x)[[var]]

	apply(tf,c(2, 3),sum,na.rm=TRUE)

})

#' inference of SNPs of ASEset
#' 
#' inference of SNPs
#' 
#' threshold.frequency is the least fraction needed to classify as bi tri or
#' quad allelic SNPs. If 'all' then all of bi tri and quad allelic SNPs will use the same
#' threshold. Everything under the treshold will be regarded as noise. 'all' will return 
#' a matrix with snps as rows and uni bi tri and quad will be columns. For this function
#' Anything that will return TRUE for tri-allelicwill also return TRUE for uni and bi-allelic
#' for the same SNP an Sample.
#' 
#'
#' @name inferAlleles
#' @rdname inferAlleles
#' @aliases inferAlleles
#' inferAlleles,ASEset-method 
#' @docType methods
#' @param x ASEset
#' @param strand strand to infer from
#' @param inferOver 'eachSample' or 'allSamples' 
#' @param allow.NA treat NA as zero when TRUE
#' @param return.type 'uni' 'bi' 'tri' 'quad' 'all' 
#' @param threshold.count.sample least amount of counts to try to infer allele
#' @param threshold.frequency least fraction to classify (see details)
#' @author Jesper R. Gadin
#' @keywords infer
#' @examples
#' 
#' data(ASEset)
#' i <- inferAlleles(ASEset)
#' 
#' @exportMethod inferAlleles

setGeneric("inferAlleles", function(x,strand="*",return.type="bi",
	threshold.frequency=0, threshold.count.sample=1,
	inferOver="eachSample", allow.NA=FALSE
	){standardGeneric("inferAlleles")
})
setMethod("inferAlleles", signature(x = "ASEset"), function(x,strand="*",return.type="bi",
	threshold.frequency=0, threshold.count.sample=1,
	inferOver="eachSample", allow.NA=FALSE
	){

	#find SNP types
	fr <- frequency(x,strand=strand, 
		threshold.count.sample=threshold.count.sample,
		return.class="array")
	
	#apply over alleles
	alleles <- apply(fr,c(1,2), function(x){
		sum(x >= threshold.frequency)
	})

	#disregard samples with NA
	if(!allow.NA){
		alleles[is.na(alleles)] <- 0
	}

	if(inferOver=="eachSample"){
		
		if(return.type%in% c("all","uni")){
			tfuni <- alleles == 1 
		}
		if(return.type%in% c("all","bi")){
			tfbi <- alleles == 2 
		}
		if(return.type%in% c("all","tri")){
			tftri <- alleles == 3 
		}
		if(return.type%in% c("all","quad")){
			tfquad <- alleles == 4 
		}
		
		if(return.type=="all"){
			tfall <- array(c(
				 tfuni | tfbi | tftri | tfquad,
				 tfbi | tftri | tfquad,
				 tftri | tfquad,
				 tfquad),
				 dim=c(nrow(x),ncol(x),4),
				 dimnames=list(rownames(x), colnames(x), c("uni","bi","tri","quad")))
			
		}	

	}
	if(inferOver=="allSamples"){
		#apply over samples
		if(return.type%in% c("all","uni")){
			tfuni <- apply(alleles,1, function(x){
				sum(x == 1 ) >= 1
			})
		}
		if(return.type%in% c("all","bi")){
			tfbi <- apply(alleles,1, function(x){
				sum(x == 2 ) >= 1
			})
		}
		if(return.type%in% c("all","tri")){
			tftri <- apply(alleles,1, function(x){
				sum(x == 3 ) >= 1
			})
		}
		if(return.type%in% c("all","quad")){
			tfquad <- apply(alleles,1, function(x){
				sum(x == 4 ) >= 1
			})
		}
		
		if(return.type=="uni"){
			tfuni
		}else if(return.type=="bi"){
			tfbi
		}else if(return.type=="tri"){
			tftri
		}else if(return.type=="quad"){
			tfquad
		}else if(return.type=="all"){
			tfall <- t(matrix(c(
				 tfuni | tfbi | tftri | tfquad,
				 tfbi | tftri | tfquad,
				 tftri | tfquad,
				 tfquad
				 ), nrow=4,byrow=TRUE,
				 dimnames=list(c("uni","bi","tri","quad"),rownames(x))))
		}	
	}

	if(return.type=="uni"){
		tfuni
	}else if(return.type=="bi"){
		tfbi
	}else if(return.type=="tri"){
		tftri
	}else if(return.type=="quad"){
		tfquad
	}else if(return.type=="all"){
		tfall 
			
	}	
	
})


#' infererence of genotypes from ASEset count data
#' 
#' inference of genotypes
#' 
#' Oftern necessary information to link AI to SNPs outside coding region
#' 
#' @name inferGenotypes
#' @rdname inferGenotypes
#' @aliases inferGenotypes inferGenotypes,ASEset-method
#' @param x ASEset
#' @param strand strand to infer from
#' @param threshold.count.sample least amount of counts to try to infer allele
#' @param threshold.frequency least fraction to classify (see details)
#' @param return.allele.allowed vector with 'bi' 'tri' or 'quad'.
#' 'uni' Always gets returned
#' @param return.class 'matrix' or 'vector'
#' @author Jesper R. Gadin
#' @keywords infer
#' @examples
#' 
#' data(ASEset)
#' g <- inferGenotypes(ASEset)
#' 
#' @exportMethod inferGenotypes

setGeneric("inferGenotypes", function(x, strand="*", return.class="matrix",
	return.allele.allowed = "bi",
	threshold.frequency = 0, threshold.count.sample = 1
	){ standardGeneric("inferGenotypes")})
					   
setMethod("inferGenotypes", signature(x = "ASEset"), function(x, strand="*", return.class="matrix",
	return.allele.allowed = "bi",
	threshold.frequency = 0, threshold.count.sample = 1
	){ 
	rn <- arank(x, strand=strand,return.type="names", return.class="matrix")			

	if(return.class=="matrix"){
		al <- inferAlleles(x, strand=strand, threshold.frequency=threshold.frequency,
			threshold.count.sample=threshold.count.sample, return.type="all")	

		ar.rn <- aperm(array(rn, dim=c(nrow(x),4, ncol(x)),
			dimnames=list(rownames(x), c("uni","bi","tri","quad"), colnames(x))), c(1,3,2))
			
		ar.rn[!al] <- ""

		#remove all alleletypes not to be returned
		if(!("quad" %in% return.allele.allowed)){
			ar.rn[,,4] <- ""
		}
		if(!("tri" %in% return.allele.allowed)){
			ar.rn[,,3] <- ""
		}
		if(!("bi" %in% return.allele.allowed)){
			ar.rn[,,2] <- ""
		}

		ret <- apply(ar.rn,c(1,2),function(x){
			tf <- x ==""

			if(sum(!tf)==1){
				paste(x[1],x[1],sep="/")
			}else if(sum(!tf)>1){
				paste(x[!tf],collapse="/")
			}else{
				NA
			}
		})

	} else if(return.class=="vector"){
		#infer allele types
		al <- inferAlleles(x, strand=strand, threshold.frequency=threshold.frequency,
			threshold.count.sample=threshold.count.sample, inferOver="allSamples",
			return.type="all")	

		#remove all not
		rn[!al] <- ""

		#remove all alleletypes not to be returned
		if(!("quad" %in% return.allele.allowed)){
			rn[,4] <- ""
		}
		if(!("tri" %in% return.allele.allowed)){
			rn[,3] <- ""
		}
		if(!("bi" %in% return.allele.allowed)){
			rn[,2] <- ""
		}

		ret <- apply(rn,1,function(x){
			tf <- x ==""
			if(sum(!tf)==1){
				paste(x[1],x[1],sep="/")
			}else{
				paste(x[!tf],collapse="/")
			}
		})
	}
	ret
})

#' inferAltAllele
#' 
#' inference of the alternate allele based on count data
#' 
#' The inference essentially ranks all alleles and the most expressed allele not 
#' declared as reference will be inferred as the alternative allele. At the moment only inference of 
#' bi-allelic alternative alleles are available.
#'
#' @name inferAltAllele
#' @rdname inferAltAllele
#' @aliases inferAltAllele,ASEset-method
#' @docType methods
#' @param x \code{matrix} see examples 
#' @param return.class class of returned object
#' @param allele.source 'arank' 
#' @param verbose make function more talkative 
#' @param ... arguments to forward to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords phase
#' @examples
#' 
#' 
#' #load data
#' data(ASEset)
#' 
#' alt <- inferAltAllele(ASEset)
#' 
#' @exportMethod inferAltAllele
NULL


setGeneric("inferAltAllele", function(x, ...
	){ standardGeneric("inferAltAllele")})
					   
setMethod("inferAltAllele", signature(x = "ASEset"), function(x, strand="*", allele.source="alleleCounts", return.class="vec", verbose=TRUE
	){ 

	if(allele.source=="alleleCounts"){

		#check if ref exists
		if(!"ref" %in% colnames(mcols(x))){
			stop("there is no metadata column for mcols() with the name 'ref'")
		}

		#to be able to infer alternative allele, we need to know the reference allele
		ref <- mcols(x)[,"ref"]
		ar <- arank(x, strand=strand, return.class="matrix")[,c(1,2)]
	}else{
		stop("no such option for allele.source")
	}

	pickSecondMostExpressedAllele(ref, ar)
})

### -------------------------------------------------------------------------
### helpers for inferAltAllele
###

pickSecondMostExpressedAllele <- function(ref, ar){

	tf <- ar == matrix(ref, nrow=nrow(ar), ncol=2)

	ap0 <- apply(tf, 1, function(x){sum(x)==0})
	if(any(ap0)){
		warning(sum(ap0)," SNP reference alleles, were not among the two most expressed alleles")
		tf[ap0,1] <- TRUE
		tf[ap0,2] <- FALSE
	}

	t(ar)[!t(tf)]

}

context("inferAlleles ASEset")

test_that("correct inference of alleles from ASEset return.type='all'", {

	#prepare testdata
	data(ASEset)	
	x <- ASEset[1:3,1:3]
		
	res <- inferAlleles(x, return.type = "all",
		threshold.frequency = 0.05, inferOver="allSamples" )

    expect_that(rownames(res), equals(rownames(x)))
    expect_that(colnames(res), equals(c("uni","bi","tri","quad")))
    expect_that(matrix(res,ncol=4), 
		equals(matrix(c(rep(TRUE,5),rep(FALSE,7)),ncol=4,byrow=FALSE)))



})

test_that("test inferAltAllele", {

	#prepare testdata
	ref <- c("G","G","C")
	ar <- matrix(c("G", "T", "C", "A", "G", "G"), ncol=2)
		
	res <- pickSecondMostExpressedAllele(ref, ar)
	exp <- c("A", "T", "G")

    expect_that(res, equals(exp))

})

#' @include initialize-methods.R
NULL

#' RegionSummary class
#' 
#' Object that holds results from the regionSummary method
#'
#' The RegionSummary-class objects contains summaries for specified regions
#'
#' @name RegionSummary-class
#' @rdname RegionSummary-class
#' @aliases RegionSummary-class RegionSummary RegionSummary-method
#' @docType class 
#' @param x RegionSummary object
#' @param ... pass arguments to internal functions
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class RegionSummary
#' @examples
#'
#' #some code
#'
#' @exportClass RegionSummary
NULL

#' @rdname RegionSummary-class
#' @exportClass RegionSummary
setClass("RegionSummary", contains = "RangedSummarizedExperiment",
	representation(
		meta = "list",
		sumnames = "character"
	)
)

#' @rdname RegionSummary-class
#' @export 
setGeneric("sumnames", function(x, ...){
    standardGeneric("sumnames")
})

#' @rdname RegionSummary-class
#' @export 
setMethod("sumnames", signature(x = "RegionSummary"), function(x) {
	x@sumnames
})

#' @rdname RegionSummary-class
#' @export 
setGeneric("basic", function(x, ...){
    standardGeneric("basic")
})

#' @rdname RegionSummary-class
#' @export 
setMethod("basic", signature(x = "RegionSummary"), function(x) {
	ar <- assays(x)[["rs1"]]
	dimnames(ar)[[3]] <- x@sumnames
	lst <- .array2MatrixList(ar)
	names(lst) <- rownames(x)
	lst
})

#'@include initialize-methods.R
NULL

#' DetectedAI class
#' 
#' Object that holds results from AI detection.
#'
#' The DetectedAI-class contains 
#'
#' @name DetectedAI-class
#' @rdname DetectedAI-class
#' @aliases DetectedAI-class DetectedAI DetectedAI-method
#' @docType class
#' @param x ASEset object or list of ASEsets
#' @param return.class type of class returned eg. "list or ""array".
#' @param ... pass arguments to internal functions
#'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class ASEset
#' @examples
#'
#' data(ASEset)
#' a <- ASEset
#' dai <- detectAI(a)
#' 
#' #summary(gba)
#' #write.tables(dai)
#'
#' @exportClass DetectedAI
NULL

#' @rdname DetectedAI-class
#' @exportClass DetectedAI
setClass("DetectedAI", contains = "RangedSummarizedExperiment",
	representation(
		strand = "character",
		threshold.count.sample.names="character",
		threshold.frequency.names="character",
		threshold.delta.frequency.names="character",
		threshold.pvalue.names="character"
	)
)

#' @rdname DetectedAI-class
#' @export 
setGeneric("referenceFrequency", function(x, ...) {
    standardGeneric("referenceFrequency")
})

#' @rdname DetectedAI-class
#' @export 
setMethod("referenceFrequency", signature(x = "DetectedAI"), function(x,
	return.class="array") {

	if(return.class=="array"){
		return(assays(x)[["reference.frequency"]])
	}
})

#' @rdname DetectedAI-class
#' @export 
setGeneric("thresholdFrequency", function(x, ...) {
    standardGeneric("thresholdFrequency")
})

#' @rdname DetectedAI-class
#' @export 
setMethod("thresholdFrequency", signature(x = "DetectedAI"), function(x,
	return.class="array") {

	if(return.class=="array"){
		return(assays(x)[["threshold.frequency"]])
	}
})

#' @rdname DetectedAI-class
#' @export 
setGeneric("thresholdCountSample", function(x, ...) {
    standardGeneric("thresholdCountSample")
})

#' @rdname DetectedAI-class
#' @export 
setMethod("thresholdCountSample", signature(x = "DetectedAI"), function(x,
	return.class="array") {

	if(return.class=="array"){
		return(assays(x)[["threshold.count.sample"]])
	}
})

#' @rdname DetectedAI-class
#' @export 
setGeneric("thresholdDeltaFrequency", function(x, ...) {
    standardGeneric("thresholdDeltaFrequency")
})

#' @rdname DetectedAI-class
#' @export 
setMethod("thresholdDeltaFrequency", signature(x = "DetectedAI"), function(x,
	return.class="array") {

	if(return.class=="array"){
		return(assays(x)[["threshold.delta.frequency"]])
	}
})

#' @rdname DetectedAI-class
#' @export 
setGeneric("thresholdPvalue", function(x, ...) {
    standardGeneric("thresholdPvalue")
})

#' @rdname DetectedAI-class
#' @export 
setMethod("thresholdPvalue", signature(x = "DetectedAI"), function(x,
	return.class="array") {

	if(return.class=="array"){
		return(assays(x)[["threshold.pvalue"]])
	}
})

#'@include barplot-methods.R
NULL

#' locationplot ASEset objects
#' 
#' plotting ASE effects over a specific genomic region
#' 
#' The locationplot methods visualises how fractions are distributed over a
#' larger region of genes on one chromosome. It takes and ASEset object as well
#' as additional information on plot type (see \code{\link{barplot}}), strand
#' type (see \code{\link{getAlleleCounts}}), colouring, as well as annotation.
#' The annotation is taken either from the bioconductor OrgDb-sets, the TxDb
#' sets or both. It is obviously important to make sure that the genome build
#' used is the same as used in aligning the RNA-seq data.
#' 
#' @name ASEset-locationplot
#' @rdname locationplot
#' @aliases ASEset-locationplot locationplot locationplot,ASEset-method
#' @docType methods
#' @param x an ASEset object.
#' @param type 'fraction' or 'count'
#' @param strand '+','-','*' or 'both'. This argument determines
#' which strand is plotted. See \code{getAlleleCounts} for more information on
#' strand.
#' @param yaxis wheter the y-axis is to be displayed or not
#' @param xaxis wheter the x-axis is to be displayed or not
#' @param ylab showing labels for the tic marks
#' @param xlab showing labels for the tic marks
#' @param ylab.text ylab text
#' @param xlab.text xlab text
#' @param legend.colnames gives colnames to the legend matrix
#' @param size will give extra space in the margins of the inner plots
#' @param main text to use as main label
#' @param pValue Display p-value
#' @param cex.main set main label size
#' @param cex.ylab set ylab label size
#' @param cex.legend set legend label size
#' @param top.fraction.criteria 'maxcount', 'ref' or 'phase'
#' @param OrgDb an OrgDb object from which to plot a gene map. If given
#' together with argument TxDb this will only be used to extract genesymbols.
#' @param TxDb a TxDb object from which to plot an exon map.
#' @param allow.whole.chromosome logical, overrides 200kb region limit, defaults to FALSE
#' @param verbose Setting \code{verbose=TRUE} gives details of procedure during
#' function run
#' @param ... arguments passed on to barplot function
#' @author Jesper R. Gadin, Lasse Folkersen
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the
#' locationplot function can be called up on.  }
#' @keywords locationplot
#' @examples
#' 
#' 
#' data(ASEset)
#' locationplot(ASEset)
#' 
#' #SNPs are plotted in the order in which they are found. 
#' #This can be sorted according to location as follows:
#' locationplot(ASEset[order(start(rowRanges(ASEset))),])
#' 
#' #for ASEsets with fewer SNPs the 'count' type plot is
#' # useful for detailed visualization.
#' locationplot(ASEset,type='count',strand='*')
#' 
#' @export
setGeneric("locationplot", function(x, ...) {
    standardGeneric("locationplot")
})

#' @rdname locationplot
#' @export
setMethod("locationplot", signature(x = "ASEset"), function(x, type = "fraction", 
    strand = "*", yaxis = TRUE, xaxis = FALSE, xlab = FALSE, ylab = TRUE, 
    xlab.text="", ylab.text="", legend.colnames = "", size = c(0.8, 1), main = NULL, pValue = FALSE, cex.main = 0.7, 
    cex.ylab = 0.6, cex.legend = 0.5, OrgDb = NULL, TxDb = NULL, verbose = TRUE, 
    top.fraction.criteria="maxcount",allow.whole.chromosome=FALSE, ...) {

    # check basic chromosome and region requirement
    if (!length(unique(seqnames(rowRanges(x)))) == 1) {
        stop("this plot only allows one chromosome")
    }
	if(!allow.whole.chromosome){
		if ((max(end(rowRanges(x))) - min(start(rowRanges(x)))) > 2e+05) {
			stop("this plot only allows a 200kb region")
		}
	}
    
    # check type
    if (class(type)[1] != "character") 
        stop(paste("type should be of class character, not", class(type)[1]))
    if (length(type) != 1) 
        stop(paste("type should be of length 1, not", length(type)))
    okPlotTypes <- c("fraction", "count")
    if (!type %in% okPlotTypes) 
        stop(paste("type can't be '", type, "' - it should be one of these: ", paste(okPlotTypes, 
            collapse = ", "), sep = ""))
    
    # check strand
    if (class(strand)[1] != "character") 
        stop(paste("strand should be of class character, not", class(strand)[1]))
    if (length(strand) != 1) 
        stop(paste("strand should be of length 1, not", length(strand)))
    okStrandTypes <- c("both", "+", "-", "*")
    if (!strand %in% okStrandTypes) 
        stop(paste("strand can't be '", strand, "' - it should be one of these: ", 
            paste(okStrandTypes, collapse = ", "), sep = ""))
    
    # check if strand type is present in object
    if (strand == "+") {
        el <- "countsPlus"
        if (!(el %in% assayNames(x))) {
            stop("strand is not present as assay in ASEset object")
        }
    } else if (strand == "-") {
        el <- "countsMinus"
        if (!(el %in% assayNames(x))) {
            stop("strand is not present as assay in ASEset object")
        }
    } else if (strand == "*") {
        el <- c("countsPlus","countsMinus")
        if (sum(el %in% assayNames(x))==0) {
            stop("neither plus or minus strand not present as assay in ASEset object")
        }
    } else if (strand == "both") {
        el <- "countsPlus"
        if (!(el %in% assayNames(x))) {
            stop("strand is not present as assay in ASEset object")
        }
        el <- "countsMinus"
        if (!(el %in% assayNames(x))) {
            stop("strand is not present as assay in ASEset object")
        }
    } else {
        stop("unknown strand option")
    }
    
    
    # check if annotation is present, and if it is, then check if it is the right
    # class.
    if (!is.null(OrgDb)) {
        if (!class(OrgDb)[1] %in% c("OrgDb")) 
            stop(paste("if given, annotation should be of class OrgDb, not", class(OrgDb)[1]))
    }
    if (!is.null(TxDb)) {
        if (!class(TxDb)[1] %in% c("TxDb")) 
            stop(paste("if given, annotation should be of class TxDb, not", class(TxDb)[1]))
    }
    
    # check verbose argument is a logical with length 1
    if (class(verbose)[1] != "logical") 
        stop(paste("verbose should be of class logical, not", class(verbose)[1]))
    if (length(verbose) != 1) 
        stop(paste("verbose should be of length 1, not", length(verbose)))
    
    
    # get annotation
    if (!is.null(OrgDb)) {
        if (verbose) 
            message("extracting genes from OrgDb annotation")
        if (is.null(TxDb)) {
            genesInRegion <- getGenesFromAnnotation(OrgDb, rowRanges(x), verbose = verbose)
        } else {
            genesInRegion <- getGenesFromAnnotation(OrgDb, rowRanges(x), getUCSC = TRUE, 
                verbose = verbose)  #if TxDb is also given, then make sure to get the UCSC ids
            
        }
    }
    if (!is.null(TxDb)) {
        if (verbose) 
            message("extracting exons from TxDb annotation")
        exonsInRegion <- getExonsFromAnnotation(TxDb, rowRanges(x), verbose = verbose)
    }
    # if user gave both TxDb and OrgDb we can cross-reference and get gene names as
    # well as UCSC-IDs
    if (!is.null(TxDb) & !is.null(OrgDb)) {
        if ("UCSCKG" %in% colnames(mcols(genesInRegion))) {
            genesymbolKey <- mcols(genesInRegion)[, "Symbol"]
            names(genesymbolKey) <- mcols(genesInRegion)[, "UCSCKG"]
            # this line adds the genesymbol from OrgDb to each of the tx_name entries
            renamed <- as(lapply(mcols(exonsInRegion)[, "tx_name"], function(x, genesymbolKey) {
                paste(genesymbolKey[x], " (", x, ")", sep = "")
            }, genesymbolKey), "CharacterList")
            mcols(exonsInRegion)[, "tx_name"] <- renamed
        } else {
            if (verbose) 
                message("The OrgDb object did not contain cross-reference to TxDb object. No genesymbols were added")
        }
    }
    
    
    # check yaxis
    if (!is.logical(yaxis)) {
        stop("yaxis has to be logical, TRUE or FALSE")
    }
    if (!length(yaxis) == 1) {
        stop("yaxis has to be of length 1")
    }
    
    # check xaxis
    if (!is.logical(xaxis)) {
        stop("xaxis has to be logical, TRUE or FALSE")
    }
    if (!length(xaxis) == 1) {
        stop("xaxis has to be of length 1")
    }
    
    # check ylab
    if (!is.logical(ylab)) {
        stop("ylab has to be logical, TRUE or FALSE")
    }
    if (!length(ylab) == 1) {
        stop("ylab has to be of length 1")
    }
    
    # check xlab
    if (!is.logical(xlab)) {
        stop("xlab has to be logical, TRUE or FALSE")
    }
    if (!length(xlab) == 1) {
        stop("xlab has to be of length 1")
    }
    
    # check legend.colnames
    if (!class(legend.colnames)[1] == "character") {
        stop("legend.colnames has to be of class character")
    }
    
    # check pValue
    if (!is.logical(pValue)) {
        stop("pValue has to be logical, TRUE or FALSE")
    }
    if (!length(pValue) == 1) {
        stop("pValue has to be of length 1")
    }
    
    # check main
    if (!is.null(main)) {
        if (!class(main)[1] == "character") {
            stop("main has to be of class character")
        }
    }
    
    # check cex.main
    if (!class(cex.main)[1] == "numeric") {
        if (cex.main <= 0 | !length(cex.main) == 1) 
            stop("cex.main has to be of class numeric, and have length 1, and a value above 0")
    }
    # check cex.ylab
    if (!class(cex.ylab)[1] == "numeric") {
        if (cex.ylab <= 0 | !length(cex.ylab) == 1) 
            stop("cex.ylab has to be of class numeric, and have length 1, and a value above 0")
    }
    # check cex.legend
    if (!class(cex.legend)[1] == "numeric") {
        if (cex.legend <= 0 | !length(cex.legend) == 1) 
            stop("cex.legend has to be of class numeric, and have length 1, and a value above 0 ")
    }
    
    # check OrgDb
    if (!is.null(OrgDb)) {
        if (!class(OrgDb)[1] == "OrgDb") {
            stop("class of OrgDb has to be an OrgDb class")
        }
    }
    if (!is.null(TxDb)) {
        if (!class(TxDb)[1] == "TxDb") {
            stop("class of TxDb has to be a TxDb class")
        }
    }
    
    
    
    # begin calculations
    chromosome <- unique(as.character(seqnames(rowRanges(x))))
    
    xlim <- range(min(start(rowRanges(x))), max(end(rowRanges(x))))
    
    # increase xlim borders by 10%
    xlim[2] <- xlim[2] + (xlim[2] - xlim[1]) * 0.1
    xlim[1] <- max(c(0, xlim[1] - (xlim[2] - xlim[1]) * 0.1))
    
    
    # standardize ylim across all SNPs
    if (type == "count") {
        if (strand != "both") {
            ylim <- c(0, max(sapply(alleleCounts(x, strand), max)))
        } else {
            maxPlus <- max(sapply(alleleCounts(x, "+"), max))
            maxMinus <- max(sapply(alleleCounts(x, "-"), max))
            max <- max(c(maxPlus, maxMinus))
            ylim <- c(-max, max)
        }
    } else {
        ylim <- NULL
    }
    
    
    # start device
    plot.default(NULL, xlim = xlim, ylim = c(-0.5, 1.1), ylab = "", xlab = paste("genomic position on chromosome", 
        chromosome), yaxt = "n")
    
    
    for (i in 1:nrow(x)) {
        
        # retrieve genomic position
        genomicPos <- start(rowRanges(x[i]))
        # calculate on-plot position and barplot size (for evenly spaced barplots)
        sizeHere <- c((xlim[2] - xlim[1])/nrow(x), 1)
        lowerLeftCorner <- c(xlim[1] + (i - 1) * sizeHere[1], 0)
        sizeHere <- sizeHere * size
        
        # do bar plots
        barplot(x[i], type = type, strand = strand, lowerLeftCorner = lowerLeftCorner, 
            size = sizeHere, addHorizontalLine = 0.5, add = TRUE, pValue = pValue, 
            cex.ylab = cex.ylab, legend.colnames = legend.colnames, yaxis = yaxis, 
            xaxis = xaxis, ylab = ylab, xlab = xlab, main = main, cex.main = cex.main, 
            cex.legend = cex.legend, top.fraction.criteria=top.fraction.criteria,
			ylab.text=ylab.text, xlab.text=xlab.text)#, ...)
        
        # create lines indicating at which genomic position the Snp is found
        lines(x = rep(lowerLeftCorner[1] + size[1]/2, 2), y = c(0, -0.1), col = "dodgerblue")
        lines(x = c(lowerLeftCorner[1] + size[1]/2, genomicPos), y = c(-0.1, -0.2), 
            col = "dodgerblue")
        lines(x = c(genomicPos, genomicPos), y = c(-0.2, -0.25), col = "dodgerblue")
        points(x = genomicPos, y = -0.25, pch = 16)
        
    }
    
    # indicate genomic position on a horizontal line a bit below the plots (at
    # y=-0.25)
    abline(h = -0.25, col = "darkblue")
    
    # try to get the genes and put them on the plot
    if (!is.null(TxDb)) {
        if (!length(exonsInRegion) == 0) {
            decorateWithExons(x, exonsInRegion, xlim = xlim, ylim = c(-0.5, -0.3), 
                chromosome)
        }
	}
    if (!is.null(OrgDb)) {
        if (!length(genesInRegion) == 0) {
            decorateWithGenes(x, genesInRegion, xlim = xlim, ylim = c(-0.5, -0.3), 
                chromosome)
        }
    }
})


#' glocationplot ASEset objects
#' 
#' plotting ASE effects over a specific genomic region using Gviz functionality
#' 
#' The glocationplot methods visualises the distribution of ASE over a larger
#' region on one chromosome. It takes and ASEset object as well as additional
#' information on plot type (see \code{\link{gbarplot}}), strand type (see
#' \code{\link{getAlleleCounts}}), Annotation tracks are created from the Gviz
#' packageh. It is obviously important to make sure that the genome build used
#' is set correctly, e.g. 'hg19'.
#' 
#' sizes has to be of the same length as the number of tracks used.
#' 
#' @name ASEset-glocationplot
#' @aliases ASEset-glocationplot glocationplot glocationplot,ASEset-method
#' @docType methods
#' @param x an ASEset object.
#' @param type 'fraction' or 'count'
#' @param strand '+','-','*' or 'both'. This argument determines which strand is
#' plotted. See \code{getAlleleCounts} for more information of choice of strand.
#' @param BamGAL GAlignmentsList covering the same genomic region as the ASEset
#' @param GenomeAxisTrack include an genomic axis track
#' @param add add to existing plot
#' @param TxDb a TxDb object which provides annotation
#' @param sizes vector with the sum 1. Describes the size of the tracks 
#' @param trackNameDeAn  trackname for deAnnotation track
#' @param verbose if set to TRUE it makes function more talkative
#' @param ... arguments passed on to barplot function
#' @author Jesper R. Gadin
#' @seealso \itemize{ \item The \code{\link{ASEset}} class which the
#' glocationplot function can be called up on.  }
#' @keywords glocationplot
#' @examples
#' 
#' data(ASEset)
#' genome(ASEset) <- 'hg19'
#' 
#' glocationplot(ASEset,strand='+')
#' 
#' #for ASEsets with fewer SNPs the 'count' type plot is useful 
#' glocationplot(ASEset,type='count',strand='+')
#' 

#' @exportMethod glocationplot
setGeneric("glocationplot", function(x, type = "fraction", strand = "*", 
    BamGAL = NULL, GenomeAxisTrack = FALSE, trackNameDeAn = paste("deTrack", type), 
    TxDb=NULL, sizes=NULL, add = FALSE, verbose = FALSE, ...) {
    standardGeneric("glocationplot")
})

setMethod("glocationplot", signature(x = "ASEset"), function(x, type = "fraction", 
    strand = "*", BamGAL = NULL, GenomeAxisTrack = FALSE, trackNameDeAn = paste("deTrack", 
        type), TxDb=NULL, sizes=NULL, add = FALSE, verbose = FALSE, ...) {
   
	#tmp
	#if(!is.null(TxDb)){stop("the functionality with TxDb is not yet ready")}

    # check genome
    if (is.null(genome(x)) | is.na(genome(x))) {
        stop(paste("genome have be set for object x", "e.g. genome(x) <- \"hg19\" "))
    }
    # check type argument
    if (!(type %in% c("fraction", "count"))) {
        stop(paste("type has to be", "fraction", "or", "count"))
    }
    
    # check seqnames has length=0
    if (!(length(seqlevels(x)) == 1)) {
        stop("This function can only use objects with one seqlevel")
    }
    
    #if (sum(strand == "+" | strand == "-") == 0) {
    #    stop("strand must be plus or minus at the moment")
    #}

    if (!nrow(x) == 1) {
       
		if(strand %in% c("+","-","*")){
			GR <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
				end = max(end(x))), strand = strand, genome = genome(x))
		}else if (strand=="both"){
			GR <- GRanges(seqnames = seqlevels(x), ranges = IRanges(start = min(start(x)), 
				end = max(end(x))), strand = "*", genome = genome(x))
		}else{
			stop("strand has to be +, -, * or 'both'")
		}
    }

    
	#make an environment from ...
    if (length(list(...)) == 0) {
        e <- new.env(hash = TRUE)
    } else {
        e <- list2env(list(...))
    }

	e$x <- x


    if (!exists("mainvec", envir = e, inherits = FALSE)) {
		e$mainvec <- rep("",nrow(e$x))
	}
    if (!exists("cex.mainvec", envir = e, inherits = FALSE)) {
		e$cex.mainvec <- 1
	}
    if (!exists("ylab", envir = e, inherits = FALSE)) {
        e$ylab <- ""
    }
    if (!exists("xlab", envir = e, inherits = FALSE)) {
        e$xlab <- ""
    }
    if (!exists("middleLine", envir = e, inherits = FALSE)) {
        e$middleLine <- TRUE
    }
    if (!exists("top.fraction.criteria", envir = e, inherits = FALSE)) {
        e$top.fraction.criteria <- "maxcount"
    }

    # make deTrack 
    if (verbose) {
        (cat("preparing detailedAnnotationTrack\n"))
	}
    deTrack <- ASEDAnnotationTrack(x, GR = GR, type, strand, 
								   trackName = trackNameDeAn,
								   mainvec=e$mainvec,
								   cex.mainvec=e$cex.mainvec,
								   ylab=e$ylab,
								   xlab=e$xlab,
								   top.fraction.criteria=e$top.fraction.criteria
								   )
    lst <- list(deTrack)
   
	start <- min(start(GR))
	end <- max(end(GR))



    if (!is.null(BamGAL)) {
        if (verbose) {
            (cat("preparing coverageDataTrack\n"))
		}

        seqlevels(BamGAL) <- seqlevels(x)
        start <- min(start(x))
        end <- max(end(x))
        
        covTracks <- unlist(CoverageDataTrack(x, BamList = BamGAL, strand = strand, meanCoverage=TRUE))
        

        #lst[[length(lst) + 1]] <- covTracks
		lst <- c(lst,covTracks)
	}


	if(!is.null(TxDb)){
        if (verbose) {
            (cat("preparing transcriptDB track\n"))
		}
		txTrack <- GeneRegionTrack(TxDb, 
			start=start(GR), end=end(GR), 
			chromosome=seqlevels(GR)
		)	   

        lst[[length(lst) + 1]] <- txTrack
	}


    if (GenomeAxisTrack) {
        if (verbose) {
            (cat("preparing GenomeAxisTrack\n"))
		}
        axTrack <- GenomeAxisTrack()
        #lst[[length(lst) + 1]] <- axTrack
		lst <- c(lst,axTrack)
    }


	#set sizes
	parts <- 1/length(lst) #need mean coverage
	if(is.null(sizes)) {
		sizes <- c(rep(parts, length(lst)))
	}else{
		if(!length(sizes)==length(lst)){
			stop("sizes vector has to be same length as the number of tracks used")
		}
	}
	#sizes <- 1
	# plot
	plotTracks(lst, from = start, to = end, sizes = sizes, col.line = NULL, showId = FALSE, 
		title.width = 1, type = "histogram", 
		add = add)


}) 

#
#.boxplot.internal <- function(x, strand="*",
#	labels.axis=TRUE, ...)
#{
#
#	bp <- boxplot(frequency(x,strand=strand), ...)
#	
#	#add numbers of used SNPs ontop of boxplot
#	labels <- hetPerSample(x,strand=strand)
#	axis(side=3,labels=labels,at=1:length(labels))
#
#	#add axis labels
#	if(labels.axis){
#		mtext("Nr. Of Heterozygots Used",side=3, padj=-3, cex=1, font=2)
#		mtext("Reference Allele Frequency", side=2,padj=-3, cex=1, font=2)
#		mtext("Samples",side=1,padj=3, cex=1, font=2)
#	}
#
#	#add red line for 0.5
#	abline(h=0.5, col="red")
#	
#	invisible(bp)
#}
#
#
#

#'@include initialize-methods.R
NULL

#' ASEset objects
#' 
#' Object that holds allele counts, genomic positions and map-bias for a set of
#' SNPs
#' 
#' An ASEset object differs from a regular RangedSummarizedExperiment object
#' in that the assays contains an array instead of matrix. This array has
#' ranges on the rows, sampleNames on the columns and variants in the third
#' dimension.
#' 
#' It is possible to use the commands barplot and locationplot on an ASEset
#' object see more details in \code{\link{barplot}} and
#' \code{\link{locationplot}}.
#' 
#' Three different alleleCount options are available. The simples one is the
#' * option, and is for experiments where the strand information is not
#' known e.g. non-stranded data. The unknown strand could also be for strand 
#' specific data when the aligner could not find
#' any strand associated with the read, but this should normally not happen, 
#' and if it does probably having an extremely low mapping quality. 
#' Then there are an option too add plus
#' and minus stranded data. When using this, it is essential to make sure that
#' the RNA-seq experiment under analysis has in fact been created so that
#' correct strand information was obtained. The most functions will by default 
#' have their strand argument set to '*'.
#'
#' The phase information is stored by the convention of 
#' 'maternal chromosome|paternal chromosome', with 0 as reference allele and 1 
#' as alternative allele. '|' when the phase is known and '/' when the phase is
#' unknown. Internally the information will be stored as an three dimensional 
#' array, dim 1 for SNPs, dim 2 for Samples and dim 3 which is fixed and stores 
#' maternal chromosome, paternal chromosome and phased (1 equals TRUE).
#'
#' 
#' @name ASEset-class
#' @rdname ASEset-class
#' @aliases ASEset-class ASEset alleleCounts mapBias fraction arank 
#' frequency genotype genotype<- phase phase<- alleleCounts,ASEset-method mapBias,ASEset-method
#' fraction,ASEset-method arank,ASEset-method 
#' frequency,ASEset-method genotype,ASEset-method genotype<-,ASEset-method
#' alleleCounts<- alleleCounts<-,ASEset-method phase,ASEset-method phase<-,ASEset-method
#' 
#' @docType class
#' @param x ASEset object
#' @param strand which strand of '+', '-' or '*'
#' @param verbose makes function more talkative
#' @param return.type return 'names', rank or 'counts'
#' @param return.class return 'list' or 'array'
#' @param top.fraction.criteria 'maxcount', 'ref' or 'phase'
#' @param value replacement variable
#' @param ... additional arguments
#' @return An object of class ASEset containing location information and allele
#' counts for a number of SNPs measured in a number of samples on various
#' strand, as well as mapBias information. All data is stored in a manner
#' similar to the SummarizedExperiment class.
#' 
#' @section Table: table(...)
#' 
#' \describe{
#' Arguments: \item{...}{An \code{ASEset object} that contains the
#' variants of interest} 
#'
#' The generics for table does not easily allow more than one argument
#' so in respect to the different strand options, \code{table} will
#' return a SimpleList with length 3, one element for each strand.
#' }
#'
#' @section Frequency: frequency(x, 
#' return.class = "list", strand = "*",
#' threshold.count.sample = 15)
#' 
#' \describe{
#' Arguments: \item{x}{An \code{ASEset object} that contains the
#' variants of interest} 
#' 
#' \item{x}{threshold.count.samples} if sample has fewer counts the function
#' return NA.
#'
#' }
#' @section Constructor: ASEsetFromCountList(rowRanges, countListNonStranded =
#' NULL, countListPlus = NULL, countListMinus = NULL, countListUnknown = NULL,
#' colData = NULL, mapBiasExpMean = array(), verbose=FALSE, ...)
#' 
#' \describe{
#' 
#' Arguments: \item{rowRanges}{A \code{GenomicRanges object} that contains the
#' variants of interest} \item{countListNonStranded}{A \code{list} where each
#' entry is a matrix with allele counts as columns and sample counts as rows}
#' \item{countListPlus}{A \code{list} where each entry is a matrix with allele
#' counts as columns and sample counts as rows} \item{countListMinus}{A
#' \code{list} where each entry is a matrix with allele counts as columns and
#' sample counts as rows} \item{countListUnknown}{A \code{list} where each
#' entry is a matrix with allele counts as columns and sample counts as rows}
#' \item{colData}{A \code{DataFrame} object containing sample specific data}
#' \item{mapBiasExpMean}{A 3D \code{array} describing mapping bias. The SNPs
#' are in the 1st dimension, samples in the 2nd dimension and variants in the
#' 3rd dimension.} \item{verbose}{Makes function more talkative}
#' \item{...}{arguments passed on to SummarizedExperiment constructor} }
#'
#'
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords class ASEset
#' @examples
#' 
#' 
#' #make example countList
#' set.seed(42)
#' countListPlus <- list()
#' snps <- c('snp1','snp2','snp3','snp4','snp5')
#' for(snp in snps){
#'   count<-matrix(rep(0,16),ncol=4,dimnames=list(
#' c('sample1','sample2','sample3','sample4'),
#' c('A','T','G','C')))
#'   #insert random counts in two of the alleles 
#'   for(allele in sample(c('A','T','G','C'),2)){
#' count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
#'   }
#'   countListPlus[[snp]] <- count
#' }
#' 
#' #make example rowRanges
#' rowRanges <- GRanges(
#'   seqnames = Rle(c('chr1', 'chr2', 'chr1', 'chr3', 'chr1')),
#'   ranges = IRanges(1:5, width = 1, names = head(letters,5)),
#'   snp = paste('snp',1:5,sep='')
#' )
#'
#' #make example colData
#' colData <- DataFrame(Treatment=c('ChIP', 'Input','Input','ChIP'), 
#'  row.names=c('ind1','ind2','ind3','ind4'))
#' 
#' #make ASEset 
#' a <- ASEsetFromCountList(rowRanges, countListPlus=countListPlus, 
#' colData=colData)
#'
#'
#' #example phase matrix (simple form)
#' p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#' p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#' 	nrow=nrow(a), ncol(a))
#' 
#' phase(a) <- p
#'
#'
#' #generate ASEset from array
#' snps <- 999
#' samples <-5
#' ar <-array(rep(unlist(lapply(1:snps,
#' 			function(x){(sample(c(TRUE,FALSE,TRUE,FALSE), size = 4))})), samples), 
#' 			dim=c(4,snps,samples))
#' ar2 <- array(sample(50:300, 4*snps*samples,replace=TRUE), dim=c(4,snps,samples))
#' ar2[ar] <- 0
#' ar2 <- aperm(ar2, c(2, 3, 1))
#' dimnames(ar2) <- list(paste("snp",1:snps,sep=""),paste("sample",1:samples,sep=""),
#'							c("A","C","G","T"))
#' gr <- GRanges(seqnames=c("chr2"), ranges=IRanges(start=1:dim(ar2)[1], width=1), strand="*")
#' a <- ASEsetFromArrays(gr, countsUnknown=ar2)
#' 
#'
#' @exportClass ASEset
#' @exportMethod alleleCounts alleleCounts<- mapBias fraction arank
#' frequency genotype genotype<- phase phase<-
#' 
#' @export 

setClass("ASEset", contains = "RangedSummarizedExperiment", 
	representation(variants = "vector"))

#' @rdname ASEset-class
#' @export 
setGeneric("alleleCounts", function(x, strand = "*", return.class="list") {
    standardGeneric("alleleCounts")
})

#' @rdname ASEset-class
#' @export 
setMethod("alleleCounts", signature(x = "ASEset"), function(x, strand = "*",
	return.class="list") {

	#check that strand parameter is correct set
    if (!sum(strand %in% c("+", "-", "*", "both")) > 0) {
        stop("strand parameter has to be either '+', '-', '*' or 'both' ")
    }

	#check if the assays are present
	if(strand=="+" ){
		if(!"countsPlus" %in% assayNames(x)){
			stop(paste("strand",strand,"is not present in ASEset object",sep=""))
		}
	}
	if(strand=="-" ){
		if(!"countsMinus" %in% assayNames(x)){
			stop(paste("strand",strand,"is not present in ASEset object",sep=""))
		}
	}
	if(strand=="*" ){
		if(!("countsMinus" %in% assayNames(x) | "countsPlus" %in% assayNames(x))){
			stop(paste("for strand '*' at least one of '+' or '-' is required to be",
					   " present in ASEset object. Old ASEsets set the '*' strand in",
					   " countsUnknown, but that has been deprecated. If so, move your counts",
					   " to the plus or minus slot instead ",
					   " assays(yourASEset, withDimnames=FALSE)[['countsPlus']] <- assays(yourASEset)[['countsUnknown']]",
					   sep=""))
		}
	}
	if(strand=="both" ){
		if(!"countsMinus" %in% assayNames(x) & "countsPlus" %in% assayNames(x)){
			stop(paste("for strand 'both' both '+' and '-' is required to be",
					   " present in the ASEset object",sep=""))
		}
	}

	#access the correct assays
    if (strand == "+") {
        ar <- assays(x)[["countsPlus"]]
    } else if (strand == "-") {
        ar <- assays(x)[["countsMinus"]]
    } else if (strand == "*") {

		if(!("countsMinus" %in% assayNames(x))){
			ar <- assays(x)[["countsPlus"]]
		}else if(!("countsPlus" %in% assayNames(x))){
			ar <- assays(x)[["countsMinus"]]
		}else{
			ar <- assays(x)[["countsMinus"]] + assays(x)[["countsPlus"]]
		}
    } else if (strand == "both") {
        ar <- array(c(assays(x)[["countsPlus"]], assays(x)[["countsMinus"]]), dim=c(dim(assays(x)[["countsPlus"]]), 2))
    } else {
        stop("not existing strand option")
    }
    
    
	if(return.class=="array"){
		dimnames(ar)[[3]]<- x@variants
		if (strand == "both") {
			dimnames(ar)[[4]]<- c("+","-")
		}
		ar

	}else if(return.class=="list"){


		if(strand=="both"){
			strands <- 2
			alleleCountList2 <- list()
		}else{
			strands <- 1
		}
		for( j in 1:strands){

			alleleCountList <- list()

			for (i in 1:nrow(ar)) {
				if(strand=="both"){
					mat <- ar[i, , ,j]
				}else{
					mat <- ar[i, , ]
				}
				if (class(mat)[1] == "integer") {
					mat <- t(as.matrix(mat))
				}
				if (class(mat)[1] == "numeric") {
					mat <- t(mat)
				}
				colnames(mat) <- x@variants
				rownames(mat) <- colnames(x)

				alleleCountList[[i]] <- mat
			}
			# add snp id
			names(alleleCountList) <- rownames(x)

			if(strand=="both"){
				alleleCountList2[[j]] <- alleleCountList
			}
		}

		if(strand=="both"){
			names(alleleCountList2) <- c("+","-")
			alleleCountList2
		}else{
			alleleCountList
		}
	}else{
		stop("return.class has to be 'list' or 'array'")
	}

    
})
### -------------------------------------------------------------------------
### helpers for alleleCounts
###
.plusStrandCountsExists <- function(x){
	"countsPlus" %in% assayNames(x)
}
.minusStrandCountsExists <- function(x){
	"countsMinus" %in% assayNames(x)
}
.unknownStrandCountsExists <- function(x){
	"countsUnknown" %in% assayNames(x)
}



#' @rdname ASEset-class
#' @export 
setGeneric("alleleCounts<-", function(x, ..., value) {
    standardGeneric("alleleCounts<-")
})

#' @rdname ASEset-class
#' @export 
setReplaceMethod("alleleCounts", "ASEset", 
	function(x, strand="*", return.class="array", ..., value) {

	#for dev
	#message("valueX: ", paste0(value, collapse=", "))

    if (!sum(strand %in% c("+", "-", "*")) > 0) {
        stop("strand parameter has to be either '+', '-', '*' ")
    }
    
    if (strand == "+") {
        el <- "countsPlus"
    } else if (strand == "-") {
        el <- "countsMinus"
    } else if (strand == "*") {
        el <- "countsUnknown"
    } else {
        stop("not existing strand option")
    }
    


	#check that value has the right dimensions (make validObject method)
	#if(!all(dim(value)==dim(assays(x, withDimnames=FALSE)[["countsUnknown"]]))){
	#	stop("dimensions in replacement object is not correct")
	#}

	assays(x, withDimnames=FALSE)[[el]][] <- value

	#return object
	x
})

#' @rdname ASEset-class
#' @export 
setGeneric("mapBias", function(x, ...) {
    standardGeneric("mapBias")
})

#' @rdname ASEset-class
#' @export 
setMethod("mapBias", signature(x = "ASEset"), function(x,
	return.class="list") {
    # assume alleleCount information is stored as element 1

	if(return.class=="array"){
		return(assays(x)[["mapBias"]])

	}else if(return.class=="list"){
		mapBiasList <- list()
		for (i in 1:nrow(x)) {
			mat <- assays(x)[["mapBias"]][i, , ]
			if (class(mat)[1] == "numeric") {
				dim(mat) <- c(1, 4)
				rownames(mat) <- colnames(x)
			}
			colnames(mat) <- x@variants

			mapBiasList[[i]] <- mat
		}
		# add snp id
		names(mapBiasList) <- rownames(x)

		return(mapBiasList)
	}
    
})

#' @rdname ASEset-class
#' @export 
setGeneric("fraction", function(x, ...) {
    standardGeneric("fraction")
})

#' @rdname ASEset-class
#' @export 
setMethod("fraction", signature(x = "ASEset"), function(x, strand = "*", 
    top.fraction.criteria="maxcount", verbose = FALSE, ...) {
    
    if (!sum(strand %in% c("+", "-", "*")) > 0) {
        stop("strand parameter has to be either '+', '-', '*' ")
    }

	#calculate frequency
	fr <- frequency(x, strand=strand, return.class="array", ...)

	#check and use top.fraction.criteria=="phase"
	if(top.fraction.criteria=="phase"){
		if(!"phase" %in% assayNames(x)){
			stop("the phase slot has not been initialized")
		}
		if(is.null(assays(x)[["phase"]])){
			stop("the phase slot cannot be empty if 'top.fraction.criteria=\"phase\"'")
		}

		#take out reference allele information
		ref <- ref(x)
		#select only ref rows (here is mcols() ref required)
		ar <- .arrayFromAlleleVector(x@variants, ref,nc=ncol(x))
		#use the array to subset the ref frequencies
		ret <- .subsetArrayToMatrix(fr, ar)
		#use maternal phase freq, by reverse values in mat that are not ref (0)
		ret <- .returnMaternalPhaseFrequency(phase(x,return.class="array")[,,1], ret)
	}else if(top.fraction.criteria=="ref"){
		#take out reference allele information
		ref <- ref(x)
		#select only ref rows (here is mcols() ref required)
		ar <- .arrayFromAlleleVector(x@variants, ref,nc=ncol(x))
		#use the array to subset the ref frequencies
		ret <- .subsetArrayToMatrix(fr, ar)
	}else if(top.fraction.criteria=="maxcount"){
		#use output from rank as maxcount, select only 1st rank 
		ar <- .arrayFromAlleleVector(x@variants, 
				arank(x, strand = strand, return.class="matrix")[,1], ncol(x))
		#use the array to subset the ref frequencies
		ret <- .subsetArrayToMatrix(fr, ar)
	}
    # return object matrix
	colnames(ret) <- colnames(x)
	rownames(ret) <- rownames(x)
    ret
})
### -------------------------------------------------------------------------
### helpers for fraction
###

#ph is an array, rf is the fraction matrix for ref frequencies
.returnMaternalPhaseFrequency <- function(ph,rf){
	rf[ph==1] <- 1 - rf[ph==1]
	rf
}

#' @rdname ASEset-class
#' @export 
setGeneric("arank", function(x, return.type = "names", 
	return.class = "list", strand = "*", ...) {
    standardGeneric("arank")
})

setMethod("arank", signature(x = "ASEset"), function(x, return.type = "names", 
	return.class = "list", strand = "*", ...) {

	if(return.class=="matrix"){
		if (return.type == "names") {
			ar <- t(apply(apply(alleleCounts(x,
						strand=strand,return.class="array"),c(1,3),sum),
					1, function(x){rank(x,ties.method="first")}))
			ar2 <- t(apply(ar,1,function(x){
						   x <- sort(x,index.return=TRUE,decreasing=TRUE)$ix
						   x
					}))

			mat <- matrix(x@variants[ar2],ncol=4, nrow=nrow(x), byrow=FALSE,
					  dimnames=list(dimnames(ar)[[1]],c(1,2,3,4)))

			return(mat)
		}else if (return.type == "rank") {
			return(t(apply(apply(alleleCounts(x,
						strand=strand,return.class="array"),c(1,3),sum),
					1, function(x){rank(x,ties.method="first")})))
		}else if (return.type == "counts") {
			return(apply(alleleCounts(x,strand=strand,return.class="array"),c(1,3),sum))
		}else{stop("return.type is not valid")}

	}else if(return.class=="list"){

		acounts <- alleleCounts(x, strand = strand)

		if (return.type == "names") {
			lapply(acounts, function(x) {
				names(sort(apply(x, 2, sum), decreasing = TRUE))
			})
		}else if (return.type == "counts") {
			lapply(acounts, function(x) {
				as.numeric(sort(apply(x, 2, sum), decreasing = TRUE))
			})
		}else if (return.type == "rank") {
			stop("rank for return.class 'list' is not implemented yet")
		}else{stop("return.type is not valid")}
	}
}) 

#setGeneric("table")
#setGeneric("table", function(x, strand = "*", sortBy="none", ...) {
#    standardGeneric("table")
#})

# @rdname ASEset-class
#setMethod("table", signature(... = "ASEset"), function(...) {
#
#	args <- list(...)
#	if (length(args) > 1)
#	  stop("Only one argument in '...' supported")
#	x <- args[[1L]]
#
#	#because the generis of table is rubbish we have to return a list for each strand
#	#retList <- list()
#
#	#for(strand in c("+","-","*")){
#	#	df <- data.frame(row.names=rownames(x))
#	#	df[,c("chromosome","position")] <- c(as.character(seqnames(x)),start(x))
#	#	df <- cbind(df,as.data.frame(arank(x, return.type="counts",
#	#				   return.class="matrix",strand=strand)))
#
#	#	#if only one sample add fraction to table()
#	#	if(ncol(x)==1){
#	#		df[,"fraction"] <- as.vector(fraction(x,strand=strand))
#	#	}
#
#	#	retList[[strand]] <- df
#
#	}
#	#return(SimpleList(retList))
#
#	df()
#
#})

#' @rdname ASEset-class
#' @export 
setGeneric("frequency")

setMethod("frequency", signature(x = "ASEset"), function(x, 
	return.class = "list", strand = "*",
	threshold.count.sample = 1) {
	#threshold.count.sample cannot be zero (further down f=1/0 woulf fail)
	if(threshold.count.sample<1){stop("threshold.count.sample needs to be >1")}
	#calculate frequency from Allele counts
	ar2 <- .calcFrequencyFromAlleleCounts(alleleCounts(x, strand=strand, return.class="array"), threshold.count.sample)
	if(return.class=="array"){
		return(ar2)
	}else if(return.class=="list"){
		return(.array2MatrixList(ar2))
	}else{
		stop("return.class has to be 'array' or 'list'")
	}
})
### -------------------------------------------------------------------------
### helpers for frequemcy
###
.calcFrequencyFromAlleleCounts <- function(ar, th){
	actot <- apply(ar, c(1,2), sum, na.rm=TRUE)
	actot[actot  < th] <- NaN
	ar * array(as.vector(1/actot),dim=dim(ar))
}



#' @rdname ASEset-class
#' @export 
setGeneric("genotype", function(x, ...){
    standardGeneric("genotype")
})

#' @rdname ASEset-class
#' @export 
setMethod("genotype", signature(x = "ASEset"), function(x,
			return.class="matrix"){

    if (!("phase" %in% assayNames(x))) {
		stop(paste("phase is not present in assays in",
				   " ASEset object, see '?inferGenotypes' "))
    }
	if(!("ref" %in% names(mcols(x)))){
		stop(paste("ref allele is not present in mcols in",
				   " ASEset object, see '?ASEset' "))
	}
	if(!("alt" %in% names(mcols(x)))){
		stop(paste("alt allele is not present in mcols in",
				   " ASEset object, see '?inferAltAllele' "))
	}

	phase2genotype(phase(x, return.class="array"), ref(x), alt(x), return.class=return.class)

})

#' @rdname ASEset-class
#' @export 
setGeneric("genotype<-", function(x, value){
    standardGeneric("genotype<-")
})

#' @rdname ASEset-class
#' @export 
setMethod("genotype<-", signature(x = "ASEset"), function(x, value){

	#check dimensions
	if(!nrow(x)==nrow(value)){
		stop("nrow(x) is not equal to nrow(value)")
	}
	if(!ncol(x)==ncol(value)){
		stop("ncol(x) is not equal to ncol(value)")
	}
	#check prexence of ref
	if(!"ref" %in% names(mcols(x))){
		stop("ref() is not set in ASEset")
	}
        #It would be better to not allow withDimnames=FALSE
        #I suspect that we need to change something in the init object to fix that.
	assays(x, withDimnames=FALSE)[["phase"]] <- genotype2phase(value, ref(x))	
	x
})


#' @rdname ASEset-class
#' @export 
setGeneric("countsPerSnp", function(x, ...){
    standardGeneric("countsPerSnp")
})

#' @rdname ASEset-class
#' @export 
setMethod("countsPerSnp", signature(x = "ASEset"), function(x, 
	return.class = "matrix", return.type="mean", strand = "*") {

	if(return.class=="matrix"){
		return(apply(alleleCounts(x, strand=strand, return.class="array"), c(1,2), sum))
	}else if(return.class=="vector"){
		if(return.type=="all"){
			return(apply(alleleCounts(x, strand=strand, return.class="array"), 1, sum))
		}else if(return.type=="mean"){
			return(apply(apply(alleleCounts(x, strand=strand, return.class="array"), c(1,2), sum), 1, mean))
		}
	}else{
		stop("return.class has to be 'vector' or 'matrix'")
	}
})

#' @rdname ASEset-class
#' @export 
setGeneric("countsPerSample", function(x, ...){
    standardGeneric("countsPerSample")
})

#' @rdname ASEset-class
#' @export 
setMethod("countsPerSample", signature(x = "ASEset"), function(x, 
	return.class = "matrix", return.type="mean", strand = "*") {

	if(return.class=="matrix"){
		return(apply(alleleCounts(x, strand=strand, return.class="array"), c(1,2), sum))
	}else if(return.class=="vector"){
		if(return.type=="all"){
			return(apply(alleleCounts(x, strand=strand, return.class="array"), 2, sum))
		}else if(return.type=="mean"){
			return(apply(apply(alleleCounts(x, strand=strand, return.class="array"), c(1,2), sum), 2, mean))
		}
	}else{
		stop("return.class has to be 'vector' or 'matrix'")
	}
})

#' @rdname ASEset-class
#' @export 
setGeneric("phase", function(x, ...){
    standardGeneric("phase")
})

#' @rdname ASEset-class
#' @export 
setMethod("phase", signature(x = "ASEset"), function(x, 
	return.class = "matrix" ) {

	if(return.class=="matrix"){
		mat <- phaseArray2phaseMatrix(assays(x)[["phase"]])
		colnames(mat) <- colnames(x)
		rownames(mat) <- rownames(x)
		mat
	}else if(return.class=="array"){
		assays(x)[["phase"]] 
	}
})

#' @rdname ASEset-class
#' @export 
setGeneric("phase<-", function(x, value){
    standardGeneric("phase<-")
})

#' @rdname ASEset-class
#' @export 
setMethod("phase<-", signature(x = "ASEset"), function(x,value) {

	if(class(value)[1]=="matrix") {

		if(!identical(dim(x),dim(value))){
			stop("dimension of value does not correspond to the values of object ASEset")
		}
	
		assays(x, withDimnames=FALSE)[["phase"]] <- phaseMatrix2Array(value,dimnames=dimnames(x))

	}else if(class(value)[1]=="array"){
		assays(x, withDimnames=FALSE)[["phase"]] <- value
	}

	x
})

#' @rdname ASEset-class
#' @export 
setGeneric("mapBias<-", function(x, value){
    standardGeneric("mapBias<-")
})

#' @rdname ASEset-class
#' @export 
setMethod("mapBias<-", signature(x = "ASEset"), function(x,value) {

	if(class(value)[1]=="array") {
		assays(x, withDimnames=FALSE)[["mapBias"]] <- value
	}else {
		stop("class has to be array")
	}
	x
})

#' @rdname ASEset-class
#' @export 
setGeneric("refExist", function(x){
    standardGeneric("refExist")
})

#' @rdname ASEset-class
#' @export 
setMethod("refExist", signature(x = "ASEset"), function(x) {
		!is.null(ref(x))
})

#' @rdname ASEset-class
#' @export 
setGeneric("ref")

#' @rdname ASEset-class
#' @export 
setMethod("ref", signature(x = "ASEset"), function(x) {

		mcols(x)[["ref"]]

})

#' @rdname ASEset-class
#' @export 
setGeneric("ref<-")

#' @rdname ASEset-class
#' @export 
setMethod("ref<-", signature(x = "ASEset"), function(x, value) {

	if(class(value)[1]=="character") {

		mcols(x)[["ref"]] <- value
	}else{

		stop("wrong class")
	}

	x
})

#' @rdname ASEset-class
#' @export 
setGeneric("altExist", function(x){
    standardGeneric("altExist")
})

#' @rdname ASEset-class
#' @export 
setMethod("altExist", signature(x = "ASEset"), function(x) {
		!is.null(ref(x))
})

#' @rdname ASEset-class
#' @export 
setGeneric("alt")

#' @rdname ASEset-class
#' @export 
setMethod("alt", signature(x = "ASEset"), function(x) {

		mcols(x)[["alt"]]

})

#' @rdname ASEset-class
#' @export 
setGeneric("alt<-")

#' @rdname ASEset-class
#' @export 
setMethod("alt<-", signature(x = "ASEset"), function(x, value) {

	if(class(value)[1]=="character") {

		mcols(x)[["alt"]] <- value
	}else{

		stop("wrong class")
	}

	x
})

#' @rdname ASEset-class
#' @export 
setGeneric("aquals", function(x, ...){
    standardGeneric("aquals")
})

#' @rdname ASEset-class
#' @export 
setMethod("aquals", signature(x = "ASEset"), function(x) {
		assays(x)[["aquals"]]
})

#' @rdname ASEset-class
#' @export 
setGeneric("aquals<-", function(x, value){
    standardGeneric("aquals<-")
})

#' @rdname ASEset-class
#' @export 
setMethod("aquals<-", signature(x = "ASEset"), function(x,value) {

	if(class(value)[1]=="array") {

		if(!identical(dim(x),dim(value)[1:2])){
			stop("dimension of value does not correspond to the values of object ASEset")
		}
		assays(x, withDimnames=FALSE)[["aquals"]] <- value

	}
	x
})


#' @rdname ASEset-class
#' @export 
setGeneric("maternalAllele", function(x, ...){
    standardGeneric("maternalAllele")
})

#' @rdname ASEset-class
#' @export 
setMethod("maternalAllele", signature(x = "ASEset"), 
		function(x) {

		mat <- phase(x,return.class="array")[,,1]
		ref <- mcols(x)[["ref"]]
		alt <- mcols(x)[["alt"]]

		apply(t(mat),1,function(y, ref, alt){

			vec <- rep(NA,length(y))
			if(any(y == 1)){
				vec[y == 1] <- alt[y == 1]
			}
			if(any(y == 0)){
				vec[y == 0] <- ref[y == 0]
			}
			vec
		}, ref=ref, alt=alt)
})

#' @rdname ASEset-class
#' @export 
setGeneric("paternalAllele", function(x, ...){
    standardGeneric("paternalAllele")
})

#' @rdname ASEset-class
#' @export 
setMethod("paternalAllele", signature(x = "ASEset"), 
		function(x) {

		mat <- phase(x,return.class="array")[,,2]
		ref <- mcols(x)[["ref"]]
		alt <- mcols(x)[["alt"]]

		apply(t(mat),1,function(y, ref, alt){

			vec <- rep(NA,length(y))
			if(any(y == 1)){
				vec[y == 1] <- alt[y == 1]
			}
			if(any(y == 0)){
				vec[y == 0] <- ref[y == 0]
			}
			vec
		}, ref=ref, alt=alt)
})


##' @rdname ASEset-class
##' @export 
#setGeneric("testet<-", signature="x", function(x, ..., value){
#    standardGeneric("testet<-")
#})
##we need to set a normal generic to be able to use the replacement generic
#setGeneric("testet", signature="x", function(x, ...){
#    standardGeneric("testet")
#})
#
##' @rdname ASEset-class
##' @export 
#setReplaceMethod("testet", c("ASEset"), 
#				 function(x, ... ,value){
#					message("value0: ", paste0(value, collapse=", "))
#					.set_ASEset_ref(x, value)
#				 }
#)
#
#setMethod("testet","ASEset",
#	function(x) ref(x)
#)
#
#.set_ASEset_ref <- function(x, value)
#{
#	message("value1: ", paste0(value, collapse=", "))
#    ## Use 'x@width[]' instead of 'x@width' so the right value is recycled.
#	ref(x)[] <- value
#	x
#}
#
#ref(x)
#testet(x) <- c("O","P","Q")
#testet(x)
#testet(x)[1:2] <- c("S","I")
#
#
##another test
#
#setGeneric("getLetters", function(x)standardGeneric("getLetters"))
#setGeneric("getLetters<-", function(x, value)standardGeneric("getLetters<-"))
#
#setMethod("getLetters", "ASEset", function(x) {
#		    x@variants
#})
#
#setReplaceMethod("getLetters", c("ASEset", "character"), function(x, value) {
#				   message("value: ", paste0(value, collapse=", "))
#				     x@variants <- value
#				     x
#})
#
## [1] "<0x3716b40>"
#getLetters(x)
##  [1] "A" "B" "C" "D" "E" "F" "G" "H" "I" "J"
#getLetters(x)[1:2] <- letters[1:2]
#
#
#

context("test fraction functionality")

#test_that(paste("test fraction default"), {
#
#	#prepare testdata
#	data(ASEset)	
#	x <- ASEset
#
#	res <- t(fraction(x))
#	res <- fraction(x)
#
#	#check 
#    expect_that(colnames(res), equals(rownames(x)))
#    expect_that(rownames(res), equals(colnames(x)))
#    expect_that(as.vector(res)[1:3], equals(c(0.8, 1.0, 1.0)))
#    expect_that(as.vector(res)[57:60], equals(c(NaN,1,1,1)))
#
#})
#
#
#test_that(paste("test fraction usePhase=TRUE"), {
#
#	#prepare testdata
#	#load data
#	data(ASEset) 
#    a <- ASEset
#  	                                                                                              
#	set.seed(1)
#    #example phase matrix 
#    p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#    p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
#    pha <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
#    	nrow=nrow(a), ncol(a))
#  	                                                                                              
#	#infer alt allele
#	mcols(a)[["alt"]] <- inferAltAllele(a)
#
#	#store
#	phase(a) <- pha
#	
#	#check 
#	res <- t(fraction(a, top.fraction.criteria="phase"))
#
#	#check 
#    expect_that(colnames(res), equals(rownames(a)))
#    expect_that(rownames(res), equals(colnames(a)))
#    expect_that(as.vector(res)[1:5], equals(c(0.2, 1.0, 1.0, 0.0, 1.0)))
#    expect_that(as.vector(res)[57:60], equals(c(NaN,0,0,0)))
#
#})
#
test_that(paste("checking .returnMaternalPhaseFrequency"), {

	#####################
	# Test 1 - 
	#####################
	
	#add one region that is missing
	ar <- aperm(array(c(T,T,F,F,F,F,F,F,F,F,F,T), dim=c(3,4,2)), c(1,3,2))
	fr <- array(c(0.3,0.2,0.3,0.2,0.8,0.2,0.3,0.7,0.4,0.2,0.1,0.3), dim=c(3,2,4))
	
	#prepare phase matrix
	ph <- array(c(1,1,0,0,1,0),dim=c(3,2))
	#prepare reference allele matrix
	rf <- array(c(0,0.2,0.8,0,0,1),dim=c(3,2))

	#prepeare expected data
	exp <- array(c(1.0,0.8,0.8,0,1,1), dim=c(3,2))

	#run tests
	res <- .returnMaternalPhaseFrequency(ph,rf)
	
	#test equality
    expect_equal(exp, res)


})

#'@include AllelicImbalance-package.R
NULL

# setMethods('initialize') is not required at the moment

#' Initialize ASEset
#' 
#' Functions to construct ASEset objects
#' 
#' The resulting ASEset object is based on the RangedSummarizedExperiment
#' class, and will therefore inherit the same accessors and ranges operations.
#' 
#' If both countListPlus and countListMinus are given they will be used to 
#' calculate countListUnknown, which is the sum of the plus and minus strands.
#' 
#' countListPlus, countListMinus and countListUnknown are
#' i.e. the outputs from the getAlleleCounts function.
#'
#' aquals is new for the devel branch and will be changed slighly before the relase 
#' to include better granularity.
#' 
#' @name initialize-ASEset
#' @rdname initialize-ASEset
#' @aliases initialize-ASEset ASEsetFromCountList
#' @param rowRanges A \code{GenomicRanges object} that contains the variants of
#' interest
#' @param countListPlus A \code{list} where each entry is a matrix with allele
#' counts as columns and sample counts as rows
#' @param countListMinus A \code{list} where each entry is a matrix with allele
#' counts as columns and sample counts as rows
#' @param countListUnknown A \code{list} where each entry is a matrix with
#' allele counts as columns and sample counts as rows
#' @param countsPlus An array containing the countinformation
#' @param countsMinus An array containing the countinformation
#' @param countsUnknown An array containing the countinformation
#' @param aquals A 4-D array containing the countinformation, see details
#' @param genotype matrix
#' @param colData A \code{DataFrame} object containing sample specific data
#' @param phase A \code{matrix} or an \code{array} containing phase information. 
#' @param mapBiasExpMean A 3D \code{array} where the SNPs are in the 1st
#' dimension, samples in the 2nd dimension and variants in the 3rd dimension.
#' @param verbose Makes function more talkative
#' @param ... arguments passed on to SummarizedExperiment constructor
#' @return \code{ASEsetFromCountList} returns an \code{ASEset} object.
#' @note \code{ASEsetFromCountList} requires the same input data as a
#' RangedSummarizedExperiment, but with minimum one assay for the allele counts.
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords ASEset ASEsetFromCountList
#' @examples
#' 
#' #make example alleleCountListPlus
#' set.seed(42)
#' countListPlus <- list()
#' snps <- c('snp1','snp2','snp3','snp4','snp5')
#' for(snp in snps){
#' count<-matrix(rep(0,16),ncol=4,dimnames=list(
#' c('sample1','sample2','sample3','sample4'),
#' c('A','T','G','C')))
#' #insert random counts in two of the alleles 
#' for(allele in sample(c('A','T','G','C'),2)){
#' count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
#' }
#' countListPlus[[snp]] <- count
#' }
#' 
#' #make example alleleCountListMinus
#' countListMinus <- list()
#' snps <- c('snp1','snp2','snp3','snp4','snp5')
#' for(snp in snps){
#' count<-matrix(rep(0,16),ncol=4,dimnames=list(
#' c('sample1','sample2','sample3','sample4'),
#' c('A','T','G','C')))
#' #insert random counts in two of the alleles 
#' for(allele in sample(c('A','T','G','C'),2)){
#' count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
#' }
#' countListMinus[[snp]] <- count
#' }
#' 
#' 
#' #make example rowRanges
#' rowRanges <- GRanges(
#' seqnames = Rle(c('chr1', 'chr2', 'chr1', 'chr3', 'chr1')),
#'          ranges = IRanges(1:5, width = 1, names = head(letters,5)),
#'          snp = paste('snp',1:5,sep='')
#'          )
#' #make example colData
#' colData <- DataFrame(Treatment=c('ChIP', 'Input','Input','ChIP'), 
#'  row.names=c('ind1','ind2','ind3','ind4'))
#' 
#' #make ASEset 
#' a <- ASEsetFromCountList(rowRanges, countListPlus=countListPlus, 
#' countListMinus=countListMinus, colData=colData)
#' 
NULL


#' @rdname initialize-ASEset
#' @export 
ASEsetFromCountList <- function(rowRanges, countListUnknown = NULL, countListPlus = NULL, 
    countListMinus = NULL, colData = NULL, mapBiasExpMean = NULL, phase = NULL, aquals = NULL,
    verbose = FALSE, ...) {
    
    if (verbose) {
        cat("rowRanges\n")
        cat(class(rowRanges)[1])
        cat("countListPlus\n")
        cat(class(countListPlus)[1])
        cat("countListMinus\n")
        cat(class(countListMinus)[1])
        cat("countListUnknown\n")
        cat(class(countListUnknown)[1])
        cat("colData\n")
        cat(class(colData)[1])
        cat("mapBiasExpMean\n")
        cat(class(mapBiasExpMean)[1])
    }

    # check that at least one of the countList options are not null
    if (is.null(c(countListPlus, countListMinus, countListUnknown))) {
        stop("at least one of the countList options has to be specified")
    }
    
    countLists <- c("countListPlus", "countListMinus", "countListUnknown")[(c( 
        !is.null(countListPlus), !is.null(countListMinus), !is.null(countListUnknown)))]
    
    # check that all lengths are the same in all lists
    l <- unlist(lapply(countLists, function(x) {
        length(get(x))
    }))
    if (sum(!(l == l[1])) > 0) {
        stop("one or more list contains more or less list elements than the others")
    }
    
    # check that the number of columns in each dataframe are the same
    l <- unlist(lapply(countLists, function(x) {
        lapply(get(x), ncol)
    }))
    mat <- matrix(unlist(l), ncol = length(l))
    if (sum(!(mat == mat[1])) > 0) {
        stop("one or more list contains more or less columns than the others")
    }
    
    # check that the number of rows in each dataframe are the same
    l <- unlist(lapply(countLists, function(x) {
        lapply(get(x), nrow)
    }))
    mat <- matrix(unlist(l), ncol = length(l))
    if (sum(!(mat == mat[1])) > 0) {
        stop("one or more list contains more or less rows than the others")
    }
    
    # check that all colnames in all dataframes are the same in same order
    cMatrix <- matrix(NA, nrow = length(unlist(unique(lapply(countLists[1], colnames)))), 
        ncol = length(countLists))
    for (i in 1:length(countLists)) {
        # within list comparision
        countListName <- countLists[i]
        countList <- get(countListName)
        l <- lapply(countList, colnames)
        mat2 <- matrix(unlist(l), ncol = length(l))
        if (sum(!(mat2 == mat2[, 1])) > 0) {
            stop(paste("the names or order of names are not the same in all data frames in list", 
                countListName))
        }
        cMatrix[, i] <- mat2[, 1]
    }
    if (sum(!(cMatrix == cMatrix[, 1])) > 0) {
        stop(paste("the names or order of names are not the same between all data frame lists"))
    }
    
    # check that all rownames in all dataframes are the same in same order
    cMatrix <- matrix(NA, nrow = length(unlist(unique(lapply(countLists[1], rownames)))), 
        ncol = length(countLists))
    for (i in 1:length(countLists)) {
        # within list comparision
        countListName <- countLists[i]
        countList <- get(countListName)
        l <- lapply(countList, rownames)
        mat2 <- matrix(unlist(l), ncol = length(l))
        if (sum(!(mat2 == mat2[, 1])) > 0) {
            stop(paste("the names or order of names are not the same in all data frames in list", 
                countListName))
        }
        cMatrix[, i] <- mat2[, 1]
    }
    if (sum(!(cMatrix == cMatrix[, 1])) > 0) {
        stop(paste("the names or order of names are not the same between all data frame lists"))
    }
    
    # check mapBiasExpMean
    if (!(is.null(mapBiasExpMean))) {
        if (!class(mapBiasExpMean)[1] == "array") {
            stop("mapBiasExpMean has to be of class array")
        }
        if (!length(dim(mapBiasExpMean)) == 3) {
            stop("mapBiasExpMean has to have three dimensions")
        }
	}
        
    # choose a common countList by picking the first one, for dimension info
    countList <- get(countLists[1])
    ind <- length(unlist(unique(lapply(countList, rownames))))
    snps <- length(countList)
    
    # SimpleList init
    assays <- SimpleList()
    
    # plus
    if (!is.null(countListPlus)) {
		#empty array that handles only four nucleotides 
        ar1 <- array(NA, c(snps, ind, 4))  
        for (i in 1:snps) {
            ar1[i, , ] <- countListPlus[[i]]
        }
    }
    # minus
    if (!is.null(countListMinus)) {
		#empty array that handles only four nucleotides 
        ar2 <- array(NA, c(snps, ind, 4))  
        for (i in 1:snps) {
            ar2[i, , ] <- countListMinus[[i]]
        }
        
    }
    # unknown
    if (!is.null(countListUnknown)) {
		#empty array that handles only four nucleotides 
        ar3 <- array(NA, c(snps, ind, 4))  
        for (i in 1:snps) {
            ar3[i, , ] <- countListUnknown[[i]]
        }

	}	

	#ar <- array(0, c(snps, ind, 4, 2))  
	if((is.null(countListMinus)) & (is.null(countListPlus))){
	#	ar[,,,1] <- ar3
		assays[["countsPlus"]] <- ar3
	}else{
		if(!is.null(countListPlus)){
	#		ar[,,,1] <- ar1	
			assays[["countsPlus"]] <- ar1
		}
		if(!is.null(countListMinus)){
	#		ar[,,,2] <- ar2	
			assays[["countsMinus"]] <- ar2
		}
	}
	#assays[["acounts"]] <- ar

    # assign mapBiasExpMean
    if (is.null(mapBiasExpMean)) {
        assays[["mapBias"]] <- getDefaultMapBiasExpMean3D(countList)
    } else {
        assays[["mapBias"]] <- mapBiasExpMean
    }
    
    # assign phase if user provides it
    if (is.null(phase)) {
        assays[["phase"]] <- defaultPhase(snps,ind)
    }

    if (is.null(aquals)) {
        assays[["aquals"]] <- NULL
    }

    if (is.null(colData)) {
        colData <- DataFrame(row.names = unlist(unique(lapply(countList, rownames))))
    }
    
    sset <- SummarizedExperiment(assays = assays, rowRanges = rowRanges, colData = colData, 
        ...)
    
    rownames(sset) <- names(countList)
    
    
    # use colnames in list matrices as variants
    variants <- unlist(unique(lapply(countList, colnames)))
    
    ASEset <- function(sset, variants) {
        # create object
        new("ASEset", sset, variants = variants)
    }
    
    # create object
    ASEset(sset, variants = variants)
} 

#' @rdname initialize-ASEset
#' @export 
ASEsetFromArrays <- function(rowRanges, countsUnknown = NULL, countsPlus = NULL, 
    countsMinus = NULL, colData=NULL,  mapBiasExpMean = NULL, phase = NULL,
	genotype = NULL, aquals = NULL,
    verbose = FALSE, ...) {
    
    # check that at least one of the countList options are not null
    if (is.null(c(countsPlus, countsMinus, countsUnknown))) {
        stop("at least one of the countList options has to be specified")
    }
    
    countLists <- c("countsPlus", "countsMinus", "countsUnknown")[(c( 
        !is.null(countsPlus), !is.null(countsMinus), !is.null(countsUnknown)))]
    
    # check mapBiasExpMean
    if (!(is.null(mapBiasExpMean))) {
        if (!class(mapBiasExpMean)[1] == "array") {
            stop("mapBiasExpMean has to be of class array")
        }
        if (!length(dim(mapBiasExpMean)) == 3) {
            stop("mapBiasExpMean has to have three dimensions")
        }
	}    

    # choose a common countList by picking the first one, for dimension info
    countList <- get(countLists[1])
    ind <- dim(countList)[2]
    ind.names <- dimnames(countList)[2]
    snps <- dim(countList)[1]
    snps.names <- dimnames(countList)[1]
    
    # SimpleList init
    assays <- SimpleList()
    
	ar <- array(0, c(snps, ind, 4, 2)) 

	if((is.null(countsMinus)) & (is.null(countsPlus))){
		#ar[,,,1] <- countsUnknown
		assays[["countsPlus"]] <- countsUnknown
	}else{
		if(!is.null(countsPlus)){
			#ar[,,,1] <- countsPlus	
		assays[["countsPlus"]] <- countsPlus
		}
		if(!is.null(countsMinus)){
			#ar[,,,2] <- countsMinus	
		assays[["countsMinus"]] <- countsMinus
		}
	}

    # assign mapBiasExpMean
    if (is.null(mapBiasExpMean)) {
        assays[["mapBias"]] <- getDefaultMapBiasExpMean3D(ar)
    } else {
        assays[["mapBias"]] <- mapBiasExpMean
    }
    
    # assign phase if user provides it
    if (is.null(phase)) {
        assays[["phase"]] <- defaultPhase(snps,ind)
    }else {
        assays[["phase"]] <- phase
	}
    if (!is.null(genotype)) {
        assays[["genotype"]] <- genotype
    }

    if (is.null(aquals)) {
        assays[["aquals"]] <- NULL
    }

    if (is.null(colData)) {
		sset <- SummarizedExperiment(assays = assays, rowRanges = rowRanges,
        ...)
    }else{
		sset <- SummarizedExperiment(assays = assays, rowRanges = rowRanges, colData=colData,
        ...)
	}

    
    rownames(sset) <- rownames(countList)
    
    
    # use colnames in list matrices as variants
    #variants <- dimnames(assays[["countsUnknown"]])[[3]]    
    variants <- c( "A",  "C", "G", "T")
    ASEset <- function(sset, variants) {
        # create object
        new("ASEset", sset, variants = variants)
    }
    
    # create object
    ASEset(sset, variants = variants)
} 

#' Initialize DetectedAI
#' 
#' Functions to construct DetectedAI objects
#' 
#' produces a class container for reference bias calculations
#' 
#' @name initialize-DetectedAI
#' @rdname initialize-DetectedAI
#' @aliases initialize-DetectedAI 
#' @param x \code{ASEset} 
#' @param strand set strand to detectAI over "+","-","*"
#' @param reference.frequency frequencies of reference alleles based allele counts
#' @param threshold.frequency logical array for frequency thresholds
#' @param threshold.count.sample logical array for per sample allele count thresholds
#' @param threshold.delta.frequency logical array for delta frequency thresholds.
#' @param threshold.pvalue logical array for pvalue thresholds (max 1, min 0)
#' @param threshold.frequency.names character vector
#' @param threshold.count.sample.names character vector
#' @param threshold.delta.frequency.names character vector
#' @param threshold.pvalue.names character vector
#' @param ... internal arguments
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords bias mapbias refBias
#' @examples
#'
#' data(ASEset)
#' a <- ASEset
#' dai <- detectAI(a)
#' 
NULL

#' @rdname initialize-DetectedAI
#' @export 
#setMethod("DetectedAI","DetectedAI", function(
DetectedAIFromArray <- function(
	x = "ASEset",
	strand = "*",
	reference.frequency=NULL,
	threshold.frequency=NULL,
	threshold.count.sample=NULL,
	threshold.delta.frequency=NULL,
	threshold.pvalue=NULL,

	#reference.frequency.names=NULL,
	threshold.frequency.names=NULL,
	threshold.count.sample.names=NULL,
	threshold.delta.frequency.names=NULL,
	threshold.pvalue.names=NULL,

	...){

	sset <- SummarizedExperiment(
				assays = SimpleList(
					reference.frequency=reference.frequency,
					threshold.frequency=threshold.frequency,
					threshold.count.sample=threshold.count.sample,
					threshold.delta.frequency=threshold.delta.frequency,
					threshold.pvalue=threshold.pvalue
					), 
				rowRanges = rowRanges(x), 
				colData = colData(x)
			) 

	rownames(sset) <- rownames(x)

	#valid
	#validObject(.Object)

	#Return object
	new("DetectedAI", sset,
		strand = strand,
		#reference.frequency.names=reference.frequency.names,
		threshold.frequency.names=threshold.frequency.names,
		threshold.count.sample.names=threshold.count.sample.names,
		threshold.delta.frequency.names=threshold.delta.frequency.names,
		threshold.pvalue.names=threshold.pvalue.names
	)
}

###################
#
# Global reference frequency analysis
#
###################

#' Initialize GlobalAnalysis
#' 
#' Functions to construct GlobalAnalysis objects
#' 
#' produces a class container for a global analysis
#' 
#' @name initialize-GlobalAnalysis
#' @rdname initialize-GlobalAnalysis
#' @aliases initialize-GlobalAnalysis
#' @param x \code{ASEset} 
#' @param ... internal arguments
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords global
#' @examples
#'
#' data(ASEset)
#' a <- ASEset
#' # gba <- gba(a)
#' 
NULL


#' @rdname initialize-GlobalAnalysis
#' @export 
#setMethod("ReferenceBias","ReferenceBias", function(
GAnalysis <- function(
	x = "ASEset",
	...
	){
	object <- new("GlobalAnalysis", data = list())

		if(!class(x)[1]=="ASEset"){
			stop("x must be of class ASEset")
		}

	
	#Return object
	object
}

#' Initialize RiskVariant
#' 
#' Functions to construct RiskVariant objects
#' 
#' produces a class container for reference bias calculations
#' 
#' @name initialize-RiskVariant
#' @rdname initialize-RiskVariant
#' @aliases initialize-RiskVariant 
#' @param x GRanges object for the SNPs
#' @param phase array with phaseinfo
#' @param ... internal arguments
#' @author Jesper R. Gadin, Lasse Folkersen
#' @keywords bias mapbias refBias
#' @examples
#'
#' data(ASEset)
#' #p <- getPhaseFromSomewhere
#' #rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p)
#'
#' 
NULL

#' @rdname initialize-RiskVariant
#' @export 
#setMethod("riskVariant","riskVariant", function(
RiskVariantFromGRangesAndPhaseArray <- function(
	x,
	phase,
	...){

		sset <- SummarizedExperiment(
					assays = SimpleList(phase=phase), 
					colData = DataFrame(row.names=1:ncol(phase)),
					rowRanges = x)

		rownames(sset) <- names(x)

		#valid
		#validObject(.Object)

		#Return object
		new("RiskVariant", sset,
			meta = list()
		)
}

###################
#
#  internal List methods
#  
###################

# general list methods
# 
# general list methods that supports flatteing, indexing of lists and conversion of
# flattened lists to lists to lists based on index.
# 
# This is a collection of supportive list methods. The documentation will
# be improved before next release.
# 


.list.depth <- function(this, thisdepth = 0, ...) {
	  if(!is.list(this)) {
		return(thisdepth)
	  }else {
		return(.list.depth(this[[1]], thisdepth = thisdepth+1))
	  }
}
			

.multiUnlist <- function(lst, ...){
	 if(!is.list(lst)){
		 return(lst)
	 }else{
		  .multiUnlist(do.call(c, unname(lst)))
	 }
}

.multiUnlist.index <- function(lst, expand.lowest.level=FALSE){
	
	list.idx.vec <- function(this, i=vector(),vec = vector()) {
		  if(class(this)[1] == "GRanges") {
			  return(c(vec,i,length(this)))
	  } else {
			return(
				unlist(lapply(seq_along(this), 
					   function(y, z, i) { list.idx.vec(y[[i]], i, z)}, y=this, z=c(vec,i))
				))
		  }
	}

	idx.mat <- matrix(list.idx.vec(lst),nrow=.list.depth(lst)+2)
					  
	if(expand.lowest.level){
		matrix(inverse.rle(structure(list(lengths = rep(idx.mat[nrow(idx.mat),],nrow(idx.mat)-1), 
								   values  = as.vector(t(idx.mat[-nrow(idx.mat),]))), class = "rle"))
						   ,nrow=nrow(idx.mat)-1, byrow=TRUE)
	}else{
		idx.mat
	}
}

.multiUnlist.index.names <- function(lst, expand.lowest.level=FALSE){
	
	list.idx.vec <- function(this, i=vector(),vec = vector(), nms=names(this)) {
		
		  if(class(this)[1] == "GRanges") {
			  return(c(vec, nms[i], length(this)))
		  }else {
			return(
				unlist(
					lapply(seq_along(this), 
					   function(y, i, z, n) { 
						   list.idx.vec(y[[i]], i=i, vec=z, nms=n)
					   },
					   y=this, z=c(vec, nms[i]), n=names(this)
					)
				)
			)
		  }
	}

	list.idx.vec(lst)

	idx.mat <- matrix(list.idx.vec(lst),nrow=.list.depth(lst)+2)
					  
	if(expand.lowest.level){
		matrix(inverse.rle(structure(list(lengths = rep(idx.mat[nrow(idx.mat),],nrow(idx.mat)-1), 
								   values  = as.vector(t(idx.mat[-nrow(idx.mat),]))), class = "rle"))
						   ,nrow=nrow(idx.mat)-1, byrow=TRUE)
	}else{
		idx.mat
	}
}

.region.list.populate <- function(ar, idx.mat, idx.mat.names ){

	if(!class(idx.mat)[1] == "matrix") {
		l <- lapply(unique(idx.mat), 
			   function(i, a, m){ 
				   a[,,m==i] 
			   },
			   a=ar, m=idx.mat)
		names(l) <- unique(idx.mat.names) 
		l
	}else{
		l <- lapply(unique(idx.mat[1,]), 
		   function(i, a, m, m2){ 

			   .region.list.populate(a[,,m[1,]==i], m[-1, m[1, ]==i], m2[-1, m[1, ]==i]) 

		   },
		   a=ar, m=idx.mat, m2=idx.mat.names)
		names(l) <- unique(idx.mat.names[1,]) 
		l
	}
}	

context("frequency ASEset")

test_that("frequency list from ASEset is calculated correctly", {
	
	#prepare testdata
	data(ASEset)	
	x <- ASEset[1:2,1:3]
	
	#test function
	fr <- frequency(x, return.class="list", threshold.count.sample = 1)

    # check 
    expect_that(names(fr), equals(rownames(x)))
    expect_that(fr[[1]], 
		equals(matrix(c(0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.2, 0.0, 0.0, 0.8, 1.0, 1.0),
		ncol=4, dimnames=list(colnames(x), x@variants))))
    expect_that(as.numeric(fr[[2]][,2]), equals(c(0.8076923, 1.0000000, 1.0000000 )))
    expect_that(round(as.numeric(fr[[2]][,3]),7), equals(c(0.1923077, 0.0000000, 0.0000000 )))
    expect_that(as.numeric(apply(fr[[1]],1,sum)), equals(c(1,1,1)))
    expect_that(as.numeric(apply(fr[[2]],1,sum)), equals(c(1,1,1)))

})

test_that("frequency array from ASEset is calculated correctly", {
	
	#prepare testdata
	data(ASEset)	
	x <- ASEset[1:3,1:3]
	
	#test function
	fr <- frequency(x, return.class="array", threshold.count.sample = 1)

    # check 
    expect_that(dimnames(fr)[[1]], equals(rownames(x)))
    expect_that(dimnames(fr)[[2]], equals(colnames(x)))
    expect_that(dimnames(fr)[[3]], equals(x@variants))
    expect_that(fr[3,3,3], equals(NaN))
    expect_that(as.numeric(apply(fr[,1,],1,sum)), equals(c(1,1,1)))
    expect_that(as.numeric(apply(fr[,2,],1,sum)), equals(c(1,1,1)))
    expect_that(as.numeric(apply(fr[,3,],1,sum)), equals(c(1,1,NaN)))

})

#context("detect AI from ASEset")
#
#test_that(paste("detectAI from ASEset results and accessors, return.class='DetectedAI',", 
#				"multiple samples, multipliple SNPs"), {
#
#	#prepare testdata
#	data(ASEset)	
#	x <- ASEset
#
#	#make this when the new reference fasta file is in place
#	res <- detectAI(x,strand="*", threshold.count.sample=1) 
#
#	#check row and colnames
#    expect_that(rownames(res), equals(rownames(x)))
#    expect_that(colnames(res), equals(colnames(x)))
#
#	#check strand
#    expect_that(rownames(res), equals(rownames(x)))
#
#	#check reference.frequency
#    expect_that(as.vector(referenceFrequency(res))[1:3], equals(c(0.8000000, 0.8076923, NaN)))
#    expect_that(round(referenceFrequency(res)[57:60],7), equals(c(NaN, 0.7656250, 0.8163265, NaN)))
#
#	#check threshold.frequency
#    expect_that(thresholdFrequency(res)[1:3], equals(c(TRUE,TRUE,NA)))
#    expect_that(thresholdFrequency(res)[57:60], equals(c(NA, TRUE, TRUE, NA)))
#	
#	#check threshold.count.sample
#    expect_that(thresholdCountSample(res)[1:3], equals(c(TRUE,TRUE,FALSE)))
#    expect_that(thresholdCountSample(res)[57:60], equals(c(FALSE, TRUE, TRUE, FALSE)))
#
#	#check threshold.delta.frequency
#    expect_that(thresholdDeltaFrequency(res)[1:3], equals(c(TRUE,TRUE,NA)))
#    expect_that(thresholdDeltaFrequency(res)[57:60], equals(c(NA, TRUE, TRUE, NA)))
#
#	#check threshold.pvalue
#    expect_that(thresholdPvalue(res)[1:3], equals(c(TRUE,TRUE,NA)))
#    expect_that(thresholdPvalue(res)[57:60], equals(c(NA, TRUE, TRUE, NA)))
#
#})
#
#
#

context("test phasing functionality")

test_that(paste("test store and access of phase"), {

	#prepare testdata
	data(ASEset)	
	x <- ASEset

	set.seed(1)
	p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(x)*ncol(x)),nrow=nrow(x), ncol(x))
	p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(x)*ncol(x)),nrow=nrow(x), ncol(x))
	p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(x)*ncol(x), replace=TRUE), p2, sep=""),
		nrow=nrow(x), ncol(x))

	#store matrix
	phase(x) <- p

	#store array
	phase(x) <- phaseMatrix2Array(p, dimnames=dimnames(x))

	#access matrix
	res <- phase(x)

	#access array
	res2 <- phase(x, return.class="array")

	#check 
    expect_that(rownames(res), equals(rownames(x)))
    expect_that(colnames(res), equals(colnames(x)))
    expect_that(as.vector(res)[1:4], equals(c("1|1","0/0","1/0","1/0")))
    expect_that(as.vector(res)[57:60], equals(c("0/0","0|1","0|0","1/0")))

    expect_that(rownames(res2), equals(rownames(x)))
    expect_that(colnames(res2), equals(colnames(x)))
    expect_that(as.vector(res2)[1:4], equals(c(1,0,1,1)))
    expect_that(as.vector(res2)[177:180], equals(c(0,1,1,0)))

})

context("positions from CIGAR")

test_that("positions including deletions are calculated correctly ", {
    
    # position on the ref-genome
    refPOS <- c(5, 4, 6)
    
    # the actual position in the read
    readPOS <- c(4, 0, 0)
    
    CIGARS <- c("3M1D6M", "3M1D1M1D5M", "3M1D1M1D5M")
    # run function
    cl <- cigarToRleList(CIGARS)
    funPOS <- mapply(realCigarPosition.old, cl, refPOS)
    
    # check if equals
    expect_that(funPOS, equals(readPOS))
})

test_that("positions including insertions are calculated correctly ", {
    
    # position on the ref-genome
    refPOS <- c(5, 4, 6, 3)
    
    # the actual position in the read
    readPOS <- c(8, 5, 8, 6)
    
    CIGARS <- c("3M3I6M", "3M1I1M2I5M", "3M1I1M1I5M", "2M3I2M2I4M")
    
    # run function
    cl <- cigarToRleList(CIGARS)
    funPOS <- mapply(realCigarPosition.old, cl, refPOS)
    
    # check if equals
    expect_that(funPOS, equals(readPOS))
    
})


test_that("positions including introns are calculated correctly ", {
    # position on the ref-genome
    refPOS <- c(20, 204, 98)
    
    # the actual position in the read
    readPOS <- c(-1, 4, -1)
    
    CIGARS <- c("3M200N97M", "3M200N97M", "97M200N3M")
    
    # run function
    cl <- cigarToRleList(CIGARS)
    funPOS <- mapply(realCigarPosition.old, cl, refPOS)
    
    # check if equals
    expect_that(funPOS, equals(readPOS))
    
    
})
 

#context("calculate reference fraction from ASEset")
#
#test_that(paste("calculate reference fraction from ASEset return.class='matrix'"), {
#
#	#prepare testdata
#	data(ASEset)	
#	x <- ASEset
#
#
#	#make this when the new reference fasta file is in place
#	res <- refFraction(x,strand="*", threshold.count.sample=1, inferGenotypes=TRUE) 
#
#	#remove one dim
#	res <- res[,,1]
#
#    expect_that(rownames(res), equals(rownames(x)))
#    expect_that(colnames(res), equals(colnames(x)))
#    expect_that(as.vector(res)[1:3], equals(c(0.8000000, 0.8076923, NaN)))
#    expect_that(round(as.vector(res)[57:60],7), equals(c(NaN, 0.7656250, 0.8163265, NaN)))
#
#})
#
#

context("calculate rank from ASEset")

test_that(paste("calculate arank from ASEset return.class='matrix' and",
				"return.type='names'"), {

	#prepare testdata
	data(ASEset)	
	x <- ASEset
		
	res <- arank(x, return.type = "names",
		return.class="matrix")

    expect_that(rownames(res), equals(rownames(x)))
    expect_that(colnames(res), equals(c("1","2","3","4")))
    expect_that(as.vector(res), equals(c(
			"T","C","G","G","G","A","C","T","T","A","A","C")))

})

context("count alleles from Bam File")

#test_that(paste("check that different import methods give same result"), {
#
#	#prepare testdata
#	data(GRvariants)
#	gr <- GRvariants
#	pathToDir <- system.file('inst/extdata/ERP000101_subset', package='AllelicImbalance')
#	#pathToDir <- system.file('inst/extdata/ERP000101_subset/tmp', package='AllelicImbalance')
#
#	#import variant 1
#	bam <- impBamGAL(pathToDir, gr, reduce=TRUE, readLength=36,
#					 scanBamFlag=scanBamFlag(), verbose=FALSE)
#	bam2 <- GAlignmentsList(lapply(bam,function(x){x[mcols(x)[["flag"]]%in%c(99,147,163,83)]}))
#	seqlevels(bam2) <- seqlevels(gr)
#
#	#change strand to match secondstrand
#	bam2 <- GAlignmentsList(lapply(bam2,function(x){
#					cat(names(x))
#					strand(x)[mcols(x)[["flag"]]%in%c(83,163)] <- "-"
#					strand(x)[mcols(x)[["flag"]]%in%c(99,147)] <- "+"
#					x
#				  }))
#
#	plus <- getAlleleCounts(bam2, gr, strand="+",return.class="array",verbose=F )
#	minus <- getAlleleCounts(bam2, gr, strand="-",return.class="array",verbose=F)
#
#	#import variant 2
#
#	#minus strand
#	arm1 <- countAllelesFromBam(gr, pathToDir, flag=83, verbose=FALSE)
#	arm2 <- countAllelesFromBam(gr, pathToDir, flag=163, verbose=FALSE)
#	arm <- arm1 + arm2
#
#	#plus strand
#	arp1 <- countAllelesFromBam(gr, pathToDir, flag=99, verbose=FALSE)
#	arp2 <- countAllelesFromBam(gr, pathToDir, flag=147, verbose=FALSE)
#	arp <- arp1 + arp2
#
#	#test equality
#    expect_that(rownames(plus), equals(rownames(arp)))
#    expect_that(colnames(plus), equals(colnames(arp)))
#    expect_that(rownames(minus), equals(rownames(arm)))
#    expect_that(colnames(minus), equals(colnames(arm)))
#	expect_identical(plus, arp)
#	expect_identical(minus, arm)
#})

context("inferGenotypes ASEset")

test_that("correct inference of genotypes from ASEset return.class='matrix'", {

	#prepare testdata
	data(ASEset)	
	x <- ASEset[1:3,c(1:9)]
		
	res <- inferGenotypes(x,strand="*", return.class = "matrix",
		threshold.frequency = 0.05,
		threshold.count.sample = 1
	)

    expect_that(rownames(res), equals(rownames(x)))
    expect_that(colnames(res), equals(colnames(x)))
    expect_that(res,equals(matrix(
				c("T/G", "C/G", "G/G", "T/T", "C/C", "G/G", "T/T", "C/C",
			   NA, "T/T", "C/C", "G/G", "T/T", "C/C", "G/G", "T/G",
			   "C/G", "G/A", "T/G", "C/G", "G/G", "T/T", "C/C", "G/G",
			   NA, NA, NA),
				nrow=nrow(x), dimnames=list(rownames(x),colnames(x)),
				byrow=FALSE)))

})

---
title: "AllelicImbalance Vignette"
author: "Jesper R. Gadin and Lasse Folkersen"
date: "`r Sys.Date()`"
output:
  BiocStyle::pdf_document:
    toc: true
    fig_caption: yes
vignette: >
  %\VignetteIndexEntry{AllelicImbalance Vignette}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---
```{r style, echo = FALSE, results = 'asis'}
BiocStyle::markdown()
```

```{r functions, include=FALSE}
# A function for captioning and referencing images
fig <- local({
    i <- 0
    ref <- list()
    list(
        cap=function(refName, text) {
            i <<- i + 1
            ref[[refName]] <<- i
            #paste("Figure ", i, ": ", text, sep="")
            paste(text, sep="")
        },
        ref=function(refName) {
            ref[[refName]]
        })
})
```

#Introduction
This `r Biocpkg("AllelicImbalance")` package contains functions for investigating allelic imbalance effects in RNA-seq data. Maternal and paternal alleles could be expected to show identical transcription rate, resulting in a 50%-50% mix of maternal and paternal mRNA in a sample. However, this turns out to sometimes not be the case. The most extreme example is the X-chromosome inactivation in females, but many autosomal genes also have deviations from identical transcription rate. The causes of this are not always known, but one likely cause is the difference in DNA, namely heterozygous SNPs, affecting enhancers, promoter regions, splicing and stability. Identifying this allelic imbalance is therefore of interest to the characterization of the genome and the aim of the AllelicImbalance package is to facilitate this.

Load AllelicImbalance
```{r echo = TRUE, eval = TRUE, message = FALSE}
library(AllelicImbalance)
```

# ASEset
The ASEset object is the central class of objects in the AllelicImbalance package. The ASEset object has the RangedSummarizedExperiment from the `r Biocpkg("SummarizedExperiment")` package as parent class, and all functions you can apply on this class you can also apply on an ASEset.

## Simple example of building an ASEset object
In this section we will walk through the various ways an ASEset object can be created. Although the preprocessing of RNA-seq data is not the primary focus of this package, it is a necessary step before analysis. There exists several different methods for obtaining a bam file, and this section should just be considered an example. For further details we refer to the web-pages of tophat, bowtie, bwa and samtools found in the links section at the end of this document.

```
wget ftp://ftp.sra.ebi.ac.uk/vol1/fastq/ERR009/ERR009135/*
bowtie -q --best --threads 5 --sam hg19 +
>      -1 ERR009135_1.fastq.gz -2 ERR009135_2.fastq.gz "ERR009135.sam"
samtools view -S -b ERR009135.sam > ERR009135.bam
```

In the above code one paired-end RNA sequencing sample is downloaded and aligned to the human genome, then converted to bam using samtools. The resulting bam files can be the direct input to the AllelicImbalance package. Other aligners can be used as well, as long as bam files are provided as input. The example code following illustrates how to use the import mechanism on a chromosome 17-located subset of 20 RNA-seq experiments of HapMap samples. The output is an ASEset object containing allele counts for all heterozygote coding SNPs in the region.

```{r echo = TRUE, eval = TRUE}
searchArea <- GRanges(seqnames = c("17"), ranges = IRanges(79478301, 79478361))
pathToFiles <- system.file("extdata/ERP000101_subset", 
								package = "AllelicImbalance")
reads <- impBamGAL(pathToFiles, searchArea, verbose = FALSE)
heterozygotePositions <- scanForHeterozygotes(reads, verbose = FALSE)
countList <- getAlleleCounts(reads, heterozygotePositions, verbose = FALSE)
a.simple <- ASEsetFromCountList(heterozygotePositions, countList)
a.simple
```

## Building an ASEset object using Bcf or Vcf files
If more than a few genes and a few samples are analyzed we recommend that a SNP-call is instead made using the samtools mpileup function (see links section). The scanForHeterozygotes function is merely a simple  SNP-caller and it is not as computationally optimized as e.g. mpileup. In this bash code we download reference sequence for chromosome 17 and show how to generate mpileup calls on one of the HapMap samples that were described above.

```
#download the reference chromosome in fasta format
wget ftp://hgdownload.cse.ucsc.edu/goldenPath/hg19/chromosomes/chr17.fa.gz

#Vcf format
samtools mpileup -uf hg19.fa ERR009135.bam > ERR009135.vcf

#Bcf format
samtools mpileup --BCF --fasta-ref hg19.fa \
	--output ERR009135.bcf ERR009135.bam
```

Samtools mpileup generates by default a Vcf file which contains SNP and short INDEL positions. Piping the output to bcftools we get its binary equivalent (Bcf), which takes less space and can be queried more effective. 

The Vcf file is a text file that stores information about positions in the genome. In addition to the location, stored informationn could for example be genotype, phase, reference and alternative alleles for a collection of samples. More detailed information can be found following this [link](http://samtools.github.io/hts-specs/VCFv4.1.pdf).
 
In the `r Biocpkg("VariantAnnotation")` package there is a lot of useful tools to handle  Vcf files. The readVcf function reads Vcf data into R, which can be subset to only ranges by granges to get a GRanges object that is the object type required by the getAlleleCounts function. 

```{r echo = TRUE, eval = TRUE, warning = FALSE}
library(VariantAnnotation)
pathToVcf <- paste(pathToFiles,"/ERP000101.vcf",sep="")
VCF <- readVcf(pathToVcf,"hg19") 
gr <- granges(VCF) 

#only use bi-allelic positions
gr.filt <- gr[width(mcols(gr)[,"REF"]) == 1 | 
				unlist(lapply(mcols(gr)[,"ALT"],width))==1]

countList <- getAlleleCounts(reads, gr.filt, verbose=FALSE) 
a.vcf <- ASEsetFromCountList(rowRanges = gr, countList)
```

With the Bcf files the process of generating an ASEset object starts with a call to the impBcfGR  function instead. This function will import the Bcf file containing all SNP calls that were generated with the samtools mpileup function.

```{r echo = TRUE, eval = TRUE}
BcfGR <- impBcfGR(pathToFiles,searchArea,verbose=FALSE)
countListBcf <- getAlleleCounts(reads, BcfGR,verbose=FALSE)
a.bcf <- ASEsetFromCountList(BcfGR, countListBcf)
```

## Using strand information
Many RNA-seq experiments do not yield useful information on the strand from which a given read was made. This is because they involve a step in which a double-stranded cDNA is created without tracking strand-information. Some RNA-seq setups do however give this information and in those cases it is important to keep track of strand in the ASE-experiment. The example data from above is from an experiment which created double-stranded cDNA before labelling and so the '+' and '-' information in it is arbitrary. However, if we assume that the information has strand information, then the correct procedure is as follows:


```{r echo = TRUE, eval = TRUE}
plus <- getAlleleCounts(reads, heterozygotePositions, strand="+",verbose=F) 
minus <- getAlleleCounts(reads, heterozygotePositions, strand="-",verbose=F)

a.stranded <-
ASEsetFromCountList(
heterozygotePositions,
countListPlus=plus,
countListMinus=minus
)
a.stranded
```
The main effect of doing this, is in the plotting functions which will separate reads from different strands if they are specified as done here. It is important, however, to make sure that the imported RNA-seq experiment does in fact have proper labeling and tracking of strand information before proceeding with this method.

## Two useful helper functions
At this stage it is worth highlighting two useful helper functions that both uses existing BioC annotation objects. One is the getAreaFromGeneNames which quickly retrieves the above mentioned searchArea when given just genesymbols as input, and relies on  `r Biocannopkg("org.Hs.eg.db")`. The other other is the getSnpIdFromLocation function which attempts to rename location-based SNP names to established rs-IDs in case they exist. These functions work as follows:

```{r echo = TRUE, eval = TRUE, message = FALSE, results = 'hide'}
#Getting searchArea from genesymbol
library(org.Hs.eg.db )
searchArea<-getAreaFromGeneNames("ACTG1",org.Hs.eg.db)

#Getting rs-IDs
library(SNPlocs.Hsapiens.dbSNP144.GRCh37)
gr <- rowRanges(a.simple)
updatedGRanges<-getSnpIdFromLocation(gr, SNPlocs.Hsapiens.dbSNP144.GRCh37)
rowRanges(a.simple)<-updatedGRanges
```

## Adding phenotype data
Typically an RNA-seq experiment will include additional information about each sample. It is an advantage to include this information when creating an ASEset because it can be used for subsequent highlights or subsetting in plotting and analysis functions.

```{r echo=TRUE, eval=TRUE}
#simulate phenotype data
pdata <- DataFrame(
	Treatment=sample(c("ChIP", "Input"),length(reads),replace=TRUE),
	Gender=sample(c("male", "female"),length(reads),replace=TRUE), 
	row.names=paste("individual",1:length(reads),sep=""))

#make new ASEset with pdata
a.new <- ASEsetFromCountList(
		heterozygotePositions,
		countList,
		colData=pdata)

#add to existing object
colData(a.simple) <- pdata
```
## Adding genotype information
The genotype of the coding SNPs can be set by the command ```genotype(x) <- value```. If the genotype information is not available it can be inferred from the allele counts. The major allele will then be the allele with most counts and minor with second most counts. The notation is major/minor and for the example G/C, The G allele would be the major and C the minor allele. To be able to infer and store the genotype information it is required to first declare reference alleles. In cases when it is not important to know which allele is reference, the reference allele can be inferred from allele counts, by random takingone of the most expressed alleles. 

```{r echo=TRUE, eval=TRUE}
#infer and add genotype require declaration of the reference allele 
ref(a.simple) <- randomRef(a.simple)
genotype(a.simple) <- inferGenotypes(a.simple)

#access to genotype information requires not only the information about the
#reference allele but also the alternative allele
alt(a.simple) <- inferAltAllele(a.simple)
genotype(a.simple)[,1:4]
```

## Adding phase information
For some functionality phase information is necessary. Phasing can be obtained from many external sources e.g. samtools. The phase information is often present in VCF-files. The lines below show how to access that information and transfer it to an ASEset. The ASEset follows the VCF-conventions on how to describe the phase, i.e. each patients phase will be described by the established notation of the form "1|0","1|1" or "1/0". There the left number is the description of the maternal allele and the right number is the description of the paternal allele. If it is 0 the allele is the same as the reference allele, and if it is 1 it is the alternative allele. For "|" the phase is known and for "/" the phase is not known. Note, that in the AllelicImbalance package only bi-allelic expression is allowed.

The phase can be manually added by constructing a user-generated matrix, or transforming the data into a matrix from an external source. The most convenient way of importing phase information is probably by reading it from a Vcf file, which is commonly used to store phase information. The readGT function from the `r Biocpkg("VariantAnnotation")` package will return a matrix ready to just attach to an ASEset object.

```{r echo=TRUE, eval=TRUE}
#construct an example phase matrix 
set.seed(1)
rows <-nrow(a.simple)
cols <- ncol(a.simple)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=rows*cols), nrow=rows, ncol=cols)
p2 <- matrix(sample(c(1,0),replace=TRUE, size=rows*cols), nrow=rows, ncol=cols)
phase.mat <- matrix(paste(p1,sample(c("|","|","/"), size=rows*cols, 
						replace=TRUE), p2, sep=""),	nrow=rows, ncol=cols)

phase(a.simple) <- phase.mat 
```

```{r echo=TRUE, eval=TRUE}
#load VariantAnnotation and use the phase information from a Vcf file
pathToVcf <- system.file("extdata/ERP000101_subset/ERP000101.vcf", 
							package = "AllelicImbalance")
p <- readGT(pathToVcf)
#The example Vcf file contains only 19 out of our 20 samples
#So we have to subset and order
a.subset <- a.simple[,colnames(a.simple) %in% colnames(p)]
p.subset <- p[, colnames(p) %in% colnames(a.subset)]
p.ordered <- p.subset[ , match(colnames(a.subset), colnames(p.subset))]
```

## Adding reference and alternative allele information
Having the information of reference and alternative allele is important to investigate any presence of mapping bias. It is also important to be able to use phasing information. The reference and alternative alleles are stored in the meta-columns and can be accessed and set through the mcols() function. All functions that require reference or alternative allele will visit the meta-columns "ref" or "alt" to extract that information.

```{r echo=TRUE, eval=TRUE}
#from simulated data
ref(a.simple) <- c("G","T","C")

#infer and set alternative allele
alt <- inferAltAllele(a.simple)
alt(a.simple) <- alt

#from reference genome
data(ASEset.sim)
fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
ref <- refAllele(ASEset.sim,fasta=fasta) 
ref(ASEset.sim) <- ref
```

Using reference allele information when measuring the impact of mapping bias globally, can be
 done by measuring the average reference allele fraction from a representative set of SNPs. Below the simulated example uses 1000 SNPs to assess any presence of mapping bias. Any deviations from 0.5 suggests a bias favouring one or the other allele. The most likely outcome is a value higher than 0.5 and is probably due to mapping bias, i.e., the reference allele actually has mapped more often than the alternative allele.

```{r echo=TRUE, eval=TRUE}
#make an example countList including a global sample of SNPs
set.seed(1)
countListUnknown <- list()
samples <- paste(rep("sample",10),1:10,sep="")
snps <- 1000
for(snp in 1:snps){
	count<-matrix(0, nrow=length(samples), ncol=4, 
					dimnames=list(samples, c('A','T','G','C')))
	alleles <- sample(1:4, 2)
	for(sample in 1:length(samples)){
		count[sample, alleles] <- as.integer(rnorm(2,mean=50,sd=10))
	}
	countListUnknown[[snp]] <- count
}

#make example rowRanges for the corresponding information
gr <- GRanges(
	seqnames = Rle(sample(paste("chr",1:22,sep=""),snps, replace=TRUE)),
	ranges = IRanges(1:snps, width = 1, names= paste("snp",1:snps,sep="")),
	strand="*"
)

#make ASEset
a <- ASEsetFromCountList(gr, countListUnknown=countListUnknown)

#set a random allele as reference
ref(a) <- randomRef(a)
genotype(a) <- inferGenotypes(a)

#get the fraction of the reference allele
refFrac <- fraction(a, top.fraction.criteria="ref")

#check mean
mean(refFrac)

```

The reference fraction mean ```mean(refFrac)``` is in this case very close to 0.5, and suggests that the mapbias globally is low if present. However, in this example we randomly assigned the reference genome to one of the two most expressed alleles by the randomRef function, so it should not have any mapbias.


# Tests
## Statistical analysis of an ASEset object
One of the simplest statistical test for use in allelic imbalance analysis is
the chi-square test. This test assumes that the uncertainty of ASE is represented by a normal distribution around an expected mean (i.e 0.5 for equal expression). A significant result suggests an ASE event. Every SNP, every sample, and every strand is tested independently. 

```{r echo=TRUE, eval=TRUE}
#set ref allele
ref(a.stranded) <- c("G","T","C")

#binomial test
binom.test(a.stranded[,5:8], "+")
#chi-square test
chisq.test(a.stranded[,5:8], "-")
```

# Summary functions
The regionSummary function can be used to investigate if there is a consistent imbalance in the same direction over a region (e.g. a transcript). Besides providing the user with information of how many AI:s are up or down, the function returns several descriptive statistics for the result. The list below explains the acronyms retrieved using the 'basic' accessor:   

* hets the number of heterozygote SNPs
* homs the number of homozygote SNPs
* mean.fr the mean of fractions for all hets
* sd.fr the standard deviation for the fractions for all hets
* mean.delta the mean of the delta fractions for all hets
* sd.delta the standard deviation for the delta fractions for all hets
* ai.up the number of hets significantly up-regulated in one allele.
* ai.down the number of hets significantly down-regulated in one allele.

```{r echo=TRUE, eval=TRUE, message=FALSE}
# in this example every snp is on separate exons
region <- granges(a.simple)
rs <- regionSummary(a.simple, region)
rs
basic(rs)
```

# Base graphics
## Plotting of an ASEset object
The barplot function for ASEset objects plots the read count of each allele in each sample. This is useful for getting a detailed view of individual SNPs in few samples. 

```{r echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotPlusStrandDefault", "The red bars show how many reads with the G-allele that overlaps the snp at position chr17:79478331, and the green bars show how many reads with the T allele that overlaps.")}
barplot(a.stranded[2], strand="+", xlab.text="", legend.interspace=2)
```

As can be seen in figure `r fig$ref("barplotPlusStrandDefault")` several samples from the HapMap data show a strong imbalance at the chr17:79478331 position on the plus strand. By default the p-value is calculated by a chi-square test, and when the counts for one allele are below 5 for one allele the chi-square test returns NA, which is why there is no P-value above the first bar in the figure `r fig$ref("barplotPlusStrandDefault")`. The default p-values can be substitued by other test results via the arguments testValue and testValue2. 

```{r echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotPlusStrandPsub", "Here the default chi-square p-values have been replaced by p-values from binomial tests.")}
#use another source of p-values
btp <- binom.test(a.stranded[1],"+")
barplot(a.stranded[2], strand="+", testValue=t(btp), xlab.text="",
			 legend.interspace=2)
```

In the figure `r fig$ref("barplotPlusStrandPsub")` the binomial test has been used instead of the default chi-square test. At low counts the P-value can differ, but as can be seen in the table below the difference matters less with more read counts. 

```{r echo=TRUE, eval=TRUE}
init <- c(15,20)
for(i in c(1,2,4,6)){
	bp <- signif(binom.test(init*i, p=0.5)$p.value,3)
	cp <- signif(chisq.test(init*i, p=c(0.5,0.5))$p.value, 3)
	cat(paste("A: ", init[1]*i , " B: ", init[2]*i, " binom p: ", bp, "chisq p: ", cp,"\n"))
}
```

Another type of barplot can be invoked by the argument type="fraction". This plotting mechanism is useful to illustrate more SNPs and more samples, using less space than the standard barplot with the default type="counts". 

```{r echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotFraction", "A barplot with type='fraction'. Each bar represents one sample and by default the most expressed allele over all samples is on the top, here in green. The black line denotes 1:1 expression of the alleles.")}
barplot(a.simple[2], type="fraction", cex.main = 0.7)
```

A typical question would be to ask why certain heterozygote samples have allele specific expression. The arguments sampleColour.top and sampleColour.bot allows for different highligts such as illustrated here below for gender. This could also be used to highlight based on genotype of proximal non-coding SNPs if available.

```{r echo=TRUE, eval=TRUE, fig.cap=fig$cap("barplotSampleColour", "A barplot with allele fractions, additionally colored by gender.")}
#top and bottom colour
sampleColour.top <-rep("palevioletred",ncol(a.simple))
sampleColour.top[colData(a.simple)[,"Gender"]%in%"male"] <- "darkgreen"
sampleColour.bot <- rep("blue",ncol(a.simple))
sampleColour.bot[colData(a.simple)[,"Gender"]%in%"male"] <- "seashell2"
barplot(a.simple[2], type="fraction", sampleColour.top=sampleColour.top,
	 sampleColour.bot=sampleColour.bot, cex.main = 0.7)
```

## Plot with annotation
It is often of interest to combine the RNA sequencing data with genomic annotation information from online databases. For this purpose there is a function to extract variant specific annotation such as gene, exon, transcript and CDS.

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotAnnotation", "A barplot with Gene information extracted from the org.Hs.eg.db package")}
library(org.Hs.eg.db)
barplot(a.simple[1],OrgDb=org.Hs.eg.db,
			cex.main = 0.7,
			xlab.text="",
			ypos.annotation = 0.08,
			annotation.interspace=1.3,
			legend.interspace=1.5
			)
```

##Top allele criteria
The barplot with type='fraction' can be visualized according to three different allele sorting criteria. The default behaviour is just to shown the allele with highest overall abundance in the upper half of the plot. This works well for most single SNP investigations. For more complex situations, however, it can be essential to keep track of phase information. This is done either through the reference allele sorting function, or even better, through consistently showing the maternal allele on top. When phase is know, this is essential to compare effect-directions of different coding SNPs

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotRef", "A barplot with the reference allele as top fraction, top.fraction.criteria='ref' ")}
#load data
data(ASEset)

#using reference and alternative allele information
alt(ASEset) <- inferAltAllele(ASEset)
barplot(ASEset[1], type="fraction", strand="+", xlab.text="", 
			top.fraction.criteria="ref", cex.main=0.7)
```


```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("barplotPhase", "A barplot with the maternal phase as top fraction, top.fraction.criteria='phase' ")}
#using phase information
phase(ASEset) <- phase.mat 
barplot(ASEset[1], type="fraction", strand="+", xlab.text="", 
			top.fraction.criteria="phase", cex.main=0.7)
```

## locationplot
Finally a given gene or set of proximal genes will often have several SNPs close to each other. It is of interest to investigate all of them together, in connection with annotation information. This can be done using the locationplot function. This function in its simplest form just plot all the SNPs in an ASEset distributed by genomic location. Additionally it contains methods for including gene-map information through the arguments OrgDb and TxDb.

The overview offers the possibility to view consistency of SNP fractions over consecutive exons which is important to assess the reliability of the measured SNPs. In the best case all fractions deviates with the same magnitude for every SNP in the same gene for an individual. To be able to inspect that the direction is right, it is possible to use the top.fraction.criteria and use phase information as explained earlier.

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("locationplotDefault", "A locationplot with countbars displaying a region of SNPs")}
# locationplot using count type
a.stranded.sorted <- sort(a.stranded, decreasing=FALSE)
locationplot(a.stranded.sorted, type="count", cex.main=0.7, cex.legend=0.4)
```


```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("locationplotAnnotation", "A locationplot with Gene and Transcript information extracted from the org.Hs.eg.db and TxDb.Hsapiens.UCSC.hg19.knownGene packages")}
# locationplot annotation
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
locationplot(a.stranded.sorted, OrgDb=org.Hs.eg.db, 
				TxDb=TxDb.Hsapiens.UCSC.hg19.knownGene)
```

# Grid graphics
To make use of the extra graphical flexibility that comes with grid graphics, the AllelicImbalance package now has functions that can be integrated in the grid environment. The low level grid functions are located in the `r CRANpkg("grid package")`, but higher level functions based on grid can be found in popular packages such as e.g. `r CRANpkg("lattice")`, `r CRANpkg("ggplot2")`. The benefits using grid graphics is a better control over different graphical regions and coordinate systems, how to construct and redirect graphical output, such as lines, points, etc and their appearance.    

One particular reason for the AllelicImbalance to use grid graphics is the `r Biocpkg("Gviz")` package, which uses grids functionality to construct tracks to visualize genomic regions in a smart way. The  AllelicImbalance package has grid based barplots and functionality to create Gviz tracks.  Observe the extra "g" prefix for the bar- and locationplot versions using the grid, see examples below.  

## gbarplot
The standard barplot functions for ASEset objects have at the moment much more parameters that can be set by the user than the gbarplot. Base graphics also produce graphs faster than the grid environment. The advantage of the gbarplot is instead the possiblity to integrate into the Gviz package and other grid based environments.

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("gbarplotcount", "A gbarplot with type='count'")}
#gbarplots with type "count" 
gbarplot(ASEset, type="count")
```


```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("gbarplotfraction", "A gbarplot with type='fraction'")}
# gbarplots with type "fraction" 
gbarplot(ASEset, type="fraction")
```

## glocationplot
The glocationplot is a wrapper to quickly get an overview of ASE in a region, similar to locationplot(), but built with the grid graphics track system from the Gviz package. 

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("glocationplot", "A glocationplot, showing the ASE of SNPs within a defined region")}
#remember to set the genome
genome(ASEset) <- "hg19"

glocationplot(ASEset, strand='+')

```

## Custom location plots
More flexibility and functionality from the Gviz package is accessed if the tracks are constructed separately. This is useful to evalute AI in respect to for example read coverage or transcript annotation. An inconsistency of AI could potentially be explained by an uneven coverage over the exons, or lack of coverage. Below is an example using two samples from the ASEset and the corresponding reads. Ensuring and setting the seqlevels equal is a security  measure, for the internal overlap calculations that otherwise might throw a warning. The GR object is defining the region that we want to plot. The ASEDAnnotationTrack will create a track based on the gbarplots and the CoverageDataTrack a track based on read coverage. The different tracks are then collected in a list with the first element appearing at the top in the final plotting by the plotTracks function. The sizes vector defines the vertical space assigned to each track. To use transcript annotation, more detailed information can be found in the Gviz [vignette](http://bioconductor.org/packages/release/bioc/vignettes/Gviz/inst/doc/Gviz.pdf)

```{r echo=TRUE, eval=TRUE, message=FALSE, fig.cap=fig$cap("glocationplot", "A custom built Gviz plot using the ASEDAnnotationTrack, showing the ASE of SNPs within a defined region together with read coverage information")}

#load Gviz package
library(Gviz)

#subset ASEset and reads
x <- ASEset[,1:2]
r <- reads[1:2]
seqlevels(r, pruning.mode="coarse") <- seqlevels(x)

GR <- GRanges(seqnames=seqlevels(x),
 		ranges=IRanges(start=min(start(x)), end=max(end(x))),
 		strand='+', genome=genome(x))

deTrack <- ASEDAnnotationTrack(x, GR=GR, type='fraction', strand='+')
covTracks <- CoverageDataTrack(x, BamList=r, strand='+') 
lst <- c(deTrack,covTracks)
sizes <- c(0.5,rep(0.5/length(covTracks),length(covTracks)))

plotTracks(lst, from=min(start(x)), to=max(end(x)), sizes=sizes, 
				col.line = NULL, showId = FALSE, main = 'main', cex.main = 1, 
				title.width = 1, type = 'histogram')
```
# Important notifications

## Update old objects
Due to changes in the RangedSummarizedExperiment class from the `r Biocpkg("SummarizedExperiment")` package, all RangedSummarizedExperiment objects prior the release of Bioconductor 3.2 needs to be updated. The ASEset is based on the RangedSummarizedExperiment class and solely needs to be updated as well.


```{r echo = TRUE, eval = TRUE, message = FALSE}
data(ASEset.old)
#this command doesnt work anymore, for some reason(Will ask the mail-list)
#ASEset.new <- updateObject(ASEset.old)
```

# Conclusion
In conclusion we hope that you will find this package useful in the investigation of the genetics of RNA-seq experiments. The various import functions should assist in the task of actually retrieving allele counts for specific nucleotide positions from all RNA-seq reads, including the non-trivial cases of intron-spanning reads. Likewise, the statistical analysis and plotting functions should be helpful in discovering any allele specific expression patterns that might be found in your data.

# Links

Bowtie
[link](http://bowtie-bio.sourceforge.net)

BWA
[link](http://bio-bwa.sourceforge.net/)

Samtools
[link](http://samtools.sourceforge.net/)

Samtools pileup
[link](http://samtools.sourceforge.net/mpileup.shtml)

Grid graphics
[link](https://www.stat.auckland.ac.nz/~paul/grid/grid.html)



# Session Info
```{r echo=TRUE, eval=TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inference-methods.R
\docType{methods}
\name{inferAltAllele}
\alias{inferAltAllele}
\alias{inferAltAllele,ASEset-method}
\title{inferAltAllele}
\arguments{
\item{x}{\code{matrix} see examples}

\item{return.class}{class of returned object}

\item{allele.source}{'arank'}

\item{verbose}{make function more talkative}

\item{...}{arguments to forward to internal functions}
}
\description{
inference of the alternate allele based on count data
}
\details{
The inference essentially ranks all alleles and the most expressed allele not 
declared as reference will be inferred as the alternative allele. At the moment only inference of 
bi-allelic alternative alleles are available.
}
\examples{


#load data
data(ASEset)

alt <- inferAltAllele(ASEset)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter-methods.R
\docType{methods}
\name{multiAllelicFilt}
\alias{multiAllelicFilt}
\alias{multiAllelicFilt,ASEset-method}
\title{multi-allelic filter methods}
\usage{
multiAllelicFilt(x, ...)

\S4method{multiAllelicFilt}{ASEset}(
  x,
  strand = "*",
  threshold.count.sample = 10,
  threshold.frequency = 0.1,
  filterOver = "eachSample"
)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{...}{internal param}

\item{strand}{strand to infer from}

\item{threshold.count.sample}{least amount of counts to try to infer allele}

\item{threshold.frequency}{least fraction to classify (see details)}

\item{filterOver}{'eachSample' or 'allSamples'}
}
\description{
filter on multiallelic snps
}
\details{
based on the allele counts for all four variants A, T, G and C and returns true 
if there is counts enough suggesting a third or more alleles. The sensitivity can 
be specified using 'threshold.count.sample' and 'threshold.frequency'.
}
\examples{

#load example data
data(ASEset)
a <- ASEset

multiAllelicFilt(a)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{filter}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapbias-methods.R
\docType{methods}
\name{defaultMapBias}
\alias{defaultMapBias}
\alias{defaultMapBias,ASEset-method}
\title{Generate default mapbias from genotype}
\usage{
defaultMapBias(x, ...)

\S4method{defaultMapBias}{ASEset}(x, return.class = "array")
}
\arguments{
\item{x}{\code{ASEset} object}

\item{...}{internal arguments}

\item{return.class}{"array" or "ASEset"}
}
\description{
Create mapbias array from genotype matrix requires genotype information
}
\details{
Default mapbias will be 0.5 for bi-allelic snps and 1 for
homozygots. For genotypes with NA, 0.5 will be placed on all four alleles.
Therefore tri-allelic can not be used atm. Genotype information has to be 
placed in the genotype(x) assay.
}
\examples{

#load example data
data(ASEset.sim)

fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
refAllele(ASEset.sim,fasta=fasta)
a <- refAllele(ASEset.sim,fasta=fasta) 

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{mapbias}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{data}
\name{reads}
\alias{reads}
\title{reads object}
\description{
This data set corresponds to the BAM-file data import illustrated in the
vignette. The data set consists of a chromosome 17 region from 20 RNA-seq
experiments of HapMap samples.
}
\examples{

##load eample data (Not Run)  
#data(reads)

}
\references{
Montgomery SB et al. Transcriptome genetics using second
generation sequencing in a Caucasian population. Nature. 2010 Apr
1;464(7289):773-7.
}
\seealso{
\itemize{ \item The \code{\link{GRvariants}} which is another
example object }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{data}
\keyword{example}
\keyword{object}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{getAreaFromGeneNames}
\alias{getAreaFromGeneNames}
\alias{getAreaFromGeneNames,character-method}
\title{Get Gene Area}
\usage{
getAreaFromGeneNames(genesymbols, ...)

\S4method{getAreaFromGeneNames}{character}(
  genesymbols,
  OrgDb,
  leftFlank = 0,
  rightFlank = 0,
  na.rm = FALSE,
  verbose = TRUE
)
}
\arguments{
\item{genesymbols}{A character vector that contains genesymbols of genes
from which we wish to retrieve the coordinates}

\item{...}{arguments to pass on}

\item{OrgDb}{An \code{OrgDb} object containing gene annotation}

\item{leftFlank}{A \code{integer} specifying number of additional
nucleotides before the genes}

\item{rightFlank}{A \code{integer} specifying number of additional
nucleotides after the genes}

\item{na.rm}{A \code{boolean} removing genes that returned NA from the
annotation}

\item{verbose}{Setting \code{verbose=TRUE} makes function more talkative}
}
\value{
\code{getAreaFromGeneNames} returns a GRanges object with genomic
coordinates around the specified genes
}
\description{
Given a character vector with genesymbols and an OrgDb object, this function
returns a GRanges giving the coordinates of the genes.
}
\details{
This function is a convenience function that can be used to determine which
genomic coordinates to specify to e.g. \code{impBamGAL} when retrieving
reads.

The function cannot handle genes that do not exist in the annotation. To
remove these please set the na.rm=TRUE.
}
\examples{

#load example data
data(ASEset)

#get counts at the three positions specified in GRvariants
library(org.Hs.eg.db )
searchArea<-getAreaFromGeneNames(c('PAX8','TLR7'), org.Hs.eg.db)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{genes}
\keyword{locations}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/summary-methods.R
\docType{methods}
\name{regionSummary}
\alias{regionSummary}
\alias{regionSummary,numeric-method}
\alias{regionSummary,ASEset-method}
\title{regionSummary}
\usage{
regionSummary(x, ...)

\S4method{regionSummary}{ASEset}(x, region, strand = "*", return.class = "RegionSummary", ...)
}
\arguments{
\item{x}{ASEset object}

\item{...}{arguments to forward to internal functions}

\item{region}{to summmarize over, the object can be a GRanges, GRangesList}

\item{strand}{can be "+", "-" or "*"}

\item{return.class}{"array" or "list".}
}
\description{
Gives a summary of AI-consistency for a transcript
}
\details{
From a given set of e.g. transcripts exon ranges the function will return
a summary for the sum of all exons. Phase information, reference and alternative
allele is required.

A limitation comes to the strand-specificness. At the moment it is not possible
to call over more than one strand type using the strands in region. This will be
improved before going to release.

to calculate the direction and binomial p-values of AI the mapbias stored in the
ASEset is used. see '?mapBias'.
}
\examples{

data(ASEset)
a <- ASEset
# Add phase
set.seed(1)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

phase(a) <- p

#add alternative allele information
mcols(a)[["alt"]] <- inferAltAllele(a)

# in this example each and all snps in the ASEset defines the region
region <- granges(a)
t <- regionSummary(a, region)

# in this example two overlapping subsets of snps in the ASEset defines the region
region <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))
t <- regionSummary(a, region)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{summary}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{data}
\name{ASEset.sim}
\alias{ASEset.sim}
\title{ASEset.sim object}
\description{
ASEset with simulated data with SNPs within the first 200bp of chromosome 17,
which is required to have example data for the refAllele function.
}
\examples{

##load eample data (Not Run)  
#data(ASEset.sim)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{data}
\keyword{example}
\keyword{object}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barplot-methods.R
\docType{methods}
\name{ASEset-gbarplot}
\alias{ASEset-gbarplot}
\alias{gbarplot}
\alias{gbarplot,ASEset-method}
\title{gbarplot ASEset objects}
\usage{
gbarplot(x, type = "count", strand = "*", verbose = FALSE, ...)
}
\arguments{
\item{x}{An \code{ASEset} object}

\item{type}{'count' or 'fraction'}

\item{strand}{four options, '+', '-', 'both' or '*'}

\item{verbose}{Makes function more talkative}

\item{...}{for simpler generics when extending function}
}
\description{
Generates gbarplots for ASEset objects. Two levels of plotting detail are
provided: a detailed gbarplot of read counts by allele useful for fewer
samples and SNPs, and a less detailed gbarplot of the fraction of imbalance,
useful for more samples and SNPs.
}
\details{
This function serves the same purpose as the normal barplot, but with
trellis graphics using lattice, to be able to integrate well with Gviz track
functionality.
}
\examples{

data(ASEset)
gbarplot(ASEset[1])

}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the gbarplot
function can be called up on.  \item The \code{\link{barplot}} non trellis
barplot.  }
}
\author{
Jesper R. Gadin
}
\keyword{gbarplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{makeMaskedFasta}
\alias{makeMaskedFasta}
\alias{makeMaskedFasta,character-method}
\title{makes masked fasta reference}
\usage{
makeMaskedFasta(fastaIn, ...)

\S4method{makeMaskedFasta}{character}(
  fastaIn,
  fastaOut,
  posToReplace,
  splitOnSeqlevels = TRUE,
  verbose = TRUE
)
}
\arguments{
\item{fastaIn}{character string of the path for the fasta file to be used}

\item{...}{arguments to pass on}

\item{fastaOut}{character string of the path for the masked fasta file (no extension)}

\item{posToReplace}{GRanges object with the genomic ranges to replace}

\item{splitOnSeqlevels}{write on file for each seqlevel to save memory}

\item{verbose}{makes function more talkative}
}
\description{
Replaces all selected positions in a fasta file with the character N
}
\examples{

data(ASEset.sim)
gr <- rowRanges(ASEset.sim)
fastaIn <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
makeMaskedFasta(fastaIn=fastaIn, fastaOut="fastaOut",posToReplace=gr)


}
\author{
Jesper R. Gadin
}
\keyword{fasta}
\keyword{masked}
\keyword{reference}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{getSnpIdFromLocation}
\alias{getSnpIdFromLocation}
\alias{getSnpIdFromLocation,GRanges-method}
\title{Get rsIDs from locations of SNP}
\usage{
getSnpIdFromLocation(GR, ...)

\S4method{getSnpIdFromLocation}{GRanges}(GR, SNPloc, return.vector = FALSE, verbose = TRUE)
}
\arguments{
\item{GR}{A \code{GRanges} that contains positions of SNPs to look up}

\item{...}{arguments to pass on}

\item{SNPloc}{A \code{SNPlocs object} containing information on SNP
locations (e.g. SNPlocs.Hsapiens.dbSNP.xxxxxxxx)}

\item{return.vector}{Setting \code{return.vector=TRUE} returns vector with
rsIds}

\item{verbose}{Setting \code{verbose=TRUE} makes function more talkative}
}
\value{
\code{getSnpIdFromLocation} returns the same GRanges object it was
given with, but with updated with rs.id information.
}
\description{
Given a GRanges object of SNPs and a SNPlocs annotation, this function
attempts to replace the names of the GRanges object entries with rs-IDs.
}
\details{
This function is used to try to identify the rs-IDs of SNPs in a GRanges
object.
}
\examples{

is_32bit_windows <- .Platform$OS.type == "windows" &&
                  .Platform$r_arch == "i386"
if (!is_32bit_windows && require(SNPlocs.Hsapiens.dbSNP144.GRCh37)) {
	#load example data
	data(ASEset)

  #get counts at the three positions specified in GRvariants
  updatedGRanges <- getSnpIdFromLocation(rowRanges(ASEset),
    SNPlocs.Hsapiens.dbSNP144.GRCh37)
}


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{SNP}
\keyword{rs-id}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GlobalAnalysis-class.R
\docType{class}
\name{GlobalAnalysis-class}
\alias{GlobalAnalysis-class}
\alias{GlobalAnalysis}
\alias{GlobalAnalysis-method}
\title{GlobalAnalysis class}
\arguments{
\item{x}{ASEset object or list of ASEsets}

\item{TxDb}{A \code{transcriptDb} object}

\item{...}{pass arguments to internal functions}
}
\value{
An object of class GlobalAnalysis containing all data to make report.
}
\description{
Object that holds results from a global AI analysis including reference bias
estimations and AI detection.
}
\details{
The GlobalAnalysis-class contains summaries and "pre-configured and pre-calculated lattice plots" needed to create an AI-report
}
\examples{

data(ASEset)
#a <- ASEset
#gba <- gba(a)

#report(gba)
#write.tables(gba)
#graphs(gba)
#as.list(gba)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{ASEset}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapbias-methods.R
\docType{methods}
\name{refAllele}
\alias{refAllele}
\alias{refAllele,ASEset-method}
\title{Reference allele}
\usage{
refAllele(x, fasta)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{fasta}{path to fasta file, index should be located in the same folder}
}
\description{
Extract the allele based on SNP location from the reference fasta file
}
\details{
The alleles will be placed in the rowRanges() meta column 'ref'
}
\examples{

#load example data
data(ASEset.sim)

fasta <- system.file('extdata/hg19.chr17.subset.fa', package='AllelicImbalance')
a <- refAllele(ASEset.sim,fasta=fasta) 

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{mapbias}
\keyword{reference}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{phaseMatrix2Array}
\alias{phaseMatrix2Array}
\alias{phaseMatrix2Array,matrix-method}
\title{phaseMatrix2Array}
\usage{
phaseMatrix2Array(x, ...)

\S4method{phaseMatrix2Array}{matrix}(x, dimnames = NULL, ...)
}
\arguments{
\item{x}{matrix see examples}

\item{...}{arguments to forward to internal functions}

\item{dimnames}{list with dimnames}
}
\description{
used to convert the phase from the visually friendly matrix to array.
}
\details{
A more effectice way of store the phase data in the ASEset object
}
\examples{

#load data
data(ASEset)
a <- ASEset

#example phase matrix
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

ar <- phaseMatrix2Array(p)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/DetectedAI-class.R
\docType{class}
\name{DetectedAI-class}
\alias{DetectedAI-class}
\alias{DetectedAI}
\alias{DetectedAI-method}
\alias{referenceFrequency}
\alias{referenceFrequency,DetectedAI-method}
\alias{thresholdFrequency}
\alias{thresholdFrequency,DetectedAI-method}
\alias{thresholdCountSample}
\alias{thresholdCountSample,DetectedAI-method}
\alias{thresholdDeltaFrequency}
\alias{thresholdDeltaFrequency,DetectedAI-method}
\alias{thresholdPvalue}
\alias{thresholdPvalue,DetectedAI-method}
\title{DetectedAI class}
\usage{
referenceFrequency(x, ...)

\S4method{referenceFrequency}{DetectedAI}(x, return.class = "array")

thresholdFrequency(x, ...)

\S4method{thresholdFrequency}{DetectedAI}(x, return.class = "array")

thresholdCountSample(x, ...)

\S4method{thresholdCountSample}{DetectedAI}(x, return.class = "array")

thresholdDeltaFrequency(x, ...)

\S4method{thresholdDeltaFrequency}{DetectedAI}(x, return.class = "array")

thresholdPvalue(x, ...)

\S4method{thresholdPvalue}{DetectedAI}(x, return.class = "array")
}
\arguments{
\item{x}{ASEset object or list of ASEsets}

\item{...}{pass arguments to internal functions}

\item{return.class}{type of class returned eg. "list or ""array".}
}
\description{
Object that holds results from AI detection.
}
\details{
The DetectedAI-class contains
}
\examples{

data(ASEset)
a <- ASEset
dai <- detectAI(a)

#summary(gba)
#write.tables(dai)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{ASEset}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RiskVariant-class.R
\docType{class}
\name{RiskVariant-class}
\alias{RiskVariant-class}
\alias{RiskVariant}
\alias{RiskVariant-method}
\alias{ref,RiskVariant-method}
\alias{ref<-,RiskVariant,ANY-method}
\alias{alt,RiskVariant-method}
\alias{alt<-,RiskVariant,ANY-method}
\alias{phase,RiskVariant-method}
\alias{phase<-,RiskVariant-method}
\title{RiskVariant class}
\usage{
\S4method{ref}{RiskVariant}(x)

\S4method{ref}{RiskVariant,ANY}(x) <- value

\S4method{alt}{RiskVariant}(x)

\S4method{alt}{RiskVariant,ANY}(x) <- value

\S4method{phase}{RiskVariant}(x, return.class = "matrix")

\S4method{phase}{RiskVariant}(x) <- value
}
\arguments{
\item{x}{RiskVariant object or list of RiskVariants}

\item{value}{argument used for replacement}

\item{return.class}{type of class returned eg. "list or ""array".}
}
\description{
Object that holds results from AI detection.
}
\details{
The RiskVariant-class contains
}
\examples{

#some code

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{RiskVariant}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{data}
\name{GRvariants}
\alias{GRvariants}
\title{GRvariants object}
\description{
this data is a \code{GRanges} object that contains the ranges for three
example SNPs.
}
\examples{

#load example data
data(GRvariants)


}
\seealso{
\itemize{ \item The \code{\link{reads}} which is another example
object }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{data}
\keyword{example}
\keyword{object}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{getAlleleQuality}
\alias{getAlleleQuality}
\alias{getAlleleQuality,GAlignmentsList-method}
\title{snp quality data}
\usage{
getAlleleQuality(BamList, ...)

\S4method{getAlleleQuality}{GAlignmentsList}(
  BamList,
  GRvariants,
  fastq.format = "illumina.1.8",
  return.class = "array",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{BamList}{A \code{GAlignmentsList object} or \code{GRangesList object}
containing data imported from a bam file}

\item{...}{parameters to pass on}

\item{GRvariants}{A \code{GRanges object} that contains positions of SNPs to
retrieve.}

\item{fastq.format}{default 'illumina.1.8'}

\item{return.class}{'list' or 'array'}

\item{verbose}{Setting \code{verbose=TRUE} makes function more talkative}
}
\value{
\code{getAlleleQuality} returns a list of several data.frame objects,
each storing the count data for one SNP.
}
\description{
Given the positions of known SNPs, this function returns allele quality from
a BamGRL object
}
\details{
This function is used to retrieve the allele quality strings from specified positions
in a set of RNA-seq reads. The \code{BamList} argument will typically have
been created using the \code{impBamGAL} function on bam-files. The
\code{GRvariants} is either a GRanges with user-specified locations or else
it is generated through scanning the same bam-files as in \code{BamList} for
heterozygote locations (e.g. using \code{scanForHeterozygotes}). The
GRvariants will currently only accept locations having width=1,
corresponding to bi-allelic SNPs. The strand type information will be kept in the
returned object. If the strand is marked as unknown "*", it will be forced to the "+"
strand.

quaity information is extracted from the BamList object, and requires the presence of
mcols(BamList)[["qual"]] to contain quality sequences.
}
\examples{

#load example data
data(reads)
data(GRvariants)

#get counts at the three positions specified in GRvariants
alleleQualityArray <- getAlleleQuality(BamList=reads,GRvariants)

#place in ASEset object
alleleCountsArray <- getAlleleCounts(BamList=reads,GRvariants,
                     strand='*', return.class="array")

	a <- ASEsetFromArrays(GRvariants, countsUnknown = alleleCountsArray)
	aquals(a) <- alleleQualityArray
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{allele}
\keyword{quality}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-functions-visuals.R
\name{legendBarplot}
\alias{legendBarplot}
\title{add legend to AllelicImbalance barplot}
\usage{
legendBarplot(
  lowerLeftCorner,
  size,
  rownames,
  colnames,
  boxsize = 1,
  boxspace = 1,
  fgCol,
  bgCol,
  ylegendPos = 1,
  xlegendPos = 0.96,
  cex = 1
)
}
\arguments{
\item{lowerLeftCorner}{position of the plot to add legend to (default c(0,0))}

\item{size}{scale the plot, default is 1}

\item{rownames}{rownames in legend}

\item{colnames}{colnames in legend}

\item{boxsize}{size of each box fill}

\item{boxspace}{space inbetween the box fill}

\item{fgCol}{color for allele1}

\item{bgCol}{color for allele2}

\item{ylegendPos}{placement of the legend within the plot for y}

\item{xlegendPos}{placement of the legend within the plot for x}

\item{cex}{size of legend text}
}
\description{
adds a very customizable legend function for AllelicImbalance barplots.
}
\details{
the function is preferably called from within the AllelicImbalance barplot method.
}
\examples{

#code placeholders
#< create a barplot with legend >
#< add legend >
 
}
\author{
Jesper R. Gadin
}
\keyword{barplot}
\keyword{legend}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/binom.test-methods.R
\docType{methods}
\name{binom.test}
\alias{binom.test}
\alias{binom.test,ASEset-method}
\title{binomial test}
\usage{
\S4method{binom.test}{ASEset}(x, n = "*")
}
\arguments{
\item{x}{\code{ASEset} object}

\item{n}{strand option}
}
\value{
\code{binom.test} returns a matrix
}
\description{
Performs a binomial test on an ASEset object.
}
\details{
the test can only be applied to one strand at the time.
}
\examples{

#load example data
data(ASEset)

#make a binomial test
binom.test(ASEset,'*')


}
\seealso{
\itemize{ \item The \code{\link{chisq.test}} which is another test
that can be applied on an \link{ASEset} object.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{binomial}
\keyword{test}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialize-methods.R
\name{initialize-GlobalAnalysis}
\alias{initialize-GlobalAnalysis}
\alias{GAnalysis}
\title{Initialize GlobalAnalysis}
\usage{
GAnalysis(x = "ASEset", ...)
}
\arguments{
\item{x}{\code{ASEset}}

\item{...}{internal arguments}
}
\description{
Functions to construct GlobalAnalysis objects
}
\details{
produces a class container for a global analysis
}
\examples{

data(ASEset)
a <- ASEset
# gba <- gba(a)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{global}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-functions-annotation.R
\name{annotation-wrappers}
\alias{annotation-wrappers}
\alias{getGenesFromAnnotation}
\alias{getGenesVector}
\alias{getExonsFromAnnotation}
\alias{getTranscriptsFromAnnotation}
\alias{getCDSFromAnnotation}
\alias{getExonsVector}
\alias{getTranscriptsVector}
\alias{getCDSVector}
\alias{getAnnotationDataFrame}
\title{AnnotationDb wrappers}
\usage{
getGenesFromAnnotation(
  OrgDb,
  GR,
  leftFlank = 0,
  rightFlank = 0,
  getUCSC = FALSE,
  verbose = FALSE
)

getGenesVector(OrgDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE)

getExonsFromAnnotation(
  TxDb,
  GR,
  leftFlank = 0,
  rightFlank = 0,
  verbose = FALSE
)

getExonsVector(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE)

getTranscriptsFromAnnotation(
  TxDb,
  GR,
  leftFlank = 0,
  rightFlank = 0,
  verbose = FALSE
)

getTranscriptsVector(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE)

getCDSFromAnnotation(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE)

getCDSVector(TxDb, GR, leftFlank = 0, rightFlank = 0, verbose = FALSE)

getAnnotationDataFrame(
  GR,
  strand = "+",
  annotationType = NULL,
  OrgDb = NULL,
  TxDb = NULL,
  verbose = FALSE
)
}
\arguments{
\item{OrgDb}{An \code{OrgDb} object}

\item{GR}{A \code{GenomicRanges} object with sample area}

\item{leftFlank}{An \code{integer} specifying number of additional
nucleotides around the SNPs for the leftFlank}

\item{rightFlank}{An \code{integer} specifying number of additional
nucleotides around the SNPs for the rightFlank}

\item{getUCSC}{A \code{logical} indicating if UCSC transcript IDs should
also be retrieved}

\item{verbose}{A \code{logical} making the functions more talkative}

\item{TxDb}{A \code{transcriptDb} object}

\item{strand}{Two options,'+' or '-'}

\item{annotationType}{select one or more from 'gene', 'exon', 'transcript',
'cds'.}
}
\value{
%OrgDb The \code{getGenesFromAnnotation} function will return a
\code{GRanges object} with ranges over the genes in the region.

The \code{getGenesVector} function will return a character vector where each
element are gene symbols separated by comma

%transcriptDb The \code{getExonsFromAnnotation} function will return a
\code{GRanges object} with ranges over the exons in the region.

The \code{getTranscriptsFromAnnotation} function will return a \code{GRanges
object} with ranges over the transcripts in the region.

The \code{getCDSFromAnnotation} function will return a \code{GRanges object}
with ranges over the CDSFs in the region.

The \code{getExonsVector} function will return a character vector where each
element are exons separated by comma

The \code{getTranscriptsVector} function will return a character vector
where each element are transcripts separated by comma

The \code{getCDSVector} function will return a character vector where each
element are CDSs separated by comma

The \code{getAnnotationDataFrame} function will return a data.frame with
annotations. This function is used internally by i.e. the barplot-function
}
\description{
These functions acts as wrappers to retrieve information from annotation
database objects (\code{annotationDb objects}) or (\code{transcriptDb
objects})
}
\details{
These functions retrieve regional annotation from OrgDb or TxDb objects,
when given GRanges objects.
}
\examples{


  data(ASEset)
  require(org.Hs.eg.db)
  require(TxDb.Hsapiens.UCSC.hg19.knownGene)
  OrgDb <- org.Hs.eg.db
  TxDb <- TxDb.Hsapiens.UCSC.hg19.knownGene

  #use for example BcfFiles as the source for SNPs of interest
  GR <- rowRanges(ASEset)
  #get annotation
  g <- getGenesFromAnnotation(OrgDb,GR)
  e <- getExonsFromAnnotation(TxDb,GR)
  t <- getTranscriptsFromAnnotation(TxDb,GR)
  c <- getCDSFromAnnotation(TxDb,GR)
  
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{CDS}
\keyword{annotation}
\keyword{exons}
\keyword{genes}
\keyword{transcripts}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-functions-visuals.R
\name{annotationBarplot}
\alias{annotationBarplot}
\title{add annotation to AllelicImbalance barplot}
\usage{
annotationBarplot(
  strand,
  snp,
  lowerLeftCorner,
  annDfPlus,
  annDfMinus,
  cex = 0.7,
  ypos = 0,
  interspace = 1
)
}
\arguments{
\item{strand}{strand, "+", "-", "*" or "both"}

\item{snp}{integer for the described snp}

\item{lowerLeftCorner}{position of the plot to add legend to (default c(0,0))}

\item{annDfPlus}{annotation dataframe plus strand}

\item{annDfMinus}{annotation dataframe minus strand}

\item{cex}{size of annotation text}

\item{ypos}{relative y-axis position for the annotation text}

\item{interspace}{space between each annotation block}
}
\description{
adds a customizable annotation functionality for AllelicImbalance barplots.
}
\details{
the function is preferably called from within the AllelicImbalance barplot method.
}
\examples{

#code placeholders
#< create a barplot without annotation >
#< add annotation >
 
}
\author{
Jesper R. Gadin
}
\keyword{annotation}
\keyword{barplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RegionSummary-class.R
\docType{class}
\name{RegionSummary-class}
\alias{RegionSummary-class}
\alias{RegionSummary}
\alias{RegionSummary-method}
\alias{sumnames}
\alias{sumnames,RegionSummary-method}
\alias{basic}
\alias{basic,RegionSummary-method}
\title{RegionSummary class}
\usage{
sumnames(x, ...)

\S4method{sumnames}{RegionSummary}(x)

basic(x, ...)

\S4method{basic}{RegionSummary}(x)
}
\arguments{
\item{x}{RegionSummary object}

\item{...}{pass arguments to internal functions}
}
\description{
Object that holds results from the regionSummary method
}
\details{
The RegionSummary-class objects contains summaries for specified regions
}
\examples{

#some code

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{RegionSummary}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-methods.R
\name{DetectedAI-plot}
\alias{DetectedAI-plot}
\alias{frequency_vs_threshold_variable_plot}
\alias{frequency_vs_threshold_variable_plot,DetectedAI-class}
\alias{frequency_vs_threshold_variable_plot,DetectedAI-method}
\alias{detectedAI_vs_threshold_variable_plot}
\alias{detectedAI_vs_threshold_variable_plot,DetectedAI-method}
\alias{reference_frequency_density_vs_threshold_variable_plot}
\alias{reference_frequency_density_vs_threshold_variable_plot,DetectedAI-method}
\alias{detectedAI_vs_threshold_variable_multigraph_plot}
\alias{detectedAI_vs_threshold_variable_multigraph_plot,DetectedAI-method}
\alias{frequency_vs_threshold_variable_multigraph_plot}
\alias{frequency_vs_threshold_variable_multigraph_plot,DetectedAI-method}
\alias{reference_frequency_density_vs_threshold_variable_multigraph_plot}
\alias{reference_frequency_density_vs_threshold_variable_multigraph_plot,DetectedAI-method}
\title{DetectedAI plot}
\usage{
frequency_vs_threshold_variable_plot(x, ...)

\S4method{frequency_vs_threshold_variable_plot}{DetectedAI}(
  x,
  var = "threshold.count.sample",
  hetOverlay = TRUE,
  smoothscatter = FALSE
)

detectedAI_vs_threshold_variable_plot(x, ...)

\S4method{detectedAI_vs_threshold_variable_plot}{DetectedAI}(
  x,
  var = "threshold.count.sample",
  summaryOverSamples = "sum",
  hetOverlay = TRUE,
  smoothscatter = FALSE
)

reference_frequency_density_vs_threshold_variable_plot(x, ...)

\S4method{reference_frequency_density_vs_threshold_variable_plot}{DetectedAI}(
  x,
  var = "threshold.count.sample"
)

detectedAI_vs_threshold_variable_multigraph_plot(x, ...)

\S4method{detectedAI_vs_threshold_variable_multigraph_plot}{DetectedAI}(x, ncol = 2, ...)

frequency_vs_threshold_variable_multigraph_plot(x, ...)

\S4method{frequency_vs_threshold_variable_multigraph_plot}{DetectedAI}(x, ncol = 2, ...)

reference_frequency_density_vs_threshold_variable_multigraph_plot(x, ...)

\S4method{reference_frequency_density_vs_threshold_variable_multigraph_plot}{DetectedAI}(
  x,
  ncol = 2,
  ...
)
}
\arguments{
\item{x}{detectedAI object}

\item{...}{pass on variables internally}

\item{var}{string, see details for available options}

\item{hetOverlay}{logical, if TRUE show nr of het SNPs used to calculate the reference allele frequency mean}

\item{smoothscatter}{boolean, smoothscatter over the means}

\item{summaryOverSamples}{'mean' or 'sum'}

\item{ncol}{nr of columns for multiplots}
}
\description{
plot functions for the DetectedAI-class
}
\details{
plot helper functions. The documentation will
be improved before next release.
}
\examples{

#some example code here
#generate example
data(ASEset)
a <- ASEset
dai <- detectAI(a, 
			threshold.count.sample=1:50,
			threshold.frequency=seq(0,0.5,by=0.01),
			threshold.delta.frequency=seq(0,0.5,by=0.01),
			threshold.pvalue=rev(seq(0.001,0.05, by=0.005))
)

frequency_vs_threshold_variable_plot(dai)
detectedAI_vs_threshold_variable_plot(dai)
detectedAI_vs_threshold_variable_multigraph_plot(dai)
frequency_vs_threshold_variable_multigraph_plot(dai)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{list}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ASEset-class.R
\docType{class}
\name{ASEset-class}
\alias{ASEset-class}
\alias{ASEset}
\alias{alleleCounts}
\alias{mapBias}
\alias{fraction}
\alias{arank}
\alias{frequency}
\alias{genotype}
\alias{genotype<-}
\alias{phase}
\alias{phase<-}
\alias{alleleCounts,ASEset-method}
\alias{mapBias,ASEset-method}
\alias{fraction,ASEset-method}
\alias{arank,ASEset-method}
\alias{frequency,ASEset-method}
\alias{genotype,ASEset-method}
\alias{genotype<-,ASEset-method}
\alias{alleleCounts<-}
\alias{alleleCounts<-,ASEset-method}
\alias{phase,ASEset-method}
\alias{phase<-,ASEset-method}
\alias{countsPerSnp}
\alias{countsPerSnp,ASEset-method}
\alias{countsPerSample}
\alias{countsPerSample,ASEset-method}
\alias{mapBias<-}
\alias{mapBias<-,ASEset-method}
\alias{refExist}
\alias{refExist,ASEset-method}
\alias{ref}
\alias{ref,ASEset-method}
\alias{ref<-}
\alias{ref<-,ASEset,ANY-method}
\alias{altExist}
\alias{altExist,ASEset-method}
\alias{alt}
\alias{alt,ASEset-method}
\alias{alt<-}
\alias{alt<-,ASEset,ANY-method}
\alias{aquals}
\alias{aquals,ASEset-method}
\alias{aquals<-}
\alias{aquals<-,ASEset-method}
\alias{maternalAllele}
\alias{maternalAllele,ASEset-method}
\alias{paternalAllele}
\alias{paternalAllele,ASEset-method}
\title{ASEset objects}
\usage{
alleleCounts(x, strand = "*", return.class = "list")

\S4method{alleleCounts}{ASEset}(x, strand = "*", return.class = "list")

alleleCounts(x, ...) <- value

\S4method{alleleCounts}{ASEset}(x, strand = "*", return.class = "array", ...) <- value

mapBias(x, ...)

\S4method{mapBias}{ASEset}(x, return.class = "list")

fraction(x, ...)

\S4method{fraction}{ASEset}(
  x,
  strand = "*",
  top.fraction.criteria = "maxcount",
  verbose = FALSE,
  ...
)

arank(x, return.type = "names", return.class = "list", strand = "*", ...)

frequency(x, ...)

genotype(x, ...)

\S4method{genotype}{ASEset}(x, return.class = "matrix")

genotype(x) <- value

\S4method{genotype}{ASEset}(x) <- value

countsPerSnp(x, ...)

\S4method{countsPerSnp}{ASEset}(x, return.class = "matrix", return.type = "mean", strand = "*")

countsPerSample(x, ...)

\S4method{countsPerSample}{ASEset}(x, return.class = "matrix", return.type = "mean", strand = "*")

phase(x, ...)

\S4method{phase}{ASEset}(x, return.class = "matrix")

phase(x) <- value

\S4method{phase}{ASEset}(x) <- value

mapBias(x) <- value

\S4method{mapBias}{ASEset}(x) <- value

refExist(x)

\S4method{refExist}{ASEset}(x)

ref(x)

\S4method{ref}{ASEset}(x)

ref(x) <- value

\S4method{ref}{ASEset,ANY}(x) <- value

altExist(x)

\S4method{altExist}{ASEset}(x)

alt(x)

\S4method{alt}{ASEset}(x)

alt(x) <- value

\S4method{alt}{ASEset,ANY}(x) <- value

aquals(x, ...)

\S4method{aquals}{ASEset}(x)

aquals(x) <- value

\S4method{aquals}{ASEset}(x) <- value

maternalAllele(x, ...)

\S4method{maternalAllele}{ASEset}(x)

paternalAllele(x, ...)

\S4method{paternalAllele}{ASEset}(x)
}
\arguments{
\item{x}{ASEset object}

\item{strand}{which strand of '+', '-' or '*'}

\item{return.class}{return 'list' or 'array'}

\item{...}{additional arguments}

\item{value}{replacement variable}

\item{top.fraction.criteria}{'maxcount', 'ref' or 'phase'}

\item{verbose}{makes function more talkative}

\item{return.type}{return 'names', rank or 'counts'}
}
\value{
An object of class ASEset containing location information and allele
counts for a number of SNPs measured in a number of samples on various
strand, as well as mapBias information. All data is stored in a manner
similar to the SummarizedExperiment class.
}
\description{
Object that holds allele counts, genomic positions and map-bias for a set of
SNPs
}
\details{
An ASEset object differs from a regular RangedSummarizedExperiment object
in that the assays contains an array instead of matrix. This array has
ranges on the rows, sampleNames on the columns and variants in the third
dimension.

It is possible to use the commands barplot and locationplot on an ASEset
object see more details in \code{\link{barplot}} and
\code{\link{locationplot}}.

Three different alleleCount options are available. The simples one is the
* option, and is for experiments where the strand information is not
known e.g. non-stranded data. The unknown strand could also be for strand 
specific data when the aligner could not find
any strand associated with the read, but this should normally not happen, 
and if it does probably having an extremely low mapping quality. 
Then there are an option too add plus
and minus stranded data. When using this, it is essential to make sure that
the RNA-seq experiment under analysis has in fact been created so that
correct strand information was obtained. The most functions will by default 
have their strand argument set to '*'.

The phase information is stored by the convention of 
'maternal chromosome|paternal chromosome', with 0 as reference allele and 1 
as alternative allele. '|' when the phase is known and '/' when the phase is
unknown. Internally the information will be stored as an three dimensional 
array, dim 1 for SNPs, dim 2 for Samples and dim 3 which is fixed and stores 
maternal chromosome, paternal chromosome and phased (1 equals TRUE).
}
\section{Table}{
 table(...)

\describe{
Arguments: \item{...}{An \code{ASEset object} that contains the
variants of interest} 

The generics for table does not easily allow more than one argument
so in respect to the different strand options, \code{table} will
return a SimpleList with length 3, one element for each strand.
}
}

\section{Frequency}{
 frequency(x, 
return.class = "list", strand = "*",
threshold.count.sample = 15)

\describe{
Arguments: \item{x}{An \code{ASEset object} that contains the
variants of interest} 

\item{x}{threshold.count.samples} if sample has fewer counts the function
return NA.

}
}

\section{Constructor}{
 ASEsetFromCountList(rowRanges, countListNonStranded =
NULL, countListPlus = NULL, countListMinus = NULL, countListUnknown = NULL,
colData = NULL, mapBiasExpMean = array(), verbose=FALSE, ...)

\describe{

Arguments: \item{rowRanges}{A \code{GenomicRanges object} that contains the
variants of interest} \item{countListNonStranded}{A \code{list} where each
entry is a matrix with allele counts as columns and sample counts as rows}
\item{countListPlus}{A \code{list} where each entry is a matrix with allele
counts as columns and sample counts as rows} \item{countListMinus}{A
\code{list} where each entry is a matrix with allele counts as columns and
sample counts as rows} \item{countListUnknown}{A \code{list} where each
entry is a matrix with allele counts as columns and sample counts as rows}
\item{colData}{A \code{DataFrame} object containing sample specific data}
\item{mapBiasExpMean}{A 3D \code{array} describing mapping bias. The SNPs
are in the 1st dimension, samples in the 2nd dimension and variants in the
3rd dimension.} \item{verbose}{Makes function more talkative}
\item{...}{arguments passed on to SummarizedExperiment constructor} }
}

\examples{


#make example countList
set.seed(42)
countListPlus <- list()
snps <- c('snp1','snp2','snp3','snp4','snp5')
for(snp in snps){
  count<-matrix(rep(0,16),ncol=4,dimnames=list(
c('sample1','sample2','sample3','sample4'),
c('A','T','G','C')))
  #insert random counts in two of the alleles 
  for(allele in sample(c('A','T','G','C'),2)){
count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
  }
  countListPlus[[snp]] <- count
}

#make example rowRanges
rowRanges <- GRanges(
  seqnames = Rle(c('chr1', 'chr2', 'chr1', 'chr3', 'chr1')),
  ranges = IRanges(1:5, width = 1, names = head(letters,5)),
  snp = paste('snp',1:5,sep='')
)

#make example colData
colData <- DataFrame(Treatment=c('ChIP', 'Input','Input','ChIP'), 
 row.names=c('ind1','ind2','ind3','ind4'))

#make ASEset 
a <- ASEsetFromCountList(rowRanges, countListPlus=countListPlus, 
colData=colData)


#example phase matrix (simple form)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

phase(a) <- p


#generate ASEset from array
snps <- 999
samples <-5
ar <-array(rep(unlist(lapply(1:snps,
			function(x){(sample(c(TRUE,FALSE,TRUE,FALSE), size = 4))})), samples), 
			dim=c(4,snps,samples))
ar2 <- array(sample(50:300, 4*snps*samples,replace=TRUE), dim=c(4,snps,samples))
ar2[ar] <- 0
ar2 <- aperm(ar2, c(2, 3, 1))
dimnames(ar2) <- list(paste("snp",1:snps,sep=""),paste("sample",1:samples,sep=""),
						c("A","C","G","T"))
gr <- GRanges(seqnames=c("chr2"), ranges=IRanges(start=1:dim(ar2)[1], width=1), strand="*")
a <- ASEsetFromArrays(gr, countsUnknown=ar2)


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{ASEset}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{gba}
\alias{gba}
\alias{gba,character-method}
\title{global analysis wrapper}
\usage{
gba(pathBam, ...)

\S4method{gba}{character}(pathBam, pathVcf, pathGFF = NULL, verbose)
}
\arguments{
\item{pathBam}{path to bam file}

\item{...}{arguments to pass on}

\item{pathVcf}{path to vcf file}

\item{pathGFF}{path to gff file}

\item{verbose}{makes function more talkative}
}
\description{
A wrapper to make a global analysis based on paths for BAM, VCF and GFF files
}
\examples{

#empty as function doesn't exist

}
\author{
Jesper R. Gadin
}
\keyword{global}
\keyword{wrapper}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inference-methods.R
\docType{methods}
\name{inferAlleles}
\alias{inferAlleles}
\alias{inferAlleles,ASEset-method}
\title{inference of SNPs of ASEset}
\usage{
inferAlleles(
  x,
  strand = "*",
  return.type = "bi",
  threshold.frequency = 0,
  threshold.count.sample = 1,
  inferOver = "eachSample",
  allow.NA = FALSE
)
}
\arguments{
\item{x}{ASEset}

\item{strand}{strand to infer from}

\item{return.type}{'uni' 'bi' 'tri' 'quad' 'all'}

\item{threshold.frequency}{least fraction to classify (see details)}

\item{threshold.count.sample}{least amount of counts to try to infer allele}

\item{inferOver}{'eachSample' or 'allSamples'}

\item{allow.NA}{treat NA as zero when TRUE}
}
\description{
inference of SNPs
}
\details{
threshold.frequency is the least fraction needed to classify as bi tri or
quad allelic SNPs. If 'all' then all of bi tri and quad allelic SNPs will use the same
threshold. Everything under the treshold will be regarded as noise. 'all' will return 
a matrix with snps as rows and uni bi tri and quad will be columns. For this function
Anything that will return TRUE for tri-allelicwill also return TRUE for uni and bi-allelic
for the same SNP an Sample.
}
\examples{

data(ASEset)
i <- inferAlleles(ASEset)

}
\author{
Jesper R. Gadin
}
\keyword{infer}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot-methods.R
\docType{methods}
\name{LinkVariantAlmlof-plot}
\alias{LinkVariantAlmlof-plot}
\alias{plot}
\alias{plot,LinkVariantAlmlof-method}
\alias{plot,LinkVariantAlmlof,ANY-method}
\title{plot LinkVariantAlmlof objects}
\usage{
plot(x, y, ...)

\S4method{plot}{LinkVariantAlmlof,ANY}(x, y, ...)
}
\arguments{
\item{x}{LinkVariantAlmlof object}

\item{y}{not used}

\item{...}{pass on arguments to internal methods}
}
\description{
plot an object of type LinkVariantAlmlof
}
\examples{

data(ASEset) 
a <- ASEset
# Add phase
set.seed(1)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

phase(a) <- p

#add alternative allele information
mcols(a)[["alt"]] <- inferAltAllele(a)

#init risk variants
p.ar <- phaseMatrix2Array(p)
rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p.ar)

#colnames has to be samea and same order in ASEset and RiskVariant
colnames(a) <- colnames(rv)

# in this example each and every snp in the ASEset defines a region
r1 <- granges(a)

# in this example two overlapping subsets of snps in the ASEset defines the region
r2 <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))

# link variant almlof (lva)
lv1 <- lva(a, rv, r1)
lv2 <- lva(a, rv, r2)
plot(lv2[1])

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{plot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/inference-methods.R
\name{inferGenotypes}
\alias{inferGenotypes}
\alias{inferGenotypes,ASEset-method}
\title{infererence of genotypes from ASEset count data}
\usage{
inferGenotypes(
  x,
  strand = "*",
  return.class = "matrix",
  return.allele.allowed = "bi",
  threshold.frequency = 0,
  threshold.count.sample = 1
)
}
\arguments{
\item{x}{ASEset}

\item{strand}{strand to infer from}

\item{return.class}{'matrix' or 'vector'}

\item{return.allele.allowed}{vector with 'bi' 'tri' or 'quad'.
'uni' Always gets returned}

\item{threshold.frequency}{least fraction to classify (see details)}

\item{threshold.count.sample}{least amount of counts to try to infer allele}
}
\description{
inference of genotypes
}
\details{
Oftern necessary information to link AI to SNPs outside coding region
}
\examples{

data(ASEset)
g <- inferGenotypes(ASEset)

}
\author{
Jesper R. Gadin
}
\keyword{infer}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/locationplot-methods.R
\docType{methods}
\name{ASEset-glocationplot}
\alias{ASEset-glocationplot}
\alias{glocationplot}
\alias{glocationplot,ASEset-method}
\title{glocationplot ASEset objects}
\usage{
glocationplot(
  x,
  type = "fraction",
  strand = "*",
  BamGAL = NULL,
  GenomeAxisTrack = FALSE,
  trackNameDeAn = paste("deTrack", type),
  TxDb = NULL,
  sizes = NULL,
  add = FALSE,
  verbose = FALSE,
  ...
)
}
\arguments{
\item{x}{an ASEset object.}

\item{type}{'fraction' or 'count'}

\item{strand}{'+','-','*' or 'both'. This argument determines which strand is
plotted. See \code{getAlleleCounts} for more information of choice of strand.}

\item{BamGAL}{GAlignmentsList covering the same genomic region as the ASEset}

\item{GenomeAxisTrack}{include an genomic axis track}

\item{trackNameDeAn}{trackname for deAnnotation track}

\item{TxDb}{a TxDb object which provides annotation}

\item{sizes}{vector with the sum 1. Describes the size of the tracks}

\item{add}{add to existing plot}

\item{verbose}{if set to TRUE it makes function more talkative}

\item{...}{arguments passed on to barplot function}
}
\description{
plotting ASE effects over a specific genomic region using Gviz functionality
}
\details{
The glocationplot methods visualises the distribution of ASE over a larger
region on one chromosome. It takes and ASEset object as well as additional
information on plot type (see \code{\link{gbarplot}}), strand type (see
\code{\link{getAlleleCounts}}), Annotation tracks are created from the Gviz
packageh. It is obviously important to make sure that the genome build used
is set correctly, e.g. 'hg19'.

sizes has to be of the same length as the number of tracks used.
}
\examples{

data(ASEset)
genome(ASEset) <- 'hg19'

glocationplot(ASEset,strand='+')

#for ASEsets with fewer SNPs the 'count' type plot is useful 
glocationplot(ASEset,type='count',strand='+')

}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the
glocationplot function can be called up on.  }
}
\author{
Jesper R. Gadin
}
\keyword{glocationplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-functions-visuals.R
\name{barplot-lattice-support}
\alias{barplot-lattice-support}
\alias{barplotLatticeCounts}
\alias{barplotLatticeFraction}
\title{lattice barplot inner functions for ASEset objects}
\usage{
barplotLatticeFraction(identifier, ...)

barplotLatticeCounts(identifier, ...)
}
\arguments{
\item{identifier, }{the single snp name to plot}

\item{...}{used to pass on variables}
}
\description{
Generates lattice barplots for ASEset objects. Two levels of plotting detail
are provided: a detailed barplot of read counts by allele useful for fewer
samples and SNPs, and a less detailed barplot of the fraction of imbalance,
useful for more samples and SNPs.
}
\details{
\code{filter.pValue.fraction} is intended to remove p-value annotation with
very large difference in frequency, which could just be a sequencing
mistake. This is to avoid p-values like 1e-235 or similar.

\code{sampleColour}User specified colours, either given as named colours
('red', 'blue', etc) or as hexadecimal code. Can be either length 1 for all
samples, or else of a length corresponding to the number of samples for
individual colouring.
}
\examples{

a <- ASEset
name <- rownames(a)[1]

barplotLatticeFraction(identifier=name, x=a, astrand="+") 
barplotLatticeCounts(identifier=name,  x=a, astrand="+") 

}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the barplot
function can be called up on.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{barplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{ASEsetFromBam}
\alias{ASEsetFromBam}
\alias{ASEsetFromBam,GRanges-method}
\title{ASEset from bam file}
\usage{
ASEsetFromBam(gr, ...)

\S4method{ASEsetFromBam}{GRanges}(
  gr,
  pathToDir,
  PE = TRUE,
  flagsMinusStrand = c(83, 163),
  flagsPlusStrand = c(99, 147),
  strandUnknown = FALSE,
  ...
)
}
\arguments{
\item{gr}{GenomicRanges of SNPs to create ASEset for}

\item{...}{passed on to ASEsetFromBam function}

\item{pathToDir}{Directory of bam files with index in same directory}

\item{PE}{if paired end or not (default: TRUE)}

\item{flagsMinusStrand}{flags that mark reads coming from minus strand}

\item{flagsPlusStrand}{flags that mark reads coming from plus strand}

\item{strandUnknown}{default: FALSE}
}
\description{
count alleles and create an ASEset direct from bam file instead of reading into R first.
}
\details{
counts the alleles in a bam file based on GRanges positions.
}
\examples{

data(GRvariants)
gr <- GRvariants

##no execution at the moment
#pathToDir <- system.file('inst/extdata/ERP000101_subset', package='AllelicImbalance')
#a <- ASEsetFromBam(gr, pathToDir)

}
\author{
Jesper R. Gadin
}
\keyword{ASEset}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/barplot-methods.R
\docType{methods}
\name{ASEset-barplot}
\alias{ASEset-barplot}
\alias{barplot}
\alias{barplot,ASEset-method}
\title{barplot ASEset objects}
\usage{
barplot(height, ...)

\S4method{barplot}{ASEset}(
  height,
  type = "count",
  sampleColour.top = NULL,
  sampleColour.bot = NULL,
  legend = TRUE,
  pValue = TRUE,
  strand = "*",
  testValue = NULL,
  testValue2 = NULL,
  OrgDb = NULL,
  TxDb = NULL,
  annotationType = c("gene", "exon", "transcript"),
  main = NULL,
  ylim = NULL,
  yaxis = TRUE,
  xaxis = FALSE,
  ylab = TRUE,
  ylab.text = NULL,
  xlab.text = "samples",
  xlab = TRUE,
  legend.colnames = "",
  las.ylab = 1,
  las.xlab = 2,
  cex.main = 1,
  cex.pValue = 0.7,
  cex.ylab = 0.7,
  cex.xlab = 0.7,
  cex.legend = 0.6,
  add = FALSE,
  lowerLeftCorner = c(0, 0),
  size = c(1, 1),
  addHorizontalLine = 0.5,
  add.frame = TRUE,
  filter.pValue.fraction = 0.99,
  legend.fill.size = 1,
  legend.interspace = 1,
  verbose = FALSE,
  top.fraction.criteria = "maxcount",
  cex.annotation = 0.7,
  ypos.annotation = 0,
  annotation.interspace = 1,
  ...
)
}
\arguments{
\item{height}{An \code{ASEset} object}

\item{...}{for simpler generics when extending function}

\item{type}{'count' or 'fraction'}

\item{sampleColour.top}{User specified colours for top fraction}

\item{sampleColour.bot}{User specified colours for bottom fraction}

\item{legend}{Display legend}

\item{pValue}{Display p-value}

\item{strand}{four options, '+', '-', 'both' or '*'}

\item{testValue}{if set, a matrix or vector with user p-values}

\item{testValue2}{if set, a matrix or vector with user p-values}

\item{OrgDb}{an OrgDb object which provides annotation}

\item{TxDb}{a TxDb object which provides annotation}

\item{annotationType}{select one or more from
'gene','exon','transcript','cds'.}

\item{main}{text to use as main label}

\item{ylim}{set plot y-axis limit}

\item{yaxis}{wheter the y-axis is to be displayed or not}

\item{xaxis}{wheter the x-axis is to be displayed or not}

\item{ylab}{showing labels for the tic marks}

\item{ylab.text}{ylab text}

\item{xlab.text}{xlab text}

\item{xlab}{showing labels for the tic marks}

\item{legend.colnames}{gives colnames to the legend matrix}

\item{las.ylab}{orientation of ylab text}

\item{las.xlab}{orientation of xlab text}

\item{cex.main}{set main label size (max 2)}

\item{cex.pValue}{set pValue label size}

\item{cex.ylab}{set ylab label size}

\item{cex.xlab}{set xlab label size}

\item{cex.legend}{set legend label size}

\item{add}{\code{boolean} indicates if a new device should be started}

\item{lowerLeftCorner}{integer that is only useful when \code{add}=TRUE}

\item{size}{Used internally by locationplot. Rescales each small barplot
window}

\item{addHorizontalLine}{adds a horizontal line that marks the default
fraction of 0.5 - 0.5}

\item{add.frame}{\code{boolean} to give the new plot a frame or not}

\item{filter.pValue.fraction}{\code{numeric} between 0 and 1 that filter
away pValues where the main allele has this frequency.}

\item{legend.fill.size}{size of the fill/boxes in the legend (default:NULL)}

\item{legend.interspace}{set legend space between fills and text}

\item{verbose}{Makes function more talkative}

\item{top.fraction.criteria}{'maxcount', 'ref' or 'phase'}

\item{cex.annotation}{size of annotation text}

\item{ypos.annotation}{relative ypos for annotation text}

\item{annotation.interspace}{space between annotation text}
}
\description{
Generates barplots for ASEset objects. Two levels of plotting detail are
provided: a detailed barplot of read counts by allele useful for fewer
samples and SNPs, and a less detailed barplot of the fraction of imbalance,
useful for more samples and SNPs.
}
\details{
\code{filter.pValue.fraction} is intended to remove p-value annotation with
very large difference in frequency, which could just be a sequencing
mistake. This is to avoid p-values like 1e-235 or similar.

\code{sampleColour}User specified colours, either given as named colours
('red', 'blue', etc) or as hexadecimal code. Can be either length 1 for all
samples, or else of a length corresponding to the number of samples for
individual colouring.
}
\examples{

data(ASEset)
barplot(ASEset[1])

}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the barplot
function can be called up on.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{barplot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{countAllelesFromBam}
\alias{countAllelesFromBam}
\alias{countAllelesFromBam,GRanges-method}
\title{alleleCounts from bam file}
\usage{
countAllelesFromBam(gr, ...)

\S4method{countAllelesFromBam}{GRanges}(
  gr,
  pathToDir,
  flag = NULL,
  scanBamFlag = NULL,
  return.class = "array",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{gr}{GRanges that contains SNPs of interest}

\item{...}{arguments to pass on}

\item{pathToDir}{path to directory of bam files}

\item{flag}{specify one flag to use as filter, default is no filtering.
allowed flags are 99, 147, 83 and 163}

\item{scanBamFlag}{set a custom flag to use as filter}

\item{return.class}{type of class for the returned object}

\item{verbose}{makes funciton more talkative}
}
\description{
count alleles before creating ASEse.
}
\details{
counts the alleles in a bam file based on GRanges positions.

Important excerpt from the details section of the internal applyPileups
 function: Regardless of 'param' values, the algorithm follows samtools by
 excluding reads flagged as unmapped, secondary, duplicate, or
 failing quality control.
}
\examples{

data(GRvariants)
gr <- GRvariants

##not run at the moment
#pathToDir <- system.file('inst/extdata/ERP000101_subset', package='AllelicImbalance')
#ar <- countAllelesFromBam(gr, pathToDir)

}
\author{
Jesper R. Gadin
}
\keyword{allelecount}
\keyword{counting}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{getDefaultMapBiasExpMean}
\alias{getDefaultMapBiasExpMean}
\alias{getDefaultMapBiasExpMean3D}
\alias{getDefaultMapBiasExpMean,ANY-method}
\alias{getDefaultMapBiasExpMean3D,ANY-method}
\alias{getDefaultMapBiasExpMean,list-method}
\title{Map Bias}
\usage{
getDefaultMapBiasExpMean(alleleCountList, ...)

getDefaultMapBiasExpMean3D(alleleCountList, ...)

\S4method{getDefaultMapBiasExpMean}{list}(alleleCountList)

\S4method{getDefaultMapBiasExpMean3D}{ANY}(alleleCountList)
}
\arguments{
\item{alleleCountList}{A \code{GRangesList object} containing read
information}

\item{...}{parameters to pass on}
}
\value{
\code{getDefaultMapBiasExpMean} returns a matrix with a default
expected mean of 0.5 for every element.
}
\description{
an allele frequency array
}
\details{
This function will assume there is no bias that comes from the mapping of
reads, and therefore create a matrix with expected frequency of 0.5 for each
allele.
}
\examples{

#load example data
data(ASEset)
#access SnpAfList
alleleCountList <- alleleCounts(ASEset)
#get default map bias exp mean
matExpMean <- getDefaultMapBiasExpMean(alleleCountList)


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bias}
\keyword{mapping}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapbias-methods.R
\docType{methods}
\name{mapBiasRef}
\alias{mapBiasRef}
\alias{mapBiasRef,ASEset-method}
\title{mapBias for reference allele}
\usage{
mapBiasRef(x, ...)

\S4method{mapBiasRef}{ASEset}(x)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{...}{internal arguments}
}
\description{
Create a matrix of bias for the reference allele
}
\details{
select the expected frequency for the reference allele
}
\examples{

#load example data
data(ASEset)
a <- ASEset

mat <- mapBiasRef(a) 

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{mapbias}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/detect-methods.R
\docType{methods}
\name{detectAI}
\alias{detectAI}
\alias{detectAI,ASEset-method}
\title{detectAI}
\usage{
detectAI(x, ...)

\S4method{detectAI}{ASEset}(
  x,
  return.class = "DetectedAI",
  strand = "*",
  threshold.frequency = 0,
  threshold.count.sample = 1,
  threshold.delta.frequency = 0,
  threshold.pvalue = 0.05,
  inferGenotype = FALSE,
  random.ref = FALSE,
  function.test = "binom.test",
  verbose = TRUE,
  gc = FALSE,
  biasMatrix = FALSE
)
}
\arguments{
\item{x}{ASEset}

\item{...}{internal arguments}

\item{return.class}{class to return (atm only class 'logical')}

\item{strand}{strand to infer from}

\item{threshold.frequency}{least fraction to classify (see details)}

\item{threshold.count.sample}{least amount of counts to try to infer allele}

\item{threshold.delta.frequency}{minimum of frequency difference 
from 0.5 (or mapbias adjusted value)}

\item{threshold.pvalue}{pvalue over this number will be filtered out}

\item{inferGenotype}{infer genotypes based on count data in ASEset object}

\item{random.ref}{set the reference as random if you dont know. Affects interpretation of results.}

\item{function.test}{At the moment the only available option is 'binomial.test'}

\item{verbose}{makes function more talkative}

\item{gc}{use garbage collection when possible to save space}

\item{biasMatrix}{use biasMatrix in ASEset, or use default expected frequency of 0.5 for all sites}
}
\description{
detection of AllelicImbalance
}
\details{
threshold.frequency is the least fraction needed to classify as bi tri or
quad allelic SNPs. If 'all' then all of bi tri and quad allelic SNPs will use the same
threshold. Everything under the treshold will be regarded as noise. 'all' will return 
a matrix with snps as rows and uni bi tri and quad will be columns. For this function
Anything that will return TRUE for tri-allelicwill also return TRUE for uni and bi-allelic
for the same SNP an Sample. 

return.type 'ref' return only AI when reference allele is more expressed. 'alt' return only
AI when alternative allele is more expressed or 'all' for both 'ref' and 'alt' alleles.
Reference allele is the one present in the reference genome on the forward strand.

threshold.delta.frequency and function.test will use the value in mapBias(x) as expected value. 

function.test will use the two most expressed alleles for testing. Make therefore sure there
are no tri-allelic SNPs or somatic mutations among the SNPs in the ASEset. 

inferGenotype(), set TRUE it should be used with as much samples as possible. If you split up the
samples and run detectAI() on each sample separately, please make sure you have inferred 
the genotypes in before hand, alternatively used the genotypes detected by another variantCaller
or chip-genotypes. Use ONLY biallelic genotypes.
}
\examples{

#load example data
data(ASEset)
a <- ASEset

dai <- detectAI(a)


}
\author{
Jesper R. Gadin
}
\keyword{detection}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{import-bam}
\alias{import-bam}
\alias{impBamGAL}
\alias{impBamGAL,character-method}
\title{Import Bam}
\usage{
impBamGAL(UserDir, ...)

\S4method{impBamGAL}{character}(
  UserDir,
  searchArea,
  files = NULL,
  XStag = FALSE,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{UserDir}{The relative or full path of folder containing bam files.}

\item{...}{arguments to pass on}

\item{searchArea}{A \code{GenomicRanges object} that contains the regions of
interest}

\item{files}{use character vector to specify one or more files to import. The
default imports all bam files from the directory.}

\item{XStag}{Setting \code{XStag=TRUE} stores the strand specific
information in the mcols slot 'XS'}

\item{verbose}{makes the function more talkative.}
}
\description{
Imports a specified genomic region from a bam file using a GRanges
object as search area.
}
\details{
If the sequence data is strand-specific you may want to set XStag=TRUE. The
strand specific information has then to be stored in the meta columns with
column name 'XS'. If the aligner did not set the XS-tag and the data is strand-
specific it is still be possible to infer the strand from the bit flags after importing
the reads to R. Depending on the strand-specific protocol different combinations of the
flags will have to be used. For illumina fr-secondstrand, 83 and 163 are minus strand
reads and 99 and 147 are plus strand reads.
}
\examples{

#Declare searchArea
searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))

#Relative or full path
pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')

#all files in directory
reads <- impBamGAL(pathToFiles,searchArea,verbose=FALSE)
#specified files in directory
reads <- impBamGAL(pathToFiles,searchArea,
			files=c("ERR009160.bam", "ERR009167.bam"),verbose=FALSE)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bam}
\keyword{import}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{genotype2phase}
\alias{genotype2phase}
\alias{genotype2phase,matrix-method}
\title{genotype2phase}
\usage{
genotype2phase(x, ...)

\S4method{genotype2phase}{matrix}(
  x,
  ref = NULL,
  return.class = "array",
  levels = c("A", "C", "G", "T"),
  ...
)
}
\arguments{
\item{x}{matrix see examples}

\item{...}{pass on additional param}

\item{ref}{reference alleles}

\item{return.class}{'array' or 'list'}

\item{levels}{vector of expected alleles}
}
\description{
used to convert the genomatrix from the visually friendly matrix to phase array.
}
\details{
To not introduce redundant information in the ASEset object, the genotype matrix is
translated to a phase matrix, containing the same information.
Does not allow tri-allelic or multi-allelic SNPs, and if present the multi-allelic
SNPs will lose the least occuring genotype.

This function can handle indels, but if the reference allele is not provided, the
rank matrix which is temporary created might use lots of memory, depending on the
amount of indels among the genotypes. As conclusion, it is preferable to send in
reference genome when converting to phase.

levels information is only important if the reference allele has to be guessed,
and so if reference information is provided, the levels argument can be ignored.
}
\examples{

#load example data
data(genomatrix)
data(ASEset)
p <- genotype2phase(genomatrix, ref(ASEset))

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GvizTrack-methods.R
\docType{methods}
\name{ASEset-gviztrack}
\alias{ASEset-gviztrack}
\alias{CoverageDataTrack}
\alias{ASEDAnnotationTrack}
\alias{CoverageDataTrack,ASEset-method}
\alias{ASEDAnnotationTrack,ASEset-method}
\title{ASEset-gviztrack ASEset objects}
\usage{
ASEDAnnotationTrack(
  x,
  GR = rowRanges(x),
  type = "fraction",
  strand = "*",
  trackName = paste("deTrack", type),
  verbose = TRUE,
  ...
)

\S4method{ASEDAnnotationTrack}{ASEset}(
  x,
  GR = rowRanges(x),
  type = "fraction",
  strand = "*",
  trackName = paste("deTrack", type),
  verbose = TRUE,
  ...
)

CoverageDataTrack(
  x,
  GR = rowRanges(x),
  BamList = NULL,
  strand = NULL,
  start = NULL,
  end = NULL,
  trackNameVec = NULL,
  meanCoverage = FALSE,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{x}{an ASEset object.}

\item{GR}{genomic range of plotting}

\item{type}{'fraction' or 'count'}

\item{strand}{'+','-'. This argument determines which strand is plotted.}

\item{trackName}{name of track (ASEDAnnotationTrack)}

\item{verbose}{Setting \code{verbose=TRUE} gives details of procedure during
function run}

\item{...}{arguments passed on to barplot function}

\item{BamList}{GAlignmnentsList object of reads from the same genomic region
as the ASEset}

\item{start}{start position of reads to be plotted}

\item{end}{end position of reads to be plotted}

\item{trackNameVec}{names of tracks (CoverageDataTrack)}

\item{meanCoverage}{mean of coverage over samples (CoverageGataTrack)}
}
\description{
plotting ASE effects over a specific genomic region
}
\details{
For information of how to use these tracks in more ways, visit the Gviz
package manual.
}
\examples{

data(ASEset)
x <- ASEset[,1:2]
r <- reads[1:2]
genome(x) <- 'hg19'
seqlevels(r) <- seqlevels(x)

GR <- GRanges(seqnames=seqlevels(x),
		ranges=IRanges(start=min(start(x)),end=max(end(x))),
		strand='+', genome=genome(x))

deTrack <- ASEDAnnotationTrack(x, GR=GR, type='fraction',strand='+')
covTracks <- CoverageDataTrack(x,BamList=r,strand='+') 

lst <- c(deTrack,covTracks)

sizes <- c(0.5,rep(0.5/length(covTracks),length(covTracks)))
#temporarily do not run this function 
#plotTracks(lst, from=min(start(x)), to=max(end(x)), 
#sizes=sizes, col.line = NULL, showId = FALSE, main='mainText', 
#cex.main=1, title.width=1, type='histogram')


}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the functions
can be called up on.}
}
\author{
Jesper R. Gadin
}
\keyword{ASEDAnnotationTrack}
\keyword{CoverageDataTrack}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{defaultPhase}
\alias{defaultPhase}
\alias{defaultPhase,numeric-method}
\title{defaultPhase}
\usage{
defaultPhase(i, ...)

\S4method{defaultPhase}{numeric}(i, j, ...)
}
\arguments{
\item{i}{number of rows}

\item{...}{arguments to forward to internal functions}

\item{j}{number of columns}
}
\description{
used to populate the phase slot in an ASEset object
}
\details{
will set everything to 0
}
\examples{


i <- 5
j <- 10
defaultPhase(i,j)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/histplot-methods.R
\docType{methods}
\name{histplot}
\alias{histplot}
\alias{hist}
\alias{hist,ReferenceBias-method}
\alias{hist,ASEset-method}
\title{histogram plots}
\usage{
\S4method{hist}{ASEset}(x, strand = "*", type = "mean", log = 1, ...)
}
\arguments{
\item{x}{\code{ReferenceBias} object or \code{ASEset} object}

\item{strand}{'+','-' or '*'}

\item{type}{'mean' (only one option atm)}

\item{log}{an integer to log each value (integer 10 for log10)}

\item{...}{arguments to forward to interal boxplots function}
}
\description{
uses base graphics hist plot
}
\details{
The histogram will show the density over frequencies for each sample
}
\examples{

##load example data

#data(ASEset)
#a <- ASEset
#hist(a)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{hist}
\keyword{plot}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{import-bcf}
\alias{import-bcf}
\alias{impBcfGRL}
\alias{impBcfGR}
\alias{impBcfGRL,character-method}
\alias{impBcfGR,character-method}
\title{Import Bcf Selection}
\usage{
impBcfGRL(UserDir, ...)

\S4method{impBcfGRL}{character}(UserDir, searchArea = NULL, verbose = TRUE, ...)

impBcfGR(UserDir, ...)

\S4method{impBcfGR}{character}(UserDir, searchArea = NULL, verbose = TRUE, ...)
}
\arguments{
\item{UserDir}{The relative or full path of folder containing bam files.}

\item{...}{parameters to pass on}

\item{searchArea}{A \code{GenomicRanges} object that contains the regions of
interest}

\item{verbose}{Setting \code{verbose=TRUE} gives details of the procedure
during function run.}
}
\value{
\code{BcfImpGRList} returns a GRangesList object.  \code{BcfImpGR}
returns one GRanges object of all unique entries from one or more bcf files.
}
\description{
Imports a selection of a bcf file or files specified by a GenomicRanges
object as search area.
}
\details{
A wrapper to import bcf files into R in the form of GenomicRanges objects.
}
\note{
Make sure there is a complementary index file \code{*.bcf.csi} for
each bcf file in \code{UserDir}. If there is not, then the functions
\code{impBcfGRL} and \code{impBcfGR} will try to create them.
}
\examples{

#Declare searchArea
searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))

#Relative or full path
pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')

#import
reads <- impBcfGRL(pathToFiles, searchArea, verbose=FALSE)

}
\seealso{
\itemize{ \item The impBamGRL for importing bam files
\item The \code{\link{getAlleleCounts}} for how to get allele(SNP) counts
\item The \code{\link{scanForHeterozygotes}} for how to find possible
heterozygote positions }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bcf}
\keyword{import}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{phase2genotype}
\alias{phase2genotype}
\alias{phase2genotype,array-method}
\title{phase2genotype}
\usage{
phase2genotype(x, ...)

\S4method{phase2genotype}{array}(x, ref, alt, return.class = "matrix", ...)
}
\arguments{
\item{x}{array see examples}

\item{...}{pass on additional param}

\item{ref}{reference allele vector}

\item{alt}{alternative allele vector}

\item{return.class}{'matrix' or 'array'}
}
\description{
Convert the phase from the internally stored phase, ref and alt information
}
\details{
To not introduce redundant information in the ASEset object, the genotype matrix is
accessed from the phase matrix, which together with ref and alt allele information
contains the same information(not taken into account three-allelic or more SNPs).

The genotype matrix retrieved from an ASEset object can differ from the genotype matrix
stored in the object if reference and alternative alleles were not used or has changed
since the phase genotype matrix was stored. Basically, it is preferable to provide
reference and alternative information when storing the genotype matrix.

If possible, it is better to not use a genotype matrix, but instead relying completely
on storing a phase matrix(or array) together with reference and alternative allele
information.
}
\examples{

#load example data
data(ASEset)
data(genomatrix)
p <- genotype2phase(genomatrix, ref(ASEset), return.class="array")
ref <- ref(ASEset)
alt <- inferAltAllele(ASEset)

gt <- phase2genotype(p, ref, alt, return.class="matrix")

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mapbias-methods.R
\docType{methods}
\name{randomRef}
\alias{randomRef}
\alias{randomRef,ASEset-method}
\title{Random ref allele from genotype}
\usage{
randomRef(x, ...)

\S4method{randomRef}{ASEset}(x, source = "alleleCounts", ...)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{...}{internal arguments}

\item{source}{'alleleCounts'}
}
\description{
Create a vector of random reference alleles
}
\details{
Randomly shuffles which of the two alleles for each genotype that is 
indicated as reference allele, based on either allele count information
or previous ref and alt alleles.

When the source is 'alleleCounts', the two most expressed alleles are taken
as reference and alternative allele.
}
\examples{

#load example data
data(ASEset.sim)
a <- ASEset.sim

ref(a) <- randomRef(a, source = 'alleleCounts') 

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{mapbias}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{coverageMatrixListFromGAL}
\alias{coverageMatrixListFromGAL}
\alias{coverageMatrixListFromGAL,GAlignmentsList-method}
\title{coverage matrix of GAlignmentsList}
\usage{
coverageMatrixListFromGAL(BamList, ...)

\S4method{coverageMatrixListFromGAL}{GAlignmentsList}(BamList, strand = "*", ignore.empty.bam.row = TRUE)
}
\arguments{
\item{BamList}{GAlignmentsList containing reads over the region to calculate
coverage}

\item{...}{arguments to pass on}

\item{strand}{strand has to be '+' or '-'}

\item{ignore.empty.bam.row}{argument not in use atm}
}
\description{
Get coverage per nucleotide for reads covering a region
}
\details{
a convenience function to get the coverage from a list of reads stored in
GAlignmnetsList, and returns by default a list with one matrix, and
information about the genomic start and stop positions.
}
\examples{

r <- reads
seqlevels(r) <- '17'
covMatList <- coverageMatrixListFromGAL(BamList=r, strand='+')

}
\author{
Jesper R. Gadin
}
\keyword{coverage}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{package}
\name{AllelicImbalance-package}
\alias{AllelicImbalance-package}
\alias{AllelicImbalance}
\title{A package meant to provide all basic functions for high-throughput allele
specific expression analysis}
\description{
Package \code{AllelicImbalance} has functions for importing, filtering and
plotting high-throughput data to make an allele specific expression
analysis. A major aim of this package is to provide functions to collect as
much information as possible from regions of choice, and to be able to
explore the allelic expression of that region in detail.
}
\details{
\tabular{ll}{ Package: \tab AllelicImbalance\cr Type: \tab Package\cr
Version: \tab 1.2.0\cr Date: \tab 2014-08-24\cr License: \tab GPL-3\cr }
}
\section{Overview - standard procedure}{
 Start out creating a \code{GRange}
object defining the region of interest. This can also be done using
\code{getAreaFromGeneNames} providing gene names as arguments. Then use
\code{BamImpGAList} to import reads from that reagion and find potential
SNPs using \code{scanForHeterozygotes}. Then retrieve the allele counts of
heterozygote sites by the function \code{getAlleleCount}. With this data
create an \code{ASEset}. At this point all pre-requisites for a 'basic'
allele specific expression analysis is available. Two ways to go on could be
to apply \code{\link{chisq.test}} or \code{\link{barplot}} on this ASEset
object.
}

\references{
Reference to published application note (work in progress)
}
\seealso{
\itemize{ \item code?ASEset }
}
\author{
Author: Jesper Robert Gadin Author: Lasse Folkersen

Maintainer: Jesper Robert Gadin <j.r.gadin@gmail.com>
}
\keyword{package}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialize-methods.R
\name{initialize-RiskVariant}
\alias{initialize-RiskVariant}
\alias{RiskVariantFromGRangesAndPhaseArray}
\title{Initialize RiskVariant}
\usage{
RiskVariantFromGRangesAndPhaseArray(x, phase, ...)
}
\arguments{
\item{x}{GRanges object for the SNPs}

\item{phase}{array with phaseinfo}

\item{...}{internal arguments}
}
\description{
Functions to construct RiskVariant objects
}
\details{
produces a class container for reference bias calculations
}
\examples{

data(ASEset)
#p <- getPhaseFromSomewhere
#rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p)


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bias}
\keyword{mapbias}
\keyword{refBias}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{data}
\name{ASEset.old}
\alias{ASEset.old}
\title{ASEset.old object}
\description{
old version of an ASEset which needs to be updated
}
\examples{

##load eample data (Not Run)  
#data(ASEset.old)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{data}
\keyword{example}
\keyword{object}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkage-methods.R
\docType{methods}
\name{lva}
\alias{lva}
\alias{lva,array-method}
\alias{lva,ASEset-method}
\title{lva}
\usage{
lva(x, ...)

\S4method{lva}{ASEset}(
  x,
  rv,
  region,
  settings = list(),
  return.class = "LinkVariantAlmlof",
  type = "lm",
  verbose = FALSE,
  covariates = matrix(),
  ...
)
}
\arguments{
\item{x}{ASEset object with phase and 'ref'/'alt' allele information}

\item{...}{arguments to forward to internal functions}

\item{rv}{RiskVariant object with phase and 'ref'/'alt' allele information}

\item{region}{RiskVariant object with phase and alternative allele information}

\item{settings}{RiskVariant object with phase and alternative allele information}

\item{return.class}{'LinkVariantAlmlof' (more options in future)}

\item{type}{"lm" or "nlme", "nlme" needs subject information}

\item{verbose}{logical, if set TRUE, then function will be more talkative}

\item{covariates}{add data.frame with covariates (only integers and numeric)}
}
\description{
make an almlof regression for arrays
}
\details{
internal method that takes one array with results from regionSummary
and one matrix with group information for each risk SNP (based on phase)
}
\examples{

data(ASEset) 
a <- ASEset
# Add phase
set.seed(1)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

phase(a) <- p

#add alternative allele information
mcols(a)[["alt"]] <- inferAltAllele(a)

#init risk variants
p.ar <- phaseMatrix2Array(p)
rv <- RiskVariantFromGRangesAndPhaseArray(x=GRvariants, phase=p.ar)

#colnames has to be samea and same order in ASEset and RiskVariant
colnames(a) <- colnames(rv)

# in this example each and every snp in the ASEset defines a region
r1 <- granges(a)

#use GRangesList to merge and use regions defined by each element of the
#GRangesList
r1b <- GRangesList(r1)
r1c <- GRangesList(r1, r1)

# in this example two overlapping subsets of snps in the ASEset defines the region
r2 <- split(granges(a)[c(1,2,2,3)],c(1,1,2,2))

# link variant almlof (lva)
lva(a, rv, r1)
lva(a, rv, r1b)
lva(a, rv, r1c)
lva(a, rv, r2)

# Use covariates (integers or nuemric)
cov <- data.frame(age=sample(20:70, ncol(a)), sex=rep(c(1,2), each=ncol(a)/2),  
row.names=colnames(a))
lva(a, rv, r1, covariates=cov)
lva(a, rv, r1b, covariates=cov)
lva(a, rv, r1c, covariates=cov)
lva(a, rv, r2, covariates=cov)

# link variant almlof (lva), using nlme
a2 <- a
ac <- assays(a2)[["countsPlus"]]
jit <- sample(c(seq(-0.10,0,length=5), seq(0,0.10,length=5)), size=length(ac) , replace=TRUE)
assays(a2, withDimnames=FALSE)[["countsPlus"]] <- round(ac * (1+jit),0)
ab <- cbind(a, a2)
colData(ab)[["subject.group"]] <- c(1:ncol(a),1:ncol(a))
rv2 <- rv[,c(1:ncol(a),1:ncol(a))]
colnames(ab) <- colnames(rv2)

lva(ab, rv2, r1, type="nlme")
lva(ab, rv2, r1b, type="nlme")
lva(ab, rv2, r1c, type="nlme")
lva(ab, rv2, r2, type="nlme")


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecations.R
\name{implodeList.old}
\alias{implodeList.old}
\title{implode list of arguments into environment}
\usage{
implodeList.old(x)
}
\arguments{
\item{x}{list of variables}
}
\description{
apply on list of variables to be put in the local environment
}
\details{
help the propagation of e.g. graphical paramters
}
\examples{

lst <- list(hungry='yes', thirsty='no')
implodeList.old(lst)
#the check ls()
 ls()
}
\author{
Jesper R. Gadin
}
\keyword{implode}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{getAlleleCounts}
\alias{getAlleleCounts}
\alias{getAlleleCounts,GAlignmentsList-method}
\title{snp count data}
\usage{
getAlleleCounts(BamList, ...)

\S4method{getAlleleCounts}{GAlignmentsList}(
  BamList,
  GRvariants,
  strand = "*",
  return.class = "list",
  verbose = TRUE,
  ...
)
}
\arguments{
\item{BamList}{A \code{GAlignmentsList object} or \code{GRangesList object}
containing data imported from a bam file}

\item{...}{parameters to pass on}

\item{GRvariants}{A \code{GRanges object} that contains positions of SNPs to
retrieve}

\item{strand}{A length 1 \code{character} with value  '+',
'-', or '*'.  This argument determines if \code{getAlleleCounts} will
retrieve counts from all reads, or only from reads marked as '+', '-' or '*'
(unknown), respectively.}

\item{return.class}{'list' or 'array'}

\item{verbose}{Setting \code{verbose=TRUE} makes function more talkative}
}
\value{
\code{getAlleleCounts} returns a list of several data.frame objects,
each storing the count data for one SNP.
}
\description{
Given the positions of known SNPs, this function returns allele counts from
a BamGRL object
}
\details{
This function is used to retrieve the allele counts from specified positions
in a set of RNA-seq reads. The \code{BamList} argument will typically have
been created using the \code{impBamGAL} function on bam-files. The
\code{GRvariants} is either a GRanges with user-specified locations or else
it is generated through scanning the same bam-files as in \code{BamList} for
heterozygote locations (e.g. using \code{scanForHeterozygotes}). The
GRvariants will currently only accept locations having width=1,
corresponding to bi-allelic SNPs. In the \code{strand} argument, specifying
'*' is the same as retrieving the sum count of '+' and '-' reads
(and unknown strand reads in case these are found in the bam file). '*' is
the default behaviour and can be used when the RNA-seq experiments strand
information is not available.
}
\examples{

#load example data
data(reads)
data(GRvariants)


#get counts at the three positions specified in GRvariants
alleleCount <- getAlleleCounts(BamList=reads,GRvariants,
strand='*')

#if the reads had contained stranded data, these two calls would
#have given the correct input objects for getAlleleCounts
alleleCountPlus <- getAlleleCounts(BamList=reads,GRvariants,
strand='+')
alleleCountMinus <- getAlleleCounts(BamList=reads,GRvariants,
strand='-')


}
\seealso{
\itemize{ \item The \code{\link{scanForHeterozygotes}} which is a
function to find possible heterozygote sites in a
GenomicAlignments object }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{SNP}
\keyword{count}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecations.R
\name{import-bam-2}
\alias{import-bam-2}
\alias{impBamGRL}
\alias{impBamGRL.old}
\title{Import Bam-2}
\usage{
impBamGRL.old(UserDir, searchArea, verbose = TRUE)
}
\arguments{
\item{UserDir}{The relative or full path of folder containing bam files.}

\item{searchArea}{A \code{GenomicRanges object} that contains the regions of
interest}

\item{verbose}{Setting \code{verbose=TRUE} gives details of procedure during
function run.}
}
\value{
\code{impBamGRL} returns a GRangesList object containing the RNA-seq
reads in the region defined by the \code{searchArea} argument.
\code{impBamGAL} returns a list with GAlignments objects containing the
RNA-seq reads in the region defined by the \code{searchArea} argument.
\code{funImpBamGAPL} returns a list with GappedAlignmentPairs object
containing the RNA-seq reads in the region defined by the \code{searchArea}
argument.
}
\description{
Imports bla bal bal a specified genomic region from a bam file using a GenomicRanges
object as search area.
}
\details{
These functions are right  on tahea wrappers to import bam files into R and store them into
either GRanges, GAlignments or GappedAlignmentpairs objects.

It is recommended to use the impBamGAL() which takes information of gaps
into account. It is also possible to use the other variants as well, but
then pre-filtering becomes important keps to understand because gapped, intron-spanning reads
will cause problems. This is because the GRanges objects can not handle if
gaps are present and will then give a wrong result when calculating the
allele (SNP) count table.
}
\examples{

#Declare searchArea
searchArea <- GRanges(seqnames=c('17'), ranges=IRanges(79478301,79478361))

#Relative or full path
pathToFiles <- system.file('extdata/ERP000101_subset', package='AllelicImbalance')


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bam}
\keyword{import}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LinkVariantAlmlof-class.R
\docType{class}
\name{LinkVariantAlmlof-class}
\alias{LinkVariantAlmlof-class}
\alias{LinkVariantAlmlof}
\alias{LinkVariantAlmlof-method}
\alias{pvalue}
\alias{pvalue,LinkVariantAlmlof-method}
\title{LinkVariantAlmlof class}
\usage{
pvalue(x, ...)

\S4method{pvalue}{LinkVariantAlmlof}(x)
}
\arguments{
\item{x}{LinkVariantAlmlof object}

\item{...}{pass arguments to internal functions}
}
\description{
Object that holds results from AI detection.
}
\details{
The LinkVariantAlmlof-class contains
}
\examples{

#some code

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{LinkVariantAlmlof}
\keyword{class}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{fractionPlotDf}
\alias{fractionPlotDf}
\alias{fractionPlotDf,ASEset-method}
\title{Plot Dataframe}
\usage{
fractionPlotDf(x, snp, strand = "*", top.fraction.criteria = "maxcount", ...)

\S4method{fractionPlotDf}{ASEset}(x, snp, strand = "*", top.fraction.criteria = "maxcount", ...)
}
\arguments{
\item{x}{ASEset}

\item{snp}{rownames identifier for ASEset or row number}

\item{strand}{'+', '-' or '*'}

\item{top.fraction.criteria}{'maxcount', 'ref' or 'phase'}

\item{...}{arguments to forward to internal functions}
}
\description{
Summarizes information to ease creating plots
}
\details{
Main purpose is to reduce the amount of overall code and ease maintenance.

top.fraction.criteria can take three options, maxcount, ref and phase. The top
allele will be every second row in the data frame, with start from row 2.
The maxcount argument will put the allele with most reads on top of the
bivariate fraction. Similarly the ref argument will put always the reference
allele on top. The phase arguments puts the maternal phase always on top.
The top.fraction.criteria for the ref or phase arguments requires that both ref
and alt is set in mcols(ASEset).
}
\examples{

#test on example ASEset
data(ASEset)
a <- ASEset
df <- fractionPlotDf(a, 1, strand="+")

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}
\keyword{plotDf}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecations.R
\name{cigar-utilities}
\alias{cigar-utilities}
\alias{realCigarPosition}
\alias{realCigarPositions}
\alias{realCigarPositionsList}
\alias{realCigarPosition.old}
\alias{realCigarPositions.old}
\alias{realCigarPositionsList.old}
\title{realCigarPosition}
\usage{
realCigarPosition.old(RleCigar, BpPos)

realCigarPositions.old(RleCigar)

realCigarPositionsList.old(RleCigarList)
}
\arguments{
\item{RleCigar}{An \code{Rle} containing cigar information}

\item{BpPos}{the absolute position on the chromosome of interest}

\item{RleCigarList}{An \code{RleList} containing cigar information}
}
\value{
realCigarPosition returns the new position
realCigarPositions returns a vector with the corrected positions to
be subsetted from a read.  \code{realCigarPositionsList} returns a list
where each element i a vector with the corrected positions to be subsetted
from a read.
}
\description{
From a GAlignments calculate the real corresponding position for each read
based on its cigar.
}
\details{
The main intention for these functions are to be the internal functions for
\code{scanForHeterozygotes} and \code{getAlleleCount}.
}
\examples{

  RleCigarList <-  cigarToRleList('3M4I93M')
  BpPos <- 5

  newPos <- realCigarPosition.old(RleCigar=RleCigarList[[1]], BpPos)
  newPositions <- realCigarPositions.old(RleCigar=RleCigarList[[1]])
  newPositionsList <- realCigarPositionsList.old(RleCigarList=RleCigarList)
}
\author{
Jesper R. Gadin
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter-methods.R
\docType{methods}
\name{ASEset-filters}
\alias{ASEset-filters}
\alias{hetFilt}
\alias{hetFilt,ASEset-method}
\title{genotype filter methods}
\usage{
hetFilt(x, ...)

\S4method{hetFilt}{ASEset}(x, source = "genotype", ...)
}
\arguments{
\item{x}{ASEset object}

\item{...}{internal param}

\item{source}{'genotype' or 'alleleCounts'}
}
\description{
useful genotype filters
}
\details{
hetFilt returns TRUE if the samples is heterozygote, based on stored genotype information
present in the phase data.
}
\examples{

#load example data
data(ASEset)
a <- ASEset

genotype(a) <- inferGenotypes(a)
hets <- hetFilt(a) 

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{filter}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialize-methods.R
\name{initialize-DetectedAI}
\alias{initialize-DetectedAI}
\alias{DetectedAIFromArray}
\title{Initialize DetectedAI}
\usage{
DetectedAIFromArray(
  x = "ASEset",
  strand = "*",
  reference.frequency = NULL,
  threshold.frequency = NULL,
  threshold.count.sample = NULL,
  threshold.delta.frequency = NULL,
  threshold.pvalue = NULL,
  threshold.frequency.names = NULL,
  threshold.count.sample.names = NULL,
  threshold.delta.frequency.names = NULL,
  threshold.pvalue.names = NULL,
  ...
)
}
\arguments{
\item{x}{\code{ASEset}}

\item{strand}{set strand to detectAI over "+","-","*"}

\item{reference.frequency}{frequencies of reference alleles based allele counts}

\item{threshold.frequency}{logical array for frequency thresholds}

\item{threshold.count.sample}{logical array for per sample allele count thresholds}

\item{threshold.delta.frequency}{logical array for delta frequency thresholds.}

\item{threshold.pvalue}{logical array for pvalue thresholds (max 1, min 0)}

\item{threshold.frequency.names}{character vector}

\item{threshold.count.sample.names}{character vector}

\item{threshold.delta.frequency.names}{character vector}

\item{threshold.pvalue.names}{character vector}

\item{...}{internal arguments}
}
\description{
Functions to construct DetectedAI objects
}
\details{
produces a class container for reference bias calculations
}
\examples{

data(ASEset)
a <- ASEset
dai <- detectAI(a)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{bias}
\keyword{mapbias}
\keyword{refBias}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/linkage-methods.R
\docType{methods}
\name{lva.internal}
\alias{lva.internal}
\alias{lva.internal,array-method}
\title{lva.internal}
\usage{
lva.internal(x, ...)

\S4method{lva.internal}{array}(
  x,
  grp,
  element = 3,
  type = "lm",
  subject = NULL,
  covariates = matrix(),
  ...
)
}
\arguments{
\item{x}{regionSummary array phased for maternal allele}

\item{...}{arguments to forward to internal functions}

\item{grp}{group 1-3 (1 for 0:0, 2 for 1:0 or 0:1, and 3 for 1:1)}

\item{element}{which column in x contains the values to use with lm.}

\item{type}{which column in x contains the values to use with lm.}

\item{subject}{which samples belongs to the same individual}

\item{covariates}{add data.frame with covariates (only integers and numeric)}
}
\description{
make an almlof regression for arrays (internal function)
}
\details{
internal method that takes one array with results from regionSummary
and one matrix with group information for each risk SNP (based on phase).
Input and output objects can change format slightly in future.
}
\examples{

data(ASEset) 
a <- ASEset
# Add phase
set.seed(1)
p1 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p2 <- matrix(sample(c(1,0),replace=TRUE, size=nrow(a)*ncol(a)),nrow=nrow(a), ncol(a))
p <- matrix(paste(p1,sample(c("|","|","/"), size=nrow(a)*ncol(a), replace=TRUE), p2, sep=""),
	nrow=nrow(a), ncol(a))

phase(a) <- p

#add alternative allele information
mcols(a)[["alt"]] <- inferAltAllele(a)

# in this example two overlapping subsets of snps in the ASEset defines the region
region <- split(granges(a)[c(1,2,2,3)], c(1,1,2,2))
rs <- regionSummary(a, region, return.class="array", return.meta=FALSE)

# use  (change to generated riskSNP phase later)
phs <- array(c(phase(a,return.class="array")[1,,c(1, 2)], 
			 phase(a,return.class="array")[2,,c(1, 2)]), dim=c(20,2,2))
grp <- matrix(2, nrow=dim(phs)[1], ncol=dim(phs)[2])		 
grp[(phs[,,1] == 0) & (phs[,,2] == 0)] <- 1
grp[(phs[,,1] == 1) & (phs[,,2] == 1)] <- 3
#only use mean.fr at the moment, which is col 3
lva.internal(x=assays(rs)[["rs1"]],grp=grp, element=3)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{phase}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods.R
\docType{methods}
\name{ASEset-scanForHeterozygotes}
\alias{ASEset-scanForHeterozygotes}
\alias{scanForHeterozygotes}
\alias{scanForHeterozygotes,ASEset-method}
\alias{scanForHeterozygotes,GAlignmentsList-method}
\title{scanForHeterozygotes}
\usage{
scanForHeterozygotes(BamList, ...)

\S4method{scanForHeterozygotes}{GAlignmentsList}(
  BamList,
  minimumReadsAtPos = 20,
  maximumMajorAlleleFrequency = 0.9,
  minimumMinorAlleleFrequency = 0.1,
  minimumBiAllelicFrequency = 0.9,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{BamList}{A \code{GAlignmentsList object}}

\item{...}{argument to pass on}

\item{minimumReadsAtPos}{minimum number of reads required to call a SNP at a
given position}

\item{maximumMajorAlleleFrequency}{maximum frequency allowed for the most
common allele. Setting this parameter lower will minimise the SNP calls
resulting from technical read errors, at the cost of missing loci with
potential strong ASE}

\item{minimumMinorAlleleFrequency}{minimum frequency allowed for the second most
common allele. Setting this parameter higher will minimise the SNP calls
resulting from technical read errors, at the cost of missing loci with
potential strong ASE}

\item{minimumBiAllelicFrequency}{minimum frequency allowed for the first and
second most common allele. Setting a Lower value for this parameter will
minimise the identification of loci with three or more alleles in one
sample. This is useful if sequencing errors are suspected to be common.}

\item{verbose}{logical indicating if process information should be displayed}
}
\value{
\code{scanForHeterozygotes} returns a GRanges object with the SNPs
for the BamList object that was used as input.
}
\description{
Identifies the positions of SNPs found in BamGR reads.
}
\details{
This function scans all reads stored in a \code{GAlignmentsList} for
possible heterozygote positions. The user can balance the sensitivity of the
search by modifying the minimumReadsAtPos, maximumMajorAlleleFrequency and
minimumBiAllelicFrequency arguments.
}
\examples{

data(reads)
s <- scanForHeterozygotes(reads,verbose=FALSE)

}
\seealso{
\itemize{ \item The \code{\link{getAlleleCounts}} which is a
function that count the number of reads overlapping a site.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{SNP}
\keyword{heterozygote}
\keyword{scan}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/initialize-methods.R
\name{initialize-ASEset}
\alias{initialize-ASEset}
\alias{ASEsetFromCountList}
\alias{ASEsetFromArrays}
\title{Initialize ASEset}
\usage{
ASEsetFromCountList(
  rowRanges,
  countListUnknown = NULL,
  countListPlus = NULL,
  countListMinus = NULL,
  colData = NULL,
  mapBiasExpMean = NULL,
  phase = NULL,
  aquals = NULL,
  verbose = FALSE,
  ...
)

ASEsetFromArrays(
  rowRanges,
  countsUnknown = NULL,
  countsPlus = NULL,
  countsMinus = NULL,
  colData = NULL,
  mapBiasExpMean = NULL,
  phase = NULL,
  genotype = NULL,
  aquals = NULL,
  verbose = FALSE,
  ...
)
}
\arguments{
\item{rowRanges}{A \code{GenomicRanges object} that contains the variants of
interest}

\item{countListUnknown}{A \code{list} where each entry is a matrix with
allele counts as columns and sample counts as rows}

\item{countListPlus}{A \code{list} where each entry is a matrix with allele
counts as columns and sample counts as rows}

\item{countListMinus}{A \code{list} where each entry is a matrix with allele
counts as columns and sample counts as rows}

\item{colData}{A \code{DataFrame} object containing sample specific data}

\item{mapBiasExpMean}{A 3D \code{array} where the SNPs are in the 1st
dimension, samples in the 2nd dimension and variants in the 3rd dimension.}

\item{phase}{A \code{matrix} or an \code{array} containing phase information.}

\item{aquals}{A 4-D array containing the countinformation, see details}

\item{verbose}{Makes function more talkative}

\item{...}{arguments passed on to SummarizedExperiment constructor}

\item{countsUnknown}{An array containing the countinformation}

\item{countsPlus}{An array containing the countinformation}

\item{countsMinus}{An array containing the countinformation}

\item{genotype}{matrix}
}
\value{
\code{ASEsetFromCountList} returns an \code{ASEset} object.
}
\description{
Functions to construct ASEset objects
}
\details{
The resulting ASEset object is based on the RangedSummarizedExperiment
class, and will therefore inherit the same accessors and ranges operations.

If both countListPlus and countListMinus are given they will be used to 
calculate countListUnknown, which is the sum of the plus and minus strands.

countListPlus, countListMinus and countListUnknown are
i.e. the outputs from the getAlleleCounts function.

aquals is new for the devel branch and will be changed slighly before the relase 
to include better granularity.
}
\note{
\code{ASEsetFromCountList} requires the same input data as a
RangedSummarizedExperiment, but with minimum one assay for the allele counts.
}
\examples{

#make example alleleCountListPlus
set.seed(42)
countListPlus <- list()
snps <- c('snp1','snp2','snp3','snp4','snp5')
for(snp in snps){
count<-matrix(rep(0,16),ncol=4,dimnames=list(
c('sample1','sample2','sample3','sample4'),
c('A','T','G','C')))
#insert random counts in two of the alleles 
for(allele in sample(c('A','T','G','C'),2)){
count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
}
countListPlus[[snp]] <- count
}

#make example alleleCountListMinus
countListMinus <- list()
snps <- c('snp1','snp2','snp3','snp4','snp5')
for(snp in snps){
count<-matrix(rep(0,16),ncol=4,dimnames=list(
c('sample1','sample2','sample3','sample4'),
c('A','T','G','C')))
#insert random counts in two of the alleles 
for(allele in sample(c('A','T','G','C'),2)){
count[,allele]<-as.integer(rnorm(4,mean=50,sd=10))
}
countListMinus[[snp]] <- count
}


#make example rowRanges
rowRanges <- GRanges(
seqnames = Rle(c('chr1', 'chr2', 'chr1', 'chr3', 'chr1')),
         ranges = IRanges(1:5, width = 1, names = head(letters,5)),
         snp = paste('snp',1:5,sep='')
         )
#make example colData
colData <- DataFrame(Treatment=c('ChIP', 'Input','Input','ChIP'), 
 row.names=c('ind1','ind2','ind3','ind4'))

#make ASEset 
a <- ASEsetFromCountList(rowRanges, countListPlus=countListPlus, 
countListMinus=countListMinus, colData=colData)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{ASEset}
\keyword{ASEsetFromCountList}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filter-methods.R
\docType{methods}
\name{minFreqFilt}
\alias{minFreqFilt}
\alias{minfreqFilt}
\alias{minFreqFilt,ASEset-method}
\title{minFreqFilt methods}
\usage{
minFreqFilt(x, ...)

\S4method{minFreqFilt}{ASEset}(
  x,
  strand = "*",
  threshold.frequency = 0.1,
  replace.with = "zero",
  return.class = "ASEset",
  sum = "all"
)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{...}{internal param}

\item{strand}{strand to infer from}

\item{threshold.frequency}{least fraction to classify (see details)}

\item{replace.with}{only option 'zero'}

\item{return.class}{'ASEset', 'array' or 'matrix'}

\item{sum}{'each' or 'all'}
}
\description{
filter on minFreqFilt snps
}
\details{
Description info here
}
\examples{

#load example data
data(ASEset)
a <- ASEset

minFreqFilt(a)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{filter}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/chisq.test-methods.R
\docType{methods}
\name{chisq.test}
\alias{chisq.test}
\alias{chisq.test,ASEset-method}
\title{chi-square test}
\usage{
\S4method{chisq.test}{ASEset}(x, y = "*")
}
\arguments{
\item{x}{\code{ASEset} object}

\item{y}{strand option}
}
\value{
\code{chisq.test} returns a matrix with the chisq.test P-value for
each SNP and sample
}
\description{
Performs a chisq.test on an ASEset object.
}
\details{
The test is performed on one strand in an ASEset object.
}
\examples{

#load example data
data(ASEset)

#make a chi-square test on default non-stranded strand 
chisq.test(ASEset)

}
\seealso{
\itemize{ \item The \code{\link{binom.test}} which is another test
that can be applied on an \link{ASEset} object.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{chi-square}
\keyword{test}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-methods-summaries.R
\name{DetectedAI-summary}
\alias{DetectedAI-summary}
\alias{frequency_vs_threshold_variable_summary}
\alias{frequency_vs_threshold_variable_summary,DetectedAI-method}
\alias{detectedAI_vs_threshold_variable_summary}
\alias{detectedAI_vs_threshold_variable_summary,DetectedAI-method}
\alias{usedSNPs_vs_threshold_variable_summary}
\alias{usedSNPs_vs_threshold_variable_summary,DetectedAI-method}
\title{DetectedAI summary}
\usage{
frequency_vs_threshold_variable_summary(x, ...)

\S4method{frequency_vs_threshold_variable_summary}{DetectedAI}(
  x,
  var = "threshold.count.sample",
  return.class = "matrix",
  ...
)

detectedAI_vs_threshold_variable_summary(x, ...)

\S4method{detectedAI_vs_threshold_variable_summary}{DetectedAI}(x, var = "threshold.count.sample")

usedSNPs_vs_threshold_variable_summary(x, ...)

\S4method{usedSNPs_vs_threshold_variable_summary}{DetectedAI}(x, var = "threshold.count.sample")
}
\arguments{
\item{x}{detectedAI object}

\item{...}{pass on variables internally}

\item{var}{string, see details for available options}

\item{return.class}{'matrix' or 'array'}
}
\description{
Summary helper functions for the DetectedAI-class
}
\details{
Summary helper functions. The documentation will
be improved before next release.
}
\examples{

#some example code here
#generate example
data(ASEset)
a <- ASEset
dai <- detectAI(a, 
			threshold.count.sample=1:50,
			threshold.frequency=seq(0,0.5,by=0.01),
			threshold.delta.frequency=seq(0,0.5,by=0.01),
			threshold.pvalue=rev(seq(0.001,0.05, by=0.005))
)

frequency_vs_threshold_variable_summary(dai)


}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{list}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auxillary-functions-annotation.R
\name{decorateWithExons}
\alias{decorateWithExons}
\title{decorateWithExons}
\usage{
decorateWithExons(x, exonsInRegion, xlim, ylim, chromosome)
}
\arguments{
\item{x}{\code{ASEset} object}

\item{exonsInRegion}{\code{GRanges} object with generegions. Can be obtained
using \code{getExonsFromAnnotation}. Must contain a column 'tx_name'}

\item{xlim}{xlim values for the pre-specified surface}

\item{ylim}{ylim values for the pre-specified surface}

\item{chromosome}{character}
}
\value{
\code{decorateWithExons} returns nothing, but draws genes
}
\description{
Internal function that can draw gene regions on pre-specified surfaces.
Necessary for the genomic-location plots.
}
\details{
The main intention of this function is to be used when plotting several bar
plots in the same window. This function add gene regions under the bars.
}
\examples{

  data(ASEset)

}
\seealso{
\itemize{ \item The \code{\link{locationplot}} which is uses this
function internally.  \item The \code{\link{decorateWithGenes}} which is
another similar function that \code{\link{locationplot}} uses internally.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllelicImbalance-package.R
\docType{data}
\name{genomatrix}
\alias{genomatrix}
\title{genomatrix object}
\description{
genomatrix is an example of a matrix with genotypes
}
\examples{

##load eample data (Not Run)  
#data(genomatrix)

}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{data}
\keyword{genotype}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/locationplot-methods.R
\docType{methods}
\name{ASEset-locationplot}
\alias{ASEset-locationplot}
\alias{locationplot}
\alias{locationplot,ASEset-method}
\title{locationplot ASEset objects}
\usage{
locationplot(x, ...)

\S4method{locationplot}{ASEset}(
  x,
  type = "fraction",
  strand = "*",
  yaxis = TRUE,
  xaxis = FALSE,
  xlab = FALSE,
  ylab = TRUE,
  xlab.text = "",
  ylab.text = "",
  legend.colnames = "",
  size = c(0.8, 1),
  main = NULL,
  pValue = FALSE,
  cex.main = 0.7,
  cex.ylab = 0.6,
  cex.legend = 0.5,
  OrgDb = NULL,
  TxDb = NULL,
  verbose = TRUE,
  top.fraction.criteria = "maxcount",
  allow.whole.chromosome = FALSE,
  ...
)
}
\arguments{
\item{x}{an ASEset object.}

\item{...}{arguments passed on to barplot function}

\item{type}{'fraction' or 'count'}

\item{strand}{'+','-','*' or 'both'. This argument determines
which strand is plotted. See \code{getAlleleCounts} for more information on
strand.}

\item{yaxis}{wheter the y-axis is to be displayed or not}

\item{xaxis}{wheter the x-axis is to be displayed or not}

\item{xlab}{showing labels for the tic marks}

\item{ylab}{showing labels for the tic marks}

\item{xlab.text}{xlab text}

\item{ylab.text}{ylab text}

\item{legend.colnames}{gives colnames to the legend matrix}

\item{size}{will give extra space in the margins of the inner plots}

\item{main}{text to use as main label}

\item{pValue}{Display p-value}

\item{cex.main}{set main label size}

\item{cex.ylab}{set ylab label size}

\item{cex.legend}{set legend label size}

\item{OrgDb}{an OrgDb object from which to plot a gene map. If given
together with argument TxDb this will only be used to extract genesymbols.}

\item{TxDb}{a TxDb object from which to plot an exon map.}

\item{verbose}{Setting \code{verbose=TRUE} gives details of procedure during
function run}

\item{top.fraction.criteria}{'maxcount', 'ref' or 'phase'}

\item{allow.whole.chromosome}{logical, overrides 200kb region limit, defaults to FALSE}
}
\description{
plotting ASE effects over a specific genomic region
}
\details{
The locationplot methods visualises how fractions are distributed over a
larger region of genes on one chromosome. It takes and ASEset object as well
as additional information on plot type (see \code{\link{barplot}}), strand
type (see \code{\link{getAlleleCounts}}), colouring, as well as annotation.
The annotation is taken either from the bioconductor OrgDb-sets, the TxDb
sets or both. It is obviously important to make sure that the genome build
used is the same as used in aligning the RNA-seq data.
}
\examples{


data(ASEset)
locationplot(ASEset)

#SNPs are plotted in the order in which they are found. 
#This can be sorted according to location as follows:
locationplot(ASEset[order(start(rowRanges(ASEset))),])

#for ASEsets with fewer SNPs the 'count' type plot is
# useful for detailed visualization.
locationplot(ASEset,type='count',strand='*')

}
\seealso{
\itemize{ \item The \code{\link{ASEset}} class which the
locationplot function can be called up on.  }
}
\author{
Jesper R. Gadin, Lasse Folkersen
}
\keyword{locationplot}
